export interface BundlerConfigGenerateOptions {
    nodeBuiltinModules?: boolean | NodeBuiltinModuleName[];
    nodeGlobals?: boolean | ("process" | "process-class")[];
    denoObject?: {
        attributes: boolean;
        global: boolean | "empty-object";
    };
    denoGlobals?: boolean | ("add-event-listener" | "remove-event-listener")[];
    workerIncompatibles?: boolean | ("eval" | "function-constructor")[];
    onIncompatible?: "ignore" | "warn" | "throw";
}
interface BundlerConfig {
    aliases: Record<string, string>;
    inject: string[];
    define: Record<string, string>;
    replaces: Record<string, string>;
}
declare const nodeBuiltinModulesAllAliasesRelative: {
    assert: string;
    buffer: string;
    console: string;
    crypto: string;
    events: string;
    fs: string;
    os: string;
    path: string;
    process: string;
    querystring: string;
    stream: string;
    string_decoder: string;
    timers: string;
    tty: string;
    url: string;
    util: string;
};
declare type NodeBuiltinModuleName = keyof typeof nodeBuiltinModulesAllAliasesRelative;
export declare const resolveAliases: (aliases: any, resolve: any) => {
    [k: string]: any;
};
export declare const nodeBuiltinModulesAliases: (moduleNames?: NodeBuiltinModuleName[]) => {
    [k: string]: any;
};
declare const generateBundlerConfig: (options: BundlerConfigGenerateOptions) => Promise<BundlerConfig>;
export default generateBundlerConfig;
