export const warnOrThrowIncompatible = (id, args = [], extraInfo) => {
    if (typeof CF_WORKER_COMPAT_ON_INCOMPATIBLE !== "undefined" &&
        CF_WORKER_COMPAT_ON_INCOMPATIBLE !== "ignore") {
        let printedArgs = [];
        if (typeof args[0] === "string" && args[0].length < 100) {
            printedArgs.push(`"${args[0]}"`);
        }
        else {
            printedArgs.push("...");
        }
        if (args.length > 1) {
            printedArgs.push("...");
        }
        const printedArgsStr = printedArgs.join(", ");
        const warningOrError = `Called \`${id}(${printedArgsStr})\`, ${extraInfo ? `${extraInfo}, ` : ''}but this is not available in Workers`;
        if (CF_WORKER_COMPAT_ON_INCOMPATIBLE === "warn") {
            console.warn(warningOrError);
        }
        else {
            throw new Error(warningOrError);
        }
    }
};
