var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};

// <define:Deno>
var define_Deno_default = {};

// ../../../build/lib/deno-globals/add-event-listener/inject.js
var workerGlobal_addEventListener = (...args) => warnOrThrowIncompatible("globalThis.addEventListener", args);

// ../../../build/warn-or-throw-incompatible.js
var warnOrThrowIncompatible = (id, args = [], extraInfo) => {
  if (true) {
    let printedArgs = [];
    if (typeof args[0] === "string" && args[0].length < 100) {
      printedArgs.push(`"${args[0]}"`);
    } else {
      printedArgs.push("...");
    }
    if (args.length > 1) {
      printedArgs.push("...");
    }
    const printedArgsStr = printedArgs.join(", ");
    const warningOrError = `Called \`${id}(${printedArgsStr})\`, ${extraInfo ? `${extraInfo}, ` : ""}but this is not available in Workers`;
    if (false) {
      console.warn(warningOrError);
    } else {
      throw new Error(warningOrError);
    }
  }
};

// ../../../build/lib/deno-object-attributes/inject.js
var workerDeno_build = {
  os: "linux",
  arch: "aarch64"
};
var workerDeno_env = {
  get: (name) => warnOrThrowIncompatible("Deno.env.get", [name]),
  set: (name, value) => warnOrThrowIncompatible("Deno.env.set", [name, value]),
  toObject: () => {
    warnOrThrowIncompatible("Deno.env.toObject");
    return {};
  }
};
var workerDeno_inspect = (value) => JSON.stringify(value);
var workerDeno_args = [];
var workerDeno_execPath = () => "./cloudflare-worker";
var workerDeno_errors = {
  NotFound: class NotFound extends Error {
  },
  PermissionDenied: class PermissionDenied extends Error {
  },
  ConnectionAborted: class ConnectionRefused extends Error {
  },
  ConnectionReset: class ConnectionReset extends Error {
  },
  ConnectionRefused: class ConnectionAborted extends Error {
  },
  NotConnected: class NotConnected extends Error {
  },
  AddrInUse: class AddrInUse extends Error {
  },
  AddrNotAvailable: class AddrNotAvailable extends Error {
  },
  BrokenPipe: class BrokenPipe extends Error {
  },
  AlreadyExists: class AlreadyExists extends Error {
  },
  InvalidData: class InvalidData extends Error {
  },
  TimedOut: class TimedOut extends Error {
  },
  Interrupted: class Interrupted extends Error {
  },
  UnexpectedEof: class WriteZero extends Error {
  },
  WriteZero: class UnexpectedEof extends Error {
  },
  BadResource: class BadResource extends Error {
  },
  Http: class Http extends Error {
  },
  Busy: class Busy extends Error {
  }
};
var workerDeno_mainModule = "file:///cloudflare-worker.js";
var workerDeno_core = {
  setNextTickCallback: void 0,
  evalContext(_code, _filename) {
    warnOrThrowIncompatible("Deno.core.evalContext", [_code, _filename]);
    throw new Error("Called Deno.core.evalContext(...) but this is not available");
  },
  encode(chunk) {
    return new TextEncoder().encode(chunk);
  }
};
var workerDeno_pid = 1;
var workerDeno_cwd = () => {
  warnOrThrowIncompatible("Deno.cwd");
  return "/cloudflare-worker";
};
var workerDeno_chdir = (...args) => warnOrThrowIncompatible("Deno.chdir", args);
var workerDeno_isatty = (...args) => {
  warnOrThrowIncompatible("Deno.isatty", args);
  return false;
};
var workerDeno_version = {
  deno: "0.144.0-cloudflare-worker"
};
var workerDeno_memoryUsage = () => {
  warnOrThrowIncompatible("Deno.memoryUsage");
  return {
    external: 0,
    heapTotal: 0,
    heapUsed: 0,
    rss: 0
  };
};
var workerDeno_stdin = null;
var workerDeno_stdout = null;
var workerDeno_stderr = null;

// build/mod.mjs
function delay(ms, options = {}) {
  const { signal } = options;
  if (signal?.aborted) {
    return Promise.reject(new DOMException("Delay was aborted.", "AbortError"));
  }
  return new Promise((resolve5, reject) => {
    const abort = () => {
      clearTimeout(i1);
      reject(new DOMException("Delay was aborted.", "AbortError"));
    };
    const done = () => {
      signal?.removeEventListener("abort", abort);
      resolve5();
    };
    const i1 = setTimeout(done, ms);
    signal?.addEventListener("abort", abort, {
      once: true
    });
  });
}
var { Deno: Deno1 } = globalThis;
typeof Deno1?.noColor === "boolean" ? Deno1.noColor : true;
new RegExp([
  "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)",
  "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-nq-uy=><~]))"
].join("|"), "g");
var DiffType;
(function(DiffType1) {
  DiffType1["removed"] = "removed";
  DiffType1["common"] = "common";
  DiffType1["added"] = "added";
})(DiffType || (DiffType = {}));
var AssertionError = class extends Error {
  name = "AssertionError";
  constructor(message) {
    super(message);
  }
};
function unreachable() {
  throw new AssertionError("unreachable");
}
function notImplemented(msg) {
  const message = msg ? `Not implemented: ${msg}` : "Not implemented";
  throw new Error(message);
}
function warnNotImplemented(msg) {
  const message = msg ? `Not implemented: ${msg}` : "Not implemented";
  console.warn(message);
}
function spliceOne(list, index) {
  for (; index + 1 < list.length; index++)
    list[index] = list[index + 1];
  list.pop();
}
function normalizeEncoding(enc) {
  if (enc == null || enc === "utf8" || enc === "utf-8")
    return "utf8";
  return slowCases(enc);
}
function slowCases(enc) {
  switch (enc.length) {
    case 4:
      if (enc === "UTF8")
        return "utf8";
      if (enc === "ucs2" || enc === "UCS2")
        return "utf16le";
      enc = `${enc}`.toLowerCase();
      if (enc === "utf8")
        return "utf8";
      if (enc === "ucs2")
        return "utf16le";
      break;
    case 3:
      if (enc === "hex" || enc === "HEX" || `${enc}`.toLowerCase() === "hex") {
        return "hex";
      }
      break;
    case 5:
      if (enc === "ascii")
        return "ascii";
      if (enc === "ucs-2")
        return "utf16le";
      if (enc === "UTF-8")
        return "utf8";
      if (enc === "ASCII")
        return "ascii";
      if (enc === "UCS-2")
        return "utf16le";
      enc = `${enc}`.toLowerCase();
      if (enc === "utf-8")
        return "utf8";
      if (enc === "ascii")
        return "ascii";
      if (enc === "ucs-2")
        return "utf16le";
      break;
    case 6:
      if (enc === "base64")
        return "base64";
      if (enc === "latin1" || enc === "binary")
        return "latin1";
      if (enc === "BASE64")
        return "base64";
      if (enc === "LATIN1" || enc === "BINARY")
        return "latin1";
      enc = `${enc}`.toLowerCase();
      if (enc === "base64")
        return "base64";
      if (enc === "latin1" || enc === "binary")
        return "latin1";
      break;
    case 7:
      if (enc === "utf16le" || enc === "UTF16LE" || `${enc}`.toLowerCase() === "utf16le") {
        return "utf16le";
      }
      break;
    case 8:
      if (enc === "utf-16le" || enc === "UTF-16LE" || `${enc}`.toLowerCase() === "utf-16le") {
        return "utf16le";
      }
      break;
    default:
      if (enc === "")
        return "utf8";
  }
}
var _toString = Object.prototype.toString;
var _isObjectLike = (value) => value !== null && typeof value === "object";
var _isFunctionLike = (value) => value !== null && typeof value === "function";
function isAnyArrayBuffer(value) {
  return _isObjectLike(value) && (_toString.call(value) === "[object ArrayBuffer]" || _toString.call(value) === "[object SharedArrayBuffer]");
}
function isArgumentsObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Arguments]";
}
function isArrayBuffer(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object ArrayBuffer]";
}
function isAsyncFunction(value) {
  return _isFunctionLike(value) && _toString.call(value) === "[object AsyncFunction]";
}
function isBooleanObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Boolean]";
}
function isBoxedPrimitive(value) {
  return isBooleanObject(value) || isStringObject(value) || isNumberObject(value) || isSymbolObject(value) || isBigIntObject(value);
}
function isDataView(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object DataView]";
}
function isDate(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Date]";
}
function isGeneratorFunction(value) {
  return _isFunctionLike(value) && _toString.call(value) === "[object GeneratorFunction]";
}
function isGeneratorObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Generator]";
}
function isMap(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Map]";
}
function isMapIterator(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Map Iterator]";
}
function isModuleNamespaceObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Module]";
}
function isNativeError(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Error]";
}
function isNumberObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Number]";
}
function isBigIntObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object BigInt]";
}
function isPromise(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Promise]";
}
function isRegExp(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object RegExp]";
}
function isSet(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Set]";
}
function isSetIterator(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Set Iterator]";
}
function isSharedArrayBuffer(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object SharedArrayBuffer]";
}
function isStringObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object String]";
}
function isSymbolObject(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object Symbol]";
}
function isWeakMap(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object WeakMap]";
}
function isWeakSet(value) {
  return _isObjectLike(value) && _toString.call(value) === "[object WeakSet]";
}
var __default = {
  isAsyncFunction,
  isGeneratorFunction,
  isAnyArrayBuffer,
  isArrayBuffer,
  isArgumentsObject,
  isBoxedPrimitive,
  isDataView,
  isMap,
  isMapIterator,
  isModuleNamespaceObject,
  isNativeError,
  isPromise,
  isSet,
  isSetIterator,
  isWeakMap,
  isWeakSet,
  isRegExp,
  isDate,
  isStringObject,
  isNumberObject,
  isBooleanObject,
  isBigIntObject
};
var mod = {
  isAnyArrayBuffer,
  isArgumentsObject,
  isArrayBuffer,
  isAsyncFunction,
  isBooleanObject,
  isBoxedPrimitive,
  isDataView,
  isDate,
  isGeneratorFunction,
  isGeneratorObject,
  isMap,
  isMapIterator,
  isModuleNamespaceObject,
  isNativeError,
  isNumberObject,
  isBigIntObject,
  isPromise,
  isRegExp,
  isSet,
  isSetIterator,
  isSharedArrayBuffer,
  isStringObject,
  isSymbolObject,
  isWeakMap,
  isWeakSet,
  default: __default
};
Symbol("kHandle");
Symbol("kKeyObject");
Symbol("kKeyType");
var _toString1 = Object.prototype.toString;
var _isObjectLike1 = (value) => value !== null && typeof value === "object";
function isArrayBufferView(value) {
  return ArrayBuffer.isView(value);
}
function isTypedArray(value) {
  const reTypedTag = /^\[object (?:Float(?:32|64)|(?:Int|Uint)(?:8|16|32)|Uint8Clamped)Array\]$/;
  return _isObjectLike1(value) && reTypedTag.test(_toString1.call(value));
}
function isUint8Array(value) {
  return _isObjectLike1(value) && _toString1.call(value) === "[object Uint8Array]";
}
var { isDate: isDate1, isArgumentsObject: isArgumentsObject1, isBigIntObject: isBigIntObject1, isBooleanObject: isBooleanObject1, isNumberObject: isNumberObject1, isStringObject: isStringObject1, isSymbolObject: isSymbolObject1, isNativeError: isNativeError1, isRegExp: isRegExp1, isAsyncFunction: isAsyncFunction1, isGeneratorFunction: isGeneratorFunction1, isGeneratorObject: isGeneratorObject1, isPromise: isPromise1, isMap: isMap1, isSet: isSet1, isMapIterator: isMapIterator1, isSetIterator: isSetIterator1, isWeakMap: isWeakMap1, isWeakSet: isWeakSet1, isArrayBuffer: isArrayBuffer1, isDataView: isDataView1, isSharedArrayBuffer: isSharedArrayBuffer1, isModuleNamespaceObject: isModuleNamespaceObject1, isAnyArrayBuffer: isAnyArrayBuffer1, isBoxedPrimitive: isBoxedPrimitive1 } = mod;
var codes = {};
function hideStackFrames(fn) {
  const hidden = "__node_internal_" + fn.name;
  Object.defineProperty(fn, "name", {
    value: hidden
  });
  return fn;
}
function normalizeEncoding1(enc) {
  if (enc == null || enc === "utf8" || enc === "utf-8")
    return "utf8";
  return slowCases1(enc);
}
function slowCases1(enc) {
  switch (enc.length) {
    case 4:
      if (enc === "UTF8")
        return "utf8";
      if (enc === "ucs2" || enc === "UCS2")
        return "utf16le";
      enc = `${enc}`.toLowerCase();
      if (enc === "utf8")
        return "utf8";
      if (enc === "ucs2")
        return "utf16le";
      break;
    case 3:
      if (enc === "hex" || enc === "HEX" || `${enc}`.toLowerCase() === "hex") {
        return "hex";
      }
      break;
    case 5:
      if (enc === "ascii")
        return "ascii";
      if (enc === "ucs-2")
        return "utf16le";
      if (enc === "UTF-8")
        return "utf8";
      if (enc === "ASCII")
        return "ascii";
      if (enc === "UCS-2")
        return "utf16le";
      enc = `${enc}`.toLowerCase();
      if (enc === "utf-8")
        return "utf8";
      if (enc === "ascii")
        return "ascii";
      if (enc === "ucs-2")
        return "utf16le";
      break;
    case 6:
      if (enc === "base64")
        return "base64";
      if (enc === "latin1" || enc === "binary")
        return "latin1";
      if (enc === "BASE64")
        return "base64";
      if (enc === "LATIN1" || enc === "BINARY")
        return "latin1";
      enc = `${enc}`.toLowerCase();
      if (enc === "base64")
        return "base64";
      if (enc === "latin1" || enc === "binary")
        return "latin1";
      break;
    case 7:
      if (enc === "utf16le" || enc === "UTF16LE" || `${enc}`.toLowerCase() === "utf16le") {
        return "utf16le";
      }
      break;
    case 8:
      if (enc === "utf-16le" || enc === "UTF-16LE" || `${enc}`.toLowerCase() === "utf-16le") {
        return "utf16le";
      }
      break;
    case 9:
      if (enc === "base64url" || enc === "BASE64URL" || `${enc}`.toLowerCase() === "base64url") {
        return "base64url";
      }
      break;
    default:
      if (enc === "")
        return "utf8";
  }
}
function isInt32(value) {
  return value === (value | 0);
}
function isUint32(value) {
  return value === value >>> 0;
}
var validateBuffer = hideStackFrames((buffer, name = "buffer") => {
  if (!isArrayBufferView(buffer)) {
    throw new codes.ERR_INVALID_ARG_TYPE(name, [
      "Buffer",
      "TypedArray",
      "DataView"
    ], buffer);
  }
});
hideStackFrames((value, name, min1 = Number.MIN_SAFE_INTEGER, max = Number.MAX_SAFE_INTEGER) => {
  if (typeof value !== "number") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "number", value);
  }
  if (!Number.isInteger(value)) {
    throw new codes.ERR_OUT_OF_RANGE(name, "an integer", value);
  }
  if (value < min1 || value > max) {
    throw new codes.ERR_OUT_OF_RANGE(name, `>= ${min1} && <= ${max}`, value);
  }
});
var validateObject = hideStackFrames((value, name, options) => {
  const useDefaultOptions = options == null;
  const allowArray = useDefaultOptions ? false : options.allowArray;
  const allowFunction = useDefaultOptions ? false : options.allowFunction;
  const nullable = useDefaultOptions ? false : options.nullable;
  if (!nullable && value === null || !allowArray && Array.isArray(value) || typeof value !== "object" && (!allowFunction || typeof value !== "function")) {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "Object", value);
  }
});
var validateInt32 = hideStackFrames((value, name, min2 = -2147483648, max = 2147483647) => {
  if (!isInt32(value)) {
    if (typeof value !== "number") {
      throw new codes.ERR_INVALID_ARG_TYPE(name, "number", value);
    }
    if (!Number.isInteger(value)) {
      throw new codes.ERR_OUT_OF_RANGE(name, "an integer", value);
    }
    throw new codes.ERR_OUT_OF_RANGE(name, `>= ${min2} && <= ${max}`, value);
  }
  if (value < min2 || value > max) {
    throw new codes.ERR_OUT_OF_RANGE(name, `>= ${min2} && <= ${max}`, value);
  }
});
hideStackFrames((value, name, positive) => {
  if (!isUint32(value)) {
    if (typeof value !== "number") {
      throw new codes.ERR_INVALID_ARG_TYPE(name, "number", value);
    }
    if (!Number.isInteger(value)) {
      throw new codes.ERR_OUT_OF_RANGE(name, "an integer", value);
    }
    const min3 = positive ? 1 : 0;
    throw new codes.ERR_OUT_OF_RANGE(name, `>= ${min3} && < 4294967296`, value);
  }
  if (positive && value === 0) {
    throw new codes.ERR_OUT_OF_RANGE(name, ">= 1 && < 4294967296", value);
  }
});
function validateString(value, name) {
  if (typeof value !== "string") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "string", value);
  }
}
function validateNumber(value, name) {
  if (typeof value !== "number") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "number", value);
  }
}
function validateBoolean(value, name) {
  if (typeof value !== "boolean") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "boolean", value);
  }
}
var validateOneOf = hideStackFrames((value, name, oneOf) => {
  if (!Array.prototype.includes.call(oneOf, value)) {
    const allowed = Array.prototype.join.call(Array.prototype.map.call(oneOf, (v) => typeof v === "string" ? `'${v}'` : String(v)), ", ");
    const reason = "must be one of: " + allowed;
    throw new codes.ERR_INVALID_ARG_VALUE(name, value, reason);
  }
});
function validatePort(port, name = "Port", allowZero = true) {
  if (typeof port !== "number" && typeof port !== "string" || typeof port === "string" && String.prototype.trim.call(port).length === 0 || +port !== +port >>> 0 || port > 65535 || port === 0 && !allowZero) {
    throw new codes.ERR_SOCKET_BAD_PORT(name, port, allowZero);
  }
  return port;
}
var validateCallback = hideStackFrames((callback) => {
  if (typeof callback !== "function") {
    throw new codes.ERR_INVALID_CALLBACK(callback);
  }
});
var validateAbortSignal = hideStackFrames((signal, name) => {
  if (signal !== void 0 && (signal === null || typeof signal !== "object" || !("aborted" in signal))) {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "AbortSignal", signal);
  }
});
var validateFunction = hideStackFrames((value, name) => {
  if (typeof value !== "function") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "Function", value);
  }
});
var validateArray = hideStackFrames((value, name, minLength = 0) => {
  if (!Array.isArray(value)) {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "Array", value);
  }
  if (value.length < minLength) {
    const reason = `must be longer than ${minLength}`;
    throw new codes.ERR_INVALID_ARG_VALUE(name, value, reason);
  }
});
function guessHandleType(_fd) {
  notImplemented("util.guessHandleType");
}
var isNumericLookup = {};
function isArrayIndex(value) {
  switch (typeof value) {
    case "number":
      return value >= 0 && (value | 0) === value;
    case "string": {
      const result = isNumericLookup[value];
      if (result !== void 0) {
        return result;
      }
      const length = value.length;
      if (length === 0) {
        return isNumericLookup[value] = false;
      }
      let ch = 0;
      let i2 = 0;
      for (; i2 < length; ++i2) {
        ch = value.charCodeAt(i2);
        if (i2 === 0 && ch === 48 && length > 1 || ch < 48 || ch > 57) {
          return isNumericLookup[value] = false;
        }
      }
      return isNumericLookup[value] = true;
    }
    default:
      return false;
  }
}
function getOwnNonIndexProperties(obj, filter) {
  let allProperties = [
    ...Object.getOwnPropertyNames(obj),
    ...Object.getOwnPropertySymbols(obj)
  ];
  if (Array.isArray(obj)) {
    allProperties = allProperties.filter((k) => !isArrayIndex(k));
  }
  if (filter === 0) {
    return allProperties;
  }
  const result = [];
  for (const key of allProperties) {
    const desc = Object.getOwnPropertyDescriptor(obj, key);
    if (desc === void 0) {
      continue;
    }
    if (filter & 1 && !desc.writable) {
      continue;
    }
    if (filter & 2 && !desc.enumerable) {
      continue;
    }
    if (filter & 4 && !desc.configurable) {
      continue;
    }
    if (filter & 8 && typeof key === "string") {
      continue;
    }
    if (filter & 16 && typeof key === "symbol") {
      continue;
    }
    result.push(key);
  }
  return result;
}
var mod1 = function() {
  return {
    guessHandleType,
    ALL_PROPERTIES: 0,
    ONLY_WRITABLE: 1,
    ONLY_ENUMERABLE: 2,
    ONLY_CONFIGURABLE: 4,
    ONLY_ENUM_WRITABLE: 6,
    SKIP_STRINGS: 8,
    SKIP_SYMBOLS: 16,
    isArrayIndex,
    getOwnNonIndexProperties
  };
}();
var kObjectType = 0;
var kArrayExtrasType = 2;
var kRejected = 2;
var meta = [
  "\\x00",
  "\\x01",
  "\\x02",
  "\\x03",
  "\\x04",
  "\\x05",
  "\\x06",
  "\\x07",
  "\\b",
  "\\t",
  "\\n",
  "\\x0B",
  "\\f",
  "\\r",
  "\\x0E",
  "\\x0F",
  "\\x10",
  "\\x11",
  "\\x12",
  "\\x13",
  "\\x14",
  "\\x15",
  "\\x16",
  "\\x17",
  "\\x18",
  "\\x19",
  "\\x1A",
  "\\x1B",
  "\\x1C",
  "\\x1D",
  "\\x1E",
  "\\x1F",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "\\'",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "\\\\",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "\\x7F",
  "\\x80",
  "\\x81",
  "\\x82",
  "\\x83",
  "\\x84",
  "\\x85",
  "\\x86",
  "\\x87",
  "\\x88",
  "\\x89",
  "\\x8A",
  "\\x8B",
  "\\x8C",
  "\\x8D",
  "\\x8E",
  "\\x8F",
  "\\x90",
  "\\x91",
  "\\x92",
  "\\x93",
  "\\x94",
  "\\x95",
  "\\x96",
  "\\x97",
  "\\x98",
  "\\x99",
  "\\x9A",
  "\\x9B",
  "\\x9C",
  "\\x9D",
  "\\x9E",
  "\\x9F"
];
var isUndetectableObject = (v) => typeof v === "undefined" && v !== void 0;
var strEscapeSequencesRegExp = /[\x00-\x1f\x27\x5c\x7f-\x9f]/;
var strEscapeSequencesReplacer = /[\x00-\x1f\x27\x5c\x7f-\x9f]/g;
var strEscapeSequencesRegExpSingle = /[\x00-\x1f\x5c\x7f-\x9f]/;
var strEscapeSequencesReplacerSingle = /[\x00-\x1f\x5c\x7f-\x9f]/g;
var keyStrRegExp = /^[a-zA-Z_][a-zA-Z_0-9]*$/;
var numberRegExp = /^(0|[1-9][0-9]*)$/;
var nodeModulesRegExp = /[/\\]node_modules[/\\](.+?)(?=[/\\])/g;
var classRegExp = /^(\s+[^(]*?)\s*{/;
var stripCommentsRegExp = /(\/\/.*?\n)|(\/\*(.|\n)*?\*\/)/g;
var inspectDefaultOptions = {
  showHidden: false,
  depth: 2,
  colors: false,
  customInspect: true,
  showProxy: false,
  maxArrayLength: 100,
  maxStringLength: 1e4,
  breakLength: 80,
  compact: 3,
  sorted: false,
  getters: false
};
function getUserOptions(ctx, isCrossContext) {
  const ret = {
    stylize: ctx.stylize,
    showHidden: ctx.showHidden,
    depth: ctx.depth,
    colors: ctx.colors,
    customInspect: ctx.customInspect,
    showProxy: ctx.showProxy,
    maxArrayLength: ctx.maxArrayLength,
    maxStringLength: ctx.maxStringLength,
    breakLength: ctx.breakLength,
    compact: ctx.compact,
    sorted: ctx.sorted,
    getters: ctx.getters,
    ...ctx.userOptions
  };
  if (isCrossContext) {
    Object.setPrototypeOf(ret, null);
    for (const key of Object.keys(ret)) {
      if ((typeof ret[key] === "object" || typeof ret[key] === "function") && ret[key] !== null) {
        delete ret[key];
      }
    }
    ret.stylize = Object.setPrototypeOf((value, flavour) => {
      let stylized;
      try {
        stylized = `${ctx.stylize(value, flavour)}`;
      } catch {
      }
      if (typeof stylized !== "string")
        return value;
      return stylized;
    }, null);
  }
  return ret;
}
function inspect(value, opts) {
  const ctx = {
    budget: {},
    indentationLvl: 0,
    seen: [],
    currentDepth: 0,
    stylize: stylizeNoColor,
    showHidden: inspectDefaultOptions.showHidden,
    depth: inspectDefaultOptions.depth,
    colors: inspectDefaultOptions.colors,
    customInspect: inspectDefaultOptions.customInspect,
    showProxy: inspectDefaultOptions.showProxy,
    maxArrayLength: inspectDefaultOptions.maxArrayLength,
    maxStringLength: inspectDefaultOptions.maxStringLength,
    breakLength: inspectDefaultOptions.breakLength,
    compact: inspectDefaultOptions.compact,
    sorted: inspectDefaultOptions.sorted,
    getters: inspectDefaultOptions.getters
  };
  if (arguments.length > 1) {
    if (arguments.length > 2) {
      if (arguments[2] !== void 0) {
        ctx.depth = arguments[2];
      }
      if (arguments.length > 3 && arguments[3] !== void 0) {
        ctx.colors = arguments[3];
      }
    }
    if (typeof opts === "boolean") {
      ctx.showHidden = opts;
    } else if (opts) {
      const optKeys = Object.keys(opts);
      for (let i3 = 0; i3 < optKeys.length; ++i3) {
        const key = optKeys[i3];
        if (inspectDefaultOptions.hasOwnProperty(key) || key === "stylize") {
          ctx[key] = opts[key];
        } else if (ctx.userOptions === void 0) {
          ctx.userOptions = opts;
        }
      }
    }
  }
  if (ctx.colors)
    ctx.stylize = stylizeWithColor;
  if (ctx.maxArrayLength === null)
    ctx.maxArrayLength = Infinity;
  if (ctx.maxStringLength === null)
    ctx.maxStringLength = Infinity;
  return formatValue(ctx, value, 0);
}
var customInspectSymbol = Symbol.for("nodejs.util.inspect.custom");
inspect.custom = customInspectSymbol;
Object.defineProperty(inspect, "defaultOptions", {
  get() {
    return inspectDefaultOptions;
  },
  set(options) {
    validateObject(options, "options");
    return Object.assign(inspectDefaultOptions, options);
  }
});
var defaultFG = 39;
var defaultBG = 49;
inspect.colors = Object.assign(/* @__PURE__ */ Object.create(null), {
  reset: [
    0,
    0
  ],
  bold: [
    1,
    22
  ],
  dim: [
    2,
    22
  ],
  italic: [
    3,
    23
  ],
  underline: [
    4,
    24
  ],
  blink: [
    5,
    25
  ],
  inverse: [
    7,
    27
  ],
  hidden: [
    8,
    28
  ],
  strikethrough: [
    9,
    29
  ],
  doubleunderline: [
    21,
    24
  ],
  black: [
    30,
    defaultFG
  ],
  red: [
    31,
    defaultFG
  ],
  green: [
    32,
    defaultFG
  ],
  yellow: [
    33,
    defaultFG
  ],
  blue: [
    34,
    defaultFG
  ],
  magenta: [
    35,
    defaultFG
  ],
  cyan: [
    36,
    defaultFG
  ],
  white: [
    37,
    defaultFG
  ],
  bgBlack: [
    40,
    defaultBG
  ],
  bgRed: [
    41,
    defaultBG
  ],
  bgGreen: [
    42,
    defaultBG
  ],
  bgYellow: [
    43,
    defaultBG
  ],
  bgBlue: [
    44,
    defaultBG
  ],
  bgMagenta: [
    45,
    defaultBG
  ],
  bgCyan: [
    46,
    defaultBG
  ],
  bgWhite: [
    47,
    defaultBG
  ],
  framed: [
    51,
    54
  ],
  overlined: [
    53,
    55
  ],
  gray: [
    90,
    defaultFG
  ],
  redBright: [
    91,
    defaultFG
  ],
  greenBright: [
    92,
    defaultFG
  ],
  yellowBright: [
    93,
    defaultFG
  ],
  blueBright: [
    94,
    defaultFG
  ],
  magentaBright: [
    95,
    defaultFG
  ],
  cyanBright: [
    96,
    defaultFG
  ],
  whiteBright: [
    97,
    defaultFG
  ],
  bgGray: [
    100,
    defaultBG
  ],
  bgRedBright: [
    101,
    defaultBG
  ],
  bgGreenBright: [
    102,
    defaultBG
  ],
  bgYellowBright: [
    103,
    defaultBG
  ],
  bgBlueBright: [
    104,
    defaultBG
  ],
  bgMagentaBright: [
    105,
    defaultBG
  ],
  bgCyanBright: [
    106,
    defaultBG
  ],
  bgWhiteBright: [
    107,
    defaultBG
  ]
});
function defineColorAlias(target, alias) {
  Object.defineProperty(inspect.colors, alias, {
    get() {
      return this[target];
    },
    set(value) {
      this[target] = value;
    },
    configurable: true,
    enumerable: false
  });
}
defineColorAlias("gray", "grey");
defineColorAlias("gray", "blackBright");
defineColorAlias("bgGray", "bgGrey");
defineColorAlias("bgGray", "bgBlackBright");
defineColorAlias("dim", "faint");
defineColorAlias("strikethrough", "crossedout");
defineColorAlias("strikethrough", "strikeThrough");
defineColorAlias("strikethrough", "crossedOut");
defineColorAlias("hidden", "conceal");
defineColorAlias("inverse", "swapColors");
defineColorAlias("inverse", "swapcolors");
defineColorAlias("doubleunderline", "doubleUnderline");
inspect.styles = Object.assign(/* @__PURE__ */ Object.create(null), {
  special: "cyan",
  number: "yellow",
  bigint: "yellow",
  boolean: "yellow",
  undefined: "grey",
  null: "bold",
  string: "green",
  symbol: "green",
  date: "magenta",
  regexp: "red",
  module: "underline"
});
function addQuotes(str, quotes) {
  if (quotes === -1) {
    return `"${str}"`;
  }
  if (quotes === -2) {
    return `\`${str}\``;
  }
  return `'${str}'`;
}
var escapeFn = (str) => meta[str.charCodeAt(0)];
function strEscape(str) {
  let escapeTest = strEscapeSequencesRegExp;
  let escapeReplace = strEscapeSequencesReplacer;
  let singleQuote = 39;
  if (str.includes("'")) {
    if (!str.includes('"')) {
      singleQuote = -1;
    } else if (!str.includes("`") && !str.includes("${")) {
      singleQuote = -2;
    }
    if (singleQuote !== 39) {
      escapeTest = strEscapeSequencesRegExpSingle;
      escapeReplace = strEscapeSequencesReplacerSingle;
    }
  }
  if (str.length < 5e3 && !escapeTest.test(str)) {
    return addQuotes(str, singleQuote);
  }
  if (str.length > 100) {
    str = str.replace(escapeReplace, escapeFn);
    return addQuotes(str, singleQuote);
  }
  let result = "";
  let last = 0;
  const lastIndex = str.length;
  for (let i4 = 0; i4 < lastIndex; i4++) {
    const point = str.charCodeAt(i4);
    if (point === singleQuote || point === 92 || point < 32 || point > 126 && point < 160) {
      if (last === i4) {
        result += meta[point];
      } else {
        result += `${str.slice(last, i4)}${meta[point]}`;
      }
      last = i4 + 1;
    }
  }
  if (last !== lastIndex) {
    result += str.slice(last);
  }
  return addQuotes(result, singleQuote);
}
function stylizeWithColor(str, styleType) {
  const style = inspect.styles[styleType];
  if (style !== void 0) {
    const color = inspect.colors[style];
    if (color !== void 0) {
      return `\x1B[${color[0]}m${str}\x1B[${color[1]}m`;
    }
  }
  return str;
}
function stylizeNoColor(str) {
  return str;
}
function formatValue(ctx, value, recurseTimes, typedArray) {
  if (typeof value !== "object" && typeof value !== "function" && !isUndetectableObject(value)) {
    return formatPrimitive(ctx.stylize, value, ctx);
  }
  if (value === null) {
    return ctx.stylize("null", "null");
  }
  const context = value;
  const proxy = void 0;
  if (ctx.customInspect) {
    const maybeCustom = value[customInspectSymbol];
    if (typeof maybeCustom === "function" && maybeCustom !== inspect && !(value.constructor && value.constructor.prototype === value)) {
      const depth = ctx.depth === null ? null : ctx.depth - recurseTimes;
      const isCrossContext = proxy !== void 0 || !(context instanceof Object);
      const ret = maybeCustom.call(context, depth, getUserOptions(ctx, isCrossContext));
      if (ret !== context) {
        if (typeof ret !== "string") {
          return formatValue(ctx, ret, recurseTimes);
        }
        return ret.replace(/\n/g, `
${" ".repeat(ctx.indentationLvl)}`);
      }
    }
  }
  if (ctx.seen.includes(value)) {
    let index = 1;
    if (ctx.circular === void 0) {
      ctx.circular = /* @__PURE__ */ new Map();
      ctx.circular.set(value, index);
    } else {
      index = ctx.circular.get(value);
      if (index === void 0) {
        index = ctx.circular.size + 1;
        ctx.circular.set(value, index);
      }
    }
    return ctx.stylize(`[Circular *${index}]`, "special");
  }
  return formatRaw(ctx, value, recurseTimes, typedArray);
}
function formatRaw(ctx, value, recurseTimes, typedArray) {
  let keys;
  let protoProps;
  if (ctx.showHidden && (recurseTimes <= ctx.depth || ctx.depth === null)) {
    protoProps = [];
  }
  const constructor = getConstructorName(value, ctx, recurseTimes, protoProps);
  if (protoProps !== void 0 && protoProps.length === 0) {
    protoProps = void 0;
  }
  let tag = value[Symbol.toStringTag];
  if (typeof tag !== "string") {
    tag = "";
  }
  let base1 = "";
  let formatter = getEmptyFormatArray;
  let braces;
  let noIterator = true;
  let i5 = 0;
  const filter = ctx.showHidden ? 0 : 2;
  let extrasType = 0;
  if (value[Symbol.iterator] || constructor === null) {
    noIterator = false;
    if (Array.isArray(value)) {
      const prefix = constructor !== "Array" || tag !== "" ? getPrefix(constructor, tag, "Array", `(${value.length})`) : "";
      keys = getOwnNonIndexProperties(value, filter);
      braces = [
        `${prefix}[`,
        "]"
      ];
      if (value.length === 0 && keys.length === 0 && protoProps === void 0) {
        return `${braces[0]}]`;
      }
      extrasType = kArrayExtrasType;
      formatter = formatArray;
    } else if (isSet1(value)) {
      const size = value.size;
      const prefix = getPrefix(constructor, tag, "Set", `(${size})`);
      keys = getKeys(value, ctx.showHidden);
      formatter = constructor !== null ? formatSet.bind(null, value) : formatSet.bind(null, value.values());
      if (size === 0 && keys.length === 0 && protoProps === void 0) {
        return `${prefix}{}`;
      }
      braces = [
        `${prefix}{`,
        "}"
      ];
    } else if (isMap1(value)) {
      const size = value.size;
      const prefix = getPrefix(constructor, tag, "Map", `(${size})`);
      keys = getKeys(value, ctx.showHidden);
      formatter = constructor !== null ? formatMap.bind(null, value) : formatMap.bind(null, value.entries());
      if (size === 0 && keys.length === 0 && protoProps === void 0) {
        return `${prefix}{}`;
      }
      braces = [
        `${prefix}{`,
        "}"
      ];
    } else if (isTypedArray(value)) {
      keys = getOwnNonIndexProperties(value, filter);
      const bound = value;
      const fallback = "";
      const size = value.length;
      const prefix = getPrefix(constructor, tag, fallback, `(${size})`);
      braces = [
        `${prefix}[`,
        "]"
      ];
      if (value.length === 0 && keys.length === 0 && !ctx.showHidden) {
        return `${braces[0]}]`;
      }
      formatter = formatTypedArray.bind(null, bound, size);
      extrasType = kArrayExtrasType;
    } else if (isMapIterator1(value)) {
      keys = getKeys(value, ctx.showHidden);
      braces = getIteratorBraces("Map", tag);
      formatter = formatIterator.bind(null, braces);
    } else if (isSetIterator1(value)) {
      keys = getKeys(value, ctx.showHidden);
      braces = getIteratorBraces("Set", tag);
      formatter = formatIterator.bind(null, braces);
    } else {
      noIterator = true;
    }
  }
  if (noIterator) {
    keys = getKeys(value, ctx.showHidden);
    braces = [
      "{",
      "}"
    ];
    if (constructor === "Object") {
      if (isArgumentsObject1(value)) {
        braces[0] = "[Arguments] {";
      } else if (tag !== "") {
        braces[0] = `${getPrefix(constructor, tag, "Object")}{`;
      }
      if (keys.length === 0 && protoProps === void 0) {
        return `${braces[0]}}`;
      }
    } else if (typeof value === "function") {
      base1 = getFunctionBase(value, constructor, tag);
      if (keys.length === 0 && protoProps === void 0) {
        return ctx.stylize(base1, "special");
      }
    } else if (isRegExp1(value)) {
      base1 = RegExp(constructor !== null ? value : new RegExp(value)).toString();
      const prefix = getPrefix(constructor, tag, "RegExp");
      if (prefix !== "RegExp ") {
        base1 = `${prefix}${base1}`;
      }
      if (keys.length === 0 && protoProps === void 0 || recurseTimes > ctx.depth && ctx.depth !== null) {
        return ctx.stylize(base1, "regexp");
      }
    } else if (isDate1(value)) {
      base1 = Number.isNaN(value.getTime()) ? value.toString() : value.toISOString();
      const prefix = getPrefix(constructor, tag, "Date");
      if (prefix !== "Date ") {
        base1 = `${prefix}${base1}`;
      }
      if (keys.length === 0 && protoProps === void 0) {
        return ctx.stylize(base1, "date");
      }
    } else if (value instanceof Error) {
      base1 = formatError(value, constructor, tag, ctx, keys);
      if (keys.length === 0 && protoProps === void 0) {
        return base1;
      }
    } else if (isAnyArrayBuffer1(value)) {
      const arrayType = isArrayBuffer1(value) ? "ArrayBuffer" : "SharedArrayBuffer";
      const prefix = getPrefix(constructor, tag, arrayType);
      if (typedArray === void 0) {
        formatter = formatArrayBuffer;
      } else if (keys.length === 0 && protoProps === void 0) {
        return prefix + `{ byteLength: ${formatNumber(ctx.stylize, value.byteLength)} }`;
      }
      braces[0] = `${prefix}{`;
      Array.prototype.unshift(keys, "byteLength");
    } else if (isDataView1(value)) {
      braces[0] = `${getPrefix(constructor, tag, "DataView")}{`;
      Array.prototype.unshift(keys, "byteLength", "byteOffset", "buffer");
    } else if (isPromise1(value)) {
      braces[0] = `${getPrefix(constructor, tag, "Promise")}{`;
      formatter = formatPromise;
    } else if (isWeakSet1(value)) {
      braces[0] = `${getPrefix(constructor, tag, "WeakSet")}{`;
      formatter = ctx.showHidden ? formatWeakSet : formatWeakCollection;
    } else if (isWeakMap1(value)) {
      braces[0] = `${getPrefix(constructor, tag, "WeakMap")}{`;
      formatter = ctx.showHidden ? formatWeakMap : formatWeakCollection;
    } else if (isModuleNamespaceObject1(value)) {
      braces[0] = `${getPrefix(constructor, tag, "Module")}{`;
      formatter = formatNamespaceObject.bind(null, keys);
    } else if (isBoxedPrimitive1(value)) {
      base1 = getBoxedBase(value, ctx, keys, constructor, tag);
      if (keys.length === 0 && protoProps === void 0) {
        return base1;
      }
    } else {
      if (keys.length === 0 && protoProps === void 0) {
        return `${getCtxStyle(value, constructor, tag)}{}`;
      }
      braces[0] = `${getCtxStyle(value, constructor, tag)}{`;
    }
  }
  if (recurseTimes > ctx.depth && ctx.depth !== null) {
    let constructorName = getCtxStyle(value, constructor, tag).slice(0, -1);
    if (constructor !== null) {
      constructorName = `[${constructorName}]`;
    }
    return ctx.stylize(constructorName, "special");
  }
  recurseTimes += 1;
  ctx.seen.push(value);
  ctx.currentDepth = recurseTimes;
  let output;
  const indentationLvl = ctx.indentationLvl;
  try {
    output = formatter(ctx, value, recurseTimes);
    for (i5 = 0; i5 < keys.length; i5++) {
      output.push(formatProperty(ctx, value, recurseTimes, keys[i5], extrasType));
    }
    if (protoProps !== void 0) {
      output.push(...protoProps);
    }
  } catch (err) {
    const constructorName = getCtxStyle(value, constructor, tag).slice(0, -1);
    return handleMaxCallStackSize(ctx, err, constructorName, indentationLvl);
  }
  if (ctx.circular !== void 0) {
    const index = ctx.circular.get(value);
    if (index !== void 0) {
      const reference = ctx.stylize(`<ref *${index}>`, "special");
      if (ctx.compact !== true) {
        base1 = base1 === "" ? reference : `${reference} ${base1}`;
      } else {
        braces[0] = `${reference} ${braces[0]}`;
      }
    }
  }
  ctx.seen.pop();
  if (ctx.sorted) {
    const comparator = ctx.sorted === true ? void 0 : ctx.sorted;
    if (extrasType === 0) {
      output = output.sort(comparator);
    } else if (keys.length > 1) {
      const sorted = output.slice(output.length - keys.length).sort(comparator);
      output.splice(output.length - keys.length, keys.length, ...sorted);
    }
  }
  const res = reduceToSingleString(ctx, output, base1, braces, extrasType, recurseTimes, value);
  const budget = ctx.budget[ctx.indentationLvl] || 0;
  const newLength = budget + res.length;
  ctx.budget[ctx.indentationLvl] = newLength;
  if (newLength > 2 ** 27) {
    ctx.depth = -1;
  }
  return res;
}
var builtInObjects = new Set(Object.getOwnPropertyNames(globalThis).filter((e) => /^[A-Z][a-zA-Z0-9]+$/.test(e)));
function addPrototypeProperties(ctx, main, obj, recurseTimes, output) {
  let depth = 0;
  let keys;
  let keySet;
  do {
    if (depth !== 0 || main === obj) {
      obj = Object.getPrototypeOf(obj);
      if (obj === null) {
        return;
      }
      const descriptor = Object.getOwnPropertyDescriptor(obj, "constructor");
      if (descriptor !== void 0 && typeof descriptor.value === "function" && builtInObjects.has(descriptor.value.name)) {
        return;
      }
    }
    if (depth === 0) {
      keySet = /* @__PURE__ */ new Set();
    } else {
      Array.prototype.forEach(keys, (key) => keySet.add(key));
    }
    keys = Reflect.ownKeys(obj);
    Array.prototype.push(ctx.seen, main);
    for (const key1 of keys) {
      if (key1 === "constructor" || main.hasOwnProperty(key1) || depth !== 0 && keySet.has(key1)) {
        continue;
      }
      const desc = Object.getOwnPropertyDescriptor(obj, key1);
      if (typeof desc.value === "function") {
        continue;
      }
      const value = formatProperty(ctx, obj, recurseTimes, key1, 0, desc, main);
      if (ctx.colors) {
        Array.prototype.push(output, `\x1B[2m${value}\x1B[22m`);
      } else {
        Array.prototype.push(output, value);
      }
    }
    Array.prototype.pop(ctx.seen);
  } while (++depth !== 3);
}
function getConstructorName(obj, ctx, recurseTimes, protoProps) {
  let firstProto;
  const tmp = obj;
  while (obj || isUndetectableObject(obj)) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, "constructor");
    if (descriptor !== void 0 && typeof descriptor.value === "function" && descriptor.value.name !== "" && isInstanceof(tmp, descriptor.value)) {
      if (protoProps !== void 0 && (firstProto !== obj || !builtInObjects.has(descriptor.value.name))) {
        addPrototypeProperties(ctx, tmp, firstProto || tmp, recurseTimes, protoProps);
      }
      return descriptor.value.name;
    }
    obj = Object.getPrototypeOf(obj);
    if (firstProto === void 0) {
      firstProto = obj;
    }
  }
  if (firstProto === null) {
    return null;
  }
  const res = void 0;
  if (recurseTimes > ctx.depth && ctx.depth !== null) {
    return `${res} <Complex prototype>`;
  }
  const protoConstr = getConstructorName(firstProto, ctx, recurseTimes + 1, protoProps);
  if (protoConstr === null) {
    return `${res} <${inspect(firstProto, {
      ...ctx,
      customInspect: false,
      depth: -1
    })}>`;
  }
  return `${res} <${protoConstr}>`;
}
function formatPrimitive(fn, value, ctx) {
  if (typeof value === "string") {
    let trailer = "";
    if (value.length > ctx.maxStringLength) {
      const remaining = value.length - ctx.maxStringLength;
      value = value.slice(0, ctx.maxStringLength);
      trailer = `... ${remaining} more character${remaining > 1 ? "s" : ""}`;
    }
    if (ctx.compact !== true && value.length > 16 && value.length > ctx.breakLength - ctx.indentationLvl - 4) {
      return value.split(/(?<=\n)/).map((line) => fn(strEscape(line), "string")).join(` +
${" ".repeat(ctx.indentationLvl + 2)}`) + trailer;
    }
    return fn(strEscape(value), "string") + trailer;
  }
  if (typeof value === "number") {
    return formatNumber(fn, value);
  }
  if (typeof value === "bigint") {
    return formatBigInt(fn, value);
  }
  if (typeof value === "boolean") {
    return fn(`${value}`, "boolean");
  }
  if (typeof value === "undefined") {
    return fn("undefined", "undefined");
  }
  return fn(value.toString(), "symbol");
}
function getEmptyFormatArray() {
  return [];
}
function isInstanceof(object, proto) {
  try {
    return object instanceof proto;
  } catch {
    return false;
  }
}
function getPrefix(constructor, tag, fallback, size = "") {
  if (constructor === null) {
    if (tag !== "" && fallback !== tag) {
      return `[${fallback}${size}: null prototype] [${tag}] `;
    }
    return `[${fallback}${size}: null prototype] `;
  }
  if (tag !== "" && constructor !== tag) {
    return `${constructor}${size} [${tag}] `;
  }
  return `${constructor}${size} `;
}
function formatArray(ctx, value, recurseTimes) {
  const valLen = value.length;
  const len = Math.min(Math.max(0, ctx.maxArrayLength), valLen);
  const remaining = valLen - len;
  const output = [];
  for (let i6 = 0; i6 < len; i6++) {
    if (!value.hasOwnProperty(i6)) {
      return formatSpecialArray(ctx, value, recurseTimes, len, output, i6);
    }
    output.push(formatProperty(ctx, value, recurseTimes, i6, 1));
  }
  if (remaining > 0) {
    output.push(`... ${remaining} more item${remaining > 1 ? "s" : ""}`);
  }
  return output;
}
function getCtxStyle(_value, constructor, tag) {
  let fallback = "";
  if (constructor === null) {
    if (fallback === tag) {
      fallback = "Object";
    }
  }
  return getPrefix(constructor, tag, fallback);
}
function getKeys(value, showHidden) {
  let keys;
  const symbols = Object.getOwnPropertySymbols(value);
  if (showHidden) {
    keys = Object.getOwnPropertyNames(value);
    if (symbols.length !== 0) {
      Array.prototype.push.apply(keys, symbols);
    }
  } else {
    try {
      keys = Object.keys(value);
    } catch (_err) {
      keys = Object.getOwnPropertyNames(value);
    }
    if (symbols.length !== 0) {
    }
  }
  return keys;
}
function formatSet(value, ctx, _ignored, recurseTimes) {
  const output = [];
  ctx.indentationLvl += 2;
  for (const v of value) {
    Array.prototype.push(output, formatValue(ctx, v, recurseTimes));
  }
  ctx.indentationLvl -= 2;
  return output;
}
function formatMap(value, ctx, _gnored, recurseTimes) {
  const output = [];
  ctx.indentationLvl += 2;
  for (const { 0: k, 1: v } of value) {
    output.push(`${formatValue(ctx, k, recurseTimes)} => ${formatValue(ctx, v, recurseTimes)}`);
  }
  ctx.indentationLvl -= 2;
  return output;
}
function formatTypedArray(value, length, ctx, _ignored, recurseTimes) {
  const maxLength = Math.min(Math.max(0, ctx.maxArrayLength), length);
  const remaining = value.length - maxLength;
  const output = new Array(maxLength);
  const elementFormatter = value.length > 0 && typeof value[0] === "number" ? formatNumber : formatBigInt;
  for (let i7 = 0; i7 < maxLength; ++i7) {
    output[i7] = elementFormatter(ctx.stylize, value[i7]);
  }
  if (remaining > 0) {
    output[maxLength] = `... ${remaining} more item${remaining > 1 ? "s" : ""}`;
  }
  if (ctx.showHidden) {
    ctx.indentationLvl += 2;
    for (const key of [
      "BYTES_PER_ELEMENT",
      "length",
      "byteLength",
      "byteOffset",
      "buffer"
    ]) {
      const str = formatValue(ctx, value[key], recurseTimes, true);
      Array.prototype.push(output, `[${key}]: ${str}`);
    }
    ctx.indentationLvl -= 2;
  }
  return output;
}
function getIteratorBraces(type, tag) {
  if (tag !== `${type} Iterator`) {
    if (tag !== "") {
      tag += "] [";
    }
    tag += `${type} Iterator`;
  }
  return [
    `[${tag}] {`,
    "}"
  ];
}
function formatIterator(braces, ctx, value, recurseTimes) {
  const { 0: entries, 1: isKeyValue } = value;
  if (isKeyValue) {
    braces[0] = braces[0].replace(/ Iterator] {$/, " Entries] {");
    return formatMapIterInner(ctx, recurseTimes, entries, 2);
  }
  return formatSetIterInner(ctx, recurseTimes, entries, 1);
}
function getFunctionBase(value, constructor, tag) {
  const stringified = Function.prototype.toString(value);
  if (stringified.slice(0, 5) === "class" && stringified.endsWith("}")) {
    const slice2 = stringified.slice(5, -1);
    const bracketIndex = slice2.indexOf("{");
    if (bracketIndex !== -1 && (!slice2.slice(0, bracketIndex).includes("(") || classRegExp.test(slice2.replace(stripCommentsRegExp)))) {
      return getClassBase(value, constructor, tag);
    }
  }
  let type = "Function";
  if (isGeneratorFunction1(value)) {
    type = `Generator${type}`;
  }
  if (isAsyncFunction1(value)) {
    type = `Async${type}`;
  }
  let base2 = `[${type}`;
  if (constructor === null) {
    base2 += " (null prototype)";
  }
  if (value.name === "") {
    base2 += " (anonymous)";
  } else {
    base2 += `: ${value.name}`;
  }
  base2 += "]";
  if (constructor !== type && constructor !== null) {
    base2 += ` ${constructor}`;
  }
  if (tag !== "" && constructor !== tag) {
    base2 += ` [${tag}]`;
  }
  return base2;
}
function formatError(err, constructor, tag, ctx, keys) {
  const name = err.name != null ? String(err.name) : "Error";
  let len = name.length;
  let stack = err.stack ? String(err.stack) : err.toString();
  if (!ctx.showHidden && keys.length !== 0) {
    for (const name2 of [
      "name",
      "message",
      "stack"
    ]) {
      const index = keys.indexOf(name2);
      if (index !== -1 && stack.includes(err[name2])) {
        keys.splice(index, 1);
      }
    }
  }
  if (constructor === null || name.endsWith("Error") && stack.startsWith(name) && (stack.length === len || stack[len] === ":" || stack[len] === "\n")) {
    let fallback = "Error";
    if (constructor === null) {
      const start = stack.match(/^([A-Z][a-z_ A-Z0-9[\]()-]+)(?::|\n {4}at)/) || stack.match(/^([a-z_A-Z0-9-]*Error)$/);
      fallback = start && start[1] || "";
      len = fallback.length;
      fallback = fallback || "Error";
    }
    const prefix = getPrefix(constructor, tag, fallback).slice(0, -1);
    if (name !== prefix) {
      if (prefix.includes(name)) {
        if (len === 0) {
          stack = `${prefix}: ${stack}`;
        } else {
          stack = `${prefix}${stack.slice(len)}`;
        }
      } else {
        stack = `${prefix} [${name}]${stack.slice(len)}`;
      }
    }
  }
  let pos = err.message && stack.indexOf(err.message) || -1;
  if (pos !== -1) {
    pos += err.message.length;
  }
  const stackStart = stack.indexOf("\n    at", pos);
  if (stackStart === -1) {
    stack = `[${stack}]`;
  } else if (ctx.colors) {
    let newStack = stack.slice(0, stackStart);
    const lines = stack.slice(stackStart + 1).split("\n");
    for (const line of lines) {
      let nodeModule;
      newStack += "\n";
      let pos2 = 0;
      while (nodeModule = nodeModulesRegExp.exec(line)) {
        newStack += line.slice(pos2, nodeModule.index + 14);
        newStack += ctx.stylize(nodeModule[1], "module");
        pos2 = nodeModule.index + nodeModule[0].length;
      }
      newStack += pos2 === 0 ? line : line.slice(pos2);
    }
    stack = newStack;
  }
  if (ctx.indentationLvl !== 0) {
    const indentation = " ".repeat(ctx.indentationLvl);
    stack = stack.replace(/\n/g, `
${indentation}`);
  }
  return stack;
}
var hexSlice;
function formatArrayBuffer(ctx, value) {
  let buffer;
  try {
    buffer = new Uint8Array(value);
  } catch {
    return [
      ctx.stylize("(detached)", "special")
    ];
  }
  let str = hexSlice(buffer, 0, Math.min(ctx.maxArrayLength, buffer.length)).replace(/(.{2})/g, "$1 ").trim();
  const remaining = buffer.length - ctx.maxArrayLength;
  if (remaining > 0) {
    str += ` ... ${remaining} more byte${remaining > 1 ? "s" : ""}`;
  }
  return [
    `${ctx.stylize("[Uint8Contents]", "special")}: <${str}>`
  ];
}
function formatNumber(fn, value) {
  return fn(Object.is(value, -0) ? "-0" : `${value}`, "number");
}
function formatPromise(ctx, value, recurseTimes) {
  let output;
  const { 0: state, 1: result } = value;
  if (state === 0) {
    output = [
      ctx.stylize("<pending>", "special")
    ];
  } else {
    ctx.indentationLvl += 2;
    const str = formatValue(ctx, result, recurseTimes);
    ctx.indentationLvl -= 2;
    output = [
      state === kRejected ? `${ctx.stylize("<rejected>", "special")} ${str}` : str
    ];
  }
  return output;
}
function formatWeakCollection(ctx) {
  return [
    ctx.stylize("<items unknown>", "special")
  ];
}
function formatWeakSet(ctx, value, recurseTimes) {
  const entries = value;
  return formatSetIterInner(ctx, recurseTimes, entries, 0);
}
function formatWeakMap(ctx, value, recurseTimes) {
  const entries = value;
  return formatMapIterInner(ctx, recurseTimes, entries, 0);
}
function formatProperty(ctx, value, recurseTimes, key, type, desc, original = value) {
  let name, str;
  let extra = " ";
  desc = desc || Object.getOwnPropertyDescriptor(value, key) || {
    value: value[key],
    enumerable: true
  };
  if (desc.value !== void 0) {
    const diff = ctx.compact !== true || type !== 0 ? 2 : 3;
    ctx.indentationLvl += diff;
    str = formatValue(ctx, desc.value, recurseTimes);
    if (diff === 3 && ctx.breakLength < getStringWidth(str, ctx.colors)) {
      extra = `
${" ".repeat(ctx.indentationLvl)}`;
    }
    ctx.indentationLvl -= diff;
  } else if (desc.get !== void 0) {
    const label = desc.set !== void 0 ? "Getter/Setter" : "Getter";
    const s = ctx.stylize;
    const sp = "special";
    if (ctx.getters && (ctx.getters === true || ctx.getters === "get" && desc.set === void 0 || ctx.getters === "set" && desc.set !== void 0)) {
      try {
        const tmp = desc.get.call(original);
        ctx.indentationLvl += 2;
        if (tmp === null) {
          str = `${s(`[${label}:`, sp)} ${s("null", "null")}${s("]", sp)}`;
        } else if (typeof tmp === "object") {
          str = `${s(`[${label}]`, sp)} ${formatValue(ctx, tmp, recurseTimes)}`;
        } else {
          const primitive = formatPrimitive(s, tmp, ctx);
          str = `${s(`[${label}:`, sp)} ${primitive}${s("]", sp)}`;
        }
        ctx.indentationLvl -= 2;
      } catch (err) {
        const message = `<Inspection threw (${err.message})>`;
        str = `${s(`[${label}:`, sp)} ${message}${s("]", sp)}`;
      }
    } else {
      str = ctx.stylize(`[${label}]`, sp);
    }
  } else if (desc.set !== void 0) {
    str = ctx.stylize("[Setter]", "special");
  } else {
    str = ctx.stylize("undefined", "undefined");
  }
  if (type === 1) {
    return str;
  }
  if (typeof key === "symbol") {
    const tmp = key.toString().replace(strEscapeSequencesReplacer, escapeFn);
    name = `[${ctx.stylize(tmp, "symbol")}]`;
  } else if (key === "__proto__") {
    name = "['__proto__']";
  } else if (desc.enumerable === false) {
    const tmp = key.replace(strEscapeSequencesReplacer, escapeFn);
    name = `[${tmp}]`;
  } else if (keyStrRegExp.test(key)) {
    name = ctx.stylize(key, "name");
  } else {
    name = ctx.stylize(strEscape(key), "string");
  }
  return `${name}:${extra}${str}`;
}
function handleMaxCallStackSize(_ctx, _err, _constructorName, _indentationLvl) {
}
var colorRegExp = /\u001b\[\d\d?m/g;
function removeColors(str) {
  return str.replace(colorRegExp, "");
}
function isBelowBreakLength(ctx, output, start, base3) {
  let totalLength = output.length + start;
  if (totalLength + output.length > ctx.breakLength) {
    return false;
  }
  for (let i8 = 0; i8 < output.length; i8++) {
    if (ctx.colors) {
      totalLength += removeColors(output[i8]).length;
    } else {
      totalLength += output[i8].length;
    }
    if (totalLength > ctx.breakLength) {
      return false;
    }
  }
  return base3 === "" || !base3.includes("\n");
}
function formatBigInt(fn, value) {
  return fn(`${value}n`, "bigint");
}
function formatNamespaceObject(keys, ctx, value, recurseTimes) {
  const output = new Array(keys.length);
  for (let i9 = 0; i9 < keys.length; i9++) {
    try {
      output[i9] = formatProperty(ctx, value, recurseTimes, keys[i9], kObjectType);
    } catch (_err) {
      const tmp = {
        [keys[i9]]: ""
      };
      output[i9] = formatProperty(ctx, tmp, recurseTimes, keys[i9], kObjectType);
      const pos = output[i9].lastIndexOf(" ");
      output[i9] = output[i9].slice(0, pos + 1) + ctx.stylize("<uninitialized>", "special");
    }
  }
  keys.length = 0;
  return output;
}
function formatSpecialArray(ctx, value, recurseTimes, maxLength, output, i10) {
  const keys = Object.keys(value);
  let index = i10;
  for (; i10 < keys.length && output.length < maxLength; i10++) {
    const key = keys[i10];
    const tmp = +key;
    if (tmp > 2 ** 32 - 2) {
      break;
    }
    if (`${index}` !== key) {
      if (!numberRegExp.test(key)) {
        break;
      }
      const emptyItems = tmp - index;
      const ending = emptyItems > 1 ? "s" : "";
      const message = `<${emptyItems} empty item${ending}>`;
      output.push(ctx.stylize(message, "undefined"));
      index = tmp;
      if (output.length === maxLength) {
        break;
      }
    }
    output.push(formatProperty(ctx, value, recurseTimes, key, 1));
    index++;
  }
  const remaining = value.length - index;
  if (output.length !== maxLength) {
    if (remaining > 0) {
      const ending = remaining > 1 ? "s" : "";
      const message = `<${remaining} empty item${ending}>`;
      output.push(ctx.stylize(message, "undefined"));
    }
  } else if (remaining > 0) {
    output.push(`... ${remaining} more item${remaining > 1 ? "s" : ""}`);
  }
  return output;
}
function getBoxedBase(value, ctx, keys, constructor, tag) {
  let type;
  if (isNumberObject1(value)) {
    type = "Number";
  } else if (isStringObject1(value)) {
    type = "String";
    keys.splice(0, value.length);
  } else if (isBooleanObject1(value)) {
    type = "Boolean";
  } else if (isBigIntObject1(value)) {
    type = "BigInt";
  } else {
    type = "Symbol";
  }
  let base4 = `[${type}`;
  if (type !== constructor) {
    if (constructor === null) {
      base4 += " (null prototype)";
    } else {
      base4 += ` (${constructor})`;
    }
  }
  base4 += `: ${formatPrimitive(stylizeNoColor, value.valueOf(), ctx)}]`;
  if (tag !== "" && tag !== constructor) {
    base4 += ` [${tag}]`;
  }
  if (keys.length !== 0 || ctx.stylize === stylizeNoColor) {
    return base4;
  }
  return ctx.stylize(base4, type.toLowerCase());
}
function getClassBase(value, constructor, tag) {
  const hasName = value.hasOwnProperty("name");
  const name = hasName && value.name || "(anonymous)";
  let base5 = `class ${name}`;
  if (constructor !== "Function" && constructor !== null) {
    base5 += ` [${constructor}]`;
  }
  if (tag !== "" && constructor !== tag) {
    base5 += ` [${tag}]`;
  }
  if (constructor !== null) {
    const superName = Object.getPrototypeOf(value).name;
    if (superName) {
      base5 += ` extends ${superName}`;
    }
  } else {
    base5 += " extends [null prototype]";
  }
  return `[${base5}]`;
}
function reduceToSingleString(ctx, output, base6, braces, extrasType, recurseTimes, value) {
  if (ctx.compact !== true) {
    if (typeof ctx.compact === "number" && ctx.compact >= 1) {
      const entries = output.length;
      if (extrasType === 2 && entries > 6) {
        output = groupArrayElements(ctx, output, value);
      }
      if (ctx.currentDepth - recurseTimes < ctx.compact && entries === output.length) {
        const start = output.length + ctx.indentationLvl + braces[0].length + base6.length + 10;
        if (isBelowBreakLength(ctx, output, start, base6)) {
          return `${base6 ? `${base6} ` : ""}${braces[0]} ${join(output, ", ")} ${braces[1]}`;
        }
      }
    }
    const indentation2 = `
${" ".repeat(ctx.indentationLvl)}`;
    return `${base6 ? `${base6} ` : ""}${braces[0]}${indentation2}  ${join(output, `,${indentation2}  `)}${indentation2}${braces[1]}`;
  }
  if (isBelowBreakLength(ctx, output, 0, base6)) {
    return `${braces[0]}${base6 ? ` ${base6}` : ""} ${join(output, ", ")} ` + braces[1];
  }
  const indentation = " ".repeat(ctx.indentationLvl);
  const ln = base6 === "" && braces[0].length === 1 ? " " : `${base6 ? ` ${base6}` : ""}
${indentation}  `;
  return `${braces[0]}${ln}${join(output, `,
${indentation}  `)} ${braces[1]}`;
}
function join(output, separator) {
  let str = "";
  if (output.length !== 0) {
    const lastIndex = output.length - 1;
    for (let i11 = 0; i11 < lastIndex; i11++) {
      str += output[i11];
      str += separator;
    }
    str += output[lastIndex];
  }
  return str;
}
function groupArrayElements(ctx, output, value) {
  let totalLength = 0;
  let maxLength = 0;
  let i12 = 0;
  let outputLength = output.length;
  if (ctx.maxArrayLength < output.length) {
    outputLength--;
  }
  const separatorSpace = 2;
  const dataLen = new Array(outputLength);
  for (; i12 < outputLength; i12++) {
    const len = getStringWidth(output[i12], ctx.colors);
    dataLen[i12] = len;
    totalLength += len + separatorSpace;
    if (maxLength < len) {
      maxLength = len;
    }
  }
  const actualMax = maxLength + 2;
  if (actualMax * 3 + ctx.indentationLvl < ctx.breakLength && (totalLength / actualMax > 5 || maxLength <= 6)) {
    const averageBias = Math.sqrt(actualMax - totalLength / output.length);
    const biasedMax = Math.max(actualMax - 3 - averageBias, 1);
    const columns = Math.min(Math.round(Math.sqrt(2.5 * biasedMax * outputLength) / biasedMax), Math.floor((ctx.breakLength - ctx.indentationLvl) / actualMax), ctx.compact * 4, 15);
    if (columns <= 1) {
      return output;
    }
    const tmp = [];
    const maxLineLength = [];
    for (let i13 = 0; i13 < columns; i13++) {
      let lineMaxLength = 0;
      for (let j = i13; j < output.length; j += columns) {
        if (dataLen[j] > lineMaxLength) {
          lineMaxLength = dataLen[j];
        }
      }
      lineMaxLength += separatorSpace;
      maxLineLength[i13] = lineMaxLength;
    }
    let order = String.prototype.padStart;
    if (value !== void 0) {
      for (let i14 = 0; i14 < output.length; i14++) {
        if (typeof value[i14] !== "number" && typeof value[i14] !== "bigint") {
          order = String.prototype.padEnd;
          break;
        }
      }
    }
    for (let i1 = 0; i1 < outputLength; i1 += columns) {
      const max = Math.min(i1 + columns, outputLength);
      let str = "";
      let j = i1;
      for (; j < max - 1; j++) {
        const padding = maxLineLength[j - i1] + output[j].length - dataLen[j];
        str += `${output[j]}, `.padStart(padding, " ");
      }
      if (order === String.prototype.padStart) {
        const padding = maxLineLength[j - i1] + output[j].length - dataLen[j] - 2;
        str += output[j].padStart(padding, " ");
      } else {
        str += output[j];
      }
      Array.prototype.push(tmp, str);
    }
    if (ctx.maxArrayLength < output.length) {
      Array.prototype.push(tmp, output[outputLength]);
    }
    output = tmp;
  }
  return output;
}
function formatMapIterInner(ctx, recurseTimes, entries, state) {
  const maxArrayLength = Math.max(ctx.maxArrayLength, 0);
  const len = entries.length / 2;
  const remaining = len - maxArrayLength;
  const maxLength = Math.min(maxArrayLength, len);
  let output = new Array(maxLength);
  let i15 = 0;
  ctx.indentationLvl += 2;
  if (state === 0) {
    for (; i15 < maxLength; i15++) {
      const pos = i15 * 2;
      output[i15] = `${formatValue(ctx, entries[pos], recurseTimes)} => ${formatValue(ctx, entries[pos + 1], recurseTimes)}`;
    }
    if (!ctx.sorted) {
      output = output.sort();
    }
  } else {
    for (; i15 < maxLength; i15++) {
      const pos = i15 * 2;
      const res = [
        formatValue(ctx, entries[pos], recurseTimes),
        formatValue(ctx, entries[pos + 1], recurseTimes)
      ];
      output[i15] = reduceToSingleString(ctx, res, "", [
        "[",
        "]"
      ], kArrayExtrasType, recurseTimes);
    }
  }
  ctx.indentationLvl -= 2;
  if (remaining > 0) {
    output.push(`... ${remaining} more item${remaining > 1 ? "s" : ""}`);
  }
  return output;
}
function formatSetIterInner(ctx, recurseTimes, entries, state) {
  const maxArrayLength = Math.max(ctx.maxArrayLength, 0);
  const maxLength = Math.min(maxArrayLength, entries.length);
  const output = new Array(maxLength);
  ctx.indentationLvl += 2;
  for (let i16 = 0; i16 < maxLength; i16++) {
    output[i16] = formatValue(ctx, entries[i16], recurseTimes);
  }
  ctx.indentationLvl -= 2;
  if (state === 0 && !ctx.sorted) {
    output.sort();
  }
  const remaining = entries.length - maxLength;
  if (remaining > 0) {
    Array.prototype.push(output, `... ${remaining} more item${remaining > 1 ? "s" : ""}`);
  }
  return output;
}
var ansiPattern = "[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)|(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))";
var ansi = new RegExp(ansiPattern, "g");
function getStringWidth(str, removeControlChars = true) {
  let width = 0;
  if (removeControlChars) {
    str = stripVTControlCharacters(str);
  }
  str = str.normalize("NFC");
  for (const __char of str[Symbol.iterator]()) {
    const code = __char.codePointAt(0);
    if (isFullWidthCodePoint(code)) {
      width += 2;
    } else if (!isZeroWidthCodePoint(code)) {
      width++;
    }
  }
  return width;
}
var isFullWidthCodePoint = (code) => {
  return code >= 4352 && (code <= 4447 || code === 9001 || code === 9002 || code >= 11904 && code <= 12871 && code !== 12351 || code >= 12880 && code <= 19903 || code >= 19968 && code <= 42182 || code >= 43360 && code <= 43388 || code >= 44032 && code <= 55203 || code >= 63744 && code <= 64255 || code >= 65040 && code <= 65049 || code >= 65072 && code <= 65131 || code >= 65281 && code <= 65376 || code >= 65504 && code <= 65510 || code >= 110592 && code <= 110593 || code >= 127488 && code <= 127569 || code >= 127744 && code <= 128591 || code >= 131072 && code <= 262141);
};
var isZeroWidthCodePoint = (code) => {
  return code <= 31 || code >= 127 && code <= 159 || code >= 768 && code <= 879 || code >= 8203 && code <= 8207 || code >= 8400 && code <= 8447 || code >= 65024 && code <= 65039 || code >= 65056 && code <= 65071 || code >= 917760 && code <= 917999;
};
function stripVTControlCharacters(str) {
  validateString(str, "str");
  return str.replace(ansi, "");
}
Symbol.for("nodejs.util.inspect.custom");
var kEnumerableProperty = /* @__PURE__ */ Object.create(null);
kEnumerableProperty.enumerable = true;
function once(callback) {
  let called = false;
  return function(...args) {
    if (called)
      return;
    called = true;
    Reflect.apply(callback, this, args);
  };
}
function createDeferredPromise() {
  let resolve7;
  let reject;
  const promise = new Promise((res, rej) => {
    resolve7 = res;
    reject = rej;
  });
  return {
    promise,
    resolve: resolve7,
    reject
  };
}
var kCustomPromisifiedSymbol = Symbol.for("nodejs.util.promisify.custom");
var kCustomPromisifyArgsSymbol = Symbol.for("nodejs.util.promisify.customArgs");
var customPromisifyArgs = kCustomPromisifyArgsSymbol;
function promisify(original) {
  validateFunction(original, "original");
  if (original[kCustomPromisifiedSymbol]) {
    const fn2 = original[kCustomPromisifiedSymbol];
    validateFunction(fn2, "util.promisify.custom");
    return Object.defineProperty(fn2, kCustomPromisifiedSymbol, {
      value: fn2,
      enumerable: false,
      writable: false,
      configurable: true
    });
  }
  const argumentNames = original[kCustomPromisifyArgsSymbol];
  function fn(...args) {
    return new Promise((resolve8, reject) => {
      args.push((err, ...values) => {
        if (err) {
          return reject(err);
        }
        if (argumentNames !== void 0 && values.length > 1) {
          const obj = {};
          for (let i17 = 0; i17 < argumentNames.length; i17++) {
            obj[argumentNames[i17]] = values[i17];
          }
          resolve8(obj);
        } else {
          resolve8(values[0]);
        }
      });
      Reflect.apply(original, this, args);
    });
  }
  Object.setPrototypeOf(fn, Object.getPrototypeOf(original));
  Object.defineProperty(fn, kCustomPromisifiedSymbol, {
    value: fn,
    enumerable: false,
    writable: false,
    configurable: true
  });
  return Object.defineProperties(fn, Object.getOwnPropertyDescriptors(original));
}
promisify.custom = kCustomPromisifiedSymbol;
var core;
if (workerDeno_core) {
  core = workerDeno_core;
} else {
  core = {
    setNextTickCallback: void 0,
    evalContext(_code, _filename) {
      throw new Error("Deno.core.evalContext is not supported in this environment");
    },
    encode(chunk) {
      return new TextEncoder().encode(chunk);
    }
  };
}
var _exiting = false;
var kSize = 2048;
var kMask = 2048 - 1;
var FixedCircularBuffer = class {
  bottom;
  top;
  list;
  next;
  constructor() {
    this.bottom = 0;
    this.top = 0;
    this.list = new Array(kSize);
    this.next = null;
  }
  isEmpty() {
    return this.top === this.bottom;
  }
  isFull() {
    return (this.top + 1 & kMask) === this.bottom;
  }
  push(data) {
    this.list[this.top] = data;
    this.top = this.top + 1 & kMask;
  }
  shift() {
    const nextItem = this.list[this.bottom];
    if (nextItem === void 0) {
      return null;
    }
    this.list[this.bottom] = void 0;
    this.bottom = this.bottom + 1 & kMask;
    return nextItem;
  }
};
var FixedQueue = class {
  head;
  tail;
  constructor() {
    this.head = this.tail = new FixedCircularBuffer();
  }
  isEmpty() {
    return this.head.isEmpty();
  }
  push(data) {
    if (this.head.isFull()) {
      this.head = this.head.next = new FixedCircularBuffer();
    }
    this.head.push(data);
  }
  shift() {
    const tail = this.tail;
    const next = tail.shift();
    if (tail.isEmpty() && tail.next !== null) {
      this.tail = tail.next;
    }
    return next;
  }
};
var queue = new FixedQueue();
var _nextTick;
if (typeof core.setNextTickCallback !== "undefined") {
  let runNextTicks = function() {
    if (!core.hasTickScheduled()) {
      core.runMicrotasks();
    }
    if (!core.hasTickScheduled()) {
      return true;
    }
    processTicksAndRejections();
    return true;
  }, processTicksAndRejections = function() {
    let tock;
    do {
      while (tock = queue.shift()) {
        try {
          const callback = tock.callback;
          if (tock.args === void 0) {
            callback();
          } else {
            const args = tock.args;
            switch (args.length) {
              case 1:
                callback(args[0]);
                break;
              case 2:
                callback(args[0], args[1]);
                break;
              case 3:
                callback(args[0], args[1], args[2]);
                break;
              case 4:
                callback(args[0], args[1], args[2], args[3]);
                break;
              default:
                callback(...args);
            }
          }
        } finally {
        }
      }
      core.runMicrotasks();
    } while (!queue.isEmpty());
    core.setHasTickScheduled(false);
  }, __nextTickNative = function(callback, ...args) {
    validateCallback(callback);
    if (_exiting) {
      return;
    }
    let args_;
    switch (args.length) {
      case 0:
        break;
      case 1:
        args_ = [
          args[0]
        ];
        break;
      case 2:
        args_ = [
          args[0],
          args[1]
        ];
        break;
      case 3:
        args_ = [
          args[0],
          args[1],
          args[2]
        ];
        break;
      default:
        args_ = new Array(args.length);
        for (let i18 = 0; i18 < args.length; i18++) {
          args_[i18] = args[i18];
        }
    }
    if (queue.isEmpty()) {
      core.setHasTickScheduled(true);
    }
    const tickObject = {
      callback,
      args: args_
    };
    queue.push(tickObject);
  };
  core.setNextTickCallback(processTicksAndRejections);
  core.setMacrotaskCallback(runNextTicks);
  _nextTick = __nextTickNative;
} else {
  let __nextTickQueueMicrotask = function(callback, ...args) {
    if (args) {
      queueMicrotask(() => callback.call(this, ...args));
    } else {
      queueMicrotask(callback);
    }
  };
  _nextTick = __nextTickQueueMicrotask;
}
function nextTick2(callback, ...args) {
  _nextTick(callback, ...args);
}
var State;
(function(State1) {
  State1[State1["PASSTHROUGH"] = 0] = "PASSTHROUGH";
  State1[State1["PERCENT"] = 1] = "PERCENT";
  State1[State1["POSITIONAL"] = 2] = "POSITIONAL";
  State1[State1["PRECISION"] = 3] = "PRECISION";
  State1[State1["WIDTH"] = 4] = "WIDTH";
})(State || (State = {}));
var WorP;
(function(WorP1) {
  WorP1[WorP1["WIDTH"] = 0] = "WIDTH";
  WorP1[WorP1["PRECISION"] = 1] = "PRECISION";
})(WorP || (WorP = {}));
var Flags = class {
  plus;
  dash;
  sharp;
  space;
  zero;
  lessthan;
  width = -1;
  precision = -1;
};
var min = Math.min;
var UNICODE_REPLACEMENT_CHARACTER = "\uFFFD";
var FLOAT_REGEXP = /(-?)(\d)\.?(\d*)e([+-])(\d+)/;
var F;
(function(F1) {
  F1[F1["sign"] = 1] = "sign";
  F1[F1["mantissa"] = 2] = "mantissa";
  F1[F1["fractional"] = 3] = "fractional";
  F1[F1["esign"] = 4] = "esign";
  F1[F1["exponent"] = 5] = "exponent";
})(F || (F = {}));
var Printf = class {
  format;
  args;
  i;
  state = State.PASSTHROUGH;
  verb = "";
  buf = "";
  argNum = 0;
  flags = new Flags();
  haveSeen;
  tmpError;
  constructor(format3, ...args) {
    this.format = format3;
    this.args = args;
    this.haveSeen = Array.from({
      length: args.length
    });
    this.i = 0;
  }
  doPrintf() {
    for (; this.i < this.format.length; ++this.i) {
      const c = this.format[this.i];
      switch (this.state) {
        case State.PASSTHROUGH:
          if (c === "%") {
            this.state = State.PERCENT;
          } else {
            this.buf += c;
          }
          break;
        case State.PERCENT:
          if (c === "%") {
            this.buf += c;
            this.state = State.PASSTHROUGH;
          } else {
            this.handleFormat();
          }
          break;
        default:
          throw Error("Should be unreachable, certainly a bug in the lib.");
      }
    }
    let extras = false;
    let err = "%!(EXTRA";
    for (let i19 = 0; i19 !== this.haveSeen.length; ++i19) {
      if (!this.haveSeen[i19]) {
        extras = true;
        err += ` '${workerDeno_inspect(this.args[i19])}'`;
      }
    }
    err += ")";
    if (extras) {
      this.buf += err;
    }
    return this.buf;
  }
  handleFormat() {
    this.flags = new Flags();
    const flags = this.flags;
    for (; this.i < this.format.length; ++this.i) {
      const c = this.format[this.i];
      switch (this.state) {
        case State.PERCENT:
          switch (c) {
            case "[":
              this.handlePositional();
              this.state = State.POSITIONAL;
              break;
            case "+":
              flags.plus = true;
              break;
            case "<":
              flags.lessthan = true;
              break;
            case "-":
              flags.dash = true;
              flags.zero = false;
              break;
            case "#":
              flags.sharp = true;
              break;
            case " ":
              flags.space = true;
              break;
            case "0":
              flags.zero = !flags.dash;
              break;
            default:
              if ("1" <= c && c <= "9" || c === "." || c === "*") {
                if (c === ".") {
                  this.flags.precision = 0;
                  this.state = State.PRECISION;
                  this.i++;
                } else {
                  this.state = State.WIDTH;
                }
                this.handleWidthAndPrecision(flags);
              } else {
                this.handleVerb();
                return;
              }
          }
          break;
        case State.POSITIONAL:
          if (c === "*") {
            const worp = this.flags.precision === -1 ? WorP.WIDTH : WorP.PRECISION;
            this.handleWidthOrPrecisionRef(worp);
            this.state = State.PERCENT;
            break;
          } else {
            this.handleVerb();
            return;
          }
        default:
          throw new Error(`Should not be here ${this.state}, library bug!`);
      }
    }
  }
  handleWidthOrPrecisionRef(wOrP) {
    if (this.argNum >= this.args.length) {
      return;
    }
    const arg = this.args[this.argNum];
    this.haveSeen[this.argNum] = true;
    if (typeof arg === "number") {
      switch (wOrP) {
        case WorP.WIDTH:
          this.flags.width = arg;
          break;
        default:
          this.flags.precision = arg;
      }
    } else {
      const tmp = wOrP === WorP.WIDTH ? "WIDTH" : "PREC";
      this.tmpError = `%!(BAD ${tmp} '${this.args[this.argNum]}')`;
    }
    this.argNum++;
  }
  handleWidthAndPrecision(flags) {
    const fmt = this.format;
    for (; this.i !== this.format.length; ++this.i) {
      const c = fmt[this.i];
      switch (this.state) {
        case State.WIDTH:
          switch (c) {
            case ".":
              this.flags.precision = 0;
              this.state = State.PRECISION;
              break;
            case "*":
              this.handleWidthOrPrecisionRef(WorP.WIDTH);
              break;
            default: {
              const val = parseInt(c);
              if (isNaN(val)) {
                this.i--;
                this.state = State.PERCENT;
                return;
              }
              flags.width = flags.width == -1 ? 0 : flags.width;
              flags.width *= 10;
              flags.width += val;
            }
          }
          break;
        case State.PRECISION: {
          if (c === "*") {
            this.handleWidthOrPrecisionRef(WorP.PRECISION);
            break;
          }
          const val = parseInt(c);
          if (isNaN(val)) {
            this.i--;
            this.state = State.PERCENT;
            return;
          }
          flags.precision *= 10;
          flags.precision += val;
          break;
        }
        default:
          throw new Error("can't be here. bug.");
      }
    }
  }
  handlePositional() {
    if (this.format[this.i] !== "[") {
      throw new Error("Can't happen? Bug.");
    }
    let positional = 0;
    const format4 = this.format;
    this.i++;
    let err = false;
    for (; this.i !== this.format.length; ++this.i) {
      if (format4[this.i] === "]") {
        break;
      }
      positional *= 10;
      const val = parseInt(format4[this.i]);
      if (isNaN(val)) {
        this.tmpError = "%!(BAD INDEX)";
        err = true;
      }
      positional += val;
    }
    if (positional - 1 >= this.args.length) {
      this.tmpError = "%!(BAD INDEX)";
      err = true;
    }
    this.argNum = err ? this.argNum : positional - 1;
    return;
  }
  handleLessThan() {
    const arg = this.args[this.argNum];
    if ((arg || {}).constructor.name !== "Array") {
      throw new Error(`arg ${arg} is not an array. Todo better error handling`);
    }
    let str = "[ ";
    for (let i20 = 0; i20 !== arg.length; ++i20) {
      if (i20 !== 0)
        str += ", ";
      str += this._handleVerb(arg[i20]);
    }
    return str + " ]";
  }
  handleVerb() {
    const verb = this.format[this.i];
    this.verb = verb;
    if (this.tmpError) {
      this.buf += this.tmpError;
      this.tmpError = void 0;
      if (this.argNum < this.haveSeen.length) {
        this.haveSeen[this.argNum] = true;
      }
    } else if (this.args.length <= this.argNum) {
      this.buf += `%!(MISSING '${verb}')`;
    } else {
      const arg = this.args[this.argNum];
      this.haveSeen[this.argNum] = true;
      if (this.flags.lessthan) {
        this.buf += this.handleLessThan();
      } else {
        this.buf += this._handleVerb(arg);
      }
    }
    this.argNum++;
    this.state = State.PASSTHROUGH;
  }
  _handleVerb(arg) {
    switch (this.verb) {
      case "t":
        return this.pad(arg.toString());
      case "b":
        return this.fmtNumber(arg, 2);
      case "c":
        return this.fmtNumberCodePoint(arg);
      case "d":
        return this.fmtNumber(arg, 10);
      case "o":
        return this.fmtNumber(arg, 8);
      case "x":
        return this.fmtHex(arg);
      case "X":
        return this.fmtHex(arg, true);
      case "e":
        return this.fmtFloatE(arg);
      case "E":
        return this.fmtFloatE(arg, true);
      case "f":
      case "F":
        return this.fmtFloatF(arg);
      case "g":
        return this.fmtFloatG(arg);
      case "G":
        return this.fmtFloatG(arg, true);
      case "s":
        return this.fmtString(arg);
      case "T":
        return this.fmtString(typeof arg);
      case "v":
        return this.fmtV(arg);
      case "j":
        return this.fmtJ(arg);
      default:
        return `%!(BAD VERB '${this.verb}')`;
    }
  }
  pad(s) {
    const padding = this.flags.zero ? "0" : " ";
    if (this.flags.dash) {
      return s.padEnd(this.flags.width, padding);
    }
    return s.padStart(this.flags.width, padding);
  }
  padNum(nStr, neg) {
    let sign;
    if (neg) {
      sign = "-";
    } else if (this.flags.plus || this.flags.space) {
      sign = this.flags.plus ? "+" : " ";
    } else {
      sign = "";
    }
    const zero = this.flags.zero;
    if (!zero) {
      nStr = sign + nStr;
    }
    const pad = zero ? "0" : " ";
    const len = zero ? this.flags.width - sign.length : this.flags.width;
    if (this.flags.dash) {
      nStr = nStr.padEnd(len, pad);
    } else {
      nStr = nStr.padStart(len, pad);
    }
    if (zero) {
      nStr = sign + nStr;
    }
    return nStr;
  }
  fmtNumber(n, radix, upcase = false) {
    let num = Math.abs(n).toString(radix);
    const prec = this.flags.precision;
    if (prec !== -1) {
      this.flags.zero = false;
      num = n === 0 && prec === 0 ? "" : num;
      while (num.length < prec) {
        num = "0" + num;
      }
    }
    let prefix = "";
    if (this.flags.sharp) {
      switch (radix) {
        case 2:
          prefix += "0b";
          break;
        case 8:
          prefix += num.startsWith("0") ? "" : "0";
          break;
        case 16:
          prefix += "0x";
          break;
        default:
          throw new Error("cannot handle base: " + radix);
      }
    }
    num = num.length === 0 ? num : prefix + num;
    if (upcase) {
      num = num.toUpperCase();
    }
    return this.padNum(num, n < 0);
  }
  fmtNumberCodePoint(n) {
    let s = "";
    try {
      s = String.fromCodePoint(n);
    } catch {
      s = UNICODE_REPLACEMENT_CHARACTER;
    }
    return this.pad(s);
  }
  fmtFloatSpecial(n) {
    if (isNaN(n)) {
      this.flags.zero = false;
      return this.padNum("NaN", false);
    }
    if (n === Number.POSITIVE_INFINITY) {
      this.flags.zero = false;
      this.flags.plus = true;
      return this.padNum("Inf", false);
    }
    if (n === Number.NEGATIVE_INFINITY) {
      this.flags.zero = false;
      return this.padNum("Inf", true);
    }
    return "";
  }
  roundFractionToPrecision(fractional, precision) {
    let round = false;
    if (fractional.length > precision) {
      fractional = "1" + fractional;
      let tmp = parseInt(fractional.substr(0, precision + 2)) / 10;
      tmp = Math.round(tmp);
      fractional = Math.floor(tmp).toString();
      round = fractional[0] === "2";
      fractional = fractional.substr(1);
    } else {
      while (fractional.length < precision) {
        fractional += "0";
      }
    }
    return [
      fractional,
      round
    ];
  }
  fmtFloatE(n, upcase = false) {
    const special = this.fmtFloatSpecial(n);
    if (special !== "") {
      return special;
    }
    const m = n.toExponential().match(FLOAT_REGEXP);
    if (!m) {
      throw Error("can't happen, bug");
    }
    let fractional = m[F.fractional];
    const precision = this.flags.precision !== -1 ? this.flags.precision : 6;
    let rounding = false;
    [fractional, rounding] = this.roundFractionToPrecision(fractional, precision);
    let e = m[F.exponent];
    let esign = m[F.esign];
    let mantissa = parseInt(m[F.mantissa]);
    if (rounding) {
      mantissa += 1;
      if (10 <= mantissa) {
        mantissa = 1;
        const r = parseInt(esign + e) + 1;
        e = r.toString();
        esign = r < 0 ? "-" : "+";
      }
    }
    e = e.length == 1 ? "0" + e : e;
    const val = `${mantissa}.${fractional}${upcase ? "E" : "e"}${esign}${e}`;
    return this.padNum(val, n < 0);
  }
  fmtFloatF(n1) {
    const special = this.fmtFloatSpecial(n1);
    if (special !== "") {
      return special;
    }
    function expandNumber(n) {
      if (Number.isSafeInteger(n)) {
        return n.toString() + ".";
      }
      const t = n.toExponential().split("e");
      let m = t[0].replace(".", "");
      const e = parseInt(t[1]);
      if (e < 0) {
        let nStr = "0.";
        for (let i21 = 0; i21 !== Math.abs(e) - 1; ++i21) {
          nStr += "0";
        }
        return nStr += m;
      } else {
        const splIdx = e + 1;
        while (m.length < splIdx) {
          m += "0";
        }
        return m.substr(0, splIdx) + "." + m.substr(splIdx);
      }
    }
    const val = expandNumber(Math.abs(n1));
    const arr = val.split(".");
    let dig = arr[0];
    let fractional = arr[1];
    const precision = this.flags.precision !== -1 ? this.flags.precision : 6;
    let round = false;
    [fractional, round] = this.roundFractionToPrecision(fractional, precision);
    if (round) {
      dig = (parseInt(dig) + 1).toString();
    }
    return this.padNum(`${dig}.${fractional}`, n1 < 0);
  }
  fmtFloatG(n, upcase = false) {
    const special = this.fmtFloatSpecial(n);
    if (special !== "") {
      return special;
    }
    let P = this.flags.precision !== -1 ? this.flags.precision : 6;
    P = P === 0 ? 1 : P;
    const m = n.toExponential().match(FLOAT_REGEXP);
    if (!m) {
      throw Error("can't happen");
    }
    const X = parseInt(m[F.exponent]) * (m[F.esign] === "-" ? -1 : 1);
    let nStr = "";
    if (P > X && X >= -4) {
      this.flags.precision = P - (X + 1);
      nStr = this.fmtFloatF(n);
      if (!this.flags.sharp) {
        nStr = nStr.replace(/\.?0*$/, "");
      }
    } else {
      this.flags.precision = P - 1;
      nStr = this.fmtFloatE(n);
      if (!this.flags.sharp) {
        nStr = nStr.replace(/\.?0*e/, upcase ? "E" : "e");
      }
    }
    return nStr;
  }
  fmtString(s) {
    if (this.flags.precision !== -1) {
      s = s.substr(0, this.flags.precision);
    }
    return this.pad(s);
  }
  fmtHex(val, upper = false) {
    switch (typeof val) {
      case "number":
        return this.fmtNumber(val, 16, upper);
      case "string": {
        const sharp = this.flags.sharp && val.length !== 0;
        let hex = sharp ? "0x" : "";
        const prec = this.flags.precision;
        const end = prec !== -1 ? min(prec, val.length) : val.length;
        for (let i22 = 0; i22 !== end; ++i22) {
          if (i22 !== 0 && this.flags.space) {
            hex += sharp ? " 0x" : " ";
          }
          const c = (val.charCodeAt(i22) & 255).toString(16);
          hex += c.length === 1 ? `0${c}` : c;
        }
        if (upper) {
          hex = hex.toUpperCase();
        }
        return this.pad(hex);
      }
      default:
        throw new Error("currently only number and string are implemented for hex");
    }
  }
  fmtV(val) {
    if (this.flags.sharp) {
      const options = this.flags.precision !== -1 ? {
        depth: this.flags.precision
      } : {};
      return this.pad(workerDeno_inspect(val, options));
    } else {
      const p = this.flags.precision;
      return p === -1 ? val.toString() : val.toString().substr(0, p);
    }
  }
  fmtJ(val) {
    return JSON.stringify(val);
  }
};
function sprintf(format5, ...args) {
  const printf1 = new Printf(format5, ...args);
  return printf1.doPrintf();
}
var debugImpls;
var testEnabled;
function initializeDebugEnv(debugEnv1) {
  debugImpls = /* @__PURE__ */ Object.create(null);
  if (debugEnv1) {
    debugEnv1 = debugEnv1.replace(/[|\\{}()[\]^$+?.]/g, "\\$&").replaceAll("*", ".*").replaceAll(",", "$|^");
    const debugEnvRegex = new RegExp(`^${debugEnv1}$`, "i");
    testEnabled = (str) => debugEnvRegex.exec(str) !== null;
  } else {
    testEnabled = () => false;
  }
}
function emitWarningIfNeeded(set) {
  if (set === "HTTP" || set === "HTTP2") {
    console.warn("Setting the NODE_DEBUG environment variable to '" + set.toLowerCase() + "' can expose sensitive data (such as passwords, tokens and authentication headers) in the resulting log.");
  }
}
var noop = () => {
};
function debuglogImpl(enabled, set) {
  if (debugImpls[set] === void 0) {
    if (enabled) {
      emitWarningIfNeeded(set);
      debugImpls[set] = function debug2(...args) {
        const msg = args.map((arg) => inspect(arg)).join(" ");
        console.error(sprintf("%s %s: %s", set, String(workerDeno_pid), msg));
      };
    } else {
      debugImpls[set] = noop;
    }
  }
  return debugImpls[set];
}
function debuglog(set, cb) {
  function init() {
    set = set.toUpperCase();
    enabled = testEnabled(set);
  }
  let debug2 = (...args) => {
    init();
    debug2 = debuglogImpl(enabled, set);
    if (typeof cb === "function") {
      cb(debug2);
    }
    return debug2(...args);
  };
  let enabled;
  let test = () => {
    init();
    test = () => enabled;
    return enabled;
  };
  const logger = (...args) => debug2(...args);
  Object.defineProperty(logger, "enabled", {
    get() {
      return test();
    },
    configurable: true,
    enumerable: true
  });
  return logger;
}
var debugEnv;
try {
  debugEnv = workerDeno_env.get("NODE_DEBUG") ?? "";
} catch (error1) {
  if (error1 instanceof workerDeno_errors.PermissionDenied) {
    debugEnv = "";
  } else {
    throw error1;
  }
}
initializeDebugEnv(debugEnv);
var osType = (() => {
  const { Deno: Deno2 } = globalThis;
  if (typeof Deno2?.build?.os === "string") {
    return Deno2.build.os;
  }
  const { navigator } = globalThis;
  if (navigator?.appVersion?.includes?.("Win")) {
    return "windows";
  }
  return "linux";
})();
var isWindows = osType === "windows";
var isLinux = osType === "linux";
function uvTranslateSysError(sysErrno) {
  switch (sysErrno) {
    case 5:
      return "EACCES";
    case 998:
      return "EACCES";
    case 10013:
      return "EACCES";
    case 1920:
      return "EACCES";
    case 1227:
      return "EADDRINUSE";
    case 10048:
      return "EADDRINUSE";
    case 10049:
      return "EADDRNOTAVAIL";
    case 10047:
      return "EAFNOSUPPORT";
    case 10035:
      return "EAGAIN";
    case 10037:
      return "EALREADY";
    case 1004:
      return "EBADF";
    case 6:
      return "EBADF";
    case 33:
      return "EBUSY";
    case 231:
      return "EBUSY";
    case 32:
      return "EBUSY";
    case 995:
      return "ECANCELED";
    case 10004:
      return "ECANCELED";
    case 1113:
      return "ECHARSET";
    case 1236:
      return "ECONNABORTED";
    case 10053:
      return "ECONNABORTED";
    case 1225:
      return "ECONNREFUSED";
    case 10061:
      return "ECONNREFUSED";
    case 64:
      return "ECONNRESET";
    case 10054:
      return "ECONNRESET";
    case 183:
      return "EEXIST";
    case 80:
      return "EEXIST";
    case 111:
      return "EFAULT";
    case 10014:
      return "EFAULT";
    case 1232:
      return "EHOSTUNREACH";
    case 10065:
      return "EHOSTUNREACH";
    case 122:
      return "EINVAL";
    case 13:
      return "EINVAL";
    case 123:
      return "EINVAL";
    case 87:
      return "EINVAL";
    case 10022:
      return "EINVAL";
    case 10046:
      return "EINVAL";
    case 1102:
      return "EIO";
    case 1111:
      return "EIO";
    case 23:
      return "EIO";
    case 1166:
      return "EIO";
    case 1165:
      return "EIO";
    case 1393:
      return "EIO";
    case 1129:
      return "EIO";
    case 1101:
      return "EIO";
    case 31:
      return "EIO";
    case 1106:
      return "EIO";
    case 1117:
      return "EIO";
    case 1104:
      return "EIO";
    case 205:
      return "EIO";
    case 110:
      return "EIO";
    case 1103:
      return "EIO";
    case 156:
      return "EIO";
    case 10056:
      return "EISCONN";
    case 1921:
      return "ELOOP";
    case 4:
      return "EMFILE";
    case 10024:
      return "EMFILE";
    case 10040:
      return "EMSGSIZE";
    case 206:
      return "ENAMETOOLONG";
    case 1231:
      return "ENETUNREACH";
    case 10051:
      return "ENETUNREACH";
    case 10055:
      return "ENOBUFS";
    case 161:
      return "ENOENT";
    case 267:
      return "ENOTDIR";
    case 203:
      return "ENOENT";
    case 2:
      return "ENOENT";
    case 15:
      return "ENOENT";
    case 4392:
      return "ENOENT";
    case 126:
      return "ENOENT";
    case 3:
      return "ENOENT";
    case 11001:
      return "ENOENT";
    case 11004:
      return "ENOENT";
    case 8:
      return "ENOMEM";
    case 14:
      return "ENOMEM";
    case 82:
      return "ENOSPC";
    case 112:
      return "ENOSPC";
    case 277:
      return "ENOSPC";
    case 1100:
      return "ENOSPC";
    case 39:
      return "ENOSPC";
    case 2250:
      return "ENOTCONN";
    case 10057:
      return "ENOTCONN";
    case 145:
      return "ENOTEMPTY";
    case 10038:
      return "ENOTSOCK";
    case 50:
      return "ENOTSUP";
    case 109:
      return "EOF";
    case 1314:
      return "EPERM";
    case 230:
      return "EPIPE";
    case 232:
      return "EPIPE";
    case 233:
      return "EPIPE";
    case 10058:
      return "EPIPE";
    case 10043:
      return "EPROTONOSUPPORT";
    case 19:
      return "EROFS";
    case 121:
      return "ETIMEDOUT";
    case 10060:
      return "ETIMEDOUT";
    case 17:
      return "EXDEV";
    case 1:
      return "EISDIR";
    case 208:
      return "E2BIG";
    case 10044:
      return "ESOCKTNOSUPPORT";
    default:
      return "UNKNOWN";
  }
}
var os = {
  UV_UDP_IPV6ONLY: 1,
  UV_UDP_PARTIAL: 2,
  UV_UDP_REUSEADDR: 4,
  UV_UDP_MMSG_CHUNK: 8,
  UV_UDP_MMSG_FREE: 16,
  UV_UDP_LINUX_RECVERR: 32,
  UV_UDP_RECVMMSG: 256,
  dlopen: {
    RTLD_LAZY: 1,
    RTLD_NOW: 2,
    RTLD_GLOBAL: 8,
    RTLD_LOCAL: 4
  },
  errno: {
    E2BIG: 7,
    EACCES: 13,
    EADDRINUSE: 48,
    EADDRNOTAVAIL: 49,
    EAFNOSUPPORT: 47,
    EAGAIN: 35,
    EALREADY: 37,
    EBADF: 9,
    EBADMSG: 94,
    EBUSY: 16,
    ECANCELED: 89,
    ECHILD: 10,
    ECONNABORTED: 53,
    ECONNREFUSED: 61,
    ECONNRESET: 54,
    EDEADLK: 11,
    EDESTADDRREQ: 39,
    EDOM: 33,
    EDQUOT: 69,
    EEXIST: 17,
    EFAULT: 14,
    EFBIG: 27,
    EHOSTUNREACH: 65,
    EIDRM: 90,
    EILSEQ: 92,
    EINPROGRESS: 36,
    EINTR: 4,
    EINVAL: 22,
    EIO: 5,
    EISCONN: 56,
    EISDIR: 21,
    ELOOP: 62,
    EMFILE: 24,
    EMLINK: 31,
    EMSGSIZE: 40,
    EMULTIHOP: 95,
    ENAMETOOLONG: 63,
    ENETDOWN: 50,
    ENETRESET: 52,
    ENETUNREACH: 51,
    ENFILE: 23,
    ENOBUFS: 55,
    ENODATA: 96,
    ENODEV: 19,
    ENOENT: 2,
    ENOEXEC: 8,
    ENOLCK: 77,
    ENOLINK: 97,
    ENOMEM: 12,
    ENOMSG: 91,
    ENOPROTOOPT: 42,
    ENOSPC: 28,
    ENOSR: 98,
    ENOSTR: 99,
    ENOSYS: 78,
    ENOTCONN: 57,
    ENOTDIR: 20,
    ENOTEMPTY: 66,
    ENOTSOCK: 38,
    ENOTSUP: 45,
    ENOTTY: 25,
    ENXIO: 6,
    EOPNOTSUPP: 102,
    EOVERFLOW: 84,
    EPERM: 1,
    EPIPE: 32,
    EPROTO: 100,
    EPROTONOSUPPORT: 43,
    EPROTOTYPE: 41,
    ERANGE: 34,
    EROFS: 30,
    ESPIPE: 29,
    ESRCH: 3,
    ESTALE: 70,
    ETIME: 101,
    ETIMEDOUT: 60,
    ETXTBSY: 26,
    EWOULDBLOCK: 35,
    EXDEV: 18
  },
  signals: {
    SIGHUP: 1,
    SIGINT: 2,
    SIGQUIT: 3,
    SIGILL: 4,
    SIGTRAP: 5,
    SIGABRT: 6,
    SIGIOT: 6,
    SIGBUS: 10,
    SIGFPE: 8,
    SIGKILL: 9,
    SIGUSR1: 30,
    SIGSEGV: 11,
    SIGUSR2: 31,
    SIGPIPE: 13,
    SIGALRM: 14,
    SIGTERM: 15,
    SIGCHLD: 20,
    SIGCONT: 19,
    SIGSTOP: 17,
    SIGTSTP: 18,
    SIGTTIN: 21,
    SIGBREAK: 21,
    SIGTTOU: 22,
    SIGURG: 16,
    SIGXCPU: 24,
    SIGXFSZ: 25,
    SIGVTALRM: 26,
    SIGPROF: 27,
    SIGWINCH: 28,
    SIGIO: 23,
    SIGINFO: 29,
    SIGSYS: 12,
    SIGEMT: 7,
    SIGPWR: 30,
    SIGSTKFLT: 16
  },
  priority: {
    PRIORITY_LOW: 19,
    PRIORITY_BELOW_NORMAL: 10,
    PRIORITY_NORMAL: 0,
    PRIORITY_ABOVE_NORMAL: -7,
    PRIORITY_HIGH: -14,
    PRIORITY_HIGHEST: -20
  }
};
var fs = {
  UV_FS_SYMLINK_DIR: 1,
  UV_FS_SYMLINK_JUNCTION: 2,
  O_RDONLY: 0,
  O_WRONLY: 1,
  O_RDWR: 2,
  UV_DIRENT_UNKNOWN: 0,
  UV_DIRENT_FILE: 1,
  UV_DIRENT_DIR: 2,
  UV_DIRENT_LINK: 3,
  UV_DIRENT_FIFO: 4,
  UV_DIRENT_SOCKET: 5,
  UV_DIRENT_CHAR: 6,
  UV_DIRENT_BLOCK: 7,
  S_IFMT: 61440,
  S_IFREG: 32768,
  S_IFDIR: 16384,
  S_IFCHR: 8192,
  S_IFBLK: 24576,
  S_IFIFO: 4096,
  S_IFLNK: 40960,
  S_IFSOCK: 49152,
  O_CREAT: 512,
  O_EXCL: 2048,
  UV_FS_O_FILEMAP: 0,
  O_NOCTTY: 131072,
  O_TRUNC: 1024,
  O_APPEND: 8,
  O_DIRECTORY: 1048576,
  O_NOFOLLOW: 256,
  O_SYNC: 128,
  O_DSYNC: 4194304,
  O_SYMLINK: 2097152,
  O_NONBLOCK: 4,
  S_IRWXU: 448,
  S_IRUSR: 256,
  S_IWUSR: 128,
  S_IXUSR: 64,
  S_IRWXG: 56,
  S_IRGRP: 32,
  S_IWGRP: 16,
  S_IXGRP: 8,
  S_IRWXO: 7,
  S_IROTH: 4,
  S_IWOTH: 2,
  S_IXOTH: 1,
  F_OK: 0,
  R_OK: 4,
  W_OK: 2,
  X_OK: 1,
  UV_FS_COPYFILE_EXCL: 1,
  COPYFILE_EXCL: 1,
  UV_FS_COPYFILE_FICLONE: 2,
  COPYFILE_FICLONE: 2,
  UV_FS_COPYFILE_FICLONE_FORCE: 4,
  COPYFILE_FICLONE_FORCE: 4
};
var crypto = {
  OPENSSL_VERSION_NUMBER: 269488319,
  SSL_OP_ALL: 2147485780,
  SSL_OP_ALLOW_NO_DHE_KEX: 1024,
  SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION: 262144,
  SSL_OP_CIPHER_SERVER_PREFERENCE: 4194304,
  SSL_OP_CISCO_ANYCONNECT: 32768,
  SSL_OP_COOKIE_EXCHANGE: 8192,
  SSL_OP_CRYPTOPRO_TLSEXT_BUG: 2147483648,
  SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS: 2048,
  SSL_OP_EPHEMERAL_RSA: 0,
  SSL_OP_LEGACY_SERVER_CONNECT: 4,
  SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER: 0,
  SSL_OP_MICROSOFT_SESS_ID_BUG: 0,
  SSL_OP_MSIE_SSLV2_RSA_PADDING: 0,
  SSL_OP_NETSCAPE_CA_DN_BUG: 0,
  SSL_OP_NETSCAPE_CHALLENGE_BUG: 0,
  SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG: 0,
  SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG: 0,
  SSL_OP_NO_COMPRESSION: 131072,
  SSL_OP_NO_ENCRYPT_THEN_MAC: 524288,
  SSL_OP_NO_QUERY_MTU: 4096,
  SSL_OP_NO_RENEGOTIATION: 1073741824,
  SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION: 65536,
  SSL_OP_NO_SSLv2: 0,
  SSL_OP_NO_SSLv3: 33554432,
  SSL_OP_NO_TICKET: 16384,
  SSL_OP_NO_TLSv1: 67108864,
  SSL_OP_NO_TLSv1_1: 268435456,
  SSL_OP_NO_TLSv1_2: 134217728,
  SSL_OP_NO_TLSv1_3: 536870912,
  SSL_OP_PKCS1_CHECK_1: 0,
  SSL_OP_PKCS1_CHECK_2: 0,
  SSL_OP_PRIORITIZE_CHACHA: 2097152,
  SSL_OP_SINGLE_DH_USE: 0,
  SSL_OP_SINGLE_ECDH_USE: 0,
  SSL_OP_SSLEAY_080_CLIENT_DH_BUG: 0,
  SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG: 0,
  SSL_OP_TLS_BLOCK_PADDING_BUG: 0,
  SSL_OP_TLS_D5_BUG: 0,
  SSL_OP_TLS_ROLLBACK_BUG: 8388608,
  ENGINE_METHOD_RSA: 1,
  ENGINE_METHOD_DSA: 2,
  ENGINE_METHOD_DH: 4,
  ENGINE_METHOD_RAND: 8,
  ENGINE_METHOD_EC: 2048,
  ENGINE_METHOD_CIPHERS: 64,
  ENGINE_METHOD_DIGESTS: 128,
  ENGINE_METHOD_PKEY_METHS: 512,
  ENGINE_METHOD_PKEY_ASN1_METHS: 1024,
  ENGINE_METHOD_ALL: 65535,
  ENGINE_METHOD_NONE: 0,
  DH_CHECK_P_NOT_SAFE_PRIME: 2,
  DH_CHECK_P_NOT_PRIME: 1,
  DH_UNABLE_TO_CHECK_GENERATOR: 4,
  DH_NOT_SUITABLE_GENERATOR: 8,
  ALPN_ENABLED: 1,
  RSA_PKCS1_PADDING: 1,
  RSA_SSLV23_PADDING: 2,
  RSA_NO_PADDING: 3,
  RSA_PKCS1_OAEP_PADDING: 4,
  RSA_X931_PADDING: 5,
  RSA_PKCS1_PSS_PADDING: 6,
  RSA_PSS_SALTLEN_DIGEST: -1,
  RSA_PSS_SALTLEN_MAX_SIGN: -2,
  RSA_PSS_SALTLEN_AUTO: -2,
  defaultCoreCipherList: "TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256:ECDHE-RSA-AES256-SHA384:DHE-RSA-AES256-SHA384:ECDHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA256:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!SRP:!CAMELLIA",
  TLS1_VERSION: 769,
  TLS1_1_VERSION: 770,
  TLS1_2_VERSION: 771,
  TLS1_3_VERSION: 772,
  POINT_CONVERSION_COMPRESSED: 2,
  POINT_CONVERSION_UNCOMPRESSED: 4,
  POINT_CONVERSION_HYBRID: 6
};
var zlib = {
  Z_NO_FLUSH: 0,
  Z_PARTIAL_FLUSH: 1,
  Z_SYNC_FLUSH: 2,
  Z_FULL_FLUSH: 3,
  Z_FINISH: 4,
  Z_BLOCK: 5,
  Z_OK: 0,
  Z_STREAM_END: 1,
  Z_NEED_DICT: 2,
  Z_ERRNO: -1,
  Z_STREAM_ERROR: -2,
  Z_DATA_ERROR: -3,
  Z_MEM_ERROR: -4,
  Z_BUF_ERROR: -5,
  Z_VERSION_ERROR: -6,
  Z_NO_COMPRESSION: 0,
  Z_BEST_SPEED: 1,
  Z_BEST_COMPRESSION: 9,
  Z_DEFAULT_COMPRESSION: -1,
  Z_FILTERED: 1,
  Z_HUFFMAN_ONLY: 2,
  Z_RLE: 3,
  Z_FIXED: 4,
  Z_DEFAULT_STRATEGY: 0,
  ZLIB_VERNUM: 4784,
  DEFLATE: 1,
  INFLATE: 2,
  GZIP: 3,
  GUNZIP: 4,
  DEFLATERAW: 5,
  INFLATERAW: 6,
  UNZIP: 7,
  BROTLI_DECODE: 8,
  BROTLI_ENCODE: 9,
  Z_MIN_WINDOWBITS: 8,
  Z_MAX_WINDOWBITS: 15,
  Z_DEFAULT_WINDOWBITS: 15,
  Z_MIN_CHUNK: 64,
  Z_MAX_CHUNK: Infinity,
  Z_DEFAULT_CHUNK: 16384,
  Z_MIN_MEMLEVEL: 1,
  Z_MAX_MEMLEVEL: 9,
  Z_DEFAULT_MEMLEVEL: 8,
  Z_MIN_LEVEL: -1,
  Z_MAX_LEVEL: 9,
  Z_DEFAULT_LEVEL: -1,
  BROTLI_OPERATION_PROCESS: 0,
  BROTLI_OPERATION_FLUSH: 1,
  BROTLI_OPERATION_FINISH: 2,
  BROTLI_OPERATION_EMIT_METADATA: 3,
  BROTLI_PARAM_MODE: 0,
  BROTLI_MODE_GENERIC: 0,
  BROTLI_MODE_TEXT: 1,
  BROTLI_MODE_FONT: 2,
  BROTLI_DEFAULT_MODE: 0,
  BROTLI_PARAM_QUALITY: 1,
  BROTLI_MIN_QUALITY: 0,
  BROTLI_MAX_QUALITY: 11,
  BROTLI_DEFAULT_QUALITY: 11,
  BROTLI_PARAM_LGWIN: 2,
  BROTLI_MIN_WINDOW_BITS: 10,
  BROTLI_MAX_WINDOW_BITS: 24,
  BROTLI_LARGE_MAX_WINDOW_BITS: 30,
  BROTLI_DEFAULT_WINDOW: 22,
  BROTLI_PARAM_LGBLOCK: 3,
  BROTLI_MIN_INPUT_BLOCK_BITS: 16,
  BROTLI_MAX_INPUT_BLOCK_BITS: 24,
  BROTLI_PARAM_DISABLE_LITERAL_CONTEXT_MODELING: 4,
  BROTLI_PARAM_SIZE_HINT: 5,
  BROTLI_PARAM_LARGE_WINDOW: 6,
  BROTLI_PARAM_NPOSTFIX: 7,
  BROTLI_PARAM_NDIRECT: 8,
  BROTLI_DECODER_RESULT_ERROR: 0,
  BROTLI_DECODER_RESULT_SUCCESS: 1,
  BROTLI_DECODER_RESULT_NEEDS_MORE_INPUT: 2,
  BROTLI_DECODER_RESULT_NEEDS_MORE_OUTPUT: 3,
  BROTLI_DECODER_PARAM_DISABLE_RING_BUFFER_REALLOCATION: 0,
  BROTLI_DECODER_PARAM_LARGE_WINDOW: 1,
  BROTLI_DECODER_NO_ERROR: 0,
  BROTLI_DECODER_SUCCESS: 1,
  BROTLI_DECODER_NEEDS_MORE_INPUT: 2,
  BROTLI_DECODER_NEEDS_MORE_OUTPUT: 3,
  BROTLI_DECODER_ERROR_FORMAT_EXUBERANT_NIBBLE: -1,
  BROTLI_DECODER_ERROR_FORMAT_RESERVED: -2,
  BROTLI_DECODER_ERROR_FORMAT_EXUBERANT_META_NIBBLE: -3,
  BROTLI_DECODER_ERROR_FORMAT_SIMPLE_HUFFMAN_ALPHABET: -4,
  BROTLI_DECODER_ERROR_FORMAT_SIMPLE_HUFFMAN_SAME: -5,
  BROTLI_DECODER_ERROR_FORMAT_CL_SPACE: -6,
  BROTLI_DECODER_ERROR_FORMAT_HUFFMAN_SPACE: -7,
  BROTLI_DECODER_ERROR_FORMAT_CONTEXT_MAP_REPEAT: -8,
  BROTLI_DECODER_ERROR_FORMAT_BLOCK_LENGTH_1: -9,
  BROTLI_DECODER_ERROR_FORMAT_BLOCK_LENGTH_2: -10,
  BROTLI_DECODER_ERROR_FORMAT_TRANSFORM: -11,
  BROTLI_DECODER_ERROR_FORMAT_DICTIONARY: -12,
  BROTLI_DECODER_ERROR_FORMAT_WINDOW_BITS: -13,
  BROTLI_DECODER_ERROR_FORMAT_PADDING_1: -14,
  BROTLI_DECODER_ERROR_FORMAT_PADDING_2: -15,
  BROTLI_DECODER_ERROR_FORMAT_DISTANCE: -16,
  BROTLI_DECODER_ERROR_DICTIONARY_NOT_SET: -19,
  BROTLI_DECODER_ERROR_INVALID_ARGUMENTS: -20,
  BROTLI_DECODER_ERROR_ALLOC_CONTEXT_MODES: -21,
  BROTLI_DECODER_ERROR_ALLOC_TREE_GROUPS: -22,
  BROTLI_DECODER_ERROR_ALLOC_CONTEXT_MAP: -25,
  BROTLI_DECODER_ERROR_ALLOC_RING_BUFFER_1: -26,
  BROTLI_DECODER_ERROR_ALLOC_RING_BUFFER_2: -27,
  BROTLI_DECODER_ERROR_ALLOC_BLOCK_TYPE_TREES: -30,
  BROTLI_DECODER_ERROR_UNREACHABLE: -31
};
var trace = {
  TRACE_EVENT_PHASE_BEGIN: 66,
  TRACE_EVENT_PHASE_END: 69,
  TRACE_EVENT_PHASE_COMPLETE: 88,
  TRACE_EVENT_PHASE_INSTANT: 73,
  TRACE_EVENT_PHASE_ASYNC_BEGIN: 83,
  TRACE_EVENT_PHASE_ASYNC_STEP_INTO: 84,
  TRACE_EVENT_PHASE_ASYNC_STEP_PAST: 112,
  TRACE_EVENT_PHASE_ASYNC_END: 70,
  TRACE_EVENT_PHASE_NESTABLE_ASYNC_BEGIN: 98,
  TRACE_EVENT_PHASE_NESTABLE_ASYNC_END: 101,
  TRACE_EVENT_PHASE_NESTABLE_ASYNC_INSTANT: 110,
  TRACE_EVENT_PHASE_FLOW_BEGIN: 115,
  TRACE_EVENT_PHASE_FLOW_STEP: 116,
  TRACE_EVENT_PHASE_FLOW_END: 102,
  TRACE_EVENT_PHASE_METADATA: 77,
  TRACE_EVENT_PHASE_COUNTER: 67,
  TRACE_EVENT_PHASE_SAMPLE: 80,
  TRACE_EVENT_PHASE_CREATE_OBJECT: 78,
  TRACE_EVENT_PHASE_SNAPSHOT_OBJECT: 79,
  TRACE_EVENT_PHASE_DELETE_OBJECT: 68,
  TRACE_EVENT_PHASE_MEMORY_DUMP: 118,
  TRACE_EVENT_PHASE_MARK: 82,
  TRACE_EVENT_PHASE_CLOCK_SYNC: 99,
  TRACE_EVENT_PHASE_ENTER_CONTEXT: 40,
  TRACE_EVENT_PHASE_LEAVE_CONTEXT: 41,
  TRACE_EVENT_PHASE_LINK_IDS: 61
};
var mod2 = {
  os,
  fs,
  crypto,
  zlib,
  trace
};
var UV_EEXIST = os.errno.EEXIST;
var UV_ENOENT = os.errno.ENOENT;
var codeToErrorWindows = [
  [
    -4093,
    [
      "E2BIG",
      "argument list too long"
    ]
  ],
  [
    -4092,
    [
      "EACCES",
      "permission denied"
    ]
  ],
  [
    -4091,
    [
      "EADDRINUSE",
      "address already in use"
    ]
  ],
  [
    -4090,
    [
      "EADDRNOTAVAIL",
      "address not available"
    ]
  ],
  [
    -4089,
    [
      "EAFNOSUPPORT",
      "address family not supported"
    ]
  ],
  [
    -4088,
    [
      "EAGAIN",
      "resource temporarily unavailable"
    ]
  ],
  [
    -3e3,
    [
      "EAI_ADDRFAMILY",
      "address family not supported"
    ]
  ],
  [
    -3001,
    [
      "EAI_AGAIN",
      "temporary failure"
    ]
  ],
  [
    -3002,
    [
      "EAI_BADFLAGS",
      "bad ai_flags value"
    ]
  ],
  [
    -3013,
    [
      "EAI_BADHINTS",
      "invalid value for hints"
    ]
  ],
  [
    -3003,
    [
      "EAI_CANCELED",
      "request canceled"
    ]
  ],
  [
    -3004,
    [
      "EAI_FAIL",
      "permanent failure"
    ]
  ],
  [
    -3005,
    [
      "EAI_FAMILY",
      "ai_family not supported"
    ]
  ],
  [
    -3006,
    [
      "EAI_MEMORY",
      "out of memory"
    ]
  ],
  [
    -3007,
    [
      "EAI_NODATA",
      "no address"
    ]
  ],
  [
    -3008,
    [
      "EAI_NONAME",
      "unknown node or service"
    ]
  ],
  [
    -3009,
    [
      "EAI_OVERFLOW",
      "argument buffer overflow"
    ]
  ],
  [
    -3014,
    [
      "EAI_PROTOCOL",
      "resolved protocol is unknown"
    ]
  ],
  [
    -3010,
    [
      "EAI_SERVICE",
      "service not available for socket type"
    ]
  ],
  [
    -3011,
    [
      "EAI_SOCKTYPE",
      "socket type not supported"
    ]
  ],
  [
    -4084,
    [
      "EALREADY",
      "connection already in progress"
    ]
  ],
  [
    -4083,
    [
      "EBADF",
      "bad file descriptor"
    ]
  ],
  [
    -4082,
    [
      "EBUSY",
      "resource busy or locked"
    ]
  ],
  [
    -4081,
    [
      "ECANCELED",
      "operation canceled"
    ]
  ],
  [
    -4080,
    [
      "ECHARSET",
      "invalid Unicode character"
    ]
  ],
  [
    -4079,
    [
      "ECONNABORTED",
      "software caused connection abort"
    ]
  ],
  [
    -4078,
    [
      "ECONNREFUSED",
      "connection refused"
    ]
  ],
  [
    -4077,
    [
      "ECONNRESET",
      "connection reset by peer"
    ]
  ],
  [
    -4076,
    [
      "EDESTADDRREQ",
      "destination address required"
    ]
  ],
  [
    -4075,
    [
      "EEXIST",
      "file already exists"
    ]
  ],
  [
    -4074,
    [
      "EFAULT",
      "bad address in system call argument"
    ]
  ],
  [
    -4036,
    [
      "EFBIG",
      "file too large"
    ]
  ],
  [
    -4073,
    [
      "EHOSTUNREACH",
      "host is unreachable"
    ]
  ],
  [
    -4072,
    [
      "EINTR",
      "interrupted system call"
    ]
  ],
  [
    -4071,
    [
      "EINVAL",
      "invalid argument"
    ]
  ],
  [
    -4070,
    [
      "EIO",
      "i/o error"
    ]
  ],
  [
    -4069,
    [
      "EISCONN",
      "socket is already connected"
    ]
  ],
  [
    -4068,
    [
      "EISDIR",
      "illegal operation on a directory"
    ]
  ],
  [
    -4067,
    [
      "ELOOP",
      "too many symbolic links encountered"
    ]
  ],
  [
    -4066,
    [
      "EMFILE",
      "too many open files"
    ]
  ],
  [
    -4065,
    [
      "EMSGSIZE",
      "message too long"
    ]
  ],
  [
    -4064,
    [
      "ENAMETOOLONG",
      "name too long"
    ]
  ],
  [
    -4063,
    [
      "ENETDOWN",
      "network is down"
    ]
  ],
  [
    -4062,
    [
      "ENETUNREACH",
      "network is unreachable"
    ]
  ],
  [
    -4061,
    [
      "ENFILE",
      "file table overflow"
    ]
  ],
  [
    -4060,
    [
      "ENOBUFS",
      "no buffer space available"
    ]
  ],
  [
    -4059,
    [
      "ENODEV",
      "no such device"
    ]
  ],
  [
    -4058,
    [
      "ENOENT",
      "no such file or directory"
    ]
  ],
  [
    -4057,
    [
      "ENOMEM",
      "not enough memory"
    ]
  ],
  [
    -4056,
    [
      "ENONET",
      "machine is not on the network"
    ]
  ],
  [
    -4035,
    [
      "ENOPROTOOPT",
      "protocol not available"
    ]
  ],
  [
    -4055,
    [
      "ENOSPC",
      "no space left on device"
    ]
  ],
  [
    -4054,
    [
      "ENOSYS",
      "function not implemented"
    ]
  ],
  [
    -4053,
    [
      "ENOTCONN",
      "socket is not connected"
    ]
  ],
  [
    -4052,
    [
      "ENOTDIR",
      "not a directory"
    ]
  ],
  [
    -4051,
    [
      "ENOTEMPTY",
      "directory not empty"
    ]
  ],
  [
    -4050,
    [
      "ENOTSOCK",
      "socket operation on non-socket"
    ]
  ],
  [
    -4049,
    [
      "ENOTSUP",
      "operation not supported on socket"
    ]
  ],
  [
    -4048,
    [
      "EPERM",
      "operation not permitted"
    ]
  ],
  [
    -4047,
    [
      "EPIPE",
      "broken pipe"
    ]
  ],
  [
    -4046,
    [
      "EPROTO",
      "protocol error"
    ]
  ],
  [
    -4045,
    [
      "EPROTONOSUPPORT",
      "protocol not supported"
    ]
  ],
  [
    -4044,
    [
      "EPROTOTYPE",
      "protocol wrong type for socket"
    ]
  ],
  [
    -4034,
    [
      "ERANGE",
      "result too large"
    ]
  ],
  [
    -4043,
    [
      "EROFS",
      "read-only file system"
    ]
  ],
  [
    -4042,
    [
      "ESHUTDOWN",
      "cannot send after transport endpoint shutdown"
    ]
  ],
  [
    -4041,
    [
      "ESPIPE",
      "invalid seek"
    ]
  ],
  [
    -4040,
    [
      "ESRCH",
      "no such process"
    ]
  ],
  [
    -4039,
    [
      "ETIMEDOUT",
      "connection timed out"
    ]
  ],
  [
    -4038,
    [
      "ETXTBSY",
      "text file is busy"
    ]
  ],
  [
    -4037,
    [
      "EXDEV",
      "cross-device link not permitted"
    ]
  ],
  [
    -4094,
    [
      "UNKNOWN",
      "unknown error"
    ]
  ],
  [
    -4095,
    [
      "EOF",
      "end of file"
    ]
  ],
  [
    -4033,
    [
      "ENXIO",
      "no such device or address"
    ]
  ],
  [
    -4032,
    [
      "EMLINK",
      "too many links"
    ]
  ],
  [
    -4031,
    [
      "EHOSTDOWN",
      "host is down"
    ]
  ],
  [
    -4030,
    [
      "EREMOTEIO",
      "remote I/O error"
    ]
  ],
  [
    -4029,
    [
      "ENOTTY",
      "inappropriate ioctl for device"
    ]
  ],
  [
    -4028,
    [
      "EFTYPE",
      "inappropriate file type or format"
    ]
  ],
  [
    -4027,
    [
      "EILSEQ",
      "illegal byte sequence"
    ]
  ]
];
var errorToCodeWindows = codeToErrorWindows.map(([status, [error2]]) => [
  error2,
  status
]);
var codeToErrorDarwin = [
  [
    -7,
    [
      "E2BIG",
      "argument list too long"
    ]
  ],
  [
    -13,
    [
      "EACCES",
      "permission denied"
    ]
  ],
  [
    -48,
    [
      "EADDRINUSE",
      "address already in use"
    ]
  ],
  [
    -49,
    [
      "EADDRNOTAVAIL",
      "address not available"
    ]
  ],
  [
    -47,
    [
      "EAFNOSUPPORT",
      "address family not supported"
    ]
  ],
  [
    -35,
    [
      "EAGAIN",
      "resource temporarily unavailable"
    ]
  ],
  [
    -3e3,
    [
      "EAI_ADDRFAMILY",
      "address family not supported"
    ]
  ],
  [
    -3001,
    [
      "EAI_AGAIN",
      "temporary failure"
    ]
  ],
  [
    -3002,
    [
      "EAI_BADFLAGS",
      "bad ai_flags value"
    ]
  ],
  [
    -3013,
    [
      "EAI_BADHINTS",
      "invalid value for hints"
    ]
  ],
  [
    -3003,
    [
      "EAI_CANCELED",
      "request canceled"
    ]
  ],
  [
    -3004,
    [
      "EAI_FAIL",
      "permanent failure"
    ]
  ],
  [
    -3005,
    [
      "EAI_FAMILY",
      "ai_family not supported"
    ]
  ],
  [
    -3006,
    [
      "EAI_MEMORY",
      "out of memory"
    ]
  ],
  [
    -3007,
    [
      "EAI_NODATA",
      "no address"
    ]
  ],
  [
    -3008,
    [
      "EAI_NONAME",
      "unknown node or service"
    ]
  ],
  [
    -3009,
    [
      "EAI_OVERFLOW",
      "argument buffer overflow"
    ]
  ],
  [
    -3014,
    [
      "EAI_PROTOCOL",
      "resolved protocol is unknown"
    ]
  ],
  [
    -3010,
    [
      "EAI_SERVICE",
      "service not available for socket type"
    ]
  ],
  [
    -3011,
    [
      "EAI_SOCKTYPE",
      "socket type not supported"
    ]
  ],
  [
    -37,
    [
      "EALREADY",
      "connection already in progress"
    ]
  ],
  [
    -9,
    [
      "EBADF",
      "bad file descriptor"
    ]
  ],
  [
    -16,
    [
      "EBUSY",
      "resource busy or locked"
    ]
  ],
  [
    -89,
    [
      "ECANCELED",
      "operation canceled"
    ]
  ],
  [
    -4080,
    [
      "ECHARSET",
      "invalid Unicode character"
    ]
  ],
  [
    -53,
    [
      "ECONNABORTED",
      "software caused connection abort"
    ]
  ],
  [
    -61,
    [
      "ECONNREFUSED",
      "connection refused"
    ]
  ],
  [
    -54,
    [
      "ECONNRESET",
      "connection reset by peer"
    ]
  ],
  [
    -39,
    [
      "EDESTADDRREQ",
      "destination address required"
    ]
  ],
  [
    -17,
    [
      "EEXIST",
      "file already exists"
    ]
  ],
  [
    -14,
    [
      "EFAULT",
      "bad address in system call argument"
    ]
  ],
  [
    -27,
    [
      "EFBIG",
      "file too large"
    ]
  ],
  [
    -65,
    [
      "EHOSTUNREACH",
      "host is unreachable"
    ]
  ],
  [
    -4,
    [
      "EINTR",
      "interrupted system call"
    ]
  ],
  [
    -22,
    [
      "EINVAL",
      "invalid argument"
    ]
  ],
  [
    -5,
    [
      "EIO",
      "i/o error"
    ]
  ],
  [
    -56,
    [
      "EISCONN",
      "socket is already connected"
    ]
  ],
  [
    -21,
    [
      "EISDIR",
      "illegal operation on a directory"
    ]
  ],
  [
    -62,
    [
      "ELOOP",
      "too many symbolic links encountered"
    ]
  ],
  [
    -24,
    [
      "EMFILE",
      "too many open files"
    ]
  ],
  [
    -40,
    [
      "EMSGSIZE",
      "message too long"
    ]
  ],
  [
    -63,
    [
      "ENAMETOOLONG",
      "name too long"
    ]
  ],
  [
    -50,
    [
      "ENETDOWN",
      "network is down"
    ]
  ],
  [
    -51,
    [
      "ENETUNREACH",
      "network is unreachable"
    ]
  ],
  [
    -23,
    [
      "ENFILE",
      "file table overflow"
    ]
  ],
  [
    -55,
    [
      "ENOBUFS",
      "no buffer space available"
    ]
  ],
  [
    -19,
    [
      "ENODEV",
      "no such device"
    ]
  ],
  [
    -2,
    [
      "ENOENT",
      "no such file or directory"
    ]
  ],
  [
    -12,
    [
      "ENOMEM",
      "not enough memory"
    ]
  ],
  [
    -4056,
    [
      "ENONET",
      "machine is not on the network"
    ]
  ],
  [
    -42,
    [
      "ENOPROTOOPT",
      "protocol not available"
    ]
  ],
  [
    -28,
    [
      "ENOSPC",
      "no space left on device"
    ]
  ],
  [
    -78,
    [
      "ENOSYS",
      "function not implemented"
    ]
  ],
  [
    -57,
    [
      "ENOTCONN",
      "socket is not connected"
    ]
  ],
  [
    -20,
    [
      "ENOTDIR",
      "not a directory"
    ]
  ],
  [
    -66,
    [
      "ENOTEMPTY",
      "directory not empty"
    ]
  ],
  [
    -38,
    [
      "ENOTSOCK",
      "socket operation on non-socket"
    ]
  ],
  [
    -45,
    [
      "ENOTSUP",
      "operation not supported on socket"
    ]
  ],
  [
    -1,
    [
      "EPERM",
      "operation not permitted"
    ]
  ],
  [
    -32,
    [
      "EPIPE",
      "broken pipe"
    ]
  ],
  [
    -100,
    [
      "EPROTO",
      "protocol error"
    ]
  ],
  [
    -43,
    [
      "EPROTONOSUPPORT",
      "protocol not supported"
    ]
  ],
  [
    -41,
    [
      "EPROTOTYPE",
      "protocol wrong type for socket"
    ]
  ],
  [
    -34,
    [
      "ERANGE",
      "result too large"
    ]
  ],
  [
    -30,
    [
      "EROFS",
      "read-only file system"
    ]
  ],
  [
    -58,
    [
      "ESHUTDOWN",
      "cannot send after transport endpoint shutdown"
    ]
  ],
  [
    -29,
    [
      "ESPIPE",
      "invalid seek"
    ]
  ],
  [
    -3,
    [
      "ESRCH",
      "no such process"
    ]
  ],
  [
    -60,
    [
      "ETIMEDOUT",
      "connection timed out"
    ]
  ],
  [
    -26,
    [
      "ETXTBSY",
      "text file is busy"
    ]
  ],
  [
    -18,
    [
      "EXDEV",
      "cross-device link not permitted"
    ]
  ],
  [
    -4094,
    [
      "UNKNOWN",
      "unknown error"
    ]
  ],
  [
    -4095,
    [
      "EOF",
      "end of file"
    ]
  ],
  [
    -6,
    [
      "ENXIO",
      "no such device or address"
    ]
  ],
  [
    -31,
    [
      "EMLINK",
      "too many links"
    ]
  ],
  [
    -64,
    [
      "EHOSTDOWN",
      "host is down"
    ]
  ],
  [
    -4030,
    [
      "EREMOTEIO",
      "remote I/O error"
    ]
  ],
  [
    -25,
    [
      "ENOTTY",
      "inappropriate ioctl for device"
    ]
  ],
  [
    -79,
    [
      "EFTYPE",
      "inappropriate file type or format"
    ]
  ],
  [
    -92,
    [
      "EILSEQ",
      "illegal byte sequence"
    ]
  ]
];
var errorToCodeDarwin = codeToErrorDarwin.map(([status, [code]]) => [
  code,
  status
]);
var codeToErrorLinux = [
  [
    -7,
    [
      "E2BIG",
      "argument list too long"
    ]
  ],
  [
    -13,
    [
      "EACCES",
      "permission denied"
    ]
  ],
  [
    -98,
    [
      "EADDRINUSE",
      "address already in use"
    ]
  ],
  [
    -99,
    [
      "EADDRNOTAVAIL",
      "address not available"
    ]
  ],
  [
    -97,
    [
      "EAFNOSUPPORT",
      "address family not supported"
    ]
  ],
  [
    -11,
    [
      "EAGAIN",
      "resource temporarily unavailable"
    ]
  ],
  [
    -3e3,
    [
      "EAI_ADDRFAMILY",
      "address family not supported"
    ]
  ],
  [
    -3001,
    [
      "EAI_AGAIN",
      "temporary failure"
    ]
  ],
  [
    -3002,
    [
      "EAI_BADFLAGS",
      "bad ai_flags value"
    ]
  ],
  [
    -3013,
    [
      "EAI_BADHINTS",
      "invalid value for hints"
    ]
  ],
  [
    -3003,
    [
      "EAI_CANCELED",
      "request canceled"
    ]
  ],
  [
    -3004,
    [
      "EAI_FAIL",
      "permanent failure"
    ]
  ],
  [
    -3005,
    [
      "EAI_FAMILY",
      "ai_family not supported"
    ]
  ],
  [
    -3006,
    [
      "EAI_MEMORY",
      "out of memory"
    ]
  ],
  [
    -3007,
    [
      "EAI_NODATA",
      "no address"
    ]
  ],
  [
    -3008,
    [
      "EAI_NONAME",
      "unknown node or service"
    ]
  ],
  [
    -3009,
    [
      "EAI_OVERFLOW",
      "argument buffer overflow"
    ]
  ],
  [
    -3014,
    [
      "EAI_PROTOCOL",
      "resolved protocol is unknown"
    ]
  ],
  [
    -3010,
    [
      "EAI_SERVICE",
      "service not available for socket type"
    ]
  ],
  [
    -3011,
    [
      "EAI_SOCKTYPE",
      "socket type not supported"
    ]
  ],
  [
    -114,
    [
      "EALREADY",
      "connection already in progress"
    ]
  ],
  [
    -9,
    [
      "EBADF",
      "bad file descriptor"
    ]
  ],
  [
    -16,
    [
      "EBUSY",
      "resource busy or locked"
    ]
  ],
  [
    -125,
    [
      "ECANCELED",
      "operation canceled"
    ]
  ],
  [
    -4080,
    [
      "ECHARSET",
      "invalid Unicode character"
    ]
  ],
  [
    -103,
    [
      "ECONNABORTED",
      "software caused connection abort"
    ]
  ],
  [
    -111,
    [
      "ECONNREFUSED",
      "connection refused"
    ]
  ],
  [
    -104,
    [
      "ECONNRESET",
      "connection reset by peer"
    ]
  ],
  [
    -89,
    [
      "EDESTADDRREQ",
      "destination address required"
    ]
  ],
  [
    -17,
    [
      "EEXIST",
      "file already exists"
    ]
  ],
  [
    -14,
    [
      "EFAULT",
      "bad address in system call argument"
    ]
  ],
  [
    -27,
    [
      "EFBIG",
      "file too large"
    ]
  ],
  [
    -113,
    [
      "EHOSTUNREACH",
      "host is unreachable"
    ]
  ],
  [
    -4,
    [
      "EINTR",
      "interrupted system call"
    ]
  ],
  [
    -22,
    [
      "EINVAL",
      "invalid argument"
    ]
  ],
  [
    -5,
    [
      "EIO",
      "i/o error"
    ]
  ],
  [
    -106,
    [
      "EISCONN",
      "socket is already connected"
    ]
  ],
  [
    -21,
    [
      "EISDIR",
      "illegal operation on a directory"
    ]
  ],
  [
    -40,
    [
      "ELOOP",
      "too many symbolic links encountered"
    ]
  ],
  [
    -24,
    [
      "EMFILE",
      "too many open files"
    ]
  ],
  [
    -90,
    [
      "EMSGSIZE",
      "message too long"
    ]
  ],
  [
    -36,
    [
      "ENAMETOOLONG",
      "name too long"
    ]
  ],
  [
    -100,
    [
      "ENETDOWN",
      "network is down"
    ]
  ],
  [
    -101,
    [
      "ENETUNREACH",
      "network is unreachable"
    ]
  ],
  [
    -23,
    [
      "ENFILE",
      "file table overflow"
    ]
  ],
  [
    -105,
    [
      "ENOBUFS",
      "no buffer space available"
    ]
  ],
  [
    -19,
    [
      "ENODEV",
      "no such device"
    ]
  ],
  [
    -2,
    [
      "ENOENT",
      "no such file or directory"
    ]
  ],
  [
    -12,
    [
      "ENOMEM",
      "not enough memory"
    ]
  ],
  [
    -64,
    [
      "ENONET",
      "machine is not on the network"
    ]
  ],
  [
    -92,
    [
      "ENOPROTOOPT",
      "protocol not available"
    ]
  ],
  [
    -28,
    [
      "ENOSPC",
      "no space left on device"
    ]
  ],
  [
    -38,
    [
      "ENOSYS",
      "function not implemented"
    ]
  ],
  [
    -107,
    [
      "ENOTCONN",
      "socket is not connected"
    ]
  ],
  [
    -20,
    [
      "ENOTDIR",
      "not a directory"
    ]
  ],
  [
    -39,
    [
      "ENOTEMPTY",
      "directory not empty"
    ]
  ],
  [
    -88,
    [
      "ENOTSOCK",
      "socket operation on non-socket"
    ]
  ],
  [
    -95,
    [
      "ENOTSUP",
      "operation not supported on socket"
    ]
  ],
  [
    -1,
    [
      "EPERM",
      "operation not permitted"
    ]
  ],
  [
    -32,
    [
      "EPIPE",
      "broken pipe"
    ]
  ],
  [
    -71,
    [
      "EPROTO",
      "protocol error"
    ]
  ],
  [
    -93,
    [
      "EPROTONOSUPPORT",
      "protocol not supported"
    ]
  ],
  [
    -91,
    [
      "EPROTOTYPE",
      "protocol wrong type for socket"
    ]
  ],
  [
    -34,
    [
      "ERANGE",
      "result too large"
    ]
  ],
  [
    -30,
    [
      "EROFS",
      "read-only file system"
    ]
  ],
  [
    -108,
    [
      "ESHUTDOWN",
      "cannot send after transport endpoint shutdown"
    ]
  ],
  [
    -29,
    [
      "ESPIPE",
      "invalid seek"
    ]
  ],
  [
    -3,
    [
      "ESRCH",
      "no such process"
    ]
  ],
  [
    -110,
    [
      "ETIMEDOUT",
      "connection timed out"
    ]
  ],
  [
    -26,
    [
      "ETXTBSY",
      "text file is busy"
    ]
  ],
  [
    -18,
    [
      "EXDEV",
      "cross-device link not permitted"
    ]
  ],
  [
    -4094,
    [
      "UNKNOWN",
      "unknown error"
    ]
  ],
  [
    -4095,
    [
      "EOF",
      "end of file"
    ]
  ],
  [
    -6,
    [
      "ENXIO",
      "no such device or address"
    ]
  ],
  [
    -31,
    [
      "EMLINK",
      "too many links"
    ]
  ],
  [
    -112,
    [
      "EHOSTDOWN",
      "host is down"
    ]
  ],
  [
    -121,
    [
      "EREMOTEIO",
      "remote I/O error"
    ]
  ],
  [
    -25,
    [
      "ENOTTY",
      "inappropriate ioctl for device"
    ]
  ],
  [
    -4028,
    [
      "EFTYPE",
      "inappropriate file type or format"
    ]
  ],
  [
    -84,
    [
      "EILSEQ",
      "illegal byte sequence"
    ]
  ]
];
var errorToCodeLinux = codeToErrorLinux.map(([status, [code]]) => [
  code,
  status
]);
var errorMap = new Map(osType === "windows" ? codeToErrorWindows : osType === "darwin" ? codeToErrorDarwin : osType === "linux" ? codeToErrorLinux : unreachable());
var codeMap = new Map(osType === "windows" ? errorToCodeWindows : osType === "darwin" ? errorToCodeDarwin : osType === "linux" ? errorToCodeLinux : unreachable());
function mapSysErrnoToUvErrno(sysErrno) {
  if (osType === "windows") {
    const code = uvTranslateSysError(sysErrno);
    return codeMap.get(code) ?? -sysErrno;
  } else {
    return -sysErrno;
  }
}
var UV_EAI_MEMORY = codeMap.get("EAI_MEMORY");
var UV_UNKNOWN = codeMap.get("UNKNOWN");
var UV_EBADF = codeMap.get("EBADF");
var UV_EINVAL = codeMap.get("EINVAL");
var UV_ENOTSOCK = codeMap.get("ENOTSOCK");
var mod3 = {
  UV_EEXIST,
  UV_ENOENT,
  errorMap,
  codeMap,
  mapSysErrnoToUvErrno,
  UV_EAI_MEMORY,
  UV_UNKNOWN,
  UV_EBADF,
  UV_EINVAL,
  UV_ENOTSOCK
};
var Encodings;
(function(Encodings1) {
  Encodings1[Encodings1["ASCII"] = 0] = "ASCII";
  Encodings1[Encodings1["UTF8"] = 1] = "UTF8";
  Encodings1[Encodings1["BASE64"] = 2] = "BASE64";
  Encodings1[Encodings1["UCS2"] = 3] = "UCS2";
  Encodings1[Encodings1["BINARY"] = 4] = "BINARY";
  Encodings1[Encodings1["HEX"] = 5] = "HEX";
  Encodings1[Encodings1["BUFFER"] = 6] = "BUFFER";
  Encodings1[Encodings1["BASE64URL"] = 7] = "BASE64URL";
  Encodings1[Encodings1["LATIN1"] = 4] = "LATIN1";
})(Encodings || (Encodings = {}));
var encodings = [];
encodings[Encodings.ASCII] = "ascii";
encodings[Encodings.BASE64] = "base64";
encodings[Encodings.BASE64URL] = "base64url";
encodings[Encodings.BUFFER] = "buffer";
encodings[Encodings.HEX] = "hex";
encodings[Encodings.LATIN1] = "latin1";
encodings[Encodings.UCS2] = "utf16le";
encodings[Encodings.UTF8] = "utf8";
var __default1 = {
  encodings
};
var mod4 = {
  encodings,
  default: __default1
};
function indexOfNeedle(source, needle, start = 0) {
  if (start >= source.length) {
    return -1;
  }
  if (start < 0) {
    start = Math.max(0, source.length + start);
  }
  const s = needle[0];
  for (let i23 = start; i23 < source.length; i23++) {
    if (source[i23] !== s)
      continue;
    const pin = i23;
    let matched = 1;
    let j = i23;
    while (matched < needle.length) {
      j++;
      if (source[j] !== needle[j - pin]) {
        break;
      }
      matched++;
    }
    if (matched === needle.length) {
      return pin;
    }
  }
  return -1;
}
function numberToBytes(n) {
  if (n === 0)
    return new Uint8Array([
      0
    ]);
  const bytes = [];
  bytes.unshift(n & 255);
  while (n >= 256) {
    n = n >>> 8;
    bytes.unshift(n & 255);
  }
  return new Uint8Array(bytes);
}
function findLastIndex(targetBuffer, buffer, offset) {
  offset = offset > targetBuffer.length ? targetBuffer.length : offset;
  const searchableBuffer = targetBuffer.slice(0, offset + buffer.length);
  const searchableBufferLastIndex = searchableBuffer.length - 1;
  const bufferLastIndex = buffer.length - 1;
  let lastMatchIndex = -1;
  let matches = 0;
  let index = -1;
  for (let x = 0; x <= searchableBufferLastIndex; x++) {
    if (searchableBuffer[searchableBufferLastIndex - x] === buffer[bufferLastIndex - matches]) {
      if (lastMatchIndex === -1) {
        lastMatchIndex = x;
      }
      matches++;
    } else {
      matches = 0;
      if (lastMatchIndex !== -1) {
        x = lastMatchIndex + 1;
        lastMatchIndex = -1;
      }
      continue;
    }
    if (matches === buffer.length) {
      index = x;
      break;
    }
  }
  if (index === -1)
    return index;
  return searchableBufferLastIndex - index;
}
function indexOfBuffer(targetBuffer, buffer, byteOffset, encoding, forwardDirection) {
  if (!Encodings[encoding] === void 0) {
    throw new Error(`Unknown encoding code ${encoding}`);
  }
  if (!forwardDirection) {
    if (byteOffset < 0) {
      byteOffset = targetBuffer.length + byteOffset;
    }
    if (buffer.length === 0) {
      return byteOffset <= targetBuffer.length ? byteOffset : targetBuffer.length;
    }
    return findLastIndex(targetBuffer, buffer, byteOffset);
  }
  if (buffer.length === 0) {
    return byteOffset <= targetBuffer.length ? byteOffset : targetBuffer.length;
  }
  return indexOfNeedle(targetBuffer, buffer, byteOffset);
}
function indexOfNumber(targetBuffer, number, byteOffset, forwardDirection) {
  const bytes = numberToBytes(number);
  if (bytes.length > 1) {
    throw new Error("Multi byte number search is not supported");
  }
  return indexOfBuffer(targetBuffer, numberToBytes(number), byteOffset, Encodings.UTF8, forwardDirection);
}
var __default2 = {
  indexOfBuffer,
  indexOfNumber
};
var mod5 = {
  indexOfBuffer,
  indexOfNumber,
  numberToBytes,
  default: __default2
};
var base64abc = [
  "A",
  "B",
  "C",
  "D",
  "E",
  "F",
  "G",
  "H",
  "I",
  "J",
  "K",
  "L",
  "M",
  "N",
  "O",
  "P",
  "Q",
  "R",
  "S",
  "T",
  "U",
  "V",
  "W",
  "X",
  "Y",
  "Z",
  "a",
  "b",
  "c",
  "d",
  "e",
  "f",
  "g",
  "h",
  "i",
  "j",
  "k",
  "l",
  "m",
  "n",
  "o",
  "p",
  "q",
  "r",
  "s",
  "t",
  "u",
  "v",
  "w",
  "x",
  "y",
  "z",
  "0",
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "8",
  "9",
  "+",
  "/"
];
function encode(data) {
  const uint8 = typeof data === "string" ? new TextEncoder().encode(data) : data instanceof Uint8Array ? data : new Uint8Array(data);
  let result = "", i24;
  const l = uint8.length;
  for (i24 = 2; i24 < l; i24 += 3) {
    result += base64abc[uint8[i24 - 2] >> 2];
    result += base64abc[(uint8[i24 - 2] & 3) << 4 | uint8[i24 - 1] >> 4];
    result += base64abc[(uint8[i24 - 1] & 15) << 2 | uint8[i24] >> 6];
    result += base64abc[uint8[i24] & 63];
  }
  if (i24 === l + 1) {
    result += base64abc[uint8[i24 - 2] >> 2];
    result += base64abc[(uint8[i24 - 2] & 3) << 4];
    result += "==";
  }
  if (i24 === l) {
    result += base64abc[uint8[i24 - 2] >> 2];
    result += base64abc[(uint8[i24 - 2] & 3) << 4 | uint8[i24 - 1] >> 4];
    result += base64abc[(uint8[i24 - 1] & 15) << 2];
    result += "=";
  }
  return result;
}
function decode(b64) {
  const binString = atob(b64);
  const size = binString.length;
  const bytes = new Uint8Array(size);
  for (let i25 = 0; i25 < size; i25++) {
    bytes[i25] = binString.charCodeAt(i25);
  }
  return bytes;
}
function addPaddingToBase64url(base64url) {
  if (base64url.length % 4 === 2)
    return base64url + "==";
  if (base64url.length % 4 === 3)
    return base64url + "=";
  if (base64url.length % 4 === 1) {
    throw new TypeError("Illegal base64url string!");
  }
  return base64url;
}
function convertBase64urlToBase64(b64url) {
  if (!/^[-_A-Z0-9]*?={0,2}$/i.test(b64url)) {
    throw new TypeError("Failed to decode base64url: invalid character");
  }
  return addPaddingToBase64url(b64url).replace(/\-/g, "+").replace(/_/g, "/");
}
function convertBase64ToBase64url(b64) {
  return b64.replace(/=/g, "").replace(/\+/g, "-").replace(/\//g, "_");
}
function encode1(data) {
  return convertBase64ToBase64url(encode(data));
}
function decode1(b64url) {
  return decode(convertBase64urlToBase64(b64url));
}
function asciiToBytes(str) {
  const byteArray = [];
  for (let i26 = 0; i26 < str.length; ++i26) {
    byteArray.push(str.charCodeAt(i26) & 255);
  }
  return new Uint8Array(byteArray);
}
function base64ToBytes(str) {
  str = base64clean(str);
  str = str.replaceAll("-", "+").replaceAll("_", "/");
  return decode(str);
}
var INVALID_BASE64_RE = /[^+/0-9A-Za-z-_]/g;
function base64clean(str) {
  str = str.split("=")[0];
  str = str.trim().replace(INVALID_BASE64_RE, "");
  if (str.length < 2)
    return "";
  while (str.length % 4 !== 0) {
    str = str + "=";
  }
  return str;
}
function base64UrlToBytes(str) {
  str = base64clean(str);
  str = str.replaceAll("+", "-").replaceAll("/", "_");
  return decode1(str);
}
function hexToBytes(str) {
  const byteArray = new Uint8Array(Math.floor((str || "").length / 2));
  let i27;
  for (i27 = 0; i27 < byteArray.length; i27++) {
    const a = Number.parseInt(str[i27 * 2], 16);
    const b = Number.parseInt(str[i27 * 2 + 1], 16);
    if (Number.isNaN(a) && Number.isNaN(b)) {
      break;
    }
    byteArray[i27] = a << 4 | b;
  }
  return new Uint8Array(i27 === byteArray.length ? byteArray : byteArray.slice(0, i27));
}
function utf16leToBytes(str, units) {
  let c, hi, lo;
  const byteArray = [];
  for (let i28 = 0; i28 < str.length; ++i28) {
    if ((units -= 2) < 0) {
      break;
    }
    c = str.charCodeAt(i28);
    hi = c >> 8;
    lo = c % 256;
    byteArray.push(lo);
    byteArray.push(hi);
  }
  return new Uint8Array(byteArray);
}
function bytesToAscii(bytes) {
  let ret = "";
  for (let i29 = 0; i29 < bytes.length; ++i29) {
    ret += String.fromCharCode(bytes[i29] & 127);
  }
  return ret;
}
function bytesToUtf16le(bytes) {
  let res = "";
  for (let i30 = 0; i30 < bytes.length - 1; i30 += 2) {
    res += String.fromCharCode(bytes[i30] + bytes[i30 + 1] * 256);
  }
  return res;
}
var utf8Encoder = new TextEncoder();
var float32Array = new Float32Array(1);
var uInt8Float32Array = new Uint8Array(float32Array.buffer);
var float64Array = new Float64Array(1);
var uInt8Float64Array = new Uint8Array(float64Array.buffer);
float32Array[0] = -1;
var bigEndian = uInt8Float32Array[3] === 0;
function readUInt48LE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 5];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 6);
  }
  return first + buf[++offset] * 2 ** 8 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 24 + (buf[++offset] + last * 2 ** 8) * 2 ** 32;
}
function readUInt40LE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 4];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 5);
  }
  return first + buf[++offset] * 2 ** 8 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 24 + last * 2 ** 32;
}
function readUInt24LE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 2];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 3);
  }
  return first + buf[++offset] * 2 ** 8 + last * 2 ** 16;
}
function readUInt48BE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 5];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 6);
  }
  return (first * 2 ** 8 + buf[++offset]) * 2 ** 32 + buf[++offset] * 2 ** 24 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 8 + last;
}
function readUInt40BE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 4];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 5);
  }
  return first * 2 ** 32 + buf[++offset] * 2 ** 24 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 8 + last;
}
function readUInt24BE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 2];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 3);
  }
  return first * 2 ** 16 + buf[++offset] * 2 ** 8 + last;
}
function readUInt16BE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 1];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 2);
  }
  return first * 2 ** 8 + last;
}
function readUInt32BE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 3];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 4);
  }
  return first * 2 ** 24 + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 8 + last;
}
function readDoubleBackwards(buffer, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buffer[offset];
  const last = buffer[offset + 7];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buffer.length - 8);
  }
  uInt8Float64Array[7] = first;
  uInt8Float64Array[6] = buffer[++offset];
  uInt8Float64Array[5] = buffer[++offset];
  uInt8Float64Array[4] = buffer[++offset];
  uInt8Float64Array[3] = buffer[++offset];
  uInt8Float64Array[2] = buffer[++offset];
  uInt8Float64Array[1] = buffer[++offset];
  uInt8Float64Array[0] = last;
  return float64Array[0];
}
function readDoubleForwards(buffer, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buffer[offset];
  const last = buffer[offset + 7];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buffer.length - 8);
  }
  uInt8Float64Array[0] = first;
  uInt8Float64Array[1] = buffer[++offset];
  uInt8Float64Array[2] = buffer[++offset];
  uInt8Float64Array[3] = buffer[++offset];
  uInt8Float64Array[4] = buffer[++offset];
  uInt8Float64Array[5] = buffer[++offset];
  uInt8Float64Array[6] = buffer[++offset];
  uInt8Float64Array[7] = last;
  return float64Array[0];
}
function writeDoubleForwards(buffer, val, offset = 0) {
  val = +val;
  checkBounds(buffer, offset, 7);
  float64Array[0] = val;
  buffer[offset++] = uInt8Float64Array[0];
  buffer[offset++] = uInt8Float64Array[1];
  buffer[offset++] = uInt8Float64Array[2];
  buffer[offset++] = uInt8Float64Array[3];
  buffer[offset++] = uInt8Float64Array[4];
  buffer[offset++] = uInt8Float64Array[5];
  buffer[offset++] = uInt8Float64Array[6];
  buffer[offset++] = uInt8Float64Array[7];
  return offset;
}
function writeDoubleBackwards(buffer, val, offset = 0) {
  val = +val;
  checkBounds(buffer, offset, 7);
  float64Array[0] = val;
  buffer[offset++] = uInt8Float64Array[7];
  buffer[offset++] = uInt8Float64Array[6];
  buffer[offset++] = uInt8Float64Array[5];
  buffer[offset++] = uInt8Float64Array[4];
  buffer[offset++] = uInt8Float64Array[3];
  buffer[offset++] = uInt8Float64Array[2];
  buffer[offset++] = uInt8Float64Array[1];
  buffer[offset++] = uInt8Float64Array[0];
  return offset;
}
function readFloatBackwards(buffer, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buffer[offset];
  const last = buffer[offset + 3];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buffer.length - 4);
  }
  uInt8Float32Array[3] = first;
  uInt8Float32Array[2] = buffer[++offset];
  uInt8Float32Array[1] = buffer[++offset];
  uInt8Float32Array[0] = last;
  return float32Array[0];
}
function readFloatForwards(buffer, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buffer[offset];
  const last = buffer[offset + 3];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buffer.length - 4);
  }
  uInt8Float32Array[0] = first;
  uInt8Float32Array[1] = buffer[++offset];
  uInt8Float32Array[2] = buffer[++offset];
  uInt8Float32Array[3] = last;
  return float32Array[0];
}
function writeFloatForwards(buffer, val, offset = 0) {
  val = +val;
  checkBounds(buffer, offset, 3);
  float32Array[0] = val;
  buffer[offset++] = uInt8Float32Array[0];
  buffer[offset++] = uInt8Float32Array[1];
  buffer[offset++] = uInt8Float32Array[2];
  buffer[offset++] = uInt8Float32Array[3];
  return offset;
}
function writeFloatBackwards(buffer, val, offset = 0) {
  val = +val;
  checkBounds(buffer, offset, 3);
  float32Array[0] = val;
  buffer[offset++] = uInt8Float32Array[3];
  buffer[offset++] = uInt8Float32Array[2];
  buffer[offset++] = uInt8Float32Array[1];
  buffer[offset++] = uInt8Float32Array[0];
  return offset;
}
function readInt24LE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 2];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 3);
  }
  const val = first + buf[++offset] * 2 ** 8 + last * 2 ** 16;
  return val | (val & 2 ** 23) * 510;
}
function readInt40LE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 4];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 5);
  }
  return (last | (last & 2 ** 7) * 33554430) * 2 ** 32 + first + buf[++offset] * 2 ** 8 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 24;
}
function readInt48LE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 5];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 6);
  }
  const val = buf[offset + 4] + last * 2 ** 8;
  return (val | (val & 2 ** 15) * 131070) * 2 ** 32 + first + buf[++offset] * 2 ** 8 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 24;
}
function readInt24BE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 2];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 3);
  }
  const val = first * 2 ** 16 + buf[++offset] * 2 ** 8 + last;
  return val | (val & 2 ** 23) * 510;
}
function readInt48BE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 5];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 6);
  }
  const val = buf[++offset] + first * 2 ** 8;
  return (val | (val & 2 ** 15) * 131070) * 2 ** 32 + buf[++offset] * 2 ** 24 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 8 + last;
}
function readInt40BE(buf, offset = 0) {
  validateNumber1(offset, "offset");
  const first = buf[offset];
  const last = buf[offset + 4];
  if (first === void 0 || last === void 0) {
    boundsError(offset, buf.length - 5);
  }
  return (first | (first & 2 ** 7) * 33554430) * 2 ** 32 + buf[++offset] * 2 ** 24 + buf[++offset] * 2 ** 16 + buf[++offset] * 2 ** 8 + last;
}
function byteLengthUtf8(str) {
  return utf8Encoder.encode(str).length;
}
function base64ByteLength(str, bytes) {
  if (str.charCodeAt(bytes - 1) === 61) {
    bytes--;
  }
  if (bytes > 1 && str.charCodeAt(bytes - 1) === 61) {
    bytes--;
  }
  return bytes * 3 >>> 2;
}
var encodingsMap = /* @__PURE__ */ Object.create(null);
for (let i = 0; i < encodings.length; ++i) {
  encodingsMap[encodings[i]] = i;
}
var encodingOps = {
  ascii: {
    byteLength: (string) => string.length,
    encoding: "ascii",
    encodingVal: encodingsMap.ascii,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, asciiToBytes(val), byteOffset, encodingsMap.ascii, dir),
    slice: (buf, start, end) => buf.asciiSlice(start, end),
    write: (buf, string, offset, len) => buf.asciiWrite(string, offset, len)
  },
  base64: {
    byteLength: (string) => base64ByteLength(string, string.length),
    encoding: "base64",
    encodingVal: encodingsMap.base64,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, base64ToBytes(val), byteOffset, encodingsMap.base64, dir),
    slice: (buf, start, end) => buf.base64Slice(start, end),
    write: (buf, string, offset, len) => buf.base64Write(string, offset, len)
  },
  base64url: {
    byteLength: (string) => base64ByteLength(string, string.length),
    encoding: "base64url",
    encodingVal: encodingsMap.base64url,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, base64UrlToBytes(val), byteOffset, encodingsMap.base64url, dir),
    slice: (buf, start, end) => buf.base64urlSlice(start, end),
    write: (buf, string, offset, len) => buf.base64urlWrite(string, offset, len)
  },
  hex: {
    byteLength: (string) => string.length >>> 1,
    encoding: "hex",
    encodingVal: encodingsMap.hex,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, hexToBytes(val), byteOffset, encodingsMap.hex, dir),
    slice: (buf, start, end) => buf.hexSlice(start, end),
    write: (buf, string, offset, len) => buf.hexWrite(string, offset, len)
  },
  latin1: {
    byteLength: (string) => string.length,
    encoding: "latin1",
    encodingVal: encodingsMap.latin1,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, asciiToBytes(val), byteOffset, encodingsMap.latin1, dir),
    slice: (buf, start, end) => buf.latin1Slice(start, end),
    write: (buf, string, offset, len) => buf.latin1Write(string, offset, len)
  },
  ucs2: {
    byteLength: (string) => string.length * 2,
    encoding: "ucs2",
    encodingVal: encodingsMap.utf16le,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, utf16leToBytes(val), byteOffset, encodingsMap.utf16le, dir),
    slice: (buf, start, end) => buf.ucs2Slice(start, end),
    write: (buf, string, offset, len) => buf.ucs2Write(string, offset, len)
  },
  utf8: {
    byteLength: byteLengthUtf8,
    encoding: "utf8",
    encodingVal: encodingsMap.utf8,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, utf8Encoder.encode(val), byteOffset, encodingsMap.utf8, dir),
    slice: (buf, start, end) => buf.utf8Slice(start, end),
    write: (buf, string, offset, len) => buf.utf8Write(string, offset, len)
  },
  utf16le: {
    byteLength: (string) => string.length * 2,
    encoding: "utf16le",
    encodingVal: encodingsMap.utf16le,
    indexOf: (buf, val, byteOffset, dir) => indexOfBuffer(buf, utf16leToBytes(val), byteOffset, encodingsMap.utf16le, dir),
    slice: (buf, start, end) => buf.ucs2Slice(start, end),
    write: (buf, string, offset, len) => buf.ucs2Write(string, offset, len)
  }
};
function getEncodingOps(encoding) {
  encoding = String(encoding).toLowerCase();
  switch (encoding.length) {
    case 4:
      if (encoding === "utf8")
        return encodingOps.utf8;
      if (encoding === "ucs2")
        return encodingOps.ucs2;
      break;
    case 5:
      if (encoding === "utf-8")
        return encodingOps.utf8;
      if (encoding === "ascii")
        return encodingOps.ascii;
      if (encoding === "ucs-2")
        return encodingOps.ucs2;
      break;
    case 7:
      if (encoding === "utf16le") {
        return encodingOps.utf16le;
      }
      break;
    case 8:
      if (encoding === "utf-16le") {
        return encodingOps.utf16le;
      }
      break;
    case 6:
      if (encoding === "latin1" || encoding === "binary") {
        return encodingOps.latin1;
      }
      if (encoding === "base64")
        return encodingOps.base64;
    case 3:
      if (encoding === "hex") {
        return encodingOps.hex;
      }
      break;
    case 9:
      if (encoding === "base64url") {
        return encodingOps.base64url;
      }
      break;
  }
}
function _copyActual(source, target, targetStart, sourceStart, sourceEnd) {
  if (sourceEnd - sourceStart > target.length - targetStart) {
    sourceEnd = sourceStart + target.length - targetStart;
  }
  let nb = sourceEnd - sourceStart;
  const sourceLen = source.length - sourceStart;
  if (nb > sourceLen) {
    nb = sourceLen;
  }
  if (sourceStart !== 0 || sourceEnd < source.length) {
    source = new Uint8Array(source.buffer, source.byteOffset + sourceStart, nb);
  }
  target.set(source, targetStart);
  return nb;
}
function boundsError(value, length, type) {
  if (Math.floor(value) !== value) {
    validateNumber1(value, type);
    throw new codes.ERR_OUT_OF_RANGE(type || "offset", "an integer", value);
  }
  if (length < 0) {
    throw new codes.ERR_BUFFER_OUT_OF_BOUNDS();
  }
  throw new codes.ERR_OUT_OF_RANGE(type || "offset", `>= ${type ? 1 : 0} and <= ${length}`, value);
}
function validateNumber1(value, name) {
  if (typeof value !== "number") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "number", value);
  }
}
function checkBounds(buf, offset, byteLength1) {
  validateNumber1(offset, "offset");
  if (buf[offset] === void 0 || buf[offset + byteLength1] === void 0) {
    boundsError(offset, buf.length - (byteLength1 + 1));
  }
}
function checkInt(value, min4, max, buf, offset, byteLength2) {
  if (value > max || value < min4) {
    const n = typeof min4 === "bigint" ? "n" : "";
    let range;
    if (byteLength2 > 3) {
      if (min4 === 0 || min4 === 0n) {
        range = `>= 0${n} and < 2${n} ** ${(byteLength2 + 1) * 8}${n}`;
      } else {
        range = `>= -(2${n} ** ${(byteLength2 + 1) * 8 - 1}${n}) and < 2${n} ** ${(byteLength2 + 1) * 8 - 1}${n}`;
      }
    } else {
      range = `>= ${min4}${n} and <= ${max}${n}`;
    }
    throw new codes.ERR_OUT_OF_RANGE("value", range, value);
  }
  checkBounds(buf, offset, byteLength2);
}
function toInteger(n, defaultVal) {
  n = +n;
  if (!Number.isNaN(n) && n >= Number.MIN_SAFE_INTEGER && n <= Number.MAX_SAFE_INTEGER) {
    return n % 1 === 0 ? n : Math.floor(n);
  }
  return defaultVal;
}
function writeU_Int8(buf, value, offset, min5, max) {
  value = +value;
  validateNumber1(offset, "offset");
  if (value > max || value < min5) {
    throw new codes.ERR_OUT_OF_RANGE("value", `>= ${min5} and <= ${max}`, value);
  }
  if (buf[offset] === void 0) {
    boundsError(offset, buf.length - 1);
  }
  buf[offset] = value;
  return offset + 1;
}
function writeU_Int16BE(buf, value, offset, min6, max) {
  value = +value;
  checkInt(value, min6, max, buf, offset, 1);
  buf[offset++] = value >>> 8;
  buf[offset++] = value;
  return offset;
}
function _writeUInt32LE(buf, value, offset, min7, max) {
  value = +value;
  checkInt(value, min7, max, buf, offset, 3);
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  return offset;
}
function writeU_Int16LE(buf, value, offset, min8, max) {
  value = +value;
  checkInt(value, min8, max, buf, offset, 1);
  buf[offset++] = value;
  buf[offset++] = value >>> 8;
  return offset;
}
function _writeUInt32BE(buf, value, offset, min9, max) {
  value = +value;
  checkInt(value, min9, max, buf, offset, 3);
  buf[offset + 3] = value;
  value = value >>> 8;
  buf[offset + 2] = value;
  value = value >>> 8;
  buf[offset + 1] = value;
  value = value >>> 8;
  buf[offset] = value;
  return offset + 4;
}
function writeU_Int48BE(buf, value, offset, min10, max) {
  value = +value;
  checkInt(value, min10, max, buf, offset, 5);
  const newVal = Math.floor(value * 2 ** -32);
  buf[offset++] = newVal >>> 8;
  buf[offset++] = newVal;
  buf[offset + 3] = value;
  value = value >>> 8;
  buf[offset + 2] = value;
  value = value >>> 8;
  buf[offset + 1] = value;
  value = value >>> 8;
  buf[offset] = value;
  return offset + 4;
}
function writeU_Int40BE(buf, value, offset, min11, max) {
  value = +value;
  checkInt(value, min11, max, buf, offset, 4);
  buf[offset++] = Math.floor(value * 2 ** -32);
  buf[offset + 3] = value;
  value = value >>> 8;
  buf[offset + 2] = value;
  value = value >>> 8;
  buf[offset + 1] = value;
  value = value >>> 8;
  buf[offset] = value;
  return offset + 4;
}
function writeU_Int32BE(buf, value, offset, min12, max) {
  value = +value;
  checkInt(value, min12, max, buf, offset, 3);
  buf[offset + 3] = value;
  value = value >>> 8;
  buf[offset + 2] = value;
  value = value >>> 8;
  buf[offset + 1] = value;
  value = value >>> 8;
  buf[offset] = value;
  return offset + 4;
}
function writeU_Int24BE(buf, value, offset, min13, max) {
  value = +value;
  checkInt(value, min13, max, buf, offset, 2);
  buf[offset + 2] = value;
  value = value >>> 8;
  buf[offset + 1] = value;
  value = value >>> 8;
  buf[offset] = value;
  return offset + 3;
}
function validateOffset(value, name, min14 = 0, max = Number.MAX_SAFE_INTEGER) {
  if (typeof value !== "number") {
    throw new codes.ERR_INVALID_ARG_TYPE(name, "number", value);
  }
  if (!Number.isInteger(value)) {
    throw new codes.ERR_OUT_OF_RANGE(name, "an integer", value);
  }
  if (value < min14 || value > max) {
    throw new codes.ERR_OUT_OF_RANGE(name, `>= ${min14} && <= ${max}`, value);
  }
}
function writeU_Int48LE(buf, value, offset, min15, max) {
  value = +value;
  checkInt(value, min15, max, buf, offset, 5);
  const newVal = Math.floor(value * 2 ** -32);
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  buf[offset++] = newVal;
  buf[offset++] = newVal >>> 8;
  return offset;
}
function writeU_Int40LE(buf, value, offset, min16, max) {
  value = +value;
  checkInt(value, min16, max, buf, offset, 4);
  const newVal = value;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  buf[offset++] = Math.floor(newVal * 2 ** -32);
  return offset;
}
function writeU_Int32LE(buf, value, offset, min17, max) {
  value = +value;
  checkInt(value, min17, max, buf, offset, 3);
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  return offset;
}
function writeU_Int24LE(buf, value, offset, min18, max) {
  value = +value;
  checkInt(value, min18, max, buf, offset, 2);
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  value = value >>> 8;
  buf[offset++] = value;
  return offset;
}
var kMaxLength = 2147483647;
var MAX_UINT32 = 2 ** 32;
var customInspectSymbol1 = typeof Symbol === "function" && typeof Symbol["for"] === "function" ? Symbol["for"]("nodejs.util.inspect.custom") : null;
var INSPECT_MAX_BYTES = 50;
Object.defineProperty(Buffer2.prototype, "parent", {
  enumerable: true,
  get: function() {
    if (!Buffer2.isBuffer(this)) {
      return void 0;
    }
    return this.buffer;
  }
});
Object.defineProperty(Buffer2.prototype, "offset", {
  enumerable: true,
  get: function() {
    if (!Buffer2.isBuffer(this)) {
      return void 0;
    }
    return this.byteOffset;
  }
});
function createBuffer(length) {
  if (length > 2147483647) {
    throw new RangeError('The value "' + length + '" is invalid for option "size"');
  }
  const buf = new Uint8Array(length);
  Object.setPrototypeOf(buf, Buffer2.prototype);
  return buf;
}
function Buffer2(arg, encodingOrOffset, length) {
  if (typeof arg === "number") {
    if (typeof encodingOrOffset === "string") {
      throw new codes.ERR_INVALID_ARG_TYPE("string", "string", arg);
    }
    return _allocUnsafe(arg);
  }
  return _from(arg, encodingOrOffset, length);
}
Buffer2.poolSize = 8192;
function _from(value, encodingOrOffset, length) {
  if (typeof value === "string") {
    return fromString(value, encodingOrOffset);
  }
  if (typeof value === "object" && value !== null) {
    if (isAnyArrayBuffer1(value)) {
      return fromArrayBuffer(value, encodingOrOffset, length);
    }
    const valueOf = value.valueOf && value.valueOf();
    if (valueOf != null && valueOf !== value && (typeof valueOf === "string" || typeof valueOf === "object")) {
      return _from(valueOf, encodingOrOffset, length);
    }
    const b = fromObject(value);
    if (b) {
      return b;
    }
    if (typeof value[Symbol.toPrimitive] === "function") {
      const primitive = value[Symbol.toPrimitive]("string");
      if (typeof primitive === "string") {
        return fromString(primitive, encodingOrOffset);
      }
    }
  }
  throw new codes.ERR_INVALID_ARG_TYPE("first argument", [
    "string",
    "Buffer",
    "ArrayBuffer",
    "Array",
    "Array-like Object"
  ], value);
}
Buffer2.from = function from(value, encodingOrOffset, length) {
  return _from(value, encodingOrOffset, length);
};
Object.setPrototypeOf(Buffer2.prototype, Uint8Array.prototype);
Object.setPrototypeOf(Buffer2, Uint8Array);
function assertSize(size) {
  validateNumber1(size, "size");
  if (!(size >= 0 && size <= 2147483647)) {
    throw new codes.ERR_INVALID_ARG_VALUE.RangeError("size", size);
  }
}
function _alloc(size, fill2, encoding) {
  assertSize(size);
  const buffer = createBuffer(size);
  if (fill2 !== void 0) {
    if (encoding !== void 0 && typeof encoding !== "string") {
      throw new codes.ERR_INVALID_ARG_TYPE("encoding", "string", encoding);
    }
    return buffer.fill(fill2, encoding);
  }
  return buffer;
}
Buffer2.alloc = function alloc(size, fill2, encoding) {
  return _alloc(size, fill2, encoding);
};
function _allocUnsafe(size) {
  assertSize(size);
  return createBuffer(size < 0 ? 0 : checked(size) | 0);
}
Buffer2.allocUnsafe = function allocUnsafe(size) {
  return _allocUnsafe(size);
};
Buffer2.allocUnsafeSlow = function allocUnsafeSlow(size) {
  return _allocUnsafe(size);
};
function fromString(string, encoding) {
  if (typeof encoding !== "string" || encoding === "") {
    encoding = "utf8";
  }
  if (!Buffer2.isEncoding(encoding)) {
    throw new codes.ERR_UNKNOWN_ENCODING(encoding);
  }
  const length = byteLength(string, encoding) | 0;
  let buf = createBuffer(length);
  const actual = buf.write(string, encoding);
  if (actual !== length) {
    buf = buf.slice(0, actual);
  }
  return buf;
}
function fromArrayLike(array) {
  const length = array.length < 0 ? 0 : checked(array.length) | 0;
  const buf = createBuffer(length);
  for (let i31 = 0; i31 < length; i31 += 1) {
    buf[i31] = array[i31] & 255;
  }
  return buf;
}
function fromObject(obj) {
  if (obj.length !== void 0 || isAnyArrayBuffer1(obj.buffer)) {
    if (typeof obj.length !== "number") {
      return createBuffer(0);
    }
    return fromArrayLike(obj);
  }
  if (obj.type === "Buffer" && Array.isArray(obj.data)) {
    return fromArrayLike(obj.data);
  }
}
function checked(length) {
  if (length >= 2147483647) {
    throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x" + 2147483647 .toString(16) + " bytes");
  }
  return length | 0;
}
function SlowBuffer(length) {
  assertSize(length);
  return Buffer2.alloc(+length);
}
Object.setPrototypeOf(SlowBuffer.prototype, Uint8Array.prototype);
Object.setPrototypeOf(SlowBuffer, Uint8Array);
Buffer2.isBuffer = function isBuffer(b) {
  return b != null && b._isBuffer === true && b !== Buffer2.prototype;
};
Buffer2.compare = function compare(a, b) {
  if (isInstance(a, Uint8Array)) {
    a = Buffer2.from(a, a.offset, a.byteLength);
  }
  if (isInstance(b, Uint8Array)) {
    b = Buffer2.from(b, b.offset, b.byteLength);
  }
  if (!Buffer2.isBuffer(a) || !Buffer2.isBuffer(b)) {
    throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');
  }
  if (a === b) {
    return 0;
  }
  let x = a.length;
  let y = b.length;
  for (let i32 = 0, len = Math.min(x, y); i32 < len; ++i32) {
    if (a[i32] !== b[i32]) {
      x = a[i32];
      y = b[i32];
      break;
    }
  }
  if (x < y) {
    return -1;
  }
  if (y < x) {
    return 1;
  }
  return 0;
};
Buffer2.isEncoding = function isEncoding(encoding) {
  return typeof encoding === "string" && encoding.length !== 0 && normalizeEncoding1(encoding) !== void 0;
};
Buffer2.concat = function concat(list, length) {
  if (!Array.isArray(list)) {
    throw new codes.ERR_INVALID_ARG_TYPE("list", "Array", list);
  }
  if (list.length === 0) {
    return Buffer2.alloc(0);
  }
  if (length === void 0) {
    length = 0;
    for (let i33 = 0; i33 < list.length; i33++) {
      if (list[i33].length) {
        length += list[i33].length;
      }
    }
  } else {
    validateOffset(length, "length");
  }
  const buffer = Buffer2.allocUnsafe(length);
  let pos = 0;
  for (let i34 = 0; i34 < list.length; i34++) {
    const buf = list[i34];
    if (!isUint8Array(buf)) {
      throw new codes.ERR_INVALID_ARG_TYPE(`list[${i34}]`, [
        "Buffer",
        "Uint8Array"
      ], list[i34]);
    }
    pos += _copyActual(buf, buffer, pos, 0, buf.length);
  }
  if (pos < length) {
    buffer.fill(0, pos, length);
  }
  return buffer;
};
function byteLength(string, encoding) {
  if (typeof string !== "string") {
    if (isArrayBufferView(string) || isAnyArrayBuffer1(string)) {
      return string.byteLength;
    }
    throw new codes.ERR_INVALID_ARG_TYPE("string", [
      "string",
      "Buffer",
      "ArrayBuffer"
    ], string);
  }
  const len = string.length;
  const mustMatch = arguments.length > 2 && arguments[2] === true;
  if (!mustMatch && len === 0) {
    return 0;
  }
  if (!encoding) {
    return mustMatch ? -1 : byteLengthUtf8(string);
  }
  const ops = getEncodingOps(encoding);
  if (ops === void 0) {
    return mustMatch ? -1 : byteLengthUtf8(string);
  }
  return ops.byteLength(string);
}
Buffer2.byteLength = byteLength;
Buffer2.prototype._isBuffer = true;
function swap(b, n, m) {
  const i35 = b[n];
  b[n] = b[m];
  b[m] = i35;
}
Buffer2.prototype.swap16 = function swap16() {
  const len = this.length;
  if (len % 2 !== 0) {
    throw new RangeError("Buffer size must be a multiple of 16-bits");
  }
  for (let i36 = 0; i36 < len; i36 += 2) {
    swap(this, i36, i36 + 1);
  }
  return this;
};
Buffer2.prototype.swap32 = function swap32() {
  const len = this.length;
  if (len % 4 !== 0) {
    throw new RangeError("Buffer size must be a multiple of 32-bits");
  }
  for (let i37 = 0; i37 < len; i37 += 4) {
    swap(this, i37, i37 + 3);
    swap(this, i37 + 1, i37 + 2);
  }
  return this;
};
Buffer2.prototype.swap64 = function swap64() {
  const len = this.length;
  if (len % 8 !== 0) {
    throw new RangeError("Buffer size must be a multiple of 64-bits");
  }
  for (let i38 = 0; i38 < len; i38 += 8) {
    swap(this, i38, i38 + 7);
    swap(this, i38 + 1, i38 + 6);
    swap(this, i38 + 2, i38 + 5);
    swap(this, i38 + 3, i38 + 4);
  }
  return this;
};
Buffer2.prototype.toString = function toString(encoding, start, end) {
  if (arguments.length === 0) {
    return this.utf8Slice(0, this.length);
  }
  const len = this.length;
  if (start <= 0) {
    start = 0;
  } else if (start >= len) {
    return "";
  } else {
    start |= 0;
  }
  if (end === void 0 || end > len) {
    end = len;
  } else {
    end |= 0;
  }
  if (end <= start) {
    return "";
  }
  if (encoding === void 0) {
    return this.utf8Slice(start, end);
  }
  const ops = getEncodingOps(encoding);
  if (ops === void 0) {
    throw new codes.ERR_UNKNOWN_ENCODING(encoding);
  }
  return ops.slice(this, start, end);
};
Buffer2.prototype.toLocaleString = Buffer2.prototype.toString;
Buffer2.prototype.equals = function equals(b) {
  if (!isUint8Array(b)) {
    throw new codes.ERR_INVALID_ARG_TYPE("otherBuffer", [
      "Buffer",
      "Uint8Array"
    ], b);
  }
  if (this === b) {
    return true;
  }
  return Buffer2.compare(this, b) === 0;
};
Buffer2.prototype.inspect = function inspect2() {
  let str = "";
  const max = INSPECT_MAX_BYTES;
  str = this.toString("hex", 0, max).replace(/(.{2})/g, "$1 ").trim();
  if (this.length > max) {
    str += " ... ";
  }
  return "<Buffer " + str + ">";
};
if (customInspectSymbol1) {
  Buffer2.prototype[customInspectSymbol1] = Buffer2.prototype.inspect;
}
Buffer2.prototype.compare = function compare2(target, start, end, thisStart, thisEnd) {
  if (isInstance(target, Uint8Array)) {
    target = Buffer2.from(target, target.offset, target.byteLength);
  }
  if (!Buffer2.isBuffer(target)) {
    throw new codes.ERR_INVALID_ARG_TYPE("target", [
      "Buffer",
      "Uint8Array"
    ], target);
  }
  if (start === void 0) {
    start = 0;
  } else {
    validateOffset(start, "targetStart", 0, kMaxLength);
  }
  if (end === void 0) {
    end = target.length;
  } else {
    validateOffset(end, "targetEnd", 0, target.length);
  }
  if (thisStart === void 0) {
    thisStart = 0;
  } else {
    validateOffset(start, "sourceStart", 0, kMaxLength);
  }
  if (thisEnd === void 0) {
    thisEnd = this.length;
  } else {
    validateOffset(end, "sourceEnd", 0, this.length);
  }
  if (start < 0 || end > target.length || thisStart < 0 || thisEnd > this.length) {
    throw new codes.ERR_OUT_OF_RANGE("out of range index", "range");
  }
  if (thisStart >= thisEnd && start >= end) {
    return 0;
  }
  if (thisStart >= thisEnd) {
    return -1;
  }
  if (start >= end) {
    return 1;
  }
  start >>>= 0;
  end >>>= 0;
  thisStart >>>= 0;
  thisEnd >>>= 0;
  if (this === target) {
    return 0;
  }
  let x = thisEnd - thisStart;
  let y = end - start;
  const len = Math.min(x, y);
  const thisCopy = this.slice(thisStart, thisEnd);
  const targetCopy = target.slice(start, end);
  for (let i39 = 0; i39 < len; ++i39) {
    if (thisCopy[i39] !== targetCopy[i39]) {
      x = thisCopy[i39];
      y = targetCopy[i39];
      break;
    }
  }
  if (x < y) {
    return -1;
  }
  if (y < x) {
    return 1;
  }
  return 0;
};
function bidirectionalIndexOf(buffer, val, byteOffset, encoding, dir) {
  validateBuffer(buffer);
  if (typeof byteOffset === "string") {
    encoding = byteOffset;
    byteOffset = void 0;
  } else if (byteOffset > 2147483647) {
    byteOffset = 2147483647;
  } else if (byteOffset < -2147483648) {
    byteOffset = -2147483648;
  }
  byteOffset = +byteOffset;
  if (Number.isNaN(byteOffset)) {
    byteOffset = dir ? 0 : buffer.length || buffer.byteLength;
  }
  dir = !!dir;
  if (typeof val === "number") {
    return indexOfNumber(buffer, val >>> 0, byteOffset, dir);
  }
  let ops;
  if (encoding === void 0) {
    ops = encodingOps.utf8;
  } else {
    ops = getEncodingOps(encoding);
  }
  if (typeof val === "string") {
    if (ops === void 0) {
      throw new codes.ERR_UNKNOWN_ENCODING(encoding);
    }
    return ops.indexOf(buffer, val, byteOffset, dir);
  }
  if (isUint8Array(val)) {
    const encodingVal = ops === void 0 ? encodingsMap.utf8 : ops.encodingVal;
    return indexOfBuffer(buffer, val, byteOffset, encodingVal, dir);
  }
  throw new codes.ERR_INVALID_ARG_TYPE("value", [
    "number",
    "string",
    "Buffer",
    "Uint8Array"
  ], val);
}
Buffer2.prototype.includes = function includes(val, byteOffset, encoding) {
  return this.indexOf(val, byteOffset, encoding) !== -1;
};
Buffer2.prototype.indexOf = function indexOf(val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, true);
};
Buffer2.prototype.lastIndexOf = function lastIndexOf(val, byteOffset, encoding) {
  return bidirectionalIndexOf(this, val, byteOffset, encoding, false);
};
Buffer2.prototype.asciiSlice = function asciiSlice(offset, length) {
  if (offset === 0 && length === this.length) {
    return bytesToAscii(this);
  } else {
    return bytesToAscii(this.slice(offset, length));
  }
};
Buffer2.prototype.asciiWrite = function asciiWrite(string, offset, length) {
  return blitBuffer(asciiToBytes(string), this, offset, length);
};
Buffer2.prototype.base64Slice = function base64Slice(offset, length) {
  if (offset === 0 && length === this.length) {
    return encode(this);
  } else {
    return encode(this.slice(offset, length));
  }
};
Buffer2.prototype.base64Write = function base64Write(string, offset, length) {
  return blitBuffer(base64ToBytes(string), this, offset, length);
};
Buffer2.prototype.base64urlSlice = function base64urlSlice(offset, length) {
  if (offset === 0 && length === this.length) {
    return encode1(this);
  } else {
    return encode1(this.slice(offset, length));
  }
};
Buffer2.prototype.base64urlWrite = function base64urlWrite(string, offset, length) {
  return blitBuffer(base64UrlToBytes(string), this, offset, length);
};
Buffer2.prototype.hexWrite = function hexWrite(string, offset, length) {
  return blitBuffer(hexToBytes(string, this.length - offset), this, offset, length);
};
Buffer2.prototype.hexSlice = function hexSlice2(string, offset, length) {
  return _hexSlice(this, string, offset, length);
};
Buffer2.prototype.latin1Slice = function latin1Slice(string, offset, length) {
  return _latin1Slice(this, string, offset, length);
};
Buffer2.prototype.latin1Write = function latin1Write(string, offset, length) {
  return blitBuffer(asciiToBytes(string), this, offset, length);
};
Buffer2.prototype.ucs2Slice = function ucs2Slice(offset, length) {
  if (offset === 0 && length === this.length) {
    return bytesToUtf16le(this);
  } else {
    return bytesToUtf16le(this.slice(offset, length));
  }
};
Buffer2.prototype.ucs2Write = function ucs2Write(string, offset, length) {
  return blitBuffer(utf16leToBytes(string, this.length - offset), this, offset, length);
};
Buffer2.prototype.utf8Slice = function utf8Slice(string, offset, length) {
  return _utf8Slice(this, string, offset, length);
};
Buffer2.prototype.utf8Write = function utf8Write(string, offset, length) {
  return blitBuffer(utf8ToBytes(string, this.length - offset), this, offset, length);
};
Buffer2.prototype.write = function write(string, offset, length, encoding) {
  if (offset === void 0) {
    return this.utf8Write(string, 0, this.length);
  }
  if (length === void 0 && typeof offset === "string") {
    encoding = offset;
    length = this.length;
    offset = 0;
  } else {
    validateOffset(offset, "offset", 0, this.length);
    const remaining = this.length - offset;
    if (length === void 0) {
      length = remaining;
    } else if (typeof length === "string") {
      encoding = length;
      length = remaining;
    } else {
      validateOffset(length, "length", 0, this.length);
      if (length > remaining) {
        length = remaining;
      }
    }
  }
  if (!encoding) {
    return this.utf8Write(string, offset, length);
  }
  const ops = getEncodingOps(encoding);
  if (ops === void 0) {
    throw new codes.ERR_UNKNOWN_ENCODING(encoding);
  }
  return ops.write(this, string, offset, length);
};
Buffer2.prototype.toJSON = function toJSON() {
  return {
    type: "Buffer",
    data: Array.prototype.slice.call(this._arr || this, 0)
  };
};
function fromArrayBuffer(obj, byteOffset, length) {
  if (byteOffset === void 0) {
    byteOffset = 0;
  } else {
    byteOffset = +byteOffset;
    if (Number.isNaN(byteOffset)) {
      byteOffset = 0;
    }
  }
  const maxLength = obj.byteLength - byteOffset;
  if (maxLength < 0) {
    throw new codes.ERR_BUFFER_OUT_OF_BOUNDS("offset");
  }
  if (length === void 0) {
    length = maxLength;
  } else {
    length = +length;
    if (length > 0) {
      if (length > maxLength) {
        throw new codes.ERR_BUFFER_OUT_OF_BOUNDS("length");
      }
    } else {
      length = 0;
    }
  }
  const buffer = new Uint8Array(obj, byteOffset, length);
  Object.setPrototypeOf(buffer, Buffer2.prototype);
  return buffer;
}
function _utf8Slice(buf, start, end) {
  end = Math.min(buf.length, end);
  const res = [];
  let i40 = start;
  while (i40 < end) {
    const firstByte = buf[i40];
    let codePoint = null;
    let bytesPerSequence = firstByte > 239 ? 4 : firstByte > 223 ? 3 : firstByte > 191 ? 2 : 1;
    if (i40 + bytesPerSequence <= end) {
      let secondByte, thirdByte, fourthByte, tempCodePoint;
      switch (bytesPerSequence) {
        case 1:
          if (firstByte < 128) {
            codePoint = firstByte;
          }
          break;
        case 2:
          secondByte = buf[i40 + 1];
          if ((secondByte & 192) === 128) {
            tempCodePoint = (firstByte & 31) << 6 | secondByte & 63;
            if (tempCodePoint > 127) {
              codePoint = tempCodePoint;
            }
          }
          break;
        case 3:
          secondByte = buf[i40 + 1];
          thirdByte = buf[i40 + 2];
          if ((secondByte & 192) === 128 && (thirdByte & 192) === 128) {
            tempCodePoint = (firstByte & 15) << 12 | (secondByte & 63) << 6 | thirdByte & 63;
            if (tempCodePoint > 2047 && (tempCodePoint < 55296 || tempCodePoint > 57343)) {
              codePoint = tempCodePoint;
            }
          }
          break;
        case 4:
          secondByte = buf[i40 + 1];
          thirdByte = buf[i40 + 2];
          fourthByte = buf[i40 + 3];
          if ((secondByte & 192) === 128 && (thirdByte & 192) === 128 && (fourthByte & 192) === 128) {
            tempCodePoint = (firstByte & 15) << 18 | (secondByte & 63) << 12 | (thirdByte & 63) << 6 | fourthByte & 63;
            if (tempCodePoint > 65535 && tempCodePoint < 1114112) {
              codePoint = tempCodePoint;
            }
          }
      }
    }
    if (codePoint === null) {
      codePoint = 65533;
      bytesPerSequence = 1;
    } else if (codePoint > 65535) {
      codePoint -= 65536;
      res.push(codePoint >>> 10 & 1023 | 55296);
      codePoint = 56320 | codePoint & 1023;
    }
    res.push(codePoint);
    i40 += bytesPerSequence;
  }
  return decodeCodePointsArray(res);
}
var MAX_ARGUMENTS_LENGTH = 4096;
function decodeCodePointsArray(codePoints) {
  const len = codePoints.length;
  if (len <= 4096) {
    return String.fromCharCode.apply(String, codePoints);
  }
  let res = "";
  let i41 = 0;
  while (i41 < len) {
    res += String.fromCharCode.apply(String, codePoints.slice(i41, i41 += MAX_ARGUMENTS_LENGTH));
  }
  return res;
}
function _latin1Slice(buf, start, end) {
  let ret = "";
  end = Math.min(buf.length, end);
  for (let i42 = start; i42 < end; ++i42) {
    ret += String.fromCharCode(buf[i42]);
  }
  return ret;
}
function _hexSlice(buf, start, end) {
  const len = buf.length;
  if (!start || start < 0) {
    start = 0;
  }
  if (!end || end < 0 || end > len) {
    end = len;
  }
  let out = "";
  for (let i43 = start; i43 < end; ++i43) {
    out += hexSliceLookupTable[buf[i43]];
  }
  return out;
}
Buffer2.prototype.slice = function slice(start, end) {
  const len = this.length;
  start = ~~start;
  end = end === void 0 ? len : ~~end;
  if (start < 0) {
    start += len;
    if (start < 0) {
      start = 0;
    }
  } else if (start > len) {
    start = len;
  }
  if (end < 0) {
    end += len;
    if (end < 0) {
      end = 0;
    }
  } else if (end > len) {
    end = len;
  }
  if (end < start) {
    end = start;
  }
  const newBuf = this.subarray(start, end);
  Object.setPrototypeOf(newBuf, Buffer2.prototype);
  return newBuf;
};
Buffer2.prototype.readUintLE = Buffer2.prototype.readUIntLE = function readUIntLE(offset, byteLength1) {
  if (offset === void 0) {
    throw new codes.ERR_INVALID_ARG_TYPE("offset", "number", offset);
  }
  if (byteLength1 === 6) {
    return readUInt48LE(this, offset);
  }
  if (byteLength1 === 5) {
    return readUInt40LE(this, offset);
  }
  if (byteLength1 === 3) {
    return readUInt24LE(this, offset);
  }
  if (byteLength1 === 4) {
    return this.readUInt32LE(offset);
  }
  if (byteLength1 === 2) {
    return this.readUInt16LE(offset);
  }
  if (byteLength1 === 1) {
    return this.readUInt8(offset);
  }
  boundsError(byteLength1, 6, "byteLength");
};
Buffer2.prototype.readUintBE = Buffer2.prototype.readUIntBE = function readUIntBE(offset, byteLength2) {
  if (offset === void 0) {
    throw new codes.ERR_INVALID_ARG_TYPE("offset", "number", offset);
  }
  if (byteLength2 === 6) {
    return readUInt48BE(this, offset);
  }
  if (byteLength2 === 5) {
    return readUInt40BE(this, offset);
  }
  if (byteLength2 === 3) {
    return readUInt24BE(this, offset);
  }
  if (byteLength2 === 4) {
    return this.readUInt32BE(offset);
  }
  if (byteLength2 === 2) {
    return this.readUInt16BE(offset);
  }
  if (byteLength2 === 1) {
    return this.readUInt8(offset);
  }
  boundsError(byteLength2, 6, "byteLength");
};
Buffer2.prototype.readUint8 = Buffer2.prototype.readUInt8 = function readUInt8(offset = 0) {
  validateNumber1(offset, "offset");
  const val = this[offset];
  if (val === void 0) {
    boundsError(offset, this.length - 1);
  }
  return val;
};
Buffer2.prototype.readUint16BE = Buffer2.prototype.readUInt16BE = readUInt16BE;
Buffer2.prototype.readUint16LE = Buffer2.prototype.readUInt16LE = function readUInt16LE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 1];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 2);
  }
  return first + last * 2 ** 8;
};
Buffer2.prototype.readUint32LE = Buffer2.prototype.readUInt32LE = function readUInt32LE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 3];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 4);
  }
  return first + this[++offset] * 2 ** 8 + this[++offset] * 2 ** 16 + last * 2 ** 24;
};
Buffer2.prototype.readUint32BE = Buffer2.prototype.readUInt32BE = readUInt32BE;
Buffer2.prototype.readBigUint64LE = Buffer2.prototype.readBigUInt64LE = defineBigIntMethod(function readBigUInt64LE(offset) {
  offset = offset >>> 0;
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 7];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 8);
  }
  const lo = first + this[++offset] * 2 ** 8 + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 24;
  const hi = this[++offset] + this[++offset] * 2 ** 8 + this[++offset] * 2 ** 16 + last * 2 ** 24;
  return BigInt(lo) + (BigInt(hi) << BigInt(32));
});
Buffer2.prototype.readBigUint64BE = Buffer2.prototype.readBigUInt64BE = defineBigIntMethod(function readBigUInt64BE(offset) {
  offset = offset >>> 0;
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 7];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 8);
  }
  const hi = first * 2 ** 24 + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 8 + this[++offset];
  const lo = this[++offset] * 2 ** 24 + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 8 + last;
  return (BigInt(hi) << BigInt(32)) + BigInt(lo);
});
Buffer2.prototype.readIntLE = function readIntLE(offset, byteLength3) {
  if (offset === void 0) {
    throw new codes.ERR_INVALID_ARG_TYPE("offset", "number", offset);
  }
  if (byteLength3 === 6) {
    return readInt48LE(this, offset);
  }
  if (byteLength3 === 5) {
    return readInt40LE(this, offset);
  }
  if (byteLength3 === 3) {
    return readInt24LE(this, offset);
  }
  if (byteLength3 === 4) {
    return this.readInt32LE(offset);
  }
  if (byteLength3 === 2) {
    return this.readInt16LE(offset);
  }
  if (byteLength3 === 1) {
    return this.readInt8(offset);
  }
  boundsError(byteLength3, 6, "byteLength");
};
Buffer2.prototype.readIntBE = function readIntBE(offset, byteLength4) {
  if (offset === void 0) {
    throw new codes.ERR_INVALID_ARG_TYPE("offset", "number", offset);
  }
  if (byteLength4 === 6) {
    return readInt48BE(this, offset);
  }
  if (byteLength4 === 5) {
    return readInt40BE(this, offset);
  }
  if (byteLength4 === 3) {
    return readInt24BE(this, offset);
  }
  if (byteLength4 === 4) {
    return this.readInt32BE(offset);
  }
  if (byteLength4 === 2) {
    return this.readInt16BE(offset);
  }
  if (byteLength4 === 1) {
    return this.readInt8(offset);
  }
  boundsError(byteLength4, 6, "byteLength");
};
Buffer2.prototype.readInt8 = function readInt8(offset = 0) {
  validateNumber1(offset, "offset");
  const val = this[offset];
  if (val === void 0) {
    boundsError(offset, this.length - 1);
  }
  return val | (val & 2 ** 7) * 33554430;
};
Buffer2.prototype.readInt16LE = function readInt16LE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 1];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 2);
  }
  const val = first + last * 2 ** 8;
  return val | (val & 2 ** 15) * 131070;
};
Buffer2.prototype.readInt16BE = function readInt16BE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 1];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 2);
  }
  const val = first * 2 ** 8 + last;
  return val | (val & 2 ** 15) * 131070;
};
Buffer2.prototype.readInt32LE = function readInt32LE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 3];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 4);
  }
  return first + this[++offset] * 2 ** 8 + this[++offset] * 2 ** 16 + (last << 24);
};
Buffer2.prototype.readInt32BE = function readInt32BE(offset = 0) {
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 3];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 4);
  }
  return (first << 24) + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 8 + last;
};
Buffer2.prototype.readBigInt64LE = defineBigIntMethod(function readBigInt64LE(offset) {
  offset = offset >>> 0;
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 7];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 8);
  }
  const val = this[offset + 4] + this[offset + 5] * 2 ** 8 + this[offset + 6] * 2 ** 16 + (last << 24);
  return (BigInt(val) << BigInt(32)) + BigInt(first + this[++offset] * 2 ** 8 + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 24);
});
Buffer2.prototype.readBigInt64BE = defineBigIntMethod(function readBigInt64BE(offset) {
  offset = offset >>> 0;
  validateNumber1(offset, "offset");
  const first = this[offset];
  const last = this[offset + 7];
  if (first === void 0 || last === void 0) {
    boundsError(offset, this.length - 8);
  }
  const val = (first << 24) + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 8 + this[++offset];
  return (BigInt(val) << BigInt(32)) + BigInt(this[++offset] * 2 ** 24 + this[++offset] * 2 ** 16 + this[++offset] * 2 ** 8 + last);
});
Buffer2.prototype.readFloatLE = function readFloatLE(offset) {
  return bigEndian ? readFloatBackwards(this, offset) : readFloatForwards(this, offset);
};
Buffer2.prototype.readFloatBE = function readFloatBE(offset) {
  return bigEndian ? readFloatForwards(this, offset) : readFloatBackwards(this, offset);
};
Buffer2.prototype.readDoubleLE = function readDoubleLE(offset) {
  return bigEndian ? readDoubleBackwards(this, offset) : readDoubleForwards(this, offset);
};
Buffer2.prototype.readDoubleBE = function readDoubleBE(offset) {
  return bigEndian ? readDoubleForwards(this, offset) : readDoubleBackwards(this, offset);
};
Buffer2.prototype.writeUintLE = Buffer2.prototype.writeUIntLE = function writeUIntLE(value, offset, byteLength5) {
  if (byteLength5 === 6) {
    return writeU_Int48LE(this, value, offset, 0, 281474976710655);
  }
  if (byteLength5 === 5) {
    return writeU_Int40LE(this, value, offset, 0, 1099511627775);
  }
  if (byteLength5 === 3) {
    return writeU_Int24LE(this, value, offset, 0, 16777215);
  }
  if (byteLength5 === 4) {
    return writeU_Int32LE(this, value, offset, 0, 4294967295);
  }
  if (byteLength5 === 2) {
    return writeU_Int16LE(this, value, offset, 0, 65535);
  }
  if (byteLength5 === 1) {
    return writeU_Int8(this, value, offset, 0, 255);
  }
  boundsError(byteLength5, 6, "byteLength");
};
Buffer2.prototype.writeUintBE = Buffer2.prototype.writeUIntBE = function writeUIntBE(value, offset, byteLength6) {
  if (byteLength6 === 6) {
    return writeU_Int48BE(this, value, offset, 0, 281474976710655);
  }
  if (byteLength6 === 5) {
    return writeU_Int40BE(this, value, offset, 0, 1099511627775);
  }
  if (byteLength6 === 3) {
    return writeU_Int24BE(this, value, offset, 0, 16777215);
  }
  if (byteLength6 === 4) {
    return writeU_Int32BE(this, value, offset, 0, 4294967295);
  }
  if (byteLength6 === 2) {
    return writeU_Int16BE(this, value, offset, 0, 65535);
  }
  if (byteLength6 === 1) {
    return writeU_Int8(this, value, offset, 0, 255);
  }
  boundsError(byteLength6, 6, "byteLength");
};
Buffer2.prototype.writeUint8 = Buffer2.prototype.writeUInt8 = function writeUInt8(value, offset = 0) {
  return writeU_Int8(this, value, offset, 0, 255);
};
Buffer2.prototype.writeUint16LE = Buffer2.prototype.writeUInt16LE = function writeUInt16LE(value, offset = 0) {
  return writeU_Int16LE(this, value, offset, 0, 65535);
};
Buffer2.prototype.writeUint16BE = Buffer2.prototype.writeUInt16BE = function writeUInt16BE(value, offset = 0) {
  return writeU_Int16BE(this, value, offset, 0, 65535);
};
Buffer2.prototype.writeUint32LE = Buffer2.prototype.writeUInt32LE = function writeUInt32LE(value, offset = 0) {
  return _writeUInt32LE(this, value, offset, 0, 4294967295);
};
Buffer2.prototype.writeUint32BE = Buffer2.prototype.writeUInt32BE = function writeUInt32BE(value, offset = 0) {
  return _writeUInt32BE(this, value, offset, 0, 4294967295);
};
function wrtBigUInt64LE(buf, value, offset, min19, max) {
  checkIntBI(value, min19, max, buf, offset, 7);
  let lo = Number(value & BigInt(4294967295));
  buf[offset++] = lo;
  lo = lo >> 8;
  buf[offset++] = lo;
  lo = lo >> 8;
  buf[offset++] = lo;
  lo = lo >> 8;
  buf[offset++] = lo;
  let hi = Number(value >> BigInt(32) & BigInt(4294967295));
  buf[offset++] = hi;
  hi = hi >> 8;
  buf[offset++] = hi;
  hi = hi >> 8;
  buf[offset++] = hi;
  hi = hi >> 8;
  buf[offset++] = hi;
  return offset;
}
function wrtBigUInt64BE(buf, value, offset, min20, max) {
  checkIntBI(value, min20, max, buf, offset, 7);
  let lo = Number(value & BigInt(4294967295));
  buf[offset + 7] = lo;
  lo = lo >> 8;
  buf[offset + 6] = lo;
  lo = lo >> 8;
  buf[offset + 5] = lo;
  lo = lo >> 8;
  buf[offset + 4] = lo;
  let hi = Number(value >> BigInt(32) & BigInt(4294967295));
  buf[offset + 3] = hi;
  hi = hi >> 8;
  buf[offset + 2] = hi;
  hi = hi >> 8;
  buf[offset + 1] = hi;
  hi = hi >> 8;
  buf[offset] = hi;
  return offset + 8;
}
Buffer2.prototype.writeBigUint64LE = Buffer2.prototype.writeBigUInt64LE = defineBigIntMethod(function writeBigUInt64LE(value, offset = 0) {
  return wrtBigUInt64LE(this, value, offset, BigInt(0), BigInt("0xffffffffffffffff"));
});
Buffer2.prototype.writeBigUint64BE = Buffer2.prototype.writeBigUInt64BE = defineBigIntMethod(function writeBigUInt64BE(value, offset = 0) {
  return wrtBigUInt64BE(this, value, offset, BigInt(0), BigInt("0xffffffffffffffff"));
});
Buffer2.prototype.writeIntLE = function writeIntLE(value, offset, byteLength7) {
  if (byteLength7 === 6) {
    return writeU_Int48LE(this, value, offset, -140737488355328, 140737488355327);
  }
  if (byteLength7 === 5) {
    return writeU_Int40LE(this, value, offset, -549755813888, 549755813887);
  }
  if (byteLength7 === 3) {
    return writeU_Int24LE(this, value, offset, -8388608, 8388607);
  }
  if (byteLength7 === 4) {
    return writeU_Int32LE(this, value, offset, -2147483648, 2147483647);
  }
  if (byteLength7 === 2) {
    return writeU_Int16LE(this, value, offset, -32768, 32767);
  }
  if (byteLength7 === 1) {
    return writeU_Int8(this, value, offset, -128, 127);
  }
  boundsError(byteLength7, 6, "byteLength");
};
Buffer2.prototype.writeIntBE = function writeIntBE(value, offset, byteLength8) {
  if (byteLength8 === 6) {
    return writeU_Int48BE(this, value, offset, -140737488355328, 140737488355327);
  }
  if (byteLength8 === 5) {
    return writeU_Int40BE(this, value, offset, -549755813888, 549755813887);
  }
  if (byteLength8 === 3) {
    return writeU_Int24BE(this, value, offset, -8388608, 8388607);
  }
  if (byteLength8 === 4) {
    return writeU_Int32BE(this, value, offset, -2147483648, 2147483647);
  }
  if (byteLength8 === 2) {
    return writeU_Int16BE(this, value, offset, -32768, 32767);
  }
  if (byteLength8 === 1) {
    return writeU_Int8(this, value, offset, -128, 127);
  }
  boundsError(byteLength8, 6, "byteLength");
};
Buffer2.prototype.writeInt8 = function writeInt8(value, offset = 0) {
  return writeU_Int8(this, value, offset, -128, 127);
};
Buffer2.prototype.writeInt16LE = function writeInt16LE(value, offset = 0) {
  return writeU_Int16LE(this, value, offset, -32768, 32767);
};
Buffer2.prototype.writeInt16BE = function writeInt16BE(value, offset = 0) {
  return writeU_Int16BE(this, value, offset, -32768, 32767);
};
Buffer2.prototype.writeInt32LE = function writeInt32LE(value, offset = 0) {
  return writeU_Int32LE(this, value, offset, -2147483648, 2147483647);
};
Buffer2.prototype.writeInt32BE = function writeInt32BE(value, offset = 0) {
  return writeU_Int32BE(this, value, offset, -2147483648, 2147483647);
};
Buffer2.prototype.writeBigInt64LE = defineBigIntMethod(function writeBigInt64LE(value, offset = 0) {
  return wrtBigUInt64LE(this, value, offset, -BigInt("0x8000000000000000"), BigInt("0x7fffffffffffffff"));
});
Buffer2.prototype.writeBigInt64BE = defineBigIntMethod(function writeBigInt64BE(value, offset = 0) {
  return wrtBigUInt64BE(this, value, offset, -BigInt("0x8000000000000000"), BigInt("0x7fffffffffffffff"));
});
Buffer2.prototype.writeFloatLE = function writeFloatLE(value, offset) {
  return bigEndian ? writeFloatBackwards(this, value, offset) : writeFloatForwards(this, value, offset);
};
Buffer2.prototype.writeFloatBE = function writeFloatBE(value, offset) {
  return bigEndian ? writeFloatForwards(this, value, offset) : writeFloatBackwards(this, value, offset);
};
Buffer2.prototype.writeDoubleLE = function writeDoubleLE(value, offset) {
  return bigEndian ? writeDoubleBackwards(this, value, offset) : writeDoubleForwards(this, value, offset);
};
Buffer2.prototype.writeDoubleBE = function writeDoubleBE(value, offset) {
  return bigEndian ? writeDoubleForwards(this, value, offset) : writeDoubleBackwards(this, value, offset);
};
Buffer2.prototype.copy = function copy(target, targetStart, sourceStart, sourceEnd) {
  if (!isUint8Array(this)) {
    throw new codes.ERR_INVALID_ARG_TYPE("source", [
      "Buffer",
      "Uint8Array"
    ], this);
  }
  if (!isUint8Array(target)) {
    throw new codes.ERR_INVALID_ARG_TYPE("target", [
      "Buffer",
      "Uint8Array"
    ], target);
  }
  if (targetStart === void 0) {
    targetStart = 0;
  } else {
    targetStart = toInteger(targetStart, 0);
    if (targetStart < 0) {
      throw new codes.ERR_OUT_OF_RANGE("targetStart", ">= 0", targetStart);
    }
  }
  if (sourceStart === void 0) {
    sourceStart = 0;
  } else {
    sourceStart = toInteger(sourceStart, 0);
    if (sourceStart < 0) {
      throw new codes.ERR_OUT_OF_RANGE("sourceStart", ">= 0", sourceStart);
    }
    if (sourceStart >= MAX_UINT32) {
      throw new codes.ERR_OUT_OF_RANGE("sourceStart", `< ${MAX_UINT32}`, sourceStart);
    }
  }
  if (sourceEnd === void 0) {
    sourceEnd = this.length;
  } else {
    sourceEnd = toInteger(sourceEnd, 0);
    if (sourceEnd < 0) {
      throw new codes.ERR_OUT_OF_RANGE("sourceEnd", ">= 0", sourceEnd);
    }
    if (sourceEnd >= MAX_UINT32) {
      throw new codes.ERR_OUT_OF_RANGE("sourceEnd", `< ${MAX_UINT32}`, sourceEnd);
    }
  }
  if (targetStart >= target.length) {
    return 0;
  }
  if (sourceEnd > 0 && sourceEnd < sourceStart) {
    sourceEnd = sourceStart;
  }
  if (sourceEnd === sourceStart) {
    return 0;
  }
  if (target.length === 0 || this.length === 0) {
    return 0;
  }
  if (sourceEnd > this.length) {
    sourceEnd = this.length;
  }
  if (target.length - targetStart < sourceEnd - sourceStart) {
    sourceEnd = target.length - targetStart + sourceStart;
  }
  const len = sourceEnd - sourceStart;
  if (this === target && typeof Uint8Array.prototype.copyWithin === "function") {
    this.copyWithin(targetStart, sourceStart, sourceEnd);
  } else {
    Uint8Array.prototype.set.call(target, this.subarray(sourceStart, sourceEnd), targetStart);
  }
  return len;
};
Buffer2.prototype.fill = function fill(val, start, end, encoding) {
  if (typeof val === "string") {
    if (typeof start === "string") {
      encoding = start;
      start = 0;
      end = this.length;
    } else if (typeof end === "string") {
      encoding = end;
      end = this.length;
    }
    if (encoding !== void 0 && typeof encoding !== "string") {
      throw new TypeError("encoding must be a string");
    }
    if (typeof encoding === "string" && !Buffer2.isEncoding(encoding)) {
      throw new TypeError("Unknown encoding: " + encoding);
    }
    if (val.length === 1) {
      const code = val.charCodeAt(0);
      if (encoding === "utf8" && code < 128 || encoding === "latin1") {
        val = code;
      }
    }
  } else if (typeof val === "number") {
    val = val & 255;
  } else if (typeof val === "boolean") {
    val = Number(val);
  }
  if (start < 0 || this.length < start || this.length < end) {
    throw new RangeError("Out of range index");
  }
  if (end <= start) {
    return this;
  }
  start = start >>> 0;
  end = end === void 0 ? this.length : end >>> 0;
  if (!val) {
    val = 0;
  }
  let i44;
  if (typeof val === "number") {
    for (i44 = start; i44 < end; ++i44) {
      this[i44] = val;
    }
  } else {
    const bytes = Buffer2.isBuffer(val) ? val : Buffer2.from(val, encoding);
    const len = bytes.length;
    if (len === 0) {
      throw new codes.ERR_INVALID_ARG_VALUE("value", val);
    }
    for (i44 = 0; i44 < end - start; ++i44) {
      this[i44 + start] = bytes[i44 % len];
    }
  }
  return this;
};
function checkBounds1(buf, offset, byteLength2) {
  validateNumber1(offset, "offset");
  if (buf[offset] === void 0 || buf[offset + byteLength2] === void 0) {
    boundsError(offset, buf.length - (byteLength2 + 1));
  }
}
function checkIntBI(value, min21, max, buf, offset, byteLength2) {
  if (value > max || value < min21) {
    const n = typeof min21 === "bigint" ? "n" : "";
    let range;
    if (byteLength2 > 3) {
      if (min21 === 0 || min21 === BigInt(0)) {
        range = `>= 0${n} and < 2${n} ** ${(byteLength2 + 1) * 8}${n}`;
      } else {
        range = `>= -(2${n} ** ${(byteLength2 + 1) * 8 - 1}${n}) and < 2 ** ${(byteLength2 + 1) * 8 - 1}${n}`;
      }
    } else {
      range = `>= ${min21}${n} and <= ${max}${n}`;
    }
    throw new codes.ERR_OUT_OF_RANGE("value", range, value);
  }
  checkBounds1(buf, offset, byteLength2);
}
function utf8ToBytes(string, units) {
  units = units || Infinity;
  let codePoint;
  const length = string.length;
  let leadSurrogate = null;
  const bytes = [];
  for (let i45 = 0; i45 < length; ++i45) {
    codePoint = string.charCodeAt(i45);
    if (codePoint > 55295 && codePoint < 57344) {
      if (!leadSurrogate) {
        if (codePoint > 56319) {
          if ((units -= 3) > -1) {
            bytes.push(239, 191, 189);
          }
          continue;
        } else if (i45 + 1 === length) {
          if ((units -= 3) > -1) {
            bytes.push(239, 191, 189);
          }
          continue;
        }
        leadSurrogate = codePoint;
        continue;
      }
      if (codePoint < 56320) {
        if ((units -= 3) > -1) {
          bytes.push(239, 191, 189);
        }
        leadSurrogate = codePoint;
        continue;
      }
      codePoint = (leadSurrogate - 55296 << 10 | codePoint - 56320) + 65536;
    } else if (leadSurrogate) {
      if ((units -= 3) > -1) {
        bytes.push(239, 191, 189);
      }
    }
    leadSurrogate = null;
    if (codePoint < 128) {
      if ((units -= 1) < 0) {
        break;
      }
      bytes.push(codePoint);
    } else if (codePoint < 2048) {
      if ((units -= 2) < 0) {
        break;
      }
      bytes.push(codePoint >> 6 | 192, codePoint & 63 | 128);
    } else if (codePoint < 65536) {
      if ((units -= 3) < 0) {
        break;
      }
      bytes.push(codePoint >> 12 | 224, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
    } else if (codePoint < 1114112) {
      if ((units -= 4) < 0) {
        break;
      }
      bytes.push(codePoint >> 18 | 240, codePoint >> 12 & 63 | 128, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
    } else {
      throw new Error("Invalid code point");
    }
  }
  return bytes;
}
function blitBuffer(src, dst, offset, byteLength9) {
  let i46;
  const length = byteLength9 === void 0 ? src.length : byteLength9;
  for (i46 = 0; i46 < length; ++i46) {
    if (i46 + offset >= dst.length || i46 >= src.length) {
      break;
    }
    dst[i46 + offset] = src[i46];
  }
  return i46;
}
function isInstance(obj, type) {
  return obj instanceof type || obj != null && obj.constructor != null && obj.constructor.name != null && obj.constructor.name === type.name;
}
var hexSliceLookupTable = function() {
  const alphabet = "0123456789abcdef";
  const table = new Array(256);
  for (let i47 = 0; i47 < 16; ++i47) {
    const i16 = i47 * 16;
    for (let j = 0; j < 16; ++j) {
      table[i16 + j] = alphabet[i47] + alphabet[j];
    }
  }
  return table;
}();
function defineBigIntMethod(fn) {
  return typeof BigInt === "undefined" ? BufferBigIntNotDefined : fn;
}
function BufferBigIntNotDefined() {
  throw new Error("BigInt not supported");
}
globalThis.atob;
globalThis.Blob;
globalThis.btoa;
var valueType;
(function(valueType1) {
  valueType1[valueType1["noIterator"] = 0] = "noIterator";
  valueType1[valueType1["isArray"] = 1] = "isArray";
  valueType1[valueType1["isSet"] = 2] = "isSet";
  valueType1[valueType1["isMap"] = 3] = "isMap";
})(valueType || (valueType = {}));
var NumberIsSafeInteger = Number.isSafeInteger;
function getSystemErrorName(code) {
  if (typeof code !== "number") {
    throw new codes.ERR_INVALID_ARG_TYPE("err", "number", code);
  }
  if (code >= 0 || !NumberIsSafeInteger(code)) {
    throw new codes.ERR_OUT_OF_RANGE("err", "a negative integer", code);
  }
  return errorMap.get(code)?.[0];
}
var DenoStdInternalError = class extends Error {
  constructor(message) {
    super(message);
    this.name = "DenoStdInternalError";
  }
};
function assert(expr, msg = "") {
  if (!expr) {
    throw new DenoStdInternalError(msg);
  }
}
var { errno: { ENOTDIR, ENOENT } } = os;
var kIsNodeError = Symbol("kIsNodeError");
var classRegExp1 = /^([A-Z][a-z0-9]*)+$/;
var kTypes = [
  "string",
  "function",
  "number",
  "object",
  "Function",
  "Object",
  "boolean",
  "bigint",
  "symbol"
];
var AbortError = class extends Error {
  code;
  constructor() {
    super("The operation was aborted");
    this.code = "ABORT_ERR";
    this.name = "AbortError";
  }
};
function addNumericalSeparator(val) {
  let res = "";
  let i51 = val.length;
  const start = val[0] === "-" ? 1 : 0;
  for (; i51 >= start + 4; i51 -= 3) {
    res = `_${val.slice(i51 - 3, i51)}${res}`;
  }
  return `${val.slice(0, i51)}${res}`;
}
var captureLargerStackTrace = hideStackFrames(function captureLargerStackTrace2(err) {
  Error.captureStackTrace(err);
  return err;
});
hideStackFrames(function uvExceptionWithHostPort(err, syscall, address, port) {
  const { 0: code, 1: uvmsg } = uvErrmapGet(err) || uvUnmappedError;
  const message = `${syscall} ${code}: ${uvmsg}`;
  let details = "";
  if (port && port > 0) {
    details = ` ${address}:${port}`;
  } else if (address) {
    details = ` ${address}`;
  }
  const ex = new Error(`${message}${details}`);
  ex.code = code;
  ex.errno = err;
  ex.syscall = syscall;
  ex.address = address;
  if (port) {
    ex.port = port;
  }
  return captureLargerStackTrace(ex);
});
var errnoException = hideStackFrames(function errnoException2(err, syscall, original) {
  const code = getSystemErrorName(err);
  const message = original ? `${syscall} ${code} ${original}` : `${syscall} ${code}`;
  const ex = new Error(message);
  ex.errno = err;
  ex.code = code;
  ex.syscall = syscall;
  return captureLargerStackTrace(ex);
});
function uvErrmapGet(name) {
  return errorMap.get(name);
}
var uvUnmappedError = [
  "UNKNOWN",
  "unknown error"
];
hideStackFrames(function uvException(ctx) {
  const { 0: code, 1: uvmsg } = uvErrmapGet(ctx.errno) || uvUnmappedError;
  let message = `${code}: ${ctx.message || uvmsg}, ${ctx.syscall}`;
  let path2;
  let dest;
  if (ctx.path) {
    path2 = ctx.path.toString();
    message += ` '${path2}'`;
  }
  if (ctx.dest) {
    dest = ctx.dest.toString();
    message += ` -> '${dest}'`;
  }
  const err = new Error(message);
  for (const prop of Object.keys(ctx)) {
    if (prop === "message" || prop === "path" || prop === "dest") {
      continue;
    }
    err[prop] = ctx[prop];
  }
  err.code = code;
  if (path2) {
    err.path = path2;
  }
  if (dest) {
    err.dest = dest;
  }
  return captureLargerStackTrace(err);
});
var exceptionWithHostPort = hideStackFrames(function exceptionWithHostPort2(err, syscall, address, port, additional) {
  const code = getSystemErrorName(err);
  let details = "";
  if (port && port > 0) {
    details = ` ${address}:${port}`;
  } else if (address) {
    details = ` ${address}`;
  }
  if (additional) {
    details += ` - Local (${additional})`;
  }
  const ex = new Error(`${syscall} ${code}${details}`);
  ex.errno = err;
  ex.code = code;
  ex.syscall = syscall;
  ex.address = address;
  if (port) {
    ex.port = port;
  }
  return captureLargerStackTrace(ex);
});
var dnsException = hideStackFrames(function(code, syscall, hostname) {
  let errno;
  if (typeof code === "number") {
    errno = code;
    if (code === codeMap.get("EAI_NODATA") || code === codeMap.get("EAI_NONAME")) {
      code = "ENOTFOUND";
    } else {
      code = getSystemErrorName(code);
    }
  }
  const message = `${syscall} ${code}${hostname ? ` ${hostname}` : ""}`;
  const ex = new Error(message);
  ex.errno = errno;
  ex.code = code;
  ex.syscall = syscall;
  if (hostname) {
    ex.hostname = hostname;
  }
  return captureLargerStackTrace(ex);
});
var NodeErrorAbstraction = class extends Error {
  code;
  constructor(name, code, message) {
    super(message);
    this.code = code;
    this.name = name;
    this.stack = this.stack && `${name} [${this.code}]${this.stack.slice(20)}`;
  }
  toString() {
    return `${this.name} [${this.code}]: ${this.message}`;
  }
};
var NodeError = class extends NodeErrorAbstraction {
  constructor(code, message) {
    super(Error.prototype.name, code, message);
  }
};
var NodeRangeError = class extends NodeErrorAbstraction {
  constructor(code, message) {
    super(RangeError.prototype.name, code, message);
    Object.setPrototypeOf(this, RangeError.prototype);
    this.toString = function() {
      return `${this.name} [${this.code}]: ${this.message}`;
    };
  }
};
var NodeTypeError = class extends NodeErrorAbstraction {
  constructor(code, message) {
    super(TypeError.prototype.name, code, message);
    Object.setPrototypeOf(this, TypeError.prototype);
    this.toString = function() {
      return `${this.name} [${this.code}]: ${this.message}`;
    };
  }
};
var NodeSystemError = class extends NodeErrorAbstraction {
  constructor(key, context, msgPrefix) {
    let message = `${msgPrefix}: ${context.syscall} returned ${context.code} (${context.message})`;
    if (context.path !== void 0) {
      message += ` ${context.path}`;
    }
    if (context.dest !== void 0) {
      message += ` => ${context.dest}`;
    }
    super("SystemError", key, message);
    captureLargerStackTrace(this);
    Object.defineProperties(this, {
      [kIsNodeError]: {
        value: true,
        enumerable: false,
        writable: false,
        configurable: true
      },
      info: {
        value: context,
        enumerable: true,
        configurable: true,
        writable: false
      },
      errno: {
        get() {
          return context.errno;
        },
        set: (value) => {
          context.errno = value;
        },
        enumerable: true,
        configurable: true
      },
      syscall: {
        get() {
          return context.syscall;
        },
        set: (value) => {
          context.syscall = value;
        },
        enumerable: true,
        configurable: true
      }
    });
    if (context.path !== void 0) {
      Object.defineProperty(this, "path", {
        get() {
          return context.path;
        },
        set: (value) => {
          context.path = value;
        },
        enumerable: true,
        configurable: true
      });
    }
    if (context.dest !== void 0) {
      Object.defineProperty(this, "dest", {
        get() {
          return context.dest;
        },
        set: (value) => {
          context.dest = value;
        },
        enumerable: true,
        configurable: true
      });
    }
  }
  toString() {
    return `${this.name} [${this.code}]: ${this.message}`;
  }
};
function makeSystemErrorWithCode(key, msgPrfix) {
  return class NodeError extends NodeSystemError {
    constructor(ctx) {
      super(key, ctx, msgPrfix);
    }
  };
}
makeSystemErrorWithCode("ERR_FS_EISDIR", "Path is a directory");
function createInvalidArgType(name, expected) {
  expected = Array.isArray(expected) ? expected : [
    expected
  ];
  let msg = "The ";
  if (name.endsWith(" argument")) {
    msg += `${name} `;
  } else {
    const type = name.includes(".") ? "property" : "argument";
    msg += `"${name}" ${type} `;
  }
  msg += "must be ";
  const types = [];
  const instances = [];
  const other = [];
  for (const value of expected) {
    if (kTypes.includes(value)) {
      types.push(value.toLocaleLowerCase());
    } else if (classRegExp1.test(value)) {
      instances.push(value);
    } else {
      other.push(value);
    }
  }
  if (instances.length > 0) {
    const pos = types.indexOf("object");
    if (pos !== -1) {
      types.splice(pos, 1);
      instances.push("Object");
    }
  }
  if (types.length > 0) {
    if (types.length > 2) {
      const last = types.pop();
      msg += `one of type ${types.join(", ")}, or ${last}`;
    } else if (types.length === 2) {
      msg += `one of type ${types[0]} or ${types[1]}`;
    } else {
      msg += `of type ${types[0]}`;
    }
    if (instances.length > 0 || other.length > 0) {
      msg += " or ";
    }
  }
  if (instances.length > 0) {
    if (instances.length > 2) {
      const last = instances.pop();
      msg += `an instance of ${instances.join(", ")}, or ${last}`;
    } else {
      msg += `an instance of ${instances[0]}`;
      if (instances.length === 2) {
        msg += ` or ${instances[1]}`;
      }
    }
    if (other.length > 0) {
      msg += " or ";
    }
  }
  if (other.length > 0) {
    if (other.length > 2) {
      const last = other.pop();
      msg += `one of ${other.join(", ")}, or ${last}`;
    } else if (other.length === 2) {
      msg += `one of ${other[0]} or ${other[1]}`;
    } else {
      if (other[0].toLowerCase() !== other[0]) {
        msg += "an ";
      }
      msg += `${other[0]}`;
    }
  }
  return msg;
}
var ERR_INVALID_ARG_TYPE_RANGE = class extends NodeRangeError {
  constructor(name, expected, actual) {
    const msg = createInvalidArgType(name, expected);
    super("ERR_INVALID_ARG_TYPE", `${msg}.${invalidArgTypeHelper(actual)}`);
  }
};
var ERR_INVALID_ARG_TYPE = class extends NodeTypeError {
  constructor(name, expected, actual) {
    const msg = createInvalidArgType(name, expected);
    super("ERR_INVALID_ARG_TYPE", `${msg}.${invalidArgTypeHelper(actual)}`);
  }
};
__publicField(ERR_INVALID_ARG_TYPE, "RangeError", ERR_INVALID_ARG_TYPE_RANGE);
var ERR_INVALID_ARG_VALUE_RANGE = class extends NodeRangeError {
  constructor(name, value, reason = "is invalid") {
    const type = name.includes(".") ? "property" : "argument";
    const inspected = inspect(value);
    super("ERR_INVALID_ARG_VALUE", `The ${type} '${name}' ${reason}. Received ${inspected}`);
  }
};
var ERR_INVALID_ARG_VALUE = class extends NodeTypeError {
  constructor(name, value, reason = "is invalid") {
    const type = name.includes(".") ? "property" : "argument";
    const inspected = inspect(value);
    super("ERR_INVALID_ARG_VALUE", `The ${type} '${name}' ${reason}. Received ${inspected}`);
  }
};
__publicField(ERR_INVALID_ARG_VALUE, "RangeError", ERR_INVALID_ARG_VALUE_RANGE);
function invalidArgTypeHelper(input) {
  if (input == null) {
    return ` Received ${input}`;
  }
  if (typeof input === "function" && input.name) {
    return ` Received function ${input.name}`;
  }
  if (typeof input === "object") {
    if (input.constructor && input.constructor.name) {
      return ` Received an instance of ${input.constructor.name}`;
    }
    return ` Received ${inspect(input, {
      depth: -1
    })}`;
  }
  let inspected = inspect(input, {
    colors: false
  });
  if (inspected.length > 25) {
    inspected = `${inspected.slice(0, 25)}...`;
  }
  return ` Received type ${typeof input} (${inspected})`;
}
var ERR_OUT_OF_RANGE = class extends RangeError {
  code = "ERR_OUT_OF_RANGE";
  constructor(str, range, input, replaceDefaultBoolean = false) {
    assert(range, 'Missing "range" argument');
    let msg = replaceDefaultBoolean ? str : `The value of "${str}" is out of range.`;
    let received;
    if (Number.isInteger(input) && Math.abs(input) > 2 ** 32) {
      received = addNumericalSeparator(String(input));
    } else if (typeof input === "bigint") {
      received = String(input);
      if (input > 2n ** 32n || input < -(2n ** 32n)) {
        received = addNumericalSeparator(received);
      }
      received += "n";
    } else {
      received = inspect(input);
    }
    msg += ` It must be ${range}. Received ${received}`;
    super(msg);
    const { name } = this;
    this.name = `${name} [${this.code}]`;
    this.stack;
    this.name = name;
  }
};
var ERR_BUFFER_OUT_OF_BOUNDS = class extends NodeRangeError {
  constructor(name) {
    super("ERR_BUFFER_OUT_OF_BOUNDS", name ? `"${name}" is outside of buffer bounds` : "Attempt to access memory outside buffer bounds");
  }
};
var ERR_DNS_SET_SERVERS_FAILED = class extends NodeError {
  constructor(x, y) {
    super("ERR_DNS_SET_SERVERS_FAILED", `c-ares failed to set servers: "${x}" [${y}]`);
  }
};
var ERR_INVALID_CALLBACK = class extends NodeTypeError {
  constructor(object) {
    super("ERR_INVALID_CALLBACK", `Callback must be a function. Received ${inspect(object)}`);
  }
};
var ERR_INVALID_IP_ADDRESS = class extends NodeTypeError {
  constructor(x) {
    super("ERR_INVALID_IP_ADDRESS", `Invalid IP address: ${x}`);
  }
};
var ERR_IPC_CHANNEL_CLOSED = class extends NodeError {
  constructor() {
    super("ERR_IPC_CHANNEL_CLOSED", `Channel closed`);
  }
};
var ERR_METHOD_NOT_IMPLEMENTED = class extends NodeError {
  constructor(x) {
    super("ERR_METHOD_NOT_IMPLEMENTED", `The ${x} method is not implemented`);
  }
};
var ERR_MISSING_ARGS = class extends NodeTypeError {
  constructor(...args) {
    let msg = "The ";
    const len = args.length;
    const wrap1 = (a) => `"${a}"`;
    args = args.map((a) => Array.isArray(a) ? a.map(wrap1).join(" or ") : wrap1(a));
    switch (len) {
      case 1:
        msg += `${args[0]} argument`;
        break;
      case 2:
        msg += `${args[0]} and ${args[1]} arguments`;
        break;
      default:
        msg += args.slice(0, len - 1).join(", ");
        msg += `, and ${args[len - 1]} arguments`;
        break;
    }
    super("ERR_MISSING_ARGS", `${msg} must be specified`);
  }
};
var ERR_MULTIPLE_CALLBACK = class extends NodeError {
  constructor() {
    super("ERR_MULTIPLE_CALLBACK", `Callback called multiple times`);
  }
};
var ERR_SOCKET_BAD_PORT = class extends NodeRangeError {
  constructor(name, port, allowZero = true) {
    assert(typeof allowZero === "boolean", "The 'allowZero' argument must be of type boolean.");
    const operator = allowZero ? ">=" : ">";
    super("ERR_SOCKET_BAD_PORT", `${name} should be ${operator} 0 and < 65536. Received ${port}.`);
  }
};
var ERR_SOCKET_CLOSED = class extends NodeError {
  constructor() {
    super("ERR_SOCKET_CLOSED", `Socket is closed`);
  }
};
var ERR_STREAM_ALREADY_FINISHED = class extends NodeError {
  constructor(x) {
    super("ERR_STREAM_ALREADY_FINISHED", `Cannot call ${x} after a stream was finished`);
  }
};
var ERR_STREAM_CANNOT_PIPE = class extends NodeError {
  constructor() {
    super("ERR_STREAM_CANNOT_PIPE", `Cannot pipe, not readable`);
  }
};
var ERR_STREAM_DESTROYED = class extends NodeError {
  constructor(x) {
    super("ERR_STREAM_DESTROYED", `Cannot call ${x} after a stream was destroyed`);
  }
};
var ERR_STREAM_NULL_VALUES = class extends NodeTypeError {
  constructor() {
    super("ERR_STREAM_NULL_VALUES", `May not write null values to stream`);
  }
};
var ERR_STREAM_PREMATURE_CLOSE = class extends NodeError {
  constructor() {
    super("ERR_STREAM_PREMATURE_CLOSE", `Premature close`);
  }
};
var ERR_STREAM_PUSH_AFTER_EOF = class extends NodeError {
  constructor() {
    super("ERR_STREAM_PUSH_AFTER_EOF", `stream.push() after EOF`);
  }
};
var ERR_STREAM_UNSHIFT_AFTER_END_EVENT = class extends NodeError {
  constructor() {
    super("ERR_STREAM_UNSHIFT_AFTER_END_EVENT", `stream.unshift() after end event`);
  }
};
var ERR_STREAM_WRITE_AFTER_END = class extends NodeError {
  constructor() {
    super("ERR_STREAM_WRITE_AFTER_END", `write after end`);
  }
};
var ERR_UNHANDLED_ERROR = class extends NodeError {
  constructor(x) {
    super("ERR_UNHANDLED_ERROR", `Unhandled error. (${x})`);
  }
};
var ERR_UNKNOWN_ENCODING = class extends NodeTypeError {
  constructor(x) {
    super("ERR_UNKNOWN_ENCODING", `Unknown encoding: ${x}`);
  }
};
var ERR_UNKNOWN_SIGNAL = class extends NodeTypeError {
  constructor(x) {
    super("ERR_UNKNOWN_SIGNAL", `Unknown signal: ${x}`);
  }
};
var ERR_INVALID_ADDRESS_FAMILY = class extends NodeRangeError {
  host;
  port;
  constructor(addressType, host, port) {
    super("ERR_INVALID_ADDRESS_FAMILY", `Invalid address family: ${addressType} ${host}:${port}`);
    this.host = host;
    this.port = port;
  }
};
function buildReturnPropertyType(value) {
  if (value && value.constructor && value.constructor.name) {
    return `instance of ${value.constructor.name}`;
  } else {
    return `type ${typeof value}`;
  }
}
var ERR_INVALID_RETURN_VALUE = class extends NodeTypeError {
  constructor(input, name, value) {
    super("ERR_INVALID_RETURN_VALUE", `Expected ${input} to be returned from the "${name}" function but got ${buildReturnPropertyType(value)}.`);
  }
};
function aggregateTwoErrors(innerError, outerError) {
  if (innerError && outerError && innerError !== outerError) {
    if (Array.isArray(outerError.errors)) {
      outerError.errors.push(innerError);
      return outerError;
    }
    const err = new AggregateError([
      outerError,
      innerError
    ], outerError.message);
    err.code = outerError.code;
    return err;
  }
  return innerError || outerError;
}
codes.ERR_IPC_CHANNEL_CLOSED = ERR_IPC_CHANNEL_CLOSED;
codes.ERR_INVALID_ARG_TYPE = ERR_INVALID_ARG_TYPE;
codes.ERR_INVALID_ARG_VALUE = ERR_INVALID_ARG_VALUE;
codes.ERR_INVALID_CALLBACK = ERR_INVALID_CALLBACK;
codes.ERR_OUT_OF_RANGE = ERR_OUT_OF_RANGE;
codes.ERR_SOCKET_BAD_PORT = ERR_SOCKET_BAD_PORT;
codes.ERR_BUFFER_OUT_OF_BOUNDS = ERR_BUFFER_OUT_OF_BOUNDS;
codes.ERR_UNKNOWN_ENCODING = ERR_UNKNOWN_ENCODING;
var genericNodeError = hideStackFrames(function genericNodeError2(message, errorProperties) {
  const err = new Error(message);
  Object.assign(err, errorProperties);
  return err;
});
var kRejection = Symbol.for("nodejs.rejection");
var kCapture = Symbol("kCapture");
var kErrorMonitor = Symbol("events.errorMonitor");
var kMaxEventTargetListeners = Symbol("events.maxEventTargetListeners");
var kMaxEventTargetListenersWarned = Symbol("events.maxEventTargetListenersWarned");
function EventEmitter(opts) {
  EventEmitter.init.call(this, opts);
}
EventEmitter.on = on;
EventEmitter.once = once1;
EventEmitter.getEventListeners = getEventListeners;
EventEmitter.EventEmitter = EventEmitter;
EventEmitter.usingDomains = false;
EventEmitter.captureRejectionSymbol = kRejection;
EventEmitter.captureRejectionSymbol;
EventEmitter.errorMonitor;
Object.defineProperty(EventEmitter, "captureRejections", {
  get() {
    return EventEmitter.prototype[kCapture];
  },
  set(value) {
    validateBoolean(value, "EventEmitter.captureRejections");
    EventEmitter.prototype[kCapture] = value;
  },
  enumerable: true
});
EventEmitter.errorMonitor = kErrorMonitor;
Object.defineProperty(EventEmitter.prototype, kCapture, {
  value: false,
  writable: true,
  enumerable: false
});
EventEmitter.prototype._events = void 0;
EventEmitter.prototype._eventsCount = 0;
EventEmitter.prototype._maxListeners = void 0;
var defaultMaxListeners = 10;
function checkListener(listener) {
  validateFunction(listener, "listener");
}
Object.defineProperty(EventEmitter, "defaultMaxListeners", {
  enumerable: true,
  get: function() {
    return defaultMaxListeners;
  },
  set: function(arg) {
    if (typeof arg !== "number" || arg < 0 || Number.isNaN(arg)) {
      throw new ERR_OUT_OF_RANGE("defaultMaxListeners", "a non-negative number", arg);
    }
    defaultMaxListeners = arg;
  }
});
Object.defineProperties(EventEmitter, {
  kMaxEventTargetListeners: {
    value: kMaxEventTargetListeners,
    enumerable: false,
    configurable: false,
    writable: false
  },
  kMaxEventTargetListenersWarned: {
    value: kMaxEventTargetListenersWarned,
    enumerable: false,
    configurable: false,
    writable: false
  }
});
EventEmitter.setMaxListeners = function(n = defaultMaxListeners, ...eventTargets) {
  if (typeof n !== "number" || n < 0 || Number.isNaN(n)) {
    throw new ERR_OUT_OF_RANGE("n", "a non-negative number", n);
  }
  if (eventTargets.length === 0) {
    defaultMaxListeners = n;
  } else {
    for (let i52 = 0; i52 < eventTargets.length; i52++) {
      const target = eventTargets[i52];
      if (target instanceof EventTarget) {
        target[kMaxEventTargetListeners] = n;
        target[kMaxEventTargetListenersWarned] = false;
      } else if (typeof target.setMaxListeners === "function") {
        target.setMaxListeners(n);
      } else {
        throw new ERR_INVALID_ARG_TYPE("eventTargets", [
          "EventEmitter",
          "EventTarget"
        ], target);
      }
    }
  }
};
EventEmitter.init = function(opts) {
  if (this._events === void 0 || this._events === Object.getPrototypeOf(this)._events) {
    this._events = /* @__PURE__ */ Object.create(null);
    this._eventsCount = 0;
  }
  this._maxListeners = this._maxListeners || void 0;
  if (opts?.captureRejections) {
    validateBoolean(opts.captureRejections, "options.captureRejections");
    this[kCapture] = Boolean(opts.captureRejections);
  } else {
    this[kCapture] = EventEmitter.prototype[kCapture];
  }
};
function addCatch(that, promise, type, args) {
  if (!that[kCapture]) {
    return;
  }
  try {
    const then = promise.then;
    if (typeof then === "function") {
      then.call(promise, void 0, function(err) {
        process.nextTick(emitUnhandledRejectionOrErr, that, err, type, args);
      });
    }
  } catch (err) {
    that.emit("error", err);
  }
}
function emitUnhandledRejectionOrErr(ee, err, type, args) {
  if (typeof ee[kRejection] === "function") {
    ee[kRejection](err, type, ...args);
  } else {
    const prev = ee[kCapture];
    try {
      ee[kCapture] = false;
      ee.emit("error", err);
    } finally {
      ee[kCapture] = prev;
    }
  }
}
EventEmitter.prototype.setMaxListeners = function setMaxListeners(n) {
  if (typeof n !== "number" || n < 0 || Number.isNaN(n)) {
    throw new ERR_OUT_OF_RANGE("n", "a non-negative number", n);
  }
  this._maxListeners = n;
  return this;
};
function _getMaxListeners(that) {
  if (that._maxListeners === void 0) {
    return EventEmitter.defaultMaxListeners;
  }
  return that._maxListeners;
}
EventEmitter.prototype.getMaxListeners = function getMaxListeners() {
  return _getMaxListeners(this);
};
EventEmitter.prototype.emit = function emit(type, ...args) {
  let doError = type === "error";
  const events = this._events;
  if (events !== void 0) {
    if (doError && events[kErrorMonitor] !== void 0) {
      this.emit(kErrorMonitor, ...args);
    }
    doError = doError && events.error === void 0;
  } else if (!doError) {
    return false;
  }
  if (doError) {
    let er;
    if (args.length > 0) {
      er = args[0];
    }
    if (er instanceof Error) {
      try {
        const capture = {};
        Error.captureStackTrace(capture, EventEmitter.prototype.emit);
      } catch {
      }
      throw er;
    }
    let stringifiedEr;
    try {
      stringifiedEr = inspect(er);
    } catch {
      stringifiedEr = er;
    }
    const err = new ERR_UNHANDLED_ERROR(stringifiedEr);
    err.context = er;
    throw err;
  }
  const handler = events[type];
  if (handler === void 0) {
    return false;
  }
  if (typeof handler === "function") {
    const result = handler.apply(this, args);
    if (result !== void 0 && result !== null) {
      addCatch(this, result, type, args);
    }
  } else {
    const len = handler.length;
    const listeners2 = arrayClone(handler);
    for (let i53 = 0; i53 < len; ++i53) {
      const result = listeners2[i53].apply(this, args);
      if (result !== void 0 && result !== null) {
        addCatch(this, result, type, args);
      }
    }
  }
  return true;
};
function _addListener(target, type, listener, prepend) {
  let m;
  let events;
  let existing;
  checkListener(listener);
  events = target._events;
  if (events === void 0) {
    events = target._events = /* @__PURE__ */ Object.create(null);
    target._eventsCount = 0;
  } else {
    if (events.newListener !== void 0) {
      target.emit("newListener", type, listener.listener ?? listener);
      events = target._events;
    }
    existing = events[type];
  }
  if (existing === void 0) {
    events[type] = listener;
    ++target._eventsCount;
  } else {
    if (typeof existing === "function") {
      existing = events[type] = prepend ? [
        listener,
        existing
      ] : [
        existing,
        listener
      ];
    } else if (prepend) {
      existing.unshift(listener);
    } else {
      existing.push(listener);
    }
    m = _getMaxListeners(target);
    if (m > 0 && existing.length > m && !existing.warned) {
      existing.warned = true;
      const w = new Error(`Possible EventEmitter memory leak detected. ${existing.length} ${String(type)} listeners added to ${inspect(target, {
        depth: -1
      })}. Use emitter.setMaxListeners() to increase limit`);
      w.name = "MaxListenersExceededWarning";
      w.emitter = target;
      w.type = type;
      w.count = existing.length;
      process.emitWarning(w);
    }
  }
  return target;
}
EventEmitter.prototype.addListener = function addListener(type, listener) {
  return _addListener(this, type, listener, false);
};
EventEmitter.prototype.on = EventEmitter.prototype.addListener;
EventEmitter.prototype.prependListener = function prependListener(type, listener) {
  return _addListener(this, type, listener, true);
};
function onceWrapper() {
  if (!this.fired) {
    this.target.removeListener(this.type, this.wrapFn);
    this.fired = true;
    if (arguments.length === 0) {
      return this.listener.call(this.target);
    }
    return this.listener.apply(this.target, arguments);
  }
}
function _onceWrap(target, type, listener) {
  const state = {
    fired: false,
    wrapFn: void 0,
    target,
    type,
    listener
  };
  const wrapped = onceWrapper.bind(state);
  wrapped.listener = listener;
  state.wrapFn = wrapped;
  return wrapped;
}
EventEmitter.prototype.once = function once2(type, listener) {
  checkListener(listener);
  this.on(type, _onceWrap(this, type, listener));
  return this;
};
EventEmitter.prototype.prependOnceListener = function prependOnceListener(type, listener) {
  checkListener(listener);
  this.prependListener(type, _onceWrap(this, type, listener));
  return this;
};
EventEmitter.prototype.removeListener = function removeListener(type, listener) {
  checkListener(listener);
  const events = this._events;
  if (events === void 0) {
    return this;
  }
  const list = events[type];
  if (list === void 0) {
    return this;
  }
  if (list === listener || list.listener === listener) {
    if (--this._eventsCount === 0) {
      this._events = /* @__PURE__ */ Object.create(null);
    } else {
      delete events[type];
      if (events.removeListener) {
        this.emit("removeListener", type, list.listener || listener);
      }
    }
  } else if (typeof list !== "function") {
    let position = -1;
    for (let i54 = list.length - 1; i54 >= 0; i54--) {
      if (list[i54] === listener || list[i54].listener === listener) {
        position = i54;
        break;
      }
    }
    if (position < 0) {
      return this;
    }
    if (position === 0) {
      list.shift();
    } else {
      spliceOne(list, position);
    }
    if (list.length === 1) {
      events[type] = list[0];
    }
    if (events.removeListener !== void 0) {
      this.emit("removeListener", type, listener);
    }
  }
  return this;
};
EventEmitter.prototype.off = EventEmitter.prototype.removeListener;
EventEmitter.prototype.removeAllListeners = function removeAllListeners(type) {
  const events = this._events;
  if (events === void 0) {
    return this;
  }
  if (events.removeListener === void 0) {
    if (arguments.length === 0) {
      this._events = /* @__PURE__ */ Object.create(null);
      this._eventsCount = 0;
    } else if (events[type] !== void 0) {
      if (--this._eventsCount === 0) {
        this._events = /* @__PURE__ */ Object.create(null);
      } else {
        delete events[type];
      }
    }
    return this;
  }
  if (arguments.length === 0) {
    for (const key of Reflect.ownKeys(events)) {
      if (key === "removeListener")
        continue;
      this.removeAllListeners(key);
    }
    this.removeAllListeners("removeListener");
    this._events = /* @__PURE__ */ Object.create(null);
    this._eventsCount = 0;
    return this;
  }
  const listeners2 = events[type];
  if (typeof listeners2 === "function") {
    this.removeListener(type, listeners2);
  } else if (listeners2 !== void 0) {
    for (let i55 = listeners2.length - 1; i55 >= 0; i55--) {
      this.removeListener(type, listeners2[i55]);
    }
  }
  return this;
};
function _listeners(target, type, unwrap) {
  const events = target._events;
  if (events === void 0) {
    return [];
  }
  const evlistener = events[type];
  if (evlistener === void 0) {
    return [];
  }
  if (typeof evlistener === "function") {
    return unwrap ? [
      evlistener.listener || evlistener
    ] : [
      evlistener
    ];
  }
  return unwrap ? unwrapListeners(evlistener) : arrayClone(evlistener);
}
EventEmitter.prototype.listeners = function listeners(type) {
  return _listeners(this, type, true);
};
EventEmitter.prototype.rawListeners = function rawListeners(type) {
  return _listeners(this, type, false);
};
EventEmitter.listenerCount = function(emitter, type) {
  if (typeof emitter.listenerCount === "function") {
    return emitter.listenerCount(type);
  }
  return listenerCount.call(emitter, type);
};
EventEmitter.prototype.listenerCount = listenerCount;
function listenerCount(type) {
  const events = this._events;
  if (events !== void 0) {
    const evlistener = events[type];
    if (typeof evlistener === "function") {
      return 1;
    } else if (evlistener !== void 0) {
      return evlistener.length;
    }
  }
  return 0;
}
EventEmitter.prototype.eventNames = function eventNames() {
  return this._eventsCount > 0 ? Reflect.ownKeys(this._events) : [];
};
function arrayClone(arr) {
  switch (arr.length) {
    case 2:
      return [
        arr[0],
        arr[1]
      ];
    case 3:
      return [
        arr[0],
        arr[1],
        arr[2]
      ];
    case 4:
      return [
        arr[0],
        arr[1],
        arr[2],
        arr[3]
      ];
    case 5:
      return [
        arr[0],
        arr[1],
        arr[2],
        arr[3],
        arr[4]
      ];
    case 6:
      return [
        arr[0],
        arr[1],
        arr[2],
        arr[3],
        arr[4],
        arr[5]
      ];
  }
  return arr.slice();
}
function unwrapListeners(arr) {
  const ret = arrayClone(arr);
  for (let i56 = 0; i56 < ret.length; ++i56) {
    const orig = ret[i56].listener;
    if (typeof orig === "function") {
      ret[i56] = orig;
    }
  }
  return ret;
}
function getEventListeners(emitterOrTarget, type) {
  if (typeof emitterOrTarget.listeners === "function") {
    return emitterOrTarget.listeners(type);
  }
  if (emitterOrTarget instanceof EventTarget) {
    const root = emitterOrTarget[kEvents].get(type);
    const listeners2 = [];
    let handler = root?.next;
    while (handler?.listener !== void 0) {
      const listener = handler.listener?.deref ? handler.listener.deref() : handler.listener;
      listeners2.push(listener);
      handler = handler.next;
    }
    return listeners2;
  }
  throw new ERR_INVALID_ARG_TYPE("emitter", [
    "EventEmitter",
    "EventTarget"
  ], emitterOrTarget);
}
async function once1(emitter, name, options = {}) {
  const signal = options?.signal;
  validateAbortSignal(signal, "options.signal");
  if (signal?.aborted) {
    throw new AbortError();
  }
  return new Promise((resolve9, reject) => {
    const errorListener = (err) => {
      emitter.removeListener(name, resolver2);
      if (signal != null) {
        eventTargetAgnosticRemoveListener(signal, "abort", abortListener);
      }
      reject(err);
    };
    const resolver2 = (...args) => {
      if (typeof emitter.removeListener === "function") {
        emitter.removeListener("error", errorListener);
      }
      if (signal != null) {
        eventTargetAgnosticRemoveListener(signal, "abort", abortListener);
      }
      resolve9(args);
    };
    eventTargetAgnosticAddListener(emitter, name, resolver2, {
      once: true
    });
    if (name !== "error" && typeof emitter.once === "function") {
      emitter.once("error", errorListener);
    }
    function abortListener() {
      eventTargetAgnosticRemoveListener(emitter, name, resolver2);
      eventTargetAgnosticRemoveListener(emitter, "error", errorListener);
      reject(new AbortError());
    }
    if (signal != null) {
      eventTargetAgnosticAddListener(signal, "abort", abortListener, {
        once: true
      });
    }
  });
}
var AsyncIteratorPrototype = Object.getPrototypeOf(Object.getPrototypeOf(async function* () {
}).prototype);
function createIterResult(value, done) {
  return {
    value,
    done
  };
}
function eventTargetAgnosticRemoveListener(emitter, name, listener, flags) {
  if (typeof emitter.removeListener === "function") {
    emitter.removeListener(name, listener);
  } else if (typeof emitter.removeEventListener === "function") {
    emitter.removeEventListener(name, listener, flags);
  } else {
    throw new ERR_INVALID_ARG_TYPE("emitter", "EventEmitter", emitter);
  }
}
function eventTargetAgnosticAddListener(emitter, name, listener, flags) {
  if (typeof emitter.on === "function") {
    if (flags?.once) {
      emitter.once(name, listener);
    } else {
      emitter.on(name, listener);
    }
  } else if (typeof emitter.addEventListener === "function") {
    emitter.addEventListener(name, (arg) => {
      listener(arg);
    }, flags);
  } else {
    throw new ERR_INVALID_ARG_TYPE("emitter", "EventEmitter", emitter);
  }
}
function on(emitter, event, options) {
  const signal = options?.signal;
  validateAbortSignal(signal, "options.signal");
  if (signal?.aborted) {
    throw new AbortError();
  }
  const unconsumedEvents = [];
  const unconsumedPromises = [];
  let error3 = null;
  let finished1 = false;
  const iterator = Object.setPrototypeOf({
    next() {
      const value = unconsumedEvents.shift();
      if (value) {
        return Promise.resolve(createIterResult(value, false));
      }
      if (error3) {
        const p = Promise.reject(error3);
        error3 = null;
        return p;
      }
      if (finished1) {
        return Promise.resolve(createIterResult(void 0, true));
      }
      return new Promise(function(resolve10, reject) {
        unconsumedPromises.push({
          resolve: resolve10,
          reject
        });
      });
    },
    return() {
      eventTargetAgnosticRemoveListener(emitter, event, eventHandler);
      eventTargetAgnosticRemoveListener(emitter, "error", errorHandler);
      if (signal) {
        eventTargetAgnosticRemoveListener(signal, "abort", abortListener, {
          once: true
        });
      }
      finished1 = true;
      for (const promise of unconsumedPromises) {
        promise.resolve(createIterResult(void 0, true));
      }
      return Promise.resolve(createIterResult(void 0, true));
    },
    throw(err) {
      if (!err || !(err instanceof Error)) {
        throw new ERR_INVALID_ARG_TYPE("EventEmitter.AsyncIterator", "Error", err);
      }
      error3 = err;
      eventTargetAgnosticRemoveListener(emitter, event, eventHandler);
      eventTargetAgnosticRemoveListener(emitter, "error", errorHandler);
    },
    [Symbol.asyncIterator]() {
      return this;
    }
  }, AsyncIteratorPrototype);
  eventTargetAgnosticAddListener(emitter, event, eventHandler);
  if (event !== "error" && typeof emitter.on === "function") {
    emitter.on("error", errorHandler);
  }
  if (signal) {
    eventTargetAgnosticAddListener(signal, "abort", abortListener, {
      once: true
    });
  }
  return iterator;
  function abortListener() {
    errorHandler(new AbortError());
  }
  function eventHandler(...args) {
    const promise = unconsumedPromises.shift();
    if (promise) {
      promise.resolve(createIterResult(args, false));
    } else {
      unconsumedEvents.push(args);
    }
  }
  function errorHandler(err) {
    finished1 = true;
    const toError = unconsumedPromises.shift();
    if (toError) {
      toError.reject(err);
    } else {
      error3 = err;
    }
    iterator.return();
  }
}
var v4Seg = "(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])";
var v4Str = `(${v4Seg}[.]){3}${v4Seg}`;
var IPv4Reg = new RegExp(`^${v4Str}$`);
var v6Seg = "(?:[0-9a-fA-F]{1,4})";
var IPv6Reg = new RegExp(`^((?:${v6Seg}:){7}(?:${v6Seg}|:)|(?:${v6Seg}:){6}(?:${v4Str}|:${v6Seg}|:)|(?:${v6Seg}:){5}(?::${v4Str}|(:${v6Seg}){1,2}|:)|(?:${v6Seg}:){4}(?:(:${v6Seg}){0,1}:${v4Str}|(:${v6Seg}){1,3}|:)|(?:${v6Seg}:){3}(?:(:${v6Seg}){0,2}:${v4Str}|(:${v6Seg}){1,4}|:)|(?:${v6Seg}:){2}(?:(:${v6Seg}){0,3}:${v4Str}|(:${v6Seg}){1,5}|:)|(?:${v6Seg}:){1}(?:(:${v6Seg}){0,4}:${v4Str}|(:${v6Seg}){1,6}|:)|(?::((?::${v6Seg}){0,5}:${v4Str}|(?::${v6Seg}){1,7}|:)))(%[0-9a-zA-Z-.:]{1,})?$`);
function isIPv4(ip) {
  return RegExp.prototype.test.call(IPv4Reg, ip);
}
function isIPv6(ip) {
  return RegExp.prototype.test.call(IPv6Reg, ip);
}
function isIP(ip) {
  if (isIPv4(ip)) {
    return 4;
  }
  if (isIPv6(ip)) {
    return 6;
  }
  return 0;
}
var normalizedArgsSymbol = Symbol("normalizedArgs");
function _uint8ArrayToBuffer(chunk) {
  return Buffer2.from(chunk.buffer, chunk.byteOffset, chunk.byteLength);
}
function _arch() {
  if (workerDeno_build.arch == "x86_64") {
    return "x64";
  } else if (workerDeno_build.arch == "aarch64") {
    return "arm64";
  } else {
    throw Error("unreachable");
  }
}
var arch = _arch();
var chdir = workerDeno_chdir;
var cwd = workerDeno_cwd;
var nextTick1 = nextTick2;
var env = new Proxy({}, {
  get(_target, prop) {
    return workerDeno_env.get(String(prop));
  },
  ownKeys: () => Reflect.ownKeys(workerDeno_env.toObject()),
  getOwnPropertyDescriptor: (_target, name) => {
    const e = workerDeno_env.toObject();
    if (name in workerDeno_env.toObject()) {
      const o = {
        enumerable: true,
        configurable: true
      };
      if (typeof name === "string") {
        o.value = e[name];
      }
      return o;
    }
  },
  set(_target, prop, value) {
    workerDeno_env.set(String(prop), String(value));
    return value;
  }
});
var pid = workerDeno_pid;
var platform = isWindows ? "win32" : workerDeno_build.os;
var version = "v16.11.1";
var versions = {
  node: "16.11.1",
  uv: "1.42.0",
  zlib: "1.2.11",
  brotli: "1.0.9",
  ares: "1.17.2",
  modules: "93",
  nghttp2: "1.45.1",
  napi: "8",
  llhttp: "6.0.4",
  openssl: "1.1.1l",
  cldr: "39.0",
  icu: "69.1",
  tz: "2021a",
  unicode: "13.0",
  ...workerDeno_version
};
function isRequest(stream) {
  return stream.setHeader && typeof stream.abort === "function";
}
function isServerResponse(stream) {
  return typeof stream._sent100 === "boolean" && typeof stream._removedConnection === "boolean" && typeof stream._removedContLen === "boolean" && typeof stream._removedTE === "boolean" && typeof stream._closed === "boolean";
}
function isReadable(stream) {
  return typeof stream.readable === "boolean" || typeof stream.readableEnded === "boolean" || !!stream._readableState;
}
function isWritable(stream) {
  return typeof stream.writable === "boolean" || typeof stream.writableEnded === "boolean" || !!stream._writableState;
}
function isWritableFinished(stream) {
  if (stream.writableFinished)
    return true;
  const wState = stream._writableState;
  if (!wState || wState.errored)
    return false;
  return wState.finished || wState.ended && wState.length === 0;
}
var nop = () => {
};
function isReadableEnded(stream) {
  if (stream.readableEnded)
    return true;
  const rState = stream._readableState;
  if (!rState || rState.errored)
    return false;
  return rState.endEmitted || rState.ended && rState.length === 0;
}
function eos(stream, options, callback) {
  if (arguments.length === 2) {
    callback = options;
    options = {};
  } else if (options == null) {
    options = {};
  } else {
    validateObject(options, "options");
  }
  validateFunction(callback, "callback");
  validateAbortSignal(options.signal, "options.signal");
  callback = once(callback);
  const readable = options.readable || options.readable !== false && isReadable(stream);
  const writable = options.writable || options.writable !== false && isWritable(stream);
  const wState = stream._writableState;
  const rState = stream._readableState;
  const state = wState || rState;
  const onlegacyfinish = () => {
    if (!stream.writable)
      onfinish();
  };
  let willEmitClose = isServerResponse(stream) || state && state.autoDestroy && state.emitClose && state.closed === false && isReadable(stream) === readable && isWritable(stream) === writable;
  let writableFinished = stream.writableFinished || wState && wState.finished;
  const onfinish = () => {
    writableFinished = true;
    if (stream.destroyed)
      willEmitClose = false;
    if (willEmitClose && (!stream.readable || readable))
      return;
    if (!readable || readableEnded)
      callback.call(stream);
  };
  let readableEnded = stream.readableEnded || rState && rState.endEmitted;
  const onend = () => {
    readableEnded = true;
    if (stream.destroyed)
      willEmitClose = false;
    if (willEmitClose && (!stream.writable || writable))
      return;
    if (!writable || writableFinished)
      callback.call(stream);
  };
  const onerror = (err) => {
    callback.call(stream, err);
  };
  const onclose = () => {
    if (readable && !readableEnded) {
      if (!isReadableEnded(stream)) {
        return callback.call(stream, new ERR_STREAM_PREMATURE_CLOSE());
      }
    }
    if (writable && !writableFinished) {
      if (!isWritableFinished(stream)) {
        return callback.call(stream, new ERR_STREAM_PREMATURE_CLOSE());
      }
    }
    callback.call(stream);
  };
  const onrequest = () => {
    stream.req.on("finish", onfinish);
  };
  if (isRequest(stream)) {
    stream.on("complete", onfinish);
    if (!willEmitClose) {
      stream.on("abort", onclose);
    }
    if (stream.req)
      onrequest();
    else
      stream.on("request", onrequest);
  } else if (writable && !wState) {
    stream.on("end", onlegacyfinish);
    stream.on("close", onlegacyfinish);
  }
  if (!willEmitClose && typeof stream.aborted === "boolean") {
    stream.on("aborted", onclose);
  }
  stream.on("end", onend);
  stream.on("finish", onfinish);
  if (options.error !== false)
    stream.on("error", onerror);
  stream.on("close", onclose);
  const closed = !wState && !rState && stream._closed === true || wState && wState.closed || rState && rState.closed || wState && wState.errorEmitted || rState && rState.errorEmitted || rState && stream.req && stream.aborted || (!wState || !willEmitClose || typeof wState.closed !== "boolean") && (!rState || !willEmitClose || typeof rState.closed !== "boolean") && (!writable || wState && wState.finished) && (!readable || rState && rState.endEmitted);
  if (closed) {
    nextTick2(() => {
      callback();
    });
  }
  const cleanup = () => {
    callback = nop;
    stream.removeListener("aborted", onclose);
    stream.removeListener("complete", onfinish);
    stream.removeListener("abort", onclose);
    stream.removeListener("request", onrequest);
    if (stream.req)
      stream.req.removeListener("finish", onfinish);
    stream.removeListener("end", onlegacyfinish);
    stream.removeListener("close", onlegacyfinish);
    stream.removeListener("finish", onfinish);
    stream.removeListener("end", onend);
    stream.removeListener("error", onerror);
    stream.removeListener("close", onclose);
  };
  if (options.signal && !closed) {
    const abort = () => {
      const endCallback = callback;
      cleanup();
      endCallback.call(stream, new AbortError());
    };
    if (options.signal.aborted) {
      nextTick2(abort);
    } else {
      const originalCallback = callback;
      callback = once((...args) => {
        options.signal.removeEventListener("abort", abort);
        originalCallback.apply(stream, args);
      });
      options.signal.addEventListener("abort", abort);
    }
  }
  return cleanup;
}
var validateAbortSignal1 = (signal, name) => {
  if (typeof signal !== "object" || !("aborted" in signal)) {
    throw new ERR_INVALID_ARG_TYPE(name, "AbortSignal", signal);
  }
};
function isStream(obj) {
  return !!(obj && typeof obj.pipe === "function");
}
function addAbortSignal(signal, stream) {
  validateAbortSignal1(signal, "signal");
  if (!isStream(stream)) {
    throw new ERR_INVALID_ARG_TYPE("stream", "stream.Stream", stream);
  }
  return addAbortSignalNoValidate(signal, stream);
}
function addAbortSignalNoValidate(signal, stream) {
  if (typeof signal !== "object" || !("aborted" in signal)) {
    return stream;
  }
  const onAbort = () => {
    stream.destroy(new AbortError());
  };
  if (signal.aborted) {
    onAbort();
  } else {
    signal.addEventListener("abort", onAbort);
    eos(stream, () => signal.removeEventListener("abort", onAbort));
  }
  return stream;
}
var kDestroy = Symbol("kDestroy");
var kConstruct = Symbol("kConstruct");
function checkError(err, w, r) {
  if (err) {
    err.stack;
    if (w && !w.errored) {
      w.errored = err;
    }
    if (r && !r.errored) {
      r.errored = err;
    }
  }
}
function destroy2(err, cb) {
  const r = this._readableState;
  const w = this._writableState;
  const s = w || r;
  if (w && w.destroyed || r && r.destroyed) {
    if (typeof cb === "function") {
      cb();
    }
    return this;
  }
  checkError(err, w, r);
  if (w) {
    w.destroyed = true;
  }
  if (r) {
    r.destroyed = true;
  }
  if (!s.constructed) {
    this.once(kDestroy, function(er) {
      _destroy(this, aggregateTwoErrors(er, err), cb);
    });
  } else {
    _destroy(this, err, cb);
  }
  return this;
}
function _destroy(self, err1, cb) {
  let called = false;
  function onDestroy(err) {
    if (called) {
      return;
    }
    called = true;
    const r = self._readableState;
    const w = self._writableState;
    checkError(err, w, r);
    if (w) {
      w.closed = true;
    }
    if (r) {
      r.closed = true;
    }
    if (typeof cb === "function") {
      cb(err);
    }
    if (err) {
      nextTick2(emitErrorCloseNT, self, err);
    } else {
      nextTick2(emitCloseNT, self);
    }
  }
  try {
    const result = self._destroy(err1 || null, onDestroy);
    if (result != null) {
      const then = result.then;
      if (typeof then === "function") {
        then.call(result, function() {
          nextTick2(onDestroy, null);
        }, function(err) {
          nextTick2(onDestroy, err);
        });
      }
    }
  } catch (err) {
    onDestroy(err);
  }
}
function emitErrorCloseNT(self, err) {
  emitErrorNT(self, err);
  emitCloseNT(self);
}
function emitCloseNT(self) {
  const r = self._readableState;
  const w = self._writableState;
  if (w) {
    w.closeEmitted = true;
  }
  if (r) {
    r.closeEmitted = true;
  }
  if (w && w.emitClose || r && r.emitClose) {
    self.emit("close");
  }
}
function emitErrorNT(self, err) {
  const r = self._readableState;
  const w = self._writableState;
  if (w && w.errorEmitted || r && r.errorEmitted) {
    return;
  }
  if (w) {
    w.errorEmitted = true;
  }
  if (r) {
    r.errorEmitted = true;
  }
  self.emit("error", err);
}
function undestroy() {
  const r = this._readableState;
  const w = this._writableState;
  if (r) {
    r.constructed = true;
    r.closed = false;
    r.closeEmitted = false;
    r.destroyed = false;
    r.errored = null;
    r.errorEmitted = false;
    r.reading = false;
    r.ended = false;
    r.endEmitted = false;
  }
  if (w) {
    w.constructed = true;
    w.destroyed = false;
    w.closed = false;
    w.closeEmitted = false;
    w.errored = null;
    w.errorEmitted = false;
    w.ended = false;
    w.ending = false;
    w.finalCalled = false;
    w.prefinished = false;
    w.finished = false;
  }
}
function errorOrDestroy(stream, err, sync) {
  const r = stream._readableState;
  const w = stream._writableState;
  if (w && w.destroyed || r && r.destroyed) {
    return this;
  }
  if (r && r.autoDestroy || w && w.autoDestroy) {
    stream.destroy(err);
  } else if (err) {
    err.stack;
    if (w && !w.errored) {
      w.errored = err;
    }
    if (r && !r.errored) {
      r.errored = err;
    }
    if (sync) {
      nextTick2(emitErrorNT, stream, err);
    } else {
      emitErrorNT(stream, err);
    }
  }
}
function construct(stream, cb) {
  if (typeof stream._construct !== "function") {
    return;
  }
  const r = stream._readableState;
  const w = stream._writableState;
  if (r) {
    r.constructed = false;
  }
  if (w) {
    w.constructed = false;
  }
  stream.once(kConstruct, cb);
  if (stream.listenerCount(kConstruct) > 1) {
    return;
  }
  nextTick2(constructNT, stream);
}
function constructNT(stream) {
  let called = false;
  function onConstruct(err) {
    if (called) {
      errorOrDestroy(stream, err ?? new ERR_MULTIPLE_CALLBACK());
      return;
    }
    called = true;
    const r = stream._readableState;
    const w = stream._writableState;
    const s = w || r;
    if (r) {
      r.constructed = true;
    }
    if (w) {
      w.constructed = true;
    }
    if (s.destroyed) {
      stream.emit(kDestroy, err);
    } else if (err) {
      errorOrDestroy(stream, err, true);
    } else {
      nextTick2(emitConstructNT, stream);
    }
  }
  try {
    const result = stream._construct(onConstruct);
    if (result != null) {
      const then = result.then;
      if (typeof then === "function") {
        then.call(result, function() {
          nextTick2(onConstruct, null);
        }, function(err) {
          nextTick2(onConstruct, err);
        });
      }
    }
  } catch (err) {
    onConstruct(err);
  }
}
function emitConstructNT(stream) {
  stream.emit(kConstruct);
}
function isRequest1(stream) {
  return stream && stream.setHeader && typeof stream.abort === "function";
}
function destroyer(stream, err) {
  if (!stream)
    return;
  if (isRequest1(stream))
    return stream.abort();
  if (isRequest1(stream.req))
    return stream.req.abort();
  if (typeof stream.destroy === "function")
    return stream.destroy(err);
  if (typeof stream.close === "function")
    return stream.close();
}
var __default3 = {
  construct,
  destroyer,
  destroy: destroy2,
  undestroy,
  errorOrDestroy
};
var kIsDisturbed = Symbol("kIsDisturbed");
function isReadableNodeStream(obj) {
  return !!(obj && typeof obj.pipe === "function" && typeof obj.on === "function" && (!obj._writableState || obj._readableState?.readable !== false) && (!obj._writableState || obj._readableState));
}
function isWritableNodeStream(obj) {
  return !!(obj && typeof obj.write === "function" && typeof obj.on === "function" && (!obj._readableState || obj._writableState?.writable !== false));
}
function isDuplexNodeStream(obj) {
  return !!(obj && typeof obj.pipe === "function" && obj._readableState && typeof obj.on === "function" && typeof obj.write === "function");
}
function isNodeStream(obj) {
  return obj && (obj._readableState || obj._writableState || typeof obj.write === "function" && typeof obj.on === "function" || typeof obj.pipe === "function" && typeof obj.on === "function");
}
function isIterable(obj, isAsync) {
  if (obj == null)
    return false;
  if (isAsync === true)
    return typeof obj[Symbol.asyncIterator] === "function";
  if (isAsync === false)
    return typeof obj[Symbol.iterator] === "function";
  return typeof obj[Symbol.asyncIterator] === "function" || typeof obj[Symbol.iterator] === "function";
}
function isDestroyed(stream) {
  if (!isNodeStream(stream))
    return null;
  const wState = stream._writableState;
  const rState = stream._readableState;
  const state = wState || rState;
  return !!(stream.destroyed || state?.destroyed);
}
function isWritableEnded(stream) {
  if (!isWritableNodeStream(stream))
    return null;
  if (stream.writableEnded === true)
    return true;
  const wState = stream._writableState;
  if (wState?.errored)
    return false;
  if (typeof wState?.ended !== "boolean")
    return null;
  return wState.ended;
}
function isReadableEnded1(stream) {
  if (!isReadableNodeStream(stream))
    return null;
  if (stream.readableEnded === true)
    return true;
  const rState = stream._readableState;
  if (!rState || rState.errored)
    return false;
  if (typeof rState?.ended !== "boolean")
    return null;
  return rState.ended;
}
function isReadableFinished(stream, strict) {
  if (!isReadableNodeStream(stream))
    return null;
  const rState = stream._readableState;
  if (rState?.errored)
    return false;
  if (typeof rState?.endEmitted !== "boolean")
    return null;
  return !!(rState.endEmitted || strict === false && rState.ended === true && rState.length === 0);
}
function isDisturbed(stream) {
  return !!(stream && (stream.readableDidRead || stream.readableAborted || stream[kIsDisturbed]));
}
function isReadable1(stream) {
  const r = isReadableNodeStream(stream);
  if (r === null || typeof stream?.readable !== "boolean")
    return null;
  if (isDestroyed(stream))
    return false;
  return r && stream.readable && !isReadableFinished(stream);
}
function isWritable1(stream) {
  const r = isWritableNodeStream(stream);
  if (r === null || typeof stream?.writable !== "boolean")
    return null;
  if (isDestroyed(stream))
    return false;
  return r && stream.writable && !isWritableEnded(stream);
}
var stdio = {};
function isBlob(object) {
  return object instanceof Blob;
}
function _from1(Readable1, iterable, opts) {
  let iterator;
  if (typeof iterable === "string" || iterable instanceof Buffer2) {
    return new Readable1({
      objectMode: true,
      ...opts,
      read() {
        this.push(iterable);
        this.push(null);
      }
    });
  }
  let isAsync;
  if (iterable && iterable[Symbol.asyncIterator]) {
    isAsync = true;
    iterator = iterable[Symbol.asyncIterator]();
  } else if (iterable && iterable[Symbol.iterator]) {
    isAsync = false;
    iterator = iterable[Symbol.iterator]();
  } else {
    throw new ERR_INVALID_ARG_TYPE("iterable", [
      "Iterable"
    ], iterable);
  }
  const readable = new Readable1({
    objectMode: true,
    highWaterMark: 1,
    ...opts
  });
  let reading = false;
  readable._read = function() {
    if (!reading) {
      reading = true;
      next();
    }
  };
  readable._destroy = function(error4, cb) {
    close(error4).then(() => nextTick1(cb, error4), (e) => nextTick1(cb, e || error4));
  };
  async function close(error5) {
    const hadError = error5 !== void 0 && error5 !== null;
    const hasThrow = typeof iterator.throw === "function";
    if (hadError && hasThrow) {
      const { value, done } = await iterator.throw(error5);
      await value;
      if (done) {
        return;
      }
    }
    if (typeof iterator.return === "function") {
      const { value } = await iterator.return();
      await value;
    }
  }
  async function next() {
    for (; ; ) {
      try {
        const { value, done } = isAsync ? await iterator.next() : iterator.next();
        if (done) {
          readable.push(null);
        } else {
          const res = value && typeof value.then === "function" ? await value : value;
          if (res === null) {
            reading = false;
            throw new ERR_STREAM_NULL_VALUES();
          } else if (readable.push(res)) {
            continue;
          } else {
            reading = false;
          }
        }
      } catch (err) {
        readable.destroy(err);
      }
      break;
    }
  }
  return readable;
}
function highWaterMarkFrom(options, isDuplex, duplexKey) {
  return options.highWaterMark != null ? options.highWaterMark : isDuplex ? options[duplexKey] : null;
}
function getDefaultHighWaterMark(objectMode) {
  return objectMode ? 16 : 16 * 1024;
}
function getHighWaterMark(state, options, duplexKey, isDuplex) {
  const hwm = highWaterMarkFrom(options, isDuplex, duplexKey);
  if (hwm != null) {
    if (!Number.isInteger(hwm) || hwm < 0) {
      const name = isDuplex ? `options.${duplexKey}` : "options.highWaterMark";
      throw new ERR_INVALID_ARG_VALUE(name, hwm);
    }
    return Math.floor(hwm);
  }
  return getDefaultHighWaterMark(state.objectMode);
}
function Stream(opts) {
  EventEmitter.call(this, opts);
}
Object.setPrototypeOf(Stream.prototype, EventEmitter.prototype);
Object.setPrototypeOf(Stream, EventEmitter);
Stream.prototype.pipe = function(dest, options) {
  const source = this;
  function ondata(chunk) {
    if (dest.writable && dest.write(chunk) === false && source.pause) {
      source.pause();
    }
  }
  source.on("data", ondata);
  function ondrain() {
    if (source.readable && source.resume) {
      source.resume();
    }
  }
  dest.on("drain", ondrain);
  if (!dest._isStdio && (!options || options.end !== false)) {
    source.on("end", onend);
    source.on("close", onclose);
  }
  let didOnEnd = false;
  function onend() {
    if (didOnEnd)
      return;
    didOnEnd = true;
    dest.end();
  }
  function onclose() {
    if (didOnEnd)
      return;
    didOnEnd = true;
    if (typeof dest.destroy === "function")
      dest.destroy();
  }
  function onerror(er) {
    cleanup();
    if (EventEmitter.listenerCount(this, "error") === 0) {
      this.emit("error", er);
    }
  }
  prependListener2(source, "error", onerror);
  prependListener2(dest, "error", onerror);
  function cleanup() {
    source.removeListener("data", ondata);
    dest.removeListener("drain", ondrain);
    source.removeListener("end", onend);
    source.removeListener("close", onclose);
    source.removeListener("error", onerror);
    dest.removeListener("error", onerror);
    source.removeListener("end", cleanup);
    source.removeListener("close", cleanup);
    dest.removeListener("close", cleanup);
  }
  source.on("end", cleanup);
  source.on("close", cleanup);
  dest.on("close", cleanup);
  dest.emit("pipe", source);
  return dest;
};
function prependListener2(emitter, event, fn) {
  if (typeof emitter.prependListener === "function") {
    return emitter.prependListener(event, fn);
  }
  if (!emitter._events || !emitter._events[event]) {
    emitter.on(event, fn);
  } else if (Array.isArray(emitter._events[event])) {
    emitter._events[event].unshift(fn);
  } else {
    emitter._events[event] = [
      fn,
      emitter._events[event]
    ];
  }
}
var NotImplemented;
(function(NotImplemented1) {
  NotImplemented1[NotImplemented1["ascii"] = 0] = "ascii";
  NotImplemented1[NotImplemented1["latin1"] = 1] = "latin1";
  NotImplemented1[NotImplemented1["utf16le"] = 2] = "utf16le";
})(NotImplemented || (NotImplemented = {}));
function normalizeEncoding2(enc) {
  const encoding = normalizeEncoding(enc ?? null);
  if (encoding && encoding in NotImplemented)
    notImplemented(encoding);
  if (!encoding && typeof enc === "string" && enc.toLowerCase() !== "raw") {
    throw new Error(`Unknown encoding: ${enc}`);
  }
  return String(encoding);
}
function utf8CheckByte(__byte) {
  if (__byte <= 127)
    return 0;
  else if (__byte >> 5 === 6)
    return 2;
  else if (__byte >> 4 === 14)
    return 3;
  else if (__byte >> 3 === 30)
    return 4;
  return __byte >> 6 === 2 ? -1 : -2;
}
function utf8CheckIncomplete(self, buf, i57) {
  let j = buf.length - 1;
  if (j < i57)
    return 0;
  let nb = utf8CheckByte(buf[j]);
  if (nb >= 0) {
    if (nb > 0)
      self.lastNeed = nb - 1;
    return nb;
  }
  if (--j < i57 || nb === -2)
    return 0;
  nb = utf8CheckByte(buf[j]);
  if (nb >= 0) {
    if (nb > 0)
      self.lastNeed = nb - 2;
    return nb;
  }
  if (--j < i57 || nb === -2)
    return 0;
  nb = utf8CheckByte(buf[j]);
  if (nb >= 0) {
    if (nb > 0) {
      if (nb === 2)
        nb = 0;
      else
        self.lastNeed = nb - 3;
    }
    return nb;
  }
  return 0;
}
function utf8CheckExtraBytes(self, buf) {
  if ((buf[0] & 192) !== 128) {
    self.lastNeed = 0;
    return "\uFFFD";
  }
  if (self.lastNeed > 1 && buf.length > 1) {
    if ((buf[1] & 192) !== 128) {
      self.lastNeed = 1;
      return "\uFFFD";
    }
    if (self.lastNeed > 2 && buf.length > 2) {
      if ((buf[2] & 192) !== 128) {
        self.lastNeed = 2;
        return "\uFFFD";
      }
    }
  }
}
function utf8FillLastComplete(buf) {
  const p = this.lastTotal - this.lastNeed;
  const r = utf8CheckExtraBytes(this, buf);
  if (r !== void 0)
    return r;
  if (this.lastNeed <= buf.length) {
    buf.copy(this.lastChar, p, 0, this.lastNeed);
    return this.lastChar.toString(this.encoding, 0, this.lastTotal);
  }
  buf.copy(this.lastChar, p, 0, buf.length);
  this.lastNeed -= buf.length;
}
function utf8FillLastIncomplete(buf) {
  if (this.lastNeed <= buf.length) {
    buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, this.lastNeed);
    return this.lastChar.toString(this.encoding, 0, this.lastTotal);
  }
  buf.copy(this.lastChar, this.lastTotal - this.lastNeed, 0, buf.length);
  this.lastNeed -= buf.length;
}
function utf8Text(buf, i58) {
  const total = utf8CheckIncomplete(this, buf, i58);
  if (!this.lastNeed)
    return buf.toString("utf8", i58);
  this.lastTotal = total;
  const end = buf.length - (total - this.lastNeed);
  buf.copy(this.lastChar, 0, end);
  return buf.toString("utf8", i58, end);
}
function utf8End(buf) {
  const r = buf && buf.length ? this.write(buf) : "";
  if (this.lastNeed)
    return r + "\uFFFD";
  return r;
}
function utf8Write2(buf) {
  if (typeof buf === "string") {
    return buf;
  }
  if (buf.length === 0)
    return "";
  let r;
  let i59;
  if (this.lastNeed) {
    r = this.fillLast(buf);
    if (r === void 0)
      return "";
    i59 = this.lastNeed;
    this.lastNeed = 0;
  } else {
    i59 = 0;
  }
  if (i59 < buf.length)
    return r ? r + this.text(buf, i59) : this.text(buf, i59);
  return r || "";
}
function base64Text(buf, i60) {
  const n = (buf.length - i60) % 3;
  if (n === 0)
    return buf.toString("base64", i60);
  this.lastNeed = 3 - n;
  this.lastTotal = 3;
  if (n === 1) {
    this.lastChar[0] = buf[buf.length - 1];
  } else {
    this.lastChar[0] = buf[buf.length - 2];
    this.lastChar[1] = buf[buf.length - 1];
  }
  return buf.toString("base64", i60, buf.length - n);
}
function base64End(buf) {
  const r = buf && buf.length ? this.write(buf) : "";
  if (this.lastNeed) {
    return r + this.lastChar.toString("base64", 0, 3 - this.lastNeed);
  }
  return r;
}
function simpleWrite(buf) {
  if (typeof buf === "string") {
    return buf;
  }
  return buf.toString(this.encoding);
}
function simpleEnd(buf) {
  return buf && buf.length ? this.write(buf) : "";
}
var StringDecoderBase = class {
  lastChar;
  lastNeed;
  lastTotal;
  constructor(encoding, nb) {
    this.encoding = encoding;
    this.lastNeed = 0;
    this.lastTotal = 0;
    this.lastChar = Buffer2.allocUnsafe(nb);
  }
  encoding;
};
var Base64Decoder = class extends StringDecoderBase {
  end = base64End;
  fillLast = utf8FillLastIncomplete;
  text = base64Text;
  write = utf8Write2;
  constructor(encoding) {
    super(normalizeEncoding2(encoding), 3);
  }
};
var GenericDecoder = class extends StringDecoderBase {
  end = simpleEnd;
  fillLast = void 0;
  text = utf8Text;
  write = simpleWrite;
  constructor(encoding) {
    super(normalizeEncoding2(encoding), 4);
  }
};
var Utf8Decoder = class extends StringDecoderBase {
  end = utf8End;
  fillLast = utf8FillLastComplete;
  text = utf8Text;
  write = utf8Write2;
  constructor(encoding) {
    super(normalizeEncoding2(encoding), 4);
  }
};
var StringDecoder = class {
  encoding;
  end;
  fillLast;
  lastChar;
  lastNeed;
  lastTotal;
  text;
  write;
  constructor(encoding) {
    let decoder;
    switch (encoding) {
      case "utf8":
        decoder = new Utf8Decoder(encoding);
        break;
      case "base64":
        decoder = new Base64Decoder(encoding);
        break;
      default:
        decoder = new GenericDecoder(encoding);
    }
    this.encoding = decoder.encoding;
    this.end = decoder.end;
    this.fillLast = decoder.fillLast;
    this.lastChar = decoder.lastChar;
    this.lastNeed = decoder.lastNeed;
    this.lastTotal = decoder.lastTotal;
    this.text = decoder.text;
    this.write = decoder.write;
  }
};
new Proxy(StringDecoder, {
  apply(_target, thisArg, args) {
    return Object.assign(thisArg, new StringDecoder(...args));
  }
});
var BufferList = class {
  constructor() {
    this.head = null;
    this.tail = null;
    this.length = 0;
  }
  push(v) {
    const entry = {
      data: v,
      next: null
    };
    if (this.length > 0) {
      this.tail.next = entry;
    } else {
      this.head = entry;
    }
    this.tail = entry;
    ++this.length;
  }
  unshift(v) {
    const entry = {
      data: v,
      next: this.head
    };
    if (this.length === 0) {
      this.tail = entry;
    }
    this.head = entry;
    ++this.length;
  }
  shift() {
    if (this.length === 0) {
      return;
    }
    const ret = this.head.data;
    if (this.length === 1) {
      this.head = this.tail = null;
    } else {
      this.head = this.head.next;
    }
    --this.length;
    return ret;
  }
  clear() {
    this.head = this.tail = null;
    this.length = 0;
  }
  join(s) {
    if (this.length === 0) {
      return "";
    }
    let p = this.head;
    let ret = "" + p.data;
    while (p = p.next) {
      ret += s + p.data;
    }
    return ret;
  }
  concat(n) {
    if (this.length === 0) {
      return Buffer2.alloc(0);
    }
    const ret = Buffer2.allocUnsafe(n >>> 0);
    let p = this.head;
    let i61 = 0;
    while (p) {
      ret.set(p.data, i61);
      i61 += p.data.length;
      p = p.next;
    }
    return ret;
  }
  consume(n, hasStrings) {
    const data = this.head.data;
    if (n < data.length) {
      const slice2 = data.slice(0, n);
      this.head.data = data.slice(n);
      return slice2;
    }
    if (n === data.length) {
      return this.shift();
    }
    return hasStrings ? this._getString(n) : this._getBuffer(n);
  }
  first() {
    return this.head.data;
  }
  *[Symbol.iterator]() {
    for (let p = this.head; p; p = p.next) {
      yield p.data;
    }
  }
  _getString(n) {
    let ret = "";
    let p = this.head;
    let c = 0;
    do {
      const str = p.data;
      if (n > str.length) {
        ret += str;
        n -= str.length;
      } else {
        if (n === str.length) {
          ret += str;
          ++c;
          if (p.next) {
            this.head = p.next;
          } else {
            this.head = this.tail = null;
          }
        } else {
          ret += str.slice(0, n);
          this.head = p;
          p.data = str.slice(n);
        }
        break;
      }
      ++c;
    } while (p = p.next);
    this.length -= c;
    return ret;
  }
  _getBuffer(n) {
    const ret = Buffer2.allocUnsafe(n);
    const retLen = n;
    let p = this.head;
    let c = 0;
    do {
      const buf = p.data;
      if (n > buf.length) {
        ret.set(buf, retLen - n);
        n -= buf.length;
      } else {
        if (n === buf.length) {
          ret.set(buf, retLen - n);
          ++c;
          if (p.next) {
            this.head = p.next;
          } else {
            this.head = this.tail = null;
          }
        } else {
          ret.set(new Uint8Array(buf.buffer, buf.byteOffset, n), retLen - n);
          this.head = p;
          p.data = buf.slice(n);
        }
        break;
      }
      ++c;
    } while (p = p.next);
    this.length -= c;
    return ret;
  }
  [inspect.custom](_, options) {
    return inspect(this, {
      ...options,
      depth: 0,
      customInspect: false
    });
  }
};
var debug = debuglog("stream", (fn) => {
  debug = fn;
});
var kPaused = Symbol("kPaused");
Object.setPrototypeOf(Readable.prototype, Stream.prototype);
Object.setPrototypeOf(Readable, Stream);
var nop1 = () => {
};
var { errorOrDestroy: errorOrDestroy1 } = __default3;
function ReadableState(options, stream, isDuplex) {
  if (typeof isDuplex !== "boolean") {
    isDuplex = stream instanceof Stream.Duplex;
  }
  this.objectMode = !!(options && options.objectMode);
  if (isDuplex) {
    this.objectMode = this.objectMode || !!(options && options.readableObjectMode);
  }
  this.highWaterMark = options ? getHighWaterMark(this, options, "readableHighWaterMark", isDuplex) : getDefaultHighWaterMark(false);
  this.buffer = new BufferList();
  this.length = 0;
  this.pipes = [];
  this.flowing = null;
  this.ended = false;
  this.endEmitted = false;
  this.reading = false;
  this.constructed = true;
  this.sync = true;
  this.needReadable = false;
  this.emittedReadable = false;
  this.readableListening = false;
  this.resumeScheduled = false;
  this[kPaused] = null;
  this.errorEmitted = false;
  this.emitClose = !options || options.emitClose !== false;
  this.autoDestroy = !options || options.autoDestroy !== false;
  this.destroyed = false;
  this.errored = null;
  this.closed = false;
  this.closeEmitted = false;
  this.defaultEncoding = options && options.defaultEncoding || "utf8";
  this.awaitDrainWriters = null;
  this.multiAwaitDrain = false;
  this.readingMore = false;
  this.dataEmitted = false;
  this.decoder = null;
  this.encoding = null;
  if (options && options.encoding) {
    this.decoder = new StringDecoder(options.encoding);
    this.encoding = options.encoding;
  }
}
function Readable(options) {
  if (!(this instanceof Readable)) {
    return new Readable(options);
  }
  const isDuplex = this instanceof Stream.Duplex;
  this._readableState = new ReadableState(options, this, isDuplex);
  if (options) {
    if (typeof options.read === "function") {
      this._read = options.read;
    }
    if (typeof options.destroy === "function") {
      this._destroy = options.destroy;
    }
    if (typeof options.construct === "function") {
      this._construct = options.construct;
    }
    if (options.signal && !isDuplex) {
      addAbortSignalNoValidate(options.signal, this);
    }
  }
  Stream.call(this, options);
  __default3.construct(this, () => {
    if (this._readableState.needReadable) {
      maybeReadMore(this, this._readableState);
    }
  });
}
Readable.prototype.destroy = __default3.destroy;
Readable.prototype._undestroy = __default3.undestroy;
Readable.prototype._destroy = function(err, cb) {
  cb(err);
};
Readable.prototype[EventEmitter.captureRejectionSymbol] = function(err) {
  this.destroy(err);
};
Readable.prototype.push = function(chunk, encoding) {
  return readableAddChunk(this, chunk, encoding, false);
};
Readable.prototype.unshift = function(chunk, encoding) {
  return readableAddChunk(this, chunk, encoding, true);
};
function readableAddChunk(stream, chunk, encoding, addToFront) {
  debug("readableAddChunk", chunk);
  const state = stream._readableState;
  let err;
  if (!state.objectMode) {
    if (typeof chunk === "string") {
      encoding = encoding || state.defaultEncoding;
      if (state.encoding !== encoding) {
        if (addToFront && state.encoding) {
          chunk = Buffer2.from(chunk, encoding).toString(state.encoding);
        } else {
          chunk = Buffer2.from(chunk, encoding);
          encoding = "";
        }
      }
    } else if (chunk instanceof Buffer2) {
      encoding = "";
    } else if (Stream._isUint8Array(chunk)) {
      chunk = Stream._uint8ArrayToBuffer(chunk);
      encoding = "";
    } else if (chunk != null) {
      err = new ERR_INVALID_ARG_TYPE("chunk", [
        "string",
        "Buffer",
        "Uint8Array"
      ], chunk);
    }
  }
  if (err) {
    errorOrDestroy1(stream, err);
  } else if (chunk === null) {
    state.reading = false;
    onEofChunk(stream, state);
  } else if (state.objectMode || chunk && chunk.length > 0) {
    if (addToFront) {
      if (state.endEmitted) {
        errorOrDestroy1(stream, new ERR_STREAM_UNSHIFT_AFTER_END_EVENT());
      } else {
        addChunk(stream, state, chunk, true);
      }
    } else if (state.ended) {
      errorOrDestroy1(stream, new ERR_STREAM_PUSH_AFTER_EOF());
    } else if (state.destroyed || state.errored) {
      return false;
    } else {
      state.reading = false;
      if (state.decoder && !encoding) {
        chunk = state.decoder.write(chunk);
        if (state.objectMode || chunk.length !== 0) {
          addChunk(stream, state, chunk, false);
        } else {
          maybeReadMore(stream, state);
        }
      } else {
        addChunk(stream, state, chunk, false);
      }
    }
  } else if (!addToFront) {
    state.reading = false;
    maybeReadMore(stream, state);
  }
  return !state.ended && (state.length < state.highWaterMark || state.length === 0);
}
function addChunk(stream, state, chunk, addToFront) {
  if (state.flowing && state.length === 0 && !state.sync && stream.listenerCount("data") > 0) {
    if (state.multiAwaitDrain) {
      state.awaitDrainWriters.clear();
    } else {
      state.awaitDrainWriters = null;
    }
    state.dataEmitted = true;
    stream.emit("data", chunk);
  } else {
    state.length += state.objectMode ? 1 : chunk.length;
    if (addToFront) {
      state.buffer.unshift(chunk);
    } else {
      state.buffer.push(chunk);
    }
    if (state.needReadable) {
      emitReadable(stream);
    }
  }
  maybeReadMore(stream, state);
}
Readable.prototype.isPaused = function() {
  const state = this._readableState;
  return state[kPaused] === true || state.flowing === false;
};
Readable.prototype.setEncoding = function(enc) {
  const decoder = new StringDecoder(enc);
  this._readableState.decoder = decoder;
  this._readableState.encoding = this._readableState.decoder.encoding;
  const buffer = this._readableState.buffer;
  let content = "";
  for (const data of buffer) {
    content += decoder.write(data);
  }
  buffer.clear();
  if (content !== "") {
    buffer.push(content);
  }
  this._readableState.length = content.length;
  return this;
};
var MAX_HWM = 1073741824;
function computeNewHighWaterMark(n) {
  if (n >= 1073741824) {
    n = MAX_HWM;
  } else {
    n--;
    n |= n >>> 1;
    n |= n >>> 2;
    n |= n >>> 4;
    n |= n >>> 8;
    n |= n >>> 16;
    n++;
  }
  return n;
}
function howMuchToRead(n, state) {
  if (n <= 0 || state.length === 0 && state.ended) {
    return 0;
  }
  if (state.objectMode) {
    return 1;
  }
  if (Number.isNaN(n)) {
    if (state.flowing && state.length) {
      return state.buffer.first().length;
    }
    return state.length;
  }
  if (n <= state.length) {
    return n;
  }
  return state.ended ? state.length : 0;
}
Readable.prototype.read = function(n) {
  debug("read", n);
  if (n === void 0) {
    n = NaN;
  } else if (!Number.isInteger(n)) {
    n = Number.parseInt(n, 10);
  }
  const state = this._readableState;
  const nOrig = n;
  if (n > state.highWaterMark) {
    state.highWaterMark = computeNewHighWaterMark(n);
  }
  if (n !== 0) {
    state.emittedReadable = false;
  }
  if (n === 0 && state.needReadable && ((state.highWaterMark !== 0 ? state.length >= state.highWaterMark : state.length > 0) || state.ended)) {
    debug("read: emitReadable", state.length, state.ended);
    if (state.length === 0 && state.ended) {
      endReadable(this);
    } else {
      emitReadable(this);
    }
    return null;
  }
  n = howMuchToRead(n, state);
  if (n === 0 && state.ended) {
    if (state.length === 0) {
      endReadable(this);
    }
    return null;
  }
  let doRead = state.needReadable;
  debug("need readable", doRead);
  if (state.length === 0 || state.length - n < state.highWaterMark) {
    doRead = true;
    debug("length less than watermark", doRead);
  }
  if (state.ended || state.reading || state.destroyed || state.errored || !state.constructed) {
    doRead = false;
    debug("reading, ended or constructing", doRead);
  } else if (doRead) {
    debug("do read");
    state.reading = true;
    state.sync = true;
    if (state.length === 0) {
      state.needReadable = true;
    }
    this._read(state.highWaterMark);
    state.sync = false;
    if (!state.reading) {
      n = howMuchToRead(nOrig, state);
    }
  }
  let ret;
  if (n > 0) {
    ret = fromList(n, state);
  } else {
    ret = null;
  }
  if (ret === null) {
    state.needReadable = state.length <= state.highWaterMark;
    n = 0;
  } else {
    state.length -= n;
    if (state.multiAwaitDrain) {
      state.awaitDrainWriters.clear();
    } else {
      state.awaitDrainWriters = null;
    }
  }
  if (state.length === 0) {
    if (!state.ended) {
      state.needReadable = true;
    }
    if (nOrig !== n && state.ended) {
      endReadable(this);
    }
  }
  if (ret !== null) {
    state.dataEmitted = true;
    this.emit("data", ret);
  }
  return ret;
};
function onEofChunk(stream, state) {
  debug("onEofChunk");
  if (state.ended)
    return;
  if (state.decoder) {
    const chunk = state.decoder.end();
    if (chunk && chunk.length) {
      state.buffer.push(chunk);
      state.length += state.objectMode ? 1 : chunk.length;
    }
  }
  state.ended = true;
  if (state.sync) {
    emitReadable(stream);
  } else {
    state.needReadable = false;
    state.emittedReadable = true;
    emitReadable_(stream);
  }
}
function emitReadable(stream) {
  const state = stream._readableState;
  debug("emitReadable", state.needReadable, state.emittedReadable);
  state.needReadable = false;
  if (!state.emittedReadable) {
    debug("emitReadable", state.flowing);
    state.emittedReadable = true;
    nextTick2(emitReadable_, stream);
  }
}
function emitReadable_(stream) {
  const state = stream._readableState;
  debug("emitReadable_", state.destroyed, state.length, state.ended);
  if (!state.destroyed && !state.errored && (state.length || state.ended)) {
    stream.emit("readable");
    state.emittedReadable = false;
  }
  state.needReadable = !state.flowing && !state.ended && state.length <= state.highWaterMark;
  flow(stream);
}
function maybeReadMore(stream, state) {
  if (!state.readingMore && state.constructed) {
    state.readingMore = true;
    nextTick2(maybeReadMore_, stream, state);
  }
}
function maybeReadMore_(stream, state) {
  while (!state.reading && !state.ended && (state.length < state.highWaterMark || state.flowing && state.length === 0)) {
    const len = state.length;
    debug("maybeReadMore read 0");
    stream.read(0);
    if (len === state.length) {
      break;
    }
  }
  state.readingMore = false;
}
Readable.prototype._read = function(n) {
  throw new ERR_METHOD_NOT_IMPLEMENTED("_read()");
};
Readable.prototype.pipe = function(dest, pipeOpts) {
  const src = this;
  const state = this._readableState;
  if (state.pipes.length === 1) {
    if (!state.multiAwaitDrain) {
      state.multiAwaitDrain = true;
      state.awaitDrainWriters = new Set(state.awaitDrainWriters ? [
        state.awaitDrainWriters
      ] : []);
    }
  }
  state.pipes.push(dest);
  debug("pipe count=%d opts=%j", state.pipes.length, pipeOpts);
  const doEnd = (!pipeOpts || pipeOpts.end !== false) && dest !== stdio.stdout && dest !== stdio.stderr;
  const endFn = doEnd ? onend : unpipe;
  if (state.endEmitted) {
    nextTick2(endFn);
  } else {
    src.once("end", endFn);
  }
  dest.on("unpipe", onunpipe);
  function onunpipe(readable, unpipeInfo) {
    debug("onunpipe");
    if (readable === src) {
      if (unpipeInfo && unpipeInfo.hasUnpiped === false) {
        unpipeInfo.hasUnpiped = true;
        cleanup();
      }
    }
  }
  function onend() {
    debug("onend");
    dest.end();
  }
  let ondrain;
  let cleanedUp = false;
  function cleanup() {
    debug("cleanup");
    dest.removeListener("close", onclose);
    dest.removeListener("finish", onfinish);
    if (ondrain) {
      dest.removeListener("drain", ondrain);
    }
    dest.removeListener("error", onerror);
    dest.removeListener("unpipe", onunpipe);
    src.removeListener("end", onend);
    src.removeListener("end", unpipe);
    src.removeListener("data", ondata);
    cleanedUp = true;
    if (ondrain && state.awaitDrainWriters && (!dest._writableState || dest._writableState.needDrain)) {
      ondrain();
    }
  }
  function pause() {
    if (!cleanedUp) {
      if (state.pipes.length === 1 && state.pipes[0] === dest) {
        debug("false write response, pause", 0);
        state.awaitDrainWriters = dest;
        state.multiAwaitDrain = false;
      } else if (state.pipes.length > 1 && state.pipes.includes(dest)) {
        debug("false write response, pause", state.awaitDrainWriters.size);
        state.awaitDrainWriters.add(dest);
      }
      src.pause();
    }
    if (!ondrain) {
      ondrain = pipeOnDrain(src, dest);
      dest.on("drain", ondrain);
    }
  }
  src.on("data", ondata);
  function ondata(chunk) {
    debug("ondata");
    const ret = dest.write(chunk);
    debug("dest.write", ret);
    if (ret === false) {
      pause();
    }
  }
  function onerror(er) {
    debug("onerror", er);
    unpipe();
    dest.removeListener("error", onerror);
    if (EventEmitter.listenerCount(dest, "error") === 0) {
      const s = dest._writableState || dest._readableState;
      if (s && !s.errorEmitted) {
        errorOrDestroy1(dest, er);
      } else {
        dest.emit("error", er);
      }
    }
  }
  prependListener2(dest, "error", onerror);
  function onclose() {
    dest.removeListener("finish", onfinish);
    unpipe();
  }
  dest.once("close", onclose);
  function onfinish() {
    debug("onfinish");
    dest.removeListener("close", onclose);
    unpipe();
  }
  dest.once("finish", onfinish);
  function unpipe() {
    debug("unpipe");
    src.unpipe(dest);
  }
  dest.emit("pipe", src);
  if (dest.writableNeedDrain === true) {
    if (state.flowing) {
      pause();
    }
  } else if (!state.flowing) {
    debug("pipe resume");
    src.resume();
  }
  return dest;
};
function pipeOnDrain(src, dest) {
  return function pipeOnDrainFunctionResult() {
    const state = src._readableState;
    if (state.awaitDrainWriters === dest) {
      debug("pipeOnDrain", 1);
      state.awaitDrainWriters = null;
    } else if (state.multiAwaitDrain) {
      debug("pipeOnDrain", state.awaitDrainWriters.size);
      state.awaitDrainWriters.delete(dest);
    }
    if ((!state.awaitDrainWriters || state.awaitDrainWriters.size === 0) && EventEmitter.listenerCount(src, "data")) {
      state.flowing = true;
      flow(src);
    }
  };
}
Readable.prototype.unpipe = function(dest) {
  const state = this._readableState;
  const unpipeInfo = {
    hasUnpiped: false
  };
  if (state.pipes.length === 0) {
    return this;
  }
  if (!dest) {
    const dests = state.pipes;
    state.pipes = [];
    this.pause();
    for (let i62 = 0; i62 < dests.length; i62++) {
      dests[i62].emit("unpipe", this, {
        hasUnpiped: false
      });
    }
    return this;
  }
  const index = state.pipes.indexOf(dest);
  if (index === -1) {
    return this;
  }
  state.pipes.splice(index, 1);
  if (state.pipes.length === 0) {
    this.pause();
  }
  dest.emit("unpipe", this, unpipeInfo);
  return this;
};
Readable.prototype.on = function(ev, fn) {
  const res = Stream.prototype.on.call(this, ev, fn);
  const state = this._readableState;
  if (ev === "data") {
    state.readableListening = this.listenerCount("readable") > 0;
    if (state.flowing !== false) {
      this.resume();
    }
  } else if (ev === "readable") {
    if (!state.endEmitted && !state.readableListening) {
      state.readableListening = state.needReadable = true;
      state.flowing = false;
      state.emittedReadable = false;
      debug("on readable", state.length, state.reading);
      if (state.length) {
        emitReadable(this);
      } else if (!state.reading) {
        nextTick2(nReadingNextTick, this);
      }
    }
  }
  return res;
};
Readable.prototype.addListener = Readable.prototype.on;
Readable.prototype.removeListener = function(ev, fn) {
  const res = Stream.prototype.removeListener.call(this, ev, fn);
  if (ev === "readable") {
    nextTick2(updateReadableListening, this);
  }
  return res;
};
Readable.prototype.off = Readable.prototype.removeListener;
Readable.prototype.removeAllListeners = function(ev) {
  const res = Stream.prototype.removeAllListeners.apply(this, arguments);
  if (ev === "readable" || ev === void 0) {
    nextTick2(updateReadableListening, this);
  }
  return res;
};
function updateReadableListening(self) {
  const state = self._readableState;
  state.readableListening = self.listenerCount("readable") > 0;
  if (state.resumeScheduled && state[kPaused] === false) {
    state.flowing = true;
  } else if (self.listenerCount("data") > 0) {
    self.resume();
  } else if (!state.readableListening) {
    state.flowing = null;
  }
}
function nReadingNextTick(self) {
  debug("readable nexttick read 0");
  self.read(0);
}
Readable.prototype.resume = function() {
  const state = this._readableState;
  if (!state.flowing) {
    debug("resume");
    state.flowing = !state.readableListening;
    resume(this, state);
  }
  state[kPaused] = false;
  return this;
};
function resume(stream, state) {
  if (!state.resumeScheduled) {
    state.resumeScheduled = true;
    nextTick2(resume_, stream, state);
  }
}
function resume_(stream, state) {
  debug("resume", state.reading);
  if (!state.reading) {
    stream.read(0);
  }
  state.resumeScheduled = false;
  stream.emit("resume");
  flow(stream);
  if (state.flowing && !state.reading) {
    stream.read(0);
  }
}
Readable.prototype.pause = function() {
  debug("call pause flowing=%j", this._readableState.flowing);
  if (this._readableState.flowing !== false) {
    debug("pause");
    this._readableState.flowing = false;
    this.emit("pause");
  }
  this._readableState[kPaused] = true;
  return this;
};
function flow(stream) {
  const state = stream._readableState;
  debug("flow", state.flowing);
  while (state.flowing && stream.read() !== null)
    ;
}
Readable.prototype.wrap = function(stream) {
  let paused = false;
  stream.on("data", (chunk) => {
    if (!this.push(chunk) && stream.pause) {
      paused = true;
      stream.pause();
    }
  });
  stream.on("end", () => {
    this.push(null);
  });
  stream.on("error", (err) => {
    errorOrDestroy1(this, err);
  });
  stream.on("close", () => {
    this.destroy();
  });
  stream.on("destroy", () => {
    this.destroy();
  });
  this._read = () => {
    if (paused && stream.resume) {
      paused = false;
      stream.resume();
    }
  };
  const streamKeys = Object.keys(stream);
  for (let j = 1; j < streamKeys.length; j++) {
    const i63 = streamKeys[j];
    if (this[i63] === void 0 && typeof stream[i63] === "function") {
      this[i63] = stream[i63].bind(stream);
    }
  }
  return this;
};
Readable.prototype[Symbol.asyncIterator] = function() {
  return streamToAsyncIterator(this);
};
Readable.prototype.iterator = function(options) {
  if (options !== void 0) {
    validateObject(options, "options");
  }
  return streamToAsyncIterator(this, options);
};
function streamToAsyncIterator(stream, options) {
  if (typeof stream.read !== "function") {
    stream = Readable.wrap(stream, {
      objectMode: true
    });
  }
  const iter = createAsyncIterator(stream, options);
  iter.stream = stream;
  return iter;
}
async function* createAsyncIterator(stream, options) {
  let callback = nop1;
  const opts = {
    destroyOnReturn: true,
    destroyOnError: true,
    ...options
  };
  function next(resolve11) {
    if (this === stream) {
      callback();
      callback = nop1;
    } else {
      callback = resolve11;
    }
  }
  const state = stream._readableState;
  let error6 = state.errored;
  let errorEmitted = state.errorEmitted;
  let endEmitted = state.endEmitted;
  let closeEmitted = state.closeEmitted;
  stream.on("readable", next).on("error", function(err) {
    error6 = err;
    errorEmitted = true;
    next.call(this);
  }).on("end", function() {
    endEmitted = true;
    next.call(this);
  }).on("close", function() {
    closeEmitted = true;
    next.call(this);
  });
  let errorThrown = false;
  try {
    while (true) {
      const chunk = stream.destroyed ? null : stream.read();
      if (chunk !== null) {
        yield chunk;
      } else if (errorEmitted) {
        throw error6;
      } else if (endEmitted) {
        break;
      } else if (closeEmitted) {
        break;
      } else {
        await new Promise(next);
      }
    }
  } catch (err) {
    if (opts.destroyOnError) {
      __default3.destroyer(stream, err);
    }
    errorThrown = true;
    throw err;
  } finally {
    if (!errorThrown && opts.destroyOnReturn) {
      if (state.autoDestroy || !endEmitted) {
        __default3.destroyer(stream, null);
      }
    }
  }
}
Object.defineProperties(Readable.prototype, {
  readable: {
    get() {
      const r = this._readableState;
      return !!r && r.readable !== false && !r.destroyed && !r.errorEmitted && !r.endEmitted;
    },
    set(val) {
      if (this._readableState) {
        this._readableState.readable = !!val;
      }
    }
  },
  readableDidRead: {
    enumerable: false,
    get: function() {
      return this._readableState.dataEmitted;
    }
  },
  readableAborted: {
    enumerable: false,
    get: function() {
      return !!(this._readableState.destroyed || this._readableState.errored) && !this._readableState.endEmitted;
    }
  },
  readableHighWaterMark: {
    enumerable: false,
    get: function() {
      return this._readableState.highWaterMark;
    }
  },
  readableBuffer: {
    enumerable: false,
    get: function() {
      return this._readableState && this._readableState.buffer;
    }
  },
  readableFlowing: {
    enumerable: false,
    get: function() {
      return this._readableState.flowing;
    },
    set: function(state) {
      if (this._readableState) {
        this._readableState.flowing = state;
      }
    }
  },
  readableLength: {
    enumerable: false,
    get() {
      return this._readableState.length;
    }
  },
  readableObjectMode: {
    enumerable: false,
    get() {
      return this._readableState ? this._readableState.objectMode : false;
    }
  },
  readableEncoding: {
    enumerable: false,
    get() {
      return this._readableState ? this._readableState.encoding : null;
    }
  },
  destroyed: {
    enumerable: false,
    get() {
      if (this._readableState === void 0) {
        return false;
      }
      return this._readableState.destroyed;
    },
    set(value) {
      if (!this._readableState) {
        return;
      }
      this._readableState.destroyed = value;
    }
  },
  readableEnded: {
    enumerable: false,
    get() {
      return this._readableState ? this._readableState.endEmitted : false;
    }
  }
});
Object.defineProperties(ReadableState.prototype, {
  pipesCount: {
    get() {
      return this.pipes.length;
    }
  },
  paused: {
    get() {
      return this[kPaused] !== false;
    },
    set(value) {
      this[kPaused] = !!value;
    }
  }
});
function fromList(n, state) {
  if (state.length === 0) {
    return null;
  }
  let ret;
  if (state.objectMode) {
    ret = state.buffer.shift();
  } else if (!n || n >= state.length) {
    if (state.decoder) {
      ret = state.buffer.join("");
    } else if (state.buffer.length === 1) {
      ret = state.buffer.first();
    } else {
      ret = state.buffer.concat(state.length);
    }
    state.buffer.clear();
  } else {
    ret = state.buffer.consume(n, state.decoder);
  }
  return ret;
}
function endReadable(stream) {
  const state = stream._readableState;
  debug("endReadable", state.endEmitted);
  if (!state.endEmitted) {
    state.ended = true;
    nextTick2(endReadableNT, state, stream);
  }
}
function endReadableNT(state, stream) {
  debug("endReadableNT", state.endEmitted, state.length);
  if (!state.errorEmitted && !state.closeEmitted && !state.endEmitted && state.length === 0) {
    state.endEmitted = true;
    stream.emit("end");
    if (stream.writable && stream.allowHalfOpen === false) {
      nextTick2(endWritableNT, stream);
    } else if (state.autoDestroy) {
      const wState = stream._writableState;
      const autoDestroy = !wState || wState.autoDestroy && (wState.finished || wState.writable === false);
      if (autoDestroy) {
        stream.destroy();
      }
    }
  }
}
function endWritableNT(stream) {
  const writable = stream.writable && !stream.writableEnded && !stream.destroyed;
  if (writable) {
    stream.end();
  }
}
function readableFrom(iterable, opts) {
  return _from1(Readable, iterable, opts);
}
function wrap(src, options) {
  return new Readable({
    objectMode: src.readableObjectMode ?? src.objectMode ?? true,
    ...options,
    destroy(err, callback) {
      __default3.destroyer(src, err);
      callback(err);
    }
  }).wrap(src);
}
Readable._fromList = fromList;
Readable.ReadableState = ReadableState;
Readable.from = readableFrom;
Readable.wrap = wrap;
var { errorOrDestroy: errorOrDestroy2 } = __default3;
function isDuplexStream(maybe_duplex) {
  const isReadable2 = Readable.prototype.isPrototypeOf(maybe_duplex);
  let prototype = maybe_duplex;
  let isDuplex = false;
  while (prototype?.constructor && prototype.constructor.name !== "Object") {
    if (prototype.constructor.name === "Duplex") {
      isDuplex = true;
      break;
    }
    prototype = Object.getPrototypeOf(prototype);
  }
  return isReadable2 && isDuplex;
}
Object.setPrototypeOf(Writable.prototype, Stream.prototype);
Object.setPrototypeOf(Writable, Stream);
function nop2() {
}
var kOnFinished = Symbol("kOnFinished");
function WritableState(options, stream, isDuplex) {
  if (typeof isDuplex !== "boolean") {
    isDuplex = isDuplexStream(stream);
  }
  this.objectMode = !!(options && options.objectMode);
  if (isDuplex) {
    this.objectMode = this.objectMode || !!(options && options.writableObjectMode);
  }
  this.highWaterMark = options ? getHighWaterMark(this, options, "writableHighWaterMark", isDuplex) : getDefaultHighWaterMark(false);
  this.finalCalled = false;
  this.needDrain = false;
  this.ending = false;
  this.ended = false;
  this.finished = false;
  this.destroyed = false;
  const noDecode = !!(options && options.decodeStrings === false);
  this.decodeStrings = !noDecode;
  this.defaultEncoding = options && options.defaultEncoding || "utf8";
  this.length = 0;
  this.writing = false;
  this.corked = 0;
  this.sync = true;
  this.bufferProcessing = false;
  this.onwrite = onwrite.bind(void 0, stream);
  this.writecb = null;
  this.writelen = 0;
  this.afterWriteTickInfo = null;
  resetBuffer(this);
  this.pendingcb = 0;
  this.constructed = true;
  this.prefinished = false;
  this.errorEmitted = false;
  this.emitClose = !options || options.emitClose !== false;
  this.autoDestroy = !options || options.autoDestroy !== false;
  this.errored = null;
  this.closed = false;
  this.closeEmitted = false;
  this[kOnFinished] = [];
}
function resetBuffer(state) {
  state.buffered = [];
  state.bufferedIndex = 0;
  state.allBuffers = true;
  state.allNoop = true;
}
WritableState.prototype.getBuffer = function getBuffer() {
  return this.buffered.slice(this.bufferedIndex);
};
Object.defineProperty(WritableState.prototype, "bufferedRequestCount", {
  get() {
    return this.buffered.length - this.bufferedIndex;
  }
});
function Writable(options) {
  const isDuplex = isDuplexStream(this);
  if (!isDuplex && !Function.prototype[Symbol.hasInstance].call(Writable, this)) {
    return new Writable(options);
  }
  this._writableState = new WritableState(options, this, isDuplex);
  if (options) {
    if (typeof options.write === "function") {
      this._write = options.write;
    }
    if (typeof options.writev === "function") {
      this._writev = options.writev;
    }
    if (typeof options.destroy === "function") {
      this._destroy = options.destroy;
    }
    if (typeof options.final === "function") {
      this._final = options.final;
    }
    if (typeof options.construct === "function") {
      this._construct = options.construct;
    }
    if (options.signal) {
      addAbortSignalNoValidate(options.signal, this);
    }
  }
  Stream.call(this, options);
  __default3.construct(this, () => {
    const state = this._writableState;
    if (!state.writing) {
      clearBuffer(this, state);
    }
    finishMaybe(this, state);
  });
}
Object.defineProperty(Writable, Symbol.hasInstance, {
  value: function(object) {
    if (Function.prototype[Symbol.hasInstance].call(this, object))
      return true;
    if (this !== Writable)
      return false;
    return object && object._writableState instanceof WritableState;
  }
});
Writable.prototype.pipe = function() {
  errorOrDestroy2(this, new ERR_STREAM_CANNOT_PIPE());
};
function _write(stream, chunk, encoding, cb) {
  const state = stream._writableState;
  if (typeof encoding === "function") {
    cb = encoding;
    encoding = state.defaultEncoding;
  } else {
    if (!encoding) {
      encoding = state.defaultEncoding;
    } else if (encoding !== "buffer" && !Buffer2.isEncoding(encoding)) {
      throw new ERR_UNKNOWN_ENCODING(encoding);
    }
    if (typeof cb !== "function") {
      cb = nop2;
    }
  }
  if (chunk === null) {
    throw new ERR_STREAM_NULL_VALUES();
  } else if (!state.objectMode) {
    if (typeof chunk === "string") {
      if (state.decodeStrings !== false) {
        chunk = Buffer2.from(chunk, encoding);
        encoding = "buffer";
      }
    } else if (chunk instanceof Buffer2) {
      encoding = "buffer";
    } else if (isUint8Array(chunk)) {
      chunk = _uint8ArrayToBuffer(chunk);
      encoding = "buffer";
    } else {
      throw new ERR_INVALID_ARG_TYPE("chunk", [
        "string",
        "Buffer",
        "Uint8Array"
      ], chunk);
    }
  }
  let err;
  if (state.ending) {
    err = new ERR_STREAM_WRITE_AFTER_END();
  } else if (state.destroyed) {
    err = new ERR_STREAM_DESTROYED("write");
  }
  if (err) {
    nextTick2(cb, err);
    errorOrDestroy2(stream, err, true);
    return err;
  }
  state.pendingcb++;
  return writeOrBuffer(stream, state, chunk, encoding, cb);
}
Writable.prototype.write = function(chunk, encoding, cb) {
  return _write(this, chunk, encoding, cb) === true;
};
Writable.prototype.cork = function() {
  this._writableState.corked++;
};
Writable.prototype.uncork = function() {
  const state = this._writableState;
  if (state.corked) {
    state.corked--;
    if (!state.writing) {
      clearBuffer(this, state);
    }
  }
};
Writable.prototype.setDefaultEncoding = function setDefaultEncoding(encoding) {
  if (typeof encoding === "string") {
    encoding = encoding.toLowerCase();
  }
  if (!Buffer2.isEncoding(encoding)) {
    throw new ERR_UNKNOWN_ENCODING(encoding);
  }
  this._writableState.defaultEncoding = encoding;
  return this;
};
function writeOrBuffer(stream, state, chunk, encoding, callback) {
  const len = state.objectMode ? 1 : chunk.length;
  state.length += len;
  const ret = state.length < state.highWaterMark;
  if (!ret) {
    state.needDrain = true;
  }
  if (state.writing || state.corked || state.errored || !state.constructed) {
    state.buffered.push({
      chunk,
      encoding,
      callback
    });
    if (state.allBuffers && encoding !== "buffer") {
      state.allBuffers = false;
    }
    if (state.allNoop && callback !== nop2) {
      state.allNoop = false;
    }
  } else {
    state.writelen = len;
    state.writecb = callback;
    state.writing = true;
    state.sync = true;
    stream._write(chunk, encoding, state.onwrite);
    state.sync = false;
  }
  return ret && !state.errored && !state.destroyed;
}
function doWrite(stream, state, writev, len, chunk, encoding, cb) {
  state.writelen = len;
  state.writecb = cb;
  state.writing = true;
  state.sync = true;
  if (state.destroyed) {
    state.onwrite(new ERR_STREAM_DESTROYED("write"));
  } else if (writev) {
    stream._writev(chunk, state.onwrite);
  } else {
    stream._write(chunk, encoding, state.onwrite);
  }
  state.sync = false;
}
function onwriteError(stream, state, er, cb) {
  --state.pendingcb;
  cb(er);
  errorBuffer(state);
  errorOrDestroy2(stream, er);
}
function onwrite(stream, er) {
  const state = stream._writableState;
  const sync = state.sync;
  const cb = state.writecb;
  if (typeof cb !== "function") {
    errorOrDestroy2(stream, new ERR_MULTIPLE_CALLBACK());
    return;
  }
  state.writing = false;
  state.writecb = null;
  state.length -= state.writelen;
  state.writelen = 0;
  if (er) {
    er.stack;
    if (!state.errored) {
      state.errored = er;
    }
    if (stream._readableState && !stream._readableState.errored) {
      stream._readableState.errored = er;
    }
    if (sync) {
      nextTick2(onwriteError, stream, state, er, cb);
    } else {
      onwriteError(stream, state, er, cb);
    }
  } else {
    if (state.buffered.length > state.bufferedIndex) {
      clearBuffer(stream, state);
    }
    if (sync) {
      if (state.afterWriteTickInfo !== null && state.afterWriteTickInfo.cb === cb) {
        state.afterWriteTickInfo.count++;
      } else {
        state.afterWriteTickInfo = {
          count: 1,
          cb,
          stream,
          state
        };
        nextTick2(afterWriteTick, state.afterWriteTickInfo);
      }
    } else {
      afterWrite(stream, state, 1, cb);
    }
  }
}
function afterWriteTick({ stream, state, count, cb }) {
  state.afterWriteTickInfo = null;
  return afterWrite(stream, state, count, cb);
}
function afterWrite(stream, state, count, cb) {
  const needDrain = !state.ending && !stream.destroyed && state.length === 0 && state.needDrain;
  if (needDrain) {
    state.needDrain = false;
    stream.emit("drain");
  }
  while (count-- > 0) {
    state.pendingcb--;
    cb();
  }
  if (state.destroyed) {
    errorBuffer(state);
  }
  finishMaybe(stream, state);
}
function errorBuffer(state) {
  if (state.writing) {
    return;
  }
  for (let n = state.bufferedIndex; n < state.buffered.length; ++n) {
    const { chunk, callback } = state.buffered[n];
    const len = state.objectMode ? 1 : chunk.length;
    state.length -= len;
    callback(new ERR_STREAM_DESTROYED("write"));
  }
  const onfinishCallbacks = state[kOnFinished].splice(0);
  for (let i64 = 0; i64 < onfinishCallbacks.length; i64++) {
    onfinishCallbacks[i64](new ERR_STREAM_DESTROYED("end"));
  }
  resetBuffer(state);
}
function clearBuffer(stream, state) {
  if (state.corked || state.bufferProcessing || state.destroyed || !state.constructed) {
    return;
  }
  const { buffered, bufferedIndex, objectMode } = state;
  const bufferedLength = buffered.length - bufferedIndex;
  if (!bufferedLength) {
    return;
  }
  let i65 = bufferedIndex;
  state.bufferProcessing = true;
  if (bufferedLength > 1 && stream._writev) {
    state.pendingcb -= bufferedLength - 1;
    const callback = state.allNoop ? nop2 : (err) => {
      for (let n = i65; n < buffered.length; ++n) {
        buffered[n].callback(err);
      }
    };
    const chunks = state.allNoop && i65 === 0 ? buffered : buffered.slice(i65);
    chunks.allBuffers = state.allBuffers;
    doWrite(stream, state, true, state.length, chunks, "", callback);
    resetBuffer(state);
  } else {
    do {
      const { chunk, encoding, callback } = buffered[i65];
      buffered[i65++] = null;
      const len = objectMode ? 1 : chunk.length;
      doWrite(stream, state, false, len, chunk, encoding, callback);
    } while (i65 < buffered.length && !state.writing);
    if (i65 === buffered.length) {
      resetBuffer(state);
    } else if (i65 > 256) {
      buffered.splice(0, i65);
      state.bufferedIndex = 0;
    } else {
      state.bufferedIndex = i65;
    }
  }
  state.bufferProcessing = false;
}
Writable.prototype._write = function(chunk, encoding, cb) {
  if (this._writev) {
    this._writev([
      {
        chunk,
        encoding
      }
    ], cb);
  } else {
    throw new ERR_METHOD_NOT_IMPLEMENTED("_write()");
  }
};
Writable.prototype._writev = null;
Writable.prototype.end = function(chunk, encoding, cb) {
  const state = this._writableState;
  if (typeof chunk === "function") {
    cb = chunk;
    chunk = null;
    encoding = null;
  } else if (typeof encoding === "function") {
    cb = encoding;
    encoding = null;
  }
  let err;
  if (chunk !== null && chunk !== void 0) {
    const ret = _write(this, chunk, encoding);
    if (ret instanceof Error) {
      err = ret;
    }
  }
  if (state.corked) {
    state.corked = 1;
    this.uncork();
  }
  if (err) {
  } else if (!state.errored && !state.ending) {
    state.ending = true;
    finishMaybe(this, state, true);
    state.ended = true;
  } else if (state.finished) {
    err = new ERR_STREAM_ALREADY_FINISHED("end");
  } else if (state.destroyed) {
    err = new ERR_STREAM_DESTROYED("end");
  }
  if (typeof cb === "function") {
    if (err || state.finished) {
      nextTick1(cb, err);
    } else {
      state[kOnFinished].push(cb);
    }
  }
  return this;
};
function needFinish(state) {
  return state.ending && state.constructed && state.length === 0 && !state.errored && state.buffered.length === 0 && !state.finished && !state.writing && !state.errorEmitted && !state.closeEmitted;
}
function callFinal(stream, state) {
  let called = false;
  function onFinish(err) {
    if (called) {
      errorOrDestroy2(stream, err ?? ERR_MULTIPLE_CALLBACK());
      return;
    }
    called = true;
    state.pendingcb--;
    if (err) {
      const onfinishCallbacks = state[kOnFinished].splice(0);
      for (let i66 = 0; i66 < onfinishCallbacks.length; i66++) {
        onfinishCallbacks[i66](err);
      }
      errorOrDestroy2(stream, err, state.sync);
    } else if (needFinish(state)) {
      state.prefinished = true;
      stream.emit("prefinish");
      state.pendingcb++;
      nextTick2(finish, stream, state);
    }
  }
  state.sync = true;
  state.pendingcb++;
  try {
    const result = stream._final(onFinish);
    if (result != null) {
      const then = result.then;
      if (typeof then === "function") {
        then.call(result, function() {
          nextTick2(onFinish, null);
        }, function(err) {
          nextTick2(onFinish, err);
        });
      }
    }
  } catch (err) {
    onFinish(stream, state, err);
  }
  state.sync = false;
}
function prefinish(stream, state) {
  if (!state.prefinished && !state.finalCalled) {
    if (typeof stream._final === "function" && !state.destroyed) {
      state.finalCalled = true;
      callFinal(stream, state);
    } else {
      state.prefinished = true;
      stream.emit("prefinish");
    }
  }
}
function finishMaybe(stream, state, sync) {
  if (needFinish(state)) {
    prefinish(stream, state);
    if (state.pendingcb === 0 && needFinish(state)) {
      state.pendingcb++;
      if (sync) {
        nextTick2(finish, stream, state);
      } else {
        finish(stream, state);
      }
    }
  }
}
function finish(stream, state) {
  state.pendingcb--;
  state.finished = true;
  const onfinishCallbacks = state[kOnFinished].splice(0);
  for (let i67 = 0; i67 < onfinishCallbacks.length; i67++) {
    onfinishCallbacks[i67]();
  }
  stream.emit("finish");
  if (state.autoDestroy) {
    const rState = stream._readableState;
    const autoDestroy = !rState || rState.autoDestroy && (rState.endEmitted || rState.readable === false);
    if (autoDestroy) {
      stream.destroy();
    }
  }
}
Object.defineProperties(Writable.prototype, {
  destroyed: {
    get() {
      return this._writableState ? this._writableState.destroyed : false;
    },
    set(value) {
      if (this._writableState) {
        this._writableState.destroyed = value;
      }
    }
  },
  writable: {
    get() {
      const w = this._writableState;
      return !!w && w.writable !== false && !w.destroyed && !w.errored && !w.ending && !w.ended;
    },
    set(val) {
      if (this._writableState) {
        this._writableState.writable = !!val;
      }
    }
  },
  writableFinished: {
    get() {
      return this._writableState ? this._writableState.finished : false;
    }
  },
  writableObjectMode: {
    get() {
      return this._writableState ? this._writableState.objectMode : false;
    }
  },
  writableBuffer: {
    get() {
      return this._writableState && this._writableState.getBuffer();
    }
  },
  writableEnded: {
    get() {
      return this._writableState ? this._writableState.ending : false;
    }
  },
  writableNeedDrain: {
    get() {
      const wState = this._writableState;
      if (!wState)
        return false;
      return !wState.destroyed && !wState.ending && wState.needDrain;
    }
  },
  writableHighWaterMark: {
    get() {
      return this._writableState && this._writableState.highWaterMark;
    }
  },
  writableCorked: {
    get() {
      return this._writableState ? this._writableState.corked : 0;
    }
  },
  writableLength: {
    get() {
      return this._writableState && this._writableState.length;
    }
  }
});
var destroy1 = __default3.destroy;
Writable.prototype.destroy = function(err, cb) {
  const state = this._writableState;
  if (!state.destroyed && (state.bufferedIndex < state.buffered.length || state[kOnFinished].length)) {
    nextTick1(errorBuffer, state);
  }
  destroy1.call(this, err, cb);
  return this;
};
Writable.prototype._undestroy = __default3.undestroy;
Writable.prototype._destroy = function(err, cb) {
  cb(err);
};
Writable.prototype[EventEmitter.captureRejectionSymbol] = function(err) {
  this.destroy(err);
};
Writable.WritableState = WritableState;
Object.setPrototypeOf(Duplex.prototype, Readable.prototype);
Object.setPrototypeOf(Duplex, Readable);
{
  for (const method of Object.keys(Writable.prototype)) {
    if (!Duplex.prototype[method]) {
      Duplex.prototype[method] = Writable.prototype[method];
    }
  }
}
function Duplex(options) {
  if (!(this instanceof Duplex)) {
    return new Duplex(options);
  }
  Readable.call(this, options);
  Writable.call(this, options);
  this.allowHalfOpen = true;
  if (options) {
    if (options.readable === false) {
      this.readable = false;
    }
    if (options.writable === false) {
      this.writable = false;
    }
    if (options.allowHalfOpen === false) {
      this.allowHalfOpen = false;
    }
  }
}
Object.defineProperties(Duplex.prototype, {
  writable: Object.getOwnPropertyDescriptor(Writable.prototype, "writable"),
  writableHighWaterMark: Object.getOwnPropertyDescriptor(Writable.prototype, "writableHighWaterMark"),
  writableObjectMode: Object.getOwnPropertyDescriptor(Writable.prototype, "writableObjectMode"),
  writableBuffer: Object.getOwnPropertyDescriptor(Writable.prototype, "writableBuffer"),
  writableLength: Object.getOwnPropertyDescriptor(Writable.prototype, "writableLength"),
  writableFinished: Object.getOwnPropertyDescriptor(Writable.prototype, "writableFinished"),
  writableCorked: Object.getOwnPropertyDescriptor(Writable.prototype, "writableCorked"),
  writableEnded: Object.getOwnPropertyDescriptor(Writable.prototype, "writableEnded"),
  writableNeedDrain: Object.getOwnPropertyDescriptor(Writable.prototype, "writableNeedDrain"),
  destroyed: {
    get() {
      if (this._readableState === void 0 || this._writableState === void 0) {
        return false;
      }
      return this._readableState.destroyed && this._writableState.destroyed;
    },
    set(value) {
      if (this._readableState && this._writableState) {
        this._readableState.destroyed = value;
        this._writableState.destroyed = value;
      }
    }
  }
});
function isReadableStream(object) {
  return object instanceof ReadableStream;
}
function isWritableStream(object) {
  return object instanceof WritableStream;
}
Duplex.fromWeb = function(pair, options) {
  validateObject(pair, "pair");
  const { readable: readableStream, writable: writableStream } = pair;
  if (!isReadableStream(readableStream)) {
    throw new ERR_INVALID_ARG_TYPE("pair.readable", "ReadableStream", readableStream);
  }
  if (!isWritableStream(writableStream)) {
    throw new ERR_INVALID_ARG_TYPE("pair.writable", "WritableStream", writableStream);
  }
  validateObject(options, "options");
  const { allowHalfOpen = false, objectMode = false, encoding: encoding1, decodeStrings = true, highWaterMark, signal } = options;
  validateBoolean(objectMode, "options.objectMode");
  if (encoding1 !== void 0 && !Buffer2.isEncoding(encoding1)) {
    throw new ERR_INVALID_ARG_VALUE(encoding1, "options.encoding");
  }
  const writer = writableStream.getWriter();
  const reader = readableStream.getReader();
  let writableClosed = false;
  let readableClosed = false;
  const duplex = new Duplex({
    allowHalfOpen,
    highWaterMark,
    objectMode,
    encoding: encoding1,
    decodeStrings,
    signal,
    writev(chunks, callback) {
      function done(error7) {
        error7 = error7.filter((e) => e);
        try {
          callback(error7.length === 0 ? void 0 : error7);
        } catch (error1) {
          nextTick1(() => destroy(duplex, error1));
        }
      }
      writer.ready.then(() => Promise.All(chunks.map((data) => writer.write(data.chunk))).then(done, done), done);
    },
    write(chunk, encoding, callback) {
      if (typeof chunk === "string" && decodeStrings && !objectMode) {
        chunk = Buffer2.from(chunk, encoding);
        chunk = new Uint8Array(chunk.buffer, chunk.byteOffset, chunk.byteLength);
      }
      function done(error8) {
        try {
          callback(error8);
        } catch (error2) {
          destroy(duplex, error2);
        }
      }
      writer.ready.then(() => writer.write(chunk).then(done, done), done);
    },
    final(callback) {
      function done(error9) {
        try {
          callback(error9);
        } catch (error3) {
          nextTick1(() => destroy(duplex, error3));
        }
      }
      if (!writableClosed) {
        writer.close().then(done, done);
      }
    },
    read() {
      reader.read().then((chunk) => {
        if (chunk.done) {
          duplex.push(null);
        } else {
          duplex.push(chunk.value);
        }
      }, (error10) => destroy(duplex, error10));
    },
    destroy(error4, callback) {
      function done() {
        try {
          callback(error4);
        } catch (error11) {
          nextTick1(() => {
            throw error11;
          });
        }
      }
      async function closeWriter() {
        if (!writableClosed) {
          await writer.abort(error4);
        }
      }
      async function closeReader() {
        if (!readableClosed) {
          await reader.cancel(error4);
        }
      }
      if (!writableClosed || !readableClosed) {
        Promise.All([
          closeWriter(),
          closeReader()
        ]).then(done, done);
        return;
      }
      done();
    }
  });
  writer.closed.then(() => {
    writableClosed = true;
    if (!isWritableEnded(duplex)) {
      destroy(duplex, new ERR_STREAM_PREMATURE_CLOSE());
    }
  }, (error12) => {
    writableClosed = true;
    readableClosed = true;
    destroy(duplex, error12);
  });
  reader.closed.then(() => {
    readableClosed = true;
    if (!isReadableEnded1(duplex)) {
      duplex.push(null);
    }
  }, (error13) => {
    writableClosed = true;
    readableClosed = true;
    destroy(duplex, error13);
  });
  return duplex;
};
var Duplexify = class extends Duplex {
  constructor(options) {
    super(options);
    if (options?.readable === false) {
      this._readableState.readable = false;
      this._readableState.ended = true;
      this._readableState.endEmitted = true;
    }
    if (options?.writable === false) {
      this._writableState.writable = false;
      this._writableState.ending = true;
      this._writableState.ended = true;
      this._writableState.finished = true;
    }
  }
};
function duplexify(body, name) {
  if (isDuplexNodeStream(body)) {
    return body;
  }
  if (isReadableNodeStream(body)) {
    return _duplexify({
      readable: body
    });
  }
  if (isWritableNodeStream(body)) {
    return _duplexify({
      writable: body
    });
  }
  if (isNodeStream(body)) {
    return _duplexify({
      writable: false,
      readable: false
    });
  }
  if (typeof body === "function") {
    const { value, write: write2, final: __final1, destroy: destroy3 } = fromAsyncGen(body);
    if (isIterable(value)) {
      return _from1(Duplexify, value, {
        objectMode: true,
        write: write2,
        final: __final1,
        destroy: destroy3
      });
    }
    const then2 = value?.then;
    if (typeof then2 === "function") {
      let d;
      const promise = then2.call(value, (val) => {
        if (val != null) {
          throw new ERR_INVALID_RETURN_VALUE("nully", "body", val);
        }
      }, (err) => {
        destroyer(d, err);
      });
      return d = new Duplexify({
        objectMode: true,
        readable: false,
        write: write2,
        final(cb) {
          __final1(async () => {
            try {
              await promise;
              nextTick1(cb, null);
            } catch (err) {
              nextTick1(cb, err);
            }
          });
        },
        destroy: destroy3
      });
    }
    throw new ERR_INVALID_RETURN_VALUE("Iterable, AsyncIterable or AsyncFunction", name, value);
  }
  if (isBlob(body)) {
    return duplexify(body.arrayBuffer());
  }
  if (isIterable(body)) {
    return _from1(Duplexify, body, {
      objectMode: true,
      writable: false
    });
  }
  if (typeof body?.writable === "object" || typeof body?.readable === "object") {
    const readable = body?.readable ? isReadableNodeStream(body?.readable) ? body?.readable : duplexify(body.readable) : void 0;
    const writable = body?.writable ? isWritableNodeStream(body?.writable) ? body?.writable : duplexify(body.writable) : void 0;
    return _duplexify({
      readable,
      writable
    });
  }
  const then = body?.then;
  if (typeof then === "function") {
    let d;
    then.call(body, (val) => {
      if (val != null) {
        d.push(val);
      }
      d.push(null);
    }, (err) => {
      destroyer(d, err);
    });
    return d = new Duplexify({
      objectMode: true,
      writable: false,
      read() {
      }
    });
  }
  throw new ERR_INVALID_ARG_TYPE(name, [
    "Blob",
    "ReadableStream",
    "WritableStream",
    "Stream",
    "Iterable",
    "AsyncIterable",
    "Function",
    "{ readable, writable } pair",
    "Promise"
  ], body);
}
function fromAsyncGen(fn) {
  let { promise, resolve: resolve12 } = createDeferredPromise();
  const ac = new AbortController();
  const signal = ac.signal;
  const value = fn(async function* () {
    while (true) {
      const _promise = promise;
      promise = null;
      const { chunk, done, cb } = await _promise;
      nextTick2(cb);
      if (done)
        return;
      if (signal.aborted)
        throw new AbortError();
      ({ promise, resolve: resolve12 } = createDeferredPromise());
      yield chunk;
    }
  }(), {
    signal
  });
  return {
    value,
    write(chunk, encoding, cb) {
      const _resolve2 = resolve12;
      resolve12 = null;
      _resolve2({
        chunk,
        done: false,
        cb
      });
    },
    final(cb) {
      const _resolve3 = resolve12;
      resolve12 = null;
      _resolve3({
        done: true,
        cb
      });
    },
    destroy(err, cb) {
      ac.abort();
      cb(err);
    }
  };
}
function _duplexify(pair) {
  const r = pair.readable && typeof pair.readable.read !== "function" ? Readable.wrap(pair.readable) : pair.readable;
  const w = pair.writable;
  let readable = !!isReadable1(r);
  let writable = !!isWritable1(w);
  let ondrain;
  let onfinish;
  let onreadable;
  let onclose;
  let d;
  function onfinished(err) {
    const cb = onclose;
    onclose = null;
    if (cb) {
      cb(err);
    } else if (err) {
      d.destroy(err);
    } else if (!readable && !writable) {
      d.destroy();
    }
  }
  d = new Duplexify({
    readableObjectMode: !!r?.readableObjectMode,
    writableObjectMode: !!w?.writableObjectMode,
    readable,
    writable
  });
  if (writable) {
    eos(w, (err) => {
      writable = false;
      if (err) {
        destroyer(r, err);
      }
      onfinished(err);
    });
    d._write = function(chunk, encoding, callback) {
      if (w.write(chunk, encoding)) {
        callback();
      } else {
        ondrain = callback;
      }
    };
    d._final = function(callback) {
      w.end();
      onfinish = callback;
    };
    w.on("drain", function() {
      if (ondrain) {
        const cb = ondrain;
        ondrain = null;
        cb();
      }
    });
    w.on("finish", function() {
      if (onfinish) {
        const cb = onfinish;
        onfinish = null;
        cb();
      }
    });
  }
  if (readable) {
    eos(r, (err) => {
      readable = false;
      if (err) {
        destroyer(r, err);
      }
      onfinished(err);
    });
    r.on("readable", function() {
      if (onreadable) {
        const cb = onreadable;
        onreadable = null;
        cb();
      }
    });
    r.on("end", function() {
      d.push(null);
    });
    d._read = function() {
      while (true) {
        const buf = r.read();
        if (buf === null) {
          onreadable = d._read;
          return;
        }
        if (!d.push(buf)) {
          return;
        }
      }
    };
  }
  d._destroy = function(err, callback) {
    if (!err && onclose !== null) {
      err = new AbortError();
    }
    onreadable = null;
    ondrain = null;
    onfinish = null;
    if (onclose === null) {
      callback(err);
    } else {
      onclose = callback;
      destroyer(w, err);
      destroyer(r, err);
    }
  };
  return d;
}
function duplexFrom(body) {
  return duplexify(body, "body");
}
Duplex.from = duplexFrom;
Object.setPrototypeOf(Transform.prototype, Duplex.prototype);
Object.setPrototypeOf(Transform, Duplex);
var kCallback = Symbol("kCallback");
function Transform(options) {
  if (!(this instanceof Transform)) {
    return new Transform(options);
  }
  Duplex.call(this, options);
  this._readableState.sync = false;
  this[kCallback] = null;
  if (options) {
    if (typeof options.transform === "function") {
      this._transform = options.transform;
    }
    if (typeof options.flush === "function") {
      this._flush = options.flush;
    }
  }
  this.on("prefinish", prefinish1);
}
function __final(cb) {
  let called = false;
  if (typeof this._flush === "function" && !this.destroyed) {
    const result = this._flush((er, data) => {
      called = true;
      if (er) {
        if (cb) {
          cb(er);
        } else {
          this.destroy(er);
        }
        return;
      }
      if (data != null) {
        this.push(data);
      }
      this.push(null);
      if (cb) {
        cb();
      }
    });
    if (result !== void 0 && result !== null) {
      try {
        const then = result.then;
        if (typeof then === "function") {
          then.call(result, (data) => {
            if (called) {
              return;
            }
            if (data != null) {
              this.push(data);
            }
            this.push(null);
            if (cb) {
              nextTick2(cb);
            }
          }, (err) => {
            if (cb) {
              nextTick2(cb, err);
            } else {
              nextTick2(() => this.destroy(err));
            }
          });
        }
      } catch (err) {
        nextTick2(() => this.destroy(err));
      }
    }
  } else {
    this.push(null);
    if (cb) {
      cb();
    }
  }
}
function prefinish1() {
  if (this._final !== __final) {
    __final.call(this);
  }
}
Transform.prototype._final = __final;
Transform.prototype._transform = function(chunk, encoding, callback) {
  throw new ERR_METHOD_NOT_IMPLEMENTED("_transform()");
};
Transform.prototype._write = function(chunk, encoding, callback) {
  const rState = this._readableState;
  const wState = this._writableState;
  const length = rState.length;
  let called = false;
  const result = this._transform(chunk, encoding, (err, val) => {
    called = true;
    if (err) {
      callback(err);
      return;
    }
    if (val != null) {
      this.push(val);
    }
    if (wState.ended || length === rState.length || rState.length < rState.highWaterMark || rState.length === 0) {
      callback();
    } else {
      this[kCallback] = callback;
    }
  });
  if (result !== void 0 && result != null) {
    try {
      const then = result.then;
      if (typeof then === "function") {
        then.call(result, (val) => {
          if (called) {
            return;
          }
          if (val != null) {
            this.push(val);
          }
          if (wState.ended || length === rState.length || rState.length < rState.highWaterMark || rState.length === 0) {
            nextTick1(callback);
          } else {
            this[kCallback] = callback;
          }
        }, (err) => {
          nextTick1(callback, err);
        });
      }
    } catch (err) {
      nextTick1(callback, err);
    }
  }
};
Transform.prototype._read = function() {
  if (this[kCallback]) {
    const callback = this[kCallback];
    this[kCallback] = null;
    callback();
  }
};
Object.setPrototypeOf(PassThrough.prototype, Transform.prototype);
Object.setPrototypeOf(PassThrough, Transform);
function PassThrough(options) {
  if (!(this instanceof PassThrough)) {
    return new PassThrough(options);
  }
  Transform.call(this, options);
}
PassThrough.prototype._transform = function(chunk, encoding, cb) {
  cb(null, chunk);
};
function destroyer1(stream, reading, writing, callback) {
  callback = once(callback);
  let finished2 = false;
  stream.on("close", () => {
    finished2 = true;
  });
  eos(stream, {
    readable: reading,
    writable: writing
  }, (err) => {
    finished2 = !err;
    const rState = stream._readableState;
    if (err && err.code === "ERR_STREAM_PREMATURE_CLOSE" && reading && rState && rState.ended && !rState.errored && !rState.errorEmitted) {
      stream.once("end", callback).once("error", callback);
    } else {
      callback(err);
    }
  });
  return (err) => {
    if (finished2)
      return;
    finished2 = true;
    __default3.destroyer(stream, err);
    callback(err || new ERR_STREAM_DESTROYED("pipe"));
  };
}
function popCallback(streams) {
  validateCallback(streams[streams.length - 1]);
  return streams.pop();
}
function makeAsyncIterable(val) {
  if (isIterable(val)) {
    return val;
  } else if (isReadableNodeStream(val)) {
    return fromReadable(val);
  }
  throw new ERR_INVALID_ARG_TYPE("val", [
    "Readable",
    "Iterable",
    "AsyncIterable"
  ], val);
}
async function* fromReadable(val) {
  yield* Readable.prototype[Symbol.asyncIterator].call(val);
}
async function pump(iterable, writable, finish1) {
  let error14;
  let onresolve2 = null;
  const resume1 = (err) => {
    if (err) {
      error14 = err;
    }
    if (onresolve2) {
      const callback = onresolve2;
      onresolve2 = null;
      callback();
    }
  };
  const wait = () => new Promise((resolve13, reject) => {
    if (error14) {
      reject(error14);
    } else {
      onresolve2 = () => {
        if (error14) {
          reject(error14);
        } else {
          resolve13();
        }
      };
    }
  });
  writable.on("drain", resume1);
  const cleanup = eos(writable, {
    readable: false
  }, resume1);
  try {
    if (writable.writableNeedDrain) {
      await wait();
    }
    for await (const chunk of iterable) {
      if (!writable.write(chunk)) {
        await wait();
      }
    }
    writable.end();
    await wait();
    finish1();
  } catch (err) {
    finish1(error14 !== err ? aggregateTwoErrors(error14, err) : err);
  } finally {
    cleanup();
    writable.off("drain", resume1);
  }
}
function pipeline(...streams) {
  const callback = once(popCallback(streams));
  if (Array.isArray(streams[0]) && streams.length === 1) {
    streams = streams[0];
  }
  return pipelineImpl(streams, callback);
}
function pipelineImpl(streams, callback, opts) {
  if (streams.length < 2) {
    throw new ERR_MISSING_ARGS("streams");
  }
  const ac = new AbortController();
  const signal = ac.signal;
  const outerSignal = opts?.signal;
  validateAbortSignal(outerSignal, "options.signal");
  function abort() {
    finishImpl(new AbortError());
  }
  outerSignal?.addEventListener("abort", abort);
  let error15;
  let value;
  const destroys = [];
  let finishCount = 0;
  function finish2(err) {
    finishImpl(err, --finishCount === 0);
  }
  function finishImpl(err, __final2) {
    if (err && (!error15 || error15.code === "ERR_STREAM_PREMATURE_CLOSE")) {
      error15 = err;
    }
    if (!error15 && !__final2) {
      return;
    }
    while (destroys.length) {
      destroys.shift()(error15);
    }
    outerSignal?.removeEventListener("abort", abort);
    ac.abort();
    if (__final2) {
      callback(error15, value);
    }
  }
  let ret;
  for (let i68 = 0; i68 < streams.length; i68++) {
    const stream = streams[i68];
    const reading = i68 < streams.length - 1;
    const writing = i68 > 0;
    if (isNodeStream(stream)) {
      finishCount++;
      destroys.push(destroyer1(stream, reading, writing, finish2));
    }
    if (i68 === 0) {
      if (typeof stream === "function") {
        ret = stream({
          signal
        });
        if (!isIterable(ret)) {
          throw new ERR_INVALID_RETURN_VALUE("Iterable, AsyncIterable or Stream", "source", ret);
        }
      } else if (isIterable(stream) || isReadableNodeStream(stream)) {
        ret = stream;
      } else {
        ret = Duplex.from(stream);
      }
    } else if (typeof stream === "function") {
      ret = makeAsyncIterable(ret);
      ret = stream(ret, {
        signal
      });
      if (reading) {
        if (!isIterable(ret, true)) {
          throw new ERR_INVALID_RETURN_VALUE("AsyncIterable", `transform[${i68 - 1}]`, ret);
        }
      } else {
        const pt = new PassThrough({
          objectMode: true
        });
        const then = ret?.then;
        if (typeof then === "function") {
          then.call(ret, (val) => {
            value = val;
            pt.end(val);
          }, (err) => {
            pt.destroy(err);
          });
        } else if (isIterable(ret, true)) {
          finishCount++;
          pump(ret, pt, finish2);
        } else {
          throw new ERR_INVALID_RETURN_VALUE("AsyncIterable or Promise", "destination", ret);
        }
        ret = pt;
        finishCount++;
        destroys.push(destroyer1(ret, false, true, finish2));
      }
    } else if (isNodeStream(stream)) {
      if (isReadableNodeStream(ret)) {
        ret.pipe(stream);
        if (stream === stdio.stdout || stream === stdio.stderr) {
          ret.on("end", () => stream.end());
        }
      } else {
        ret = makeAsyncIterable(ret);
        finishCount++;
        pump(ret, stream, finish2);
      }
      ret = stream;
    } else {
      ret = Duplex.from(stream);
    }
  }
  if (signal?.aborted || outerSignal?.aborted) {
    nextTick2(abort);
  }
  return ret;
}
var ComposeDuplex = class extends Duplex {
  constructor(options) {
    super(options);
    if (options?.readable === false) {
      this._readableState.readable = false;
      this._readableState.ended = true;
      this._readableState.endEmitted = true;
    }
    if (options?.writable === false) {
      this._writableState.writable = false;
      this._writableState.ending = true;
      this._writableState.ended = true;
      this._writableState.finished = true;
    }
  }
};
function compose(...streams) {
  if (streams.length === 0) {
    throw new ERR_MISSING_ARGS("streams");
  }
  if (streams.length === 1) {
    return Duplex.from(streams[0]);
  }
  const orgStreams = [
    ...streams
  ];
  if (typeof streams[0] === "function") {
    streams[0] = Duplex.from(streams[0]);
  }
  if (typeof streams[streams.length - 1] === "function") {
    const idx = streams.length - 1;
    streams[idx] = Duplex.from(streams[idx]);
  }
  for (let n = 0; n < streams.length; ++n) {
    if (!isNodeStream(streams[n])) {
      continue;
    }
    if (n < streams.length - 1 && !isReadable1(streams[n])) {
      throw new ERR_INVALID_ARG_VALUE(`streams[${n}]`, orgStreams[n], "must be readable");
    }
    if (n > 0 && !isWritable1(streams[n])) {
      throw new ERR_INVALID_ARG_VALUE(`streams[${n}]`, orgStreams[n], "must be writable");
    }
  }
  let ondrain;
  let onfinish;
  let onreadable;
  let onclose;
  let d;
  function onfinished(err) {
    const cb = onclose;
    onclose = null;
    if (cb) {
      cb(err);
    } else if (err) {
      d.destroy(err);
    } else if (!readable && !writable) {
      d.destroy();
    }
  }
  const head = streams[0];
  const tail = pipeline(streams, onfinished);
  const writable = !!isWritable1(head);
  const readable = !!isReadable1(tail);
  d = new ComposeDuplex({
    writableObjectMode: !!head?.writableObjectMode,
    readableObjectMode: !!tail?.writableObjectMode,
    writable,
    readable
  });
  if (writable) {
    d._write = function(chunk, encoding, callback) {
      if (head.write(chunk, encoding)) {
        callback();
      } else {
        ondrain = callback;
      }
    };
    d._final = function(callback) {
      head.end();
      onfinish = callback;
    };
    head.on("drain", function() {
      if (ondrain) {
        const cb = ondrain;
        ondrain = null;
        cb();
      }
    });
    tail.on("finish", function() {
      if (onfinish) {
        const cb = onfinish;
        onfinish = null;
        cb();
      }
    });
  }
  if (readable) {
    tail.on("readable", function() {
      if (onreadable) {
        const cb = onreadable;
        onreadable = null;
        cb();
      }
    });
    tail.on("end", function() {
      d.push(null);
    });
    d._read = function() {
      while (true) {
        const buf = tail.read();
        if (buf === null) {
          onreadable = d._read;
          return;
        }
        if (!d.push(buf)) {
          return;
        }
      }
    };
  }
  d._destroy = function(err, callback) {
    if (!err && onclose !== null) {
      err = new AbortError();
    }
    onreadable = null;
    ondrain = null;
    onfinish = null;
    if (onclose === null) {
      callback(err);
    } else {
      onclose = callback;
      destroyer(tail, err);
    }
  };
  return d;
}
function pipeline1(...streams) {
  return new Promise((resolve14, reject) => {
    let signal;
    let end;
    const lastArg = streams[streams.length - 1];
    if (lastArg && typeof lastArg === "object" && !isNodeStream(lastArg) && !isIterable(lastArg)) {
      const options = streams.pop();
      signal = options.signal;
      end = options.end;
    }
    pipelineImpl(streams, (err, value) => {
      if (err) {
        reject(err);
      } else {
        resolve14(value);
      }
    }, {
      signal,
      end
    });
  });
}
function finished(stream, opts) {
  return new Promise((resolve15, reject) => {
    eos(stream, opts, (err) => {
      if (err) {
        reject(err);
      } else {
        resolve15();
      }
    });
  });
}
var __default4 = {
  finished,
  pipeline: pipeline1
};
var { custom: customPromisify } = promisify;
Stream.isDisturbed = isDisturbed;
Stream.Readable = Readable;
Stream.Writable = Writable;
Stream.Duplex = Duplex;
Stream.Transform = Transform;
Stream.PassThrough = PassThrough;
Stream.pipeline = pipeline;
Stream.addAbortSignal = addAbortSignal;
Stream.finished = eos;
Stream.destroy = destroyer;
Stream.compose = compose;
Object.defineProperty(Stream, "promises", {
  configurable: true,
  enumerable: true,
  get() {
    return __default4;
  }
});
Object.defineProperty(pipeline, customPromisify, {
  enumerable: true,
  get() {
    return __default4.pipeline;
  }
});
Object.defineProperty(eos, customPromisify, {
  enumerable: true,
  get() {
    return __default4.finished;
  }
});
Stream.Stream = Stream;
Stream._isUint8Array = isUint8Array;
Stream._uint8ArrayToBuffer = _uint8ArrayToBuffer;
function registerDestroyHook(_target, _asyncId, _prop) {
}
var constants;
(function(constants4) {
  constants4[constants4["kInit"] = 0] = "kInit";
  constants4[constants4["kBefore"] = 1] = "kBefore";
  constants4[constants4["kAfter"] = 2] = "kAfter";
  constants4[constants4["kDestroy"] = 3] = "kDestroy";
  constants4[constants4["kPromiseResolve"] = 4] = "kPromiseResolve";
  constants4[constants4["kTotals"] = 5] = "kTotals";
  constants4[constants4["kCheck"] = 6] = "kCheck";
  constants4[constants4["kExecutionAsyncId"] = 7] = "kExecutionAsyncId";
  constants4[constants4["kTriggerAsyncId"] = 8] = "kTriggerAsyncId";
  constants4[constants4["kAsyncIdCounter"] = 9] = "kAsyncIdCounter";
  constants4[constants4["kDefaultTriggerAsyncId"] = 10] = "kDefaultTriggerAsyncId";
  constants4[constants4["kUsesExecutionAsyncResource"] = 11] = "kUsesExecutionAsyncResource";
  constants4[constants4["kStackLength"] = 12] = "kStackLength";
})(constants || (constants = {}));
var asyncHookFields = new Uint32Array(Object.keys(constants).length);
function newAsyncId() {
  return ++asyncIdFields[constants.kAsyncIdCounter];
}
var UidFields;
(function(UidFields1) {
  UidFields1[UidFields1["kExecutionAsyncId"] = 0] = "kExecutionAsyncId";
  UidFields1[UidFields1["kTriggerAsyncId"] = 1] = "kTriggerAsyncId";
  UidFields1[UidFields1["kAsyncIdCounter"] = 2] = "kAsyncIdCounter";
  UidFields1[UidFields1["kDefaultTriggerAsyncId"] = 3] = "kDefaultTriggerAsyncId";
  UidFields1[UidFields1["kUidFieldsCount"] = 4] = "kUidFieldsCount";
})(UidFields || (UidFields = {}));
var asyncIdFields = new Float64Array(Object.keys(UidFields).length);
asyncIdFields[UidFields.kAsyncIdCounter] = 1;
asyncIdFields[UidFields.kDefaultTriggerAsyncId] = -1;
var providerType;
(function(providerType1) {
  providerType1[providerType1["NONE"] = 0] = "NONE";
  providerType1[providerType1["DIRHANDLE"] = 1] = "DIRHANDLE";
  providerType1[providerType1["DNSCHANNEL"] = 2] = "DNSCHANNEL";
  providerType1[providerType1["ELDHISTOGRAM"] = 3] = "ELDHISTOGRAM";
  providerType1[providerType1["FILEHANDLE"] = 4] = "FILEHANDLE";
  providerType1[providerType1["FILEHANDLECLOSEREQ"] = 5] = "FILEHANDLECLOSEREQ";
  providerType1[providerType1["FIXEDSIZEBLOBCOPY"] = 6] = "FIXEDSIZEBLOBCOPY";
  providerType1[providerType1["FSEVENTWRAP"] = 7] = "FSEVENTWRAP";
  providerType1[providerType1["FSREQCALLBACK"] = 8] = "FSREQCALLBACK";
  providerType1[providerType1["FSREQPROMISE"] = 9] = "FSREQPROMISE";
  providerType1[providerType1["GETADDRINFOREQWRAP"] = 10] = "GETADDRINFOREQWRAP";
  providerType1[providerType1["GETNAMEINFOREQWRAP"] = 11] = "GETNAMEINFOREQWRAP";
  providerType1[providerType1["HEAPSNAPSHOT"] = 12] = "HEAPSNAPSHOT";
  providerType1[providerType1["HTTP2SESSION"] = 13] = "HTTP2SESSION";
  providerType1[providerType1["HTTP2STREAM"] = 14] = "HTTP2STREAM";
  providerType1[providerType1["HTTP2PING"] = 15] = "HTTP2PING";
  providerType1[providerType1["HTTP2SETTINGS"] = 16] = "HTTP2SETTINGS";
  providerType1[providerType1["HTTPINCOMINGMESSAGE"] = 17] = "HTTPINCOMINGMESSAGE";
  providerType1[providerType1["HTTPCLIENTREQUEST"] = 18] = "HTTPCLIENTREQUEST";
  providerType1[providerType1["JSSTREAM"] = 19] = "JSSTREAM";
  providerType1[providerType1["JSUDPWRAP"] = 20] = "JSUDPWRAP";
  providerType1[providerType1["MESSAGEPORT"] = 21] = "MESSAGEPORT";
  providerType1[providerType1["PIPECONNECTWRAP"] = 22] = "PIPECONNECTWRAP";
  providerType1[providerType1["PIPESERVERWRAP"] = 23] = "PIPESERVERWRAP";
  providerType1[providerType1["PIPEWRAP"] = 24] = "PIPEWRAP";
  providerType1[providerType1["PROCESSWRAP"] = 25] = "PROCESSWRAP";
  providerType1[providerType1["PROMISE"] = 26] = "PROMISE";
  providerType1[providerType1["QUERYWRAP"] = 27] = "QUERYWRAP";
  providerType1[providerType1["SHUTDOWNWRAP"] = 28] = "SHUTDOWNWRAP";
  providerType1[providerType1["SIGNALWRAP"] = 29] = "SIGNALWRAP";
  providerType1[providerType1["STATWATCHER"] = 30] = "STATWATCHER";
  providerType1[providerType1["STREAMPIPE"] = 31] = "STREAMPIPE";
  providerType1[providerType1["TCPCONNECTWRAP"] = 32] = "TCPCONNECTWRAP";
  providerType1[providerType1["TCPSERVERWRAP"] = 33] = "TCPSERVERWRAP";
  providerType1[providerType1["TCPWRAP"] = 34] = "TCPWRAP";
  providerType1[providerType1["TTYWRAP"] = 35] = "TTYWRAP";
  providerType1[providerType1["UDPSENDWRAP"] = 36] = "UDPSENDWRAP";
  providerType1[providerType1["UDPWRAP"] = 37] = "UDPWRAP";
  providerType1[providerType1["SIGINTWATCHDOG"] = 38] = "SIGINTWATCHDOG";
  providerType1[providerType1["WORKER"] = 39] = "WORKER";
  providerType1[providerType1["WORKERHEAPSNAPSHOT"] = 40] = "WORKERHEAPSNAPSHOT";
  providerType1[providerType1["WRITEWRAP"] = 41] = "WRITEWRAP";
  providerType1[providerType1["ZLIB"] = 42] = "ZLIB";
})(providerType || (providerType = {}));
var kInvalidAsyncId = -1;
var AsyncWrap = class {
  provider = providerType.NONE;
  asyncId = kInvalidAsyncId;
  constructor(provider) {
    this.provider = provider;
    this.getAsyncId();
  }
  getAsyncId() {
    this.asyncId = this.asyncId === kInvalidAsyncId ? newAsyncId() : this.asyncId;
    return this.asyncId;
  }
  getProviderType() {
    return this.provider;
  }
};
var mod6 = {
  async_hook_fields: asyncHookFields,
  asyncIdFields,
  registerDestroyHook,
  constants,
  newAsyncId,
  UidFields,
  providerType,
  AsyncWrap
};
var asyncIdSymbol = Symbol("asyncIdSymbol");
var ownerSymbol = Symbol("ownerSymbol");
var mod7 = {
  asyncIdSymbol,
  ownerSymbol
};
mod6.registerDestroyHook;
var { async_hook_fields, asyncIdFields: async_id_fields, newAsyncId: newAsyncId1, constants: constants1 } = mod6;
var { kInit, kBefore, kAfter, kDestroy: kDestroy1, kPromiseResolve, kTotals, kCheck, kDefaultTriggerAsyncId, kStackLength } = constants1;
Symbol("resource");
Symbol("trigger_async_id");
Symbol("trigger_async_id");
Symbol("init");
Symbol("before");
Symbol("after");
Symbol("destroy");
Symbol("promiseResolve");
function defaultTriggerAsyncIdScope(triggerAsyncId, block, ...args) {
  if (triggerAsyncId === void 0) {
    return block.apply(null, args);
  }
  const oldDefaultTriggerAsyncId = async_id_fields[kDefaultTriggerAsyncId];
  async_id_fields[kDefaultTriggerAsyncId] = triggerAsyncId;
  try {
    return block.apply(null, args);
  } finally {
    async_id_fields[kDefaultTriggerAsyncId] = oldDefaultTriggerAsyncId;
  }
}
var HandleWrap = class extends AsyncWrap {
  constructor(provider) {
    super(provider);
  }
  close(cb = () => {
  }) {
    this._onClose();
    cb();
  }
  ref() {
    unreachable();
  }
  unref() {
    unreachable();
  }
  _onClose() {
  }
};
var CR = "\r".charCodeAt(0);
var LF = "\n".charCodeAt(0);
async function writeAll(w, arr) {
  let nwritten = 0;
  while (nwritten < arr.length) {
    nwritten += await w.write(arr.subarray(nwritten));
  }
}
var StreamBaseStateFields;
(function(StreamBaseStateFields1) {
  StreamBaseStateFields1[StreamBaseStateFields1["kReadBytesOrError"] = 0] = "kReadBytesOrError";
  StreamBaseStateFields1[StreamBaseStateFields1["kArrayBufferOffset"] = 1] = "kArrayBufferOffset";
  StreamBaseStateFields1[StreamBaseStateFields1["kBytesWritten"] = 2] = "kBytesWritten";
  StreamBaseStateFields1[StreamBaseStateFields1["kLastWriteWasAsync"] = 3] = "kLastWriteWasAsync";
  StreamBaseStateFields1[StreamBaseStateFields1["kNumStreamBaseStateFields"] = 4] = "kNumStreamBaseStateFields";
})(StreamBaseStateFields || (StreamBaseStateFields = {}));
var kReadBytesOrError = StreamBaseStateFields.kReadBytesOrError;
var kArrayBufferOffset = StreamBaseStateFields.kArrayBufferOffset;
var kBytesWritten = StreamBaseStateFields.kBytesWritten;
var kLastWriteWasAsync = StreamBaseStateFields.kLastWriteWasAsync;
var kNumStreamBaseStateFields = StreamBaseStateFields.kNumStreamBaseStateFields;
var streamBaseState = new Uint8Array(5);
streamBaseState[kLastWriteWasAsync] = 1;
var WriteWrap = class extends AsyncWrap {
  handle;
  oncomplete;
  async;
  bytes;
  buffer;
  callback;
  _chunks;
  constructor() {
    super(providerType.WRITEWRAP);
  }
};
var ShutdownWrap = class extends AsyncWrap {
  handle;
  oncomplete;
  callback;
  constructor() {
    super(providerType.SHUTDOWNWRAP);
  }
};
var kStreamBaseField = Symbol("kStreamBaseField");
var SUGGESTED_SIZE = 64 * 1024;
var LibuvStreamWrap = class extends HandleWrap {
  [kStreamBaseField];
  reading;
  #reading = false;
  destroyed = false;
  writeQueueSize = 0;
  bytesRead = 0;
  bytesWritten = 0;
  onread;
  constructor(provider, stream) {
    super(provider);
    this.#attachToObject(stream);
  }
  readStart() {
    if (!this.#reading) {
      this.#reading = true;
      this.#read();
    }
    return 0;
  }
  readStop() {
    this.#reading = false;
    return 0;
  }
  shutdown(req) {
    const status = this._onClose();
    try {
      req.oncomplete(status);
    } catch {
    }
    return 0;
  }
  useUserBuffer(_userBuf) {
    notImplemented("LibuvStreamWrap.prototype.useUserBuffer");
  }
  writeBuffer(req, data) {
    this.#write(req, data);
    return 0;
  }
  writev(req, chunks, allBuffers) {
    const count = allBuffers ? chunks.length : chunks.length >> 1;
    const buffers = new Array(count);
    if (!allBuffers) {
      for (let i71 = 0; i71 < count; i71++) {
        const chunk = chunks[i71 * 2];
        if (Buffer2.isBuffer(chunk)) {
          buffers[i71] = chunk;
        }
        const encoding = chunks[i71 * 2 + 1];
        buffers[i71] = Buffer2.from(chunk, encoding);
      }
    } else {
      for (let i72 = 0; i72 < count; i72++) {
        buffers[i72] = chunks[i72];
      }
    }
    return this.writeBuffer(req, Buffer2.concat(buffers));
  }
  writeAsciiString(req, data) {
    const buffer = new TextEncoder().encode(data);
    return this.writeBuffer(req, buffer);
  }
  writeUtf8String(req, data) {
    const buffer = new TextEncoder().encode(data);
    return this.writeBuffer(req, buffer);
  }
  writeUcs2String(_req, _data) {
    notImplemented("LibuvStreamWrap.prototype.writeUcs2String");
  }
  writeLatin1String(req, data) {
    const buffer = Buffer2.from(data, "latin1");
    return this.writeBuffer(req, buffer);
  }
  _onClose() {
    let status = 0;
    this.#reading = false;
    try {
      this[kStreamBaseField]?.close();
    } catch {
      status = codeMap.get("ENOTCONN");
    }
    return status;
  }
  #attachToObject(stream) {
    this[kStreamBaseField] = stream;
  }
  async #read() {
    let buf = new Uint8Array(SUGGESTED_SIZE);
    let nread;
    try {
      nread = await this[kStreamBaseField].read(buf);
    } catch (e) {
      if (e instanceof workerDeno_errors.Interrupted || e instanceof workerDeno_errors.BadResource) {
        nread = codeMap.get("EOF");
      } else if (e instanceof workerDeno_errors.ConnectionReset || e instanceof workerDeno_errors.ConnectionAborted) {
        nread = codeMap.get("ECONNRESET");
      } else {
        nread = codeMap.get("UNKNOWN");
      }
      buf = new Uint8Array(0);
    }
    nread ??= codeMap.get("EOF");
    streamBaseState[kReadBytesOrError] = nread;
    if (nread > 0) {
      this.bytesRead += nread;
    }
    buf = buf.slice(0, nread);
    streamBaseState[kArrayBufferOffset] = 0;
    try {
      this.onread(buf, nread);
    } catch {
    }
    if (nread >= 0 && this.#reading) {
      this.#read();
    }
  }
  async #write(req, data) {
    const { byteLength: byteLength2 } = data;
    try {
      await writeAll(this[kStreamBaseField], data);
    } catch (e) {
      let status;
      if (e instanceof workerDeno_errors.BadResource || e instanceof workerDeno_errors.BrokenPipe) {
        status = codeMap.get("EBADF");
      } else {
        status = codeMap.get("UNKNOWN");
      }
      try {
        req.oncomplete(status);
      } catch {
      }
      return;
    }
    streamBaseState[kBytesWritten] = byteLength2;
    this.bytesWritten += byteLength2;
    try {
      req.oncomplete(0);
    } catch {
    }
    return;
  }
};
var mod8 = {
  kReadBytesOrError,
  kArrayBufferOffset,
  kBytesWritten,
  kLastWriteWasAsync,
  kNumStreamBaseStateFields,
  streamBaseState,
  WriteWrap,
  ShutdownWrap,
  kStreamBaseField,
  LibuvStreamWrap
};
function addSignalListener(...args) {
  if (typeof define_Deno_default.addSignalListener == "function") {
    return define_Deno_default.addSignalListener(...args);
  } else {
    throw new TypeError("Requires --unstable");
  }
}
function removeSignalListener(...args) {
  if (typeof define_Deno_default.removeSignalListener == "function") {
    return define_Deno_default.removeSignalListener(...args);
  } else {
    throw new TypeError("Requires --unstable");
  }
}
function setRaw(...args) {
  if (typeof define_Deno_default.setRaw == "function") {
    return define_Deno_default.setRaw(...args);
  } else {
    throw new TypeError("Requires --unstable");
  }
}
async function connect(options) {
  return await define_Deno_default.connect(options);
}
function listen(options) {
  return define_Deno_default.listen(options);
}
function listenDatagram(options) {
  return define_Deno_default.listenDatagram(options);
}
function ListenerRef(listener, ...args) {
  if (typeof listener.ref == "function") {
    return listener.ref(...args);
  } else {
    throw new TypeError("Requires --unstable");
  }
}
function ListenerUnref(listener, ...args) {
  if (typeof listener.unref == "function") {
    return listener.unref(...args);
  } else {
    throw new TypeError("Requires --unstable");
  }
}
var { hasOwn } = Object;
function get(obj, key) {
  if (hasOwn(obj, key)) {
    return obj[key];
  }
}
function getForce(obj, key) {
  const v = get(obj, key);
  assert(v != null);
  return v;
}
function isNumber(x) {
  if (typeof x === "number")
    return true;
  if (/^0x[0-9a-f]+$/i.test(String(x)))
    return true;
  return /^[-+]?(?:\d+(?:\.\d*)?|\.\d+)(e[-+]?\d+)?$/.test(String(x));
}
function hasKey(obj, keys) {
  let o = obj;
  keys.slice(0, -1).forEach((key) => {
    o = get(o, key) ?? {};
  });
  const key1 = keys[keys.length - 1];
  return key1 in o;
}
function parse(args, {
  "--": doubleDash = false,
  alias: alias3 = {},
  boolean: __boolean = false,
  default: defaults = {},
  stopEarly = false,
  string = [],
  collect: collect1 = [],
  negatable = [],
  unknown = (i73) => i73
} = {}) {
  const flags = {
    bools: {},
    strings: {},
    unknownFn: unknown,
    allBools: false,
    collect: {},
    negatable: {}
  };
  if (__boolean !== void 0) {
    if (typeof __boolean === "boolean") {
      flags.allBools = !!__boolean;
    } else {
      const booleanArgs = typeof __boolean === "string" ? [
        __boolean
      ] : __boolean;
      for (const key of booleanArgs.filter(Boolean)) {
        flags.bools[key] = true;
      }
    }
  }
  const aliases = {};
  if (alias3 !== void 0) {
    for (const key in alias3) {
      const val = getForce(alias3, key);
      if (typeof val === "string") {
        aliases[key] = [
          val
        ];
      } else {
        aliases[key] = val;
      }
      for (const alias1 of getForce(aliases, key)) {
        aliases[alias1] = [
          key
        ].concat(aliases[key].filter((y) => alias1 !== y));
      }
    }
  }
  if (string !== void 0) {
    const stringArgs = typeof string === "string" ? [
      string
    ] : string;
    for (const key of stringArgs.filter(Boolean)) {
      flags.strings[key] = true;
      const alias = get(aliases, key);
      if (alias) {
        for (const al of alias) {
          flags.strings[al] = true;
        }
      }
    }
  }
  if (collect1 !== void 0) {
    const collectArgs = typeof collect1 === "string" ? [
      collect1
    ] : collect1;
    for (const key of collectArgs.filter(Boolean)) {
      flags.collect[key] = true;
      const alias = get(aliases, key);
      if (alias) {
        for (const al of alias) {
          flags.collect[al] = true;
        }
      }
    }
  }
  if (negatable !== void 0) {
    const negatableArgs = typeof negatable === "string" ? [
      negatable
    ] : negatable;
    for (const key of negatableArgs.filter(Boolean)) {
      flags.negatable[key] = true;
      const alias = get(aliases, key);
      if (alias) {
        for (const al of alias) {
          flags.negatable[al] = true;
        }
      }
    }
  }
  const argv1 = {
    _: []
  };
  function argDefined(key, arg) {
    return flags.allBools && /^--[^=]+$/.test(arg) || get(flags.bools, key) || !!get(flags.strings, key) || !!get(aliases, key);
  }
  function setKey(obj, name, value, collect = true) {
    let o = obj;
    const keys = name.split(".");
    keys.slice(0, -1).forEach(function(key) {
      if (get(o, key) === void 0) {
        o[key] = {};
      }
      o = get(o, key);
    });
    const key5 = keys[keys.length - 1];
    const collectable = collect && !!get(flags.collect, name);
    if (!collectable) {
      o[key5] = value;
    } else if (get(o, key5) === void 0) {
      o[key5] = [
        value
      ];
    } else if (Array.isArray(get(o, key5))) {
      o[key5].push(value);
    } else {
      o[key5] = [
        get(o, key5),
        value
      ];
    }
  }
  function setArg(key, val, arg = void 0, collect) {
    if (arg && flags.unknownFn && !argDefined(key, arg)) {
      if (flags.unknownFn(arg, key, val) === false)
        return;
    }
    const value = !get(flags.strings, key) && isNumber(val) ? Number(val) : val;
    setKey(argv1, key, value, collect);
    const alias = get(aliases, key);
    if (alias) {
      for (const x of alias) {
        setKey(argv1, x, value, collect);
      }
    }
  }
  function aliasIsBoolean(key) {
    return getForce(aliases, key).some((x) => typeof get(flags.bools, x) === "boolean");
  }
  let notFlags = [];
  if (args.includes("--")) {
    notFlags = args.slice(args.indexOf("--") + 1);
    args = args.slice(0, args.indexOf("--"));
  }
  for (let i74 = 0; i74 < args.length; i74++) {
    const arg = args[i74];
    if (/^--.+=/.test(arg)) {
      const m = arg.match(/^--([^=]+)=(.*)$/s);
      assert(m != null);
      const [, key, value] = m;
      if (flags.bools[key]) {
        const booleanValue = value !== "false";
        setArg(key, booleanValue, arg);
      } else {
        setArg(key, value, arg);
      }
    } else if (/^--no-.+/.test(arg) && get(flags.negatable, arg.replace(/^--no-/, ""))) {
      const m = arg.match(/^--no-(.+)/);
      assert(m != null);
      setArg(m[1], false, arg, false);
    } else if (/^--.+/.test(arg)) {
      const m = arg.match(/^--(.+)/);
      assert(m != null);
      const [, key] = m;
      const next = args[i74 + 1];
      if (next !== void 0 && !/^-/.test(next) && !get(flags.bools, key) && !flags.allBools && (get(aliases, key) ? !aliasIsBoolean(key) : true)) {
        setArg(key, next, arg);
        i74++;
      } else if (/^(true|false)$/.test(next)) {
        setArg(key, next === "true", arg);
        i74++;
      } else {
        setArg(key, get(flags.strings, key) ? "" : true, arg);
      }
    } else if (/^-[^-]+/.test(arg)) {
      const letters = arg.slice(1, -1).split("");
      let broken = false;
      for (let j = 0; j < letters.length; j++) {
        const next = arg.slice(j + 2);
        if (next === "-") {
          setArg(letters[j], next, arg);
          continue;
        }
        if (/[A-Za-z]/.test(letters[j]) && /=/.test(next)) {
          setArg(letters[j], next.split(/=(.+)/)[1], arg);
          broken = true;
          break;
        }
        if (/[A-Za-z]/.test(letters[j]) && /-?\d+(\.\d*)?(e-?\d+)?$/.test(next)) {
          setArg(letters[j], next, arg);
          broken = true;
          break;
        }
        if (letters[j + 1] && letters[j + 1].match(/\W/)) {
          setArg(letters[j], arg.slice(j + 2), arg);
          broken = true;
          break;
        } else {
          setArg(letters[j], get(flags.strings, letters[j]) ? "" : true, arg);
        }
      }
      const [key] = arg.slice(-1);
      if (!broken && key !== "-") {
        if (args[i74 + 1] && !/^(-|--)[^-]/.test(args[i74 + 1]) && !get(flags.bools, key) && (get(aliases, key) ? !aliasIsBoolean(key) : true)) {
          setArg(key, args[i74 + 1], arg);
          i74++;
        } else if (args[i74 + 1] && /^(true|false)$/.test(args[i74 + 1])) {
          setArg(key, args[i74 + 1] === "true", arg);
          i74++;
        } else {
          setArg(key, get(flags.strings, key) ? "" : true, arg);
        }
      }
    } else {
      if (!flags.unknownFn || flags.unknownFn(arg) !== false) {
        argv1._.push(flags.strings["_"] ?? !isNumber(arg) ? arg : Number(arg));
      }
      if (stopEarly) {
        argv1._.push(...args.slice(i74 + 1));
        break;
      }
    }
  }
  for (const [key4, value1] of Object.entries(defaults)) {
    if (!hasKey(argv1, key4.split("."))) {
      setKey(argv1, key4, value1);
      if (aliases[key4]) {
        for (const x of aliases[key4]) {
          setKey(argv1, x, value1);
        }
      }
    }
  }
  for (const key2 of Object.keys(flags.bools)) {
    if (!hasKey(argv1, key2.split("."))) {
      const value = get(flags.collect, key2) ? [] : false;
      setKey(argv1, key2, value, false);
    }
  }
  for (const key3 of Object.keys(flags.strings)) {
    if (!hasKey(argv1, key3.split(".")) && get(flags.collect, key3)) {
      setKey(argv1, key3, [], false);
    }
  }
  if (doubleDash) {
    argv1["--"] = [];
    for (const key of notFlags) {
      argv1["--"].push(key);
    }
  } else {
    for (const key of notFlags) {
      argv1._.push(key);
    }
  }
  return argv1;
}
function getOptions() {
  const args = parse(workerDeno_args);
  const options = new Map(Object.entries(args).map(([key, value]) => [
    key,
    {
      value
    }
  ]));
  return {
    options
  };
}
var optionsMap;
function getOptionsFromBinding() {
  if (!optionsMap) {
    ({ options: optionsMap } = getOptions());
  }
  return optionsMap;
}
function getOptionValue(optionName) {
  const options = getOptionsFromBinding();
  if (optionName.startsWith("--no-")) {
    const option = options.get("--" + optionName.slice(5));
    return option && !option.value;
  }
  return options.get(optionName)?.value;
}
var CHAR_FORWARD_SLASH = 47;
function assertPath(path3) {
  if (typeof path3 !== "string") {
    throw new TypeError(`Path must be a string. Received ${JSON.stringify(path3)}`);
  }
}
function isPosixPathSeparator(code) {
  return code === 47;
}
function isPathSeparator(code) {
  return isPosixPathSeparator(code) || code === 92;
}
function isWindowsDeviceRoot(code) {
  return code >= 97 && code <= 122 || code >= 65 && code <= 90;
}
function normalizeString(path4, allowAboveRoot, separator, isPathSeparator1) {
  let res = "";
  let lastSegmentLength = 0;
  let lastSlash = -1;
  let dots = 0;
  let code;
  for (let i75 = 0, len = path4.length; i75 <= len; ++i75) {
    if (i75 < len)
      code = path4.charCodeAt(i75);
    else if (isPathSeparator1(code))
      break;
    else
      code = CHAR_FORWARD_SLASH;
    if (isPathSeparator1(code)) {
      if (lastSlash === i75 - 1 || dots === 1) {
      } else if (lastSlash !== i75 - 1 && dots === 2) {
        if (res.length < 2 || lastSegmentLength !== 2 || res.charCodeAt(res.length - 1) !== 46 || res.charCodeAt(res.length - 2) !== 46) {
          if (res.length > 2) {
            const lastSlashIndex = res.lastIndexOf(separator);
            if (lastSlashIndex === -1) {
              res = "";
              lastSegmentLength = 0;
            } else {
              res = res.slice(0, lastSlashIndex);
              lastSegmentLength = res.length - 1 - res.lastIndexOf(separator);
            }
            lastSlash = i75;
            dots = 0;
            continue;
          } else if (res.length === 2 || res.length === 1) {
            res = "";
            lastSegmentLength = 0;
            lastSlash = i75;
            dots = 0;
            continue;
          }
        }
        if (allowAboveRoot) {
          if (res.length > 0)
            res += `${separator}..`;
          else
            res = "..";
          lastSegmentLength = 2;
        }
      } else {
        if (res.length > 0)
          res += separator + path4.slice(lastSlash + 1, i75);
        else
          res = path4.slice(lastSlash + 1, i75);
        lastSegmentLength = i75 - lastSlash - 1;
      }
      lastSlash = i75;
      dots = 0;
    } else if (code === 46 && dots !== -1) {
      ++dots;
    } else {
      dots = -1;
    }
  }
  return res;
}
function _format(sep3, pathObject) {
  const dir = pathObject.dir || pathObject.root;
  const base7 = pathObject.base || (pathObject.name || "") + (pathObject.ext || "");
  if (!dir)
    return base7;
  if (dir === pathObject.root)
    return dir + base7;
  return dir + sep3 + base7;
}
var WHITESPACE_ENCODINGS = {
  "	": "%09",
  "\n": "%0A",
  "\v": "%0B",
  "\f": "%0C",
  "\r": "%0D",
  " ": "%20"
};
function encodeWhitespace(string) {
  return string.replaceAll(/[\s]/g, (c) => {
    return WHITESPACE_ENCODINGS[c] ?? c;
  });
}
var sep = "\\";
var delimiter = ";";
function resolve(...pathSegments) {
  let resolvedDevice = "";
  let resolvedTail = "";
  let resolvedAbsolute = false;
  for (let i76 = pathSegments.length - 1; i76 >= -1; i76--) {
    let path5;
    const { Deno: Deno2 } = globalThis;
    if (i76 >= 0) {
      path5 = pathSegments[i76];
    } else if (!resolvedDevice) {
      if (typeof Deno2?.cwd !== "function") {
        throw new TypeError("Resolved a drive-letter-less path without a CWD.");
      }
      path5 = Deno2.cwd();
    } else {
      if (typeof Deno2?.env?.get !== "function" || typeof Deno2?.cwd !== "function") {
        throw new TypeError("Resolved a relative path without a CWD.");
      }
      path5 = Deno2.cwd();
      if (path5 === void 0 || path5.slice(0, 3).toLowerCase() !== `${resolvedDevice.toLowerCase()}\\`) {
        path5 = `${resolvedDevice}\\`;
      }
    }
    assertPath(path5);
    const len = path5.length;
    if (len === 0)
      continue;
    let rootEnd = 0;
    let device = "";
    let isAbsolute12 = false;
    const code = path5.charCodeAt(0);
    if (len > 1) {
      if (isPathSeparator(code)) {
        isAbsolute12 = true;
        if (isPathSeparator(path5.charCodeAt(1))) {
          let j = 2;
          let last = j;
          for (; j < len; ++j) {
            if (isPathSeparator(path5.charCodeAt(j)))
              break;
          }
          if (j < len && j !== last) {
            const firstPart = path5.slice(last, j);
            last = j;
            for (; j < len; ++j) {
              if (!isPathSeparator(path5.charCodeAt(j)))
                break;
            }
            if (j < len && j !== last) {
              last = j;
              for (; j < len; ++j) {
                if (isPathSeparator(path5.charCodeAt(j)))
                  break;
              }
              if (j === len) {
                device = `\\\\${firstPart}\\${path5.slice(last)}`;
                rootEnd = j;
              } else if (j !== last) {
                device = `\\\\${firstPart}\\${path5.slice(last, j)}`;
                rootEnd = j;
              }
            }
          }
        } else {
          rootEnd = 1;
        }
      } else if (isWindowsDeviceRoot(code)) {
        if (path5.charCodeAt(1) === 58) {
          device = path5.slice(0, 2);
          rootEnd = 2;
          if (len > 2) {
            if (isPathSeparator(path5.charCodeAt(2))) {
              isAbsolute12 = true;
              rootEnd = 3;
            }
          }
        }
      }
    } else if (isPathSeparator(code)) {
      rootEnd = 1;
      isAbsolute12 = true;
    }
    if (device.length > 0 && resolvedDevice.length > 0 && device.toLowerCase() !== resolvedDevice.toLowerCase()) {
      continue;
    }
    if (resolvedDevice.length === 0 && device.length > 0) {
      resolvedDevice = device;
    }
    if (!resolvedAbsolute) {
      resolvedTail = `${path5.slice(rootEnd)}\\${resolvedTail}`;
      resolvedAbsolute = isAbsolute12;
    }
    if (resolvedAbsolute && resolvedDevice.length > 0)
      break;
  }
  resolvedTail = normalizeString(resolvedTail, !resolvedAbsolute, "\\", isPathSeparator);
  return resolvedDevice + (resolvedAbsolute ? "\\" : "") + resolvedTail || ".";
}
function normalize(path6) {
  assertPath(path6);
  const len = path6.length;
  if (len === 0)
    return ".";
  let rootEnd = 0;
  let device;
  let isAbsolute22 = false;
  const code = path6.charCodeAt(0);
  if (len > 1) {
    if (isPathSeparator(code)) {
      isAbsolute22 = true;
      if (isPathSeparator(path6.charCodeAt(1))) {
        let j = 2;
        let last = j;
        for (; j < len; ++j) {
          if (isPathSeparator(path6.charCodeAt(j)))
            break;
        }
        if (j < len && j !== last) {
          const firstPart = path6.slice(last, j);
          last = j;
          for (; j < len; ++j) {
            if (!isPathSeparator(path6.charCodeAt(j)))
              break;
          }
          if (j < len && j !== last) {
            last = j;
            for (; j < len; ++j) {
              if (isPathSeparator(path6.charCodeAt(j)))
                break;
            }
            if (j === len) {
              return `\\\\${firstPart}\\${path6.slice(last)}\\`;
            } else if (j !== last) {
              device = `\\\\${firstPart}\\${path6.slice(last, j)}`;
              rootEnd = j;
            }
          }
        }
      } else {
        rootEnd = 1;
      }
    } else if (isWindowsDeviceRoot(code)) {
      if (path6.charCodeAt(1) === 58) {
        device = path6.slice(0, 2);
        rootEnd = 2;
        if (len > 2) {
          if (isPathSeparator(path6.charCodeAt(2))) {
            isAbsolute22 = true;
            rootEnd = 3;
          }
        }
      }
    }
  } else if (isPathSeparator(code)) {
    return "\\";
  }
  let tail;
  if (rootEnd < len) {
    tail = normalizeString(path6.slice(rootEnd), !isAbsolute22, "\\", isPathSeparator);
  } else {
    tail = "";
  }
  if (tail.length === 0 && !isAbsolute22)
    tail = ".";
  if (tail.length > 0 && isPathSeparator(path6.charCodeAt(len - 1))) {
    tail += "\\";
  }
  if (device === void 0) {
    if (isAbsolute22) {
      if (tail.length > 0)
        return `\\${tail}`;
      else
        return "\\";
    } else if (tail.length > 0) {
      return tail;
    } else {
      return "";
    }
  } else if (isAbsolute22) {
    if (tail.length > 0)
      return `${device}\\${tail}`;
    else
      return `${device}\\`;
  } else if (tail.length > 0) {
    return device + tail;
  } else {
    return device;
  }
}
function isAbsolute(path7) {
  assertPath(path7);
  const len = path7.length;
  if (len === 0)
    return false;
  const code = path7.charCodeAt(0);
  if (isPathSeparator(code)) {
    return true;
  } else if (isWindowsDeviceRoot(code)) {
    if (len > 2 && path7.charCodeAt(1) === 58) {
      if (isPathSeparator(path7.charCodeAt(2)))
        return true;
    }
  }
  return false;
}
function join1(...paths) {
  const pathsCount = paths.length;
  if (pathsCount === 0)
    return ".";
  let joined;
  let firstPart = null;
  for (let i77 = 0; i77 < pathsCount; ++i77) {
    const path8 = paths[i77];
    assertPath(path8);
    if (path8.length > 0) {
      if (joined === void 0)
        joined = firstPart = path8;
      else
        joined += `\\${path8}`;
    }
  }
  if (joined === void 0)
    return ".";
  let needsReplace = true;
  let slashCount = 0;
  assert(firstPart != null);
  if (isPathSeparator(firstPart.charCodeAt(0))) {
    ++slashCount;
    const firstLen = firstPart.length;
    if (firstLen > 1) {
      if (isPathSeparator(firstPart.charCodeAt(1))) {
        ++slashCount;
        if (firstLen > 2) {
          if (isPathSeparator(firstPart.charCodeAt(2)))
            ++slashCount;
          else {
            needsReplace = false;
          }
        }
      }
    }
  }
  if (needsReplace) {
    for (; slashCount < joined.length; ++slashCount) {
      if (!isPathSeparator(joined.charCodeAt(slashCount)))
        break;
    }
    if (slashCount >= 2)
      joined = `\\${joined.slice(slashCount)}`;
  }
  return normalize(joined);
}
function relative(from2, to) {
  assertPath(from2);
  assertPath(to);
  if (from2 === to)
    return "";
  const fromOrig = resolve(from2);
  const toOrig = resolve(to);
  if (fromOrig === toOrig)
    return "";
  from2 = fromOrig.toLowerCase();
  to = toOrig.toLowerCase();
  if (from2 === to)
    return "";
  let fromStart = 0;
  let fromEnd = from2.length;
  for (; fromStart < fromEnd; ++fromStart) {
    if (from2.charCodeAt(fromStart) !== 92)
      break;
  }
  for (; fromEnd - 1 > fromStart; --fromEnd) {
    if (from2.charCodeAt(fromEnd - 1) !== 92)
      break;
  }
  const fromLen = fromEnd - fromStart;
  let toStart = 0;
  let toEnd = to.length;
  for (; toStart < toEnd; ++toStart) {
    if (to.charCodeAt(toStart) !== 92)
      break;
  }
  for (; toEnd - 1 > toStart; --toEnd) {
    if (to.charCodeAt(toEnd - 1) !== 92)
      break;
  }
  const toLen = toEnd - toStart;
  const length = fromLen < toLen ? fromLen : toLen;
  let lastCommonSep = -1;
  let i78 = 0;
  for (; i78 <= length; ++i78) {
    if (i78 === length) {
      if (toLen > length) {
        if (to.charCodeAt(toStart + i78) === 92) {
          return toOrig.slice(toStart + i78 + 1);
        } else if (i78 === 2) {
          return toOrig.slice(toStart + i78);
        }
      }
      if (fromLen > length) {
        if (from2.charCodeAt(fromStart + i78) === 92) {
          lastCommonSep = i78;
        } else if (i78 === 2) {
          lastCommonSep = 3;
        }
      }
      break;
    }
    const fromCode = from2.charCodeAt(fromStart + i78);
    const toCode = to.charCodeAt(toStart + i78);
    if (fromCode !== toCode)
      break;
    else if (fromCode === 92)
      lastCommonSep = i78;
  }
  if (i78 !== length && lastCommonSep === -1) {
    return toOrig;
  }
  let out = "";
  if (lastCommonSep === -1)
    lastCommonSep = 0;
  for (i78 = fromStart + lastCommonSep + 1; i78 <= fromEnd; ++i78) {
    if (i78 === fromEnd || from2.charCodeAt(i78) === 92) {
      if (out.length === 0)
        out += "..";
      else
        out += "\\..";
    }
  }
  if (out.length > 0) {
    return out + toOrig.slice(toStart + lastCommonSep, toEnd);
  } else {
    toStart += lastCommonSep;
    if (toOrig.charCodeAt(toStart) === 92)
      ++toStart;
    return toOrig.slice(toStart, toEnd);
  }
}
function toNamespacedPath(path9) {
  if (typeof path9 !== "string")
    return path9;
  if (path9.length === 0)
    return "";
  const resolvedPath = resolve(path9);
  if (resolvedPath.length >= 3) {
    if (resolvedPath.charCodeAt(0) === 92) {
      if (resolvedPath.charCodeAt(1) === 92) {
        const code = resolvedPath.charCodeAt(2);
        if (code !== 63 && code !== 46) {
          return `\\\\?\\UNC\\${resolvedPath.slice(2)}`;
        }
      }
    } else if (isWindowsDeviceRoot(resolvedPath.charCodeAt(0))) {
      if (resolvedPath.charCodeAt(1) === 58 && resolvedPath.charCodeAt(2) === 92) {
        return `\\\\?\\${resolvedPath}`;
      }
    }
  }
  return path9;
}
function dirname(path10) {
  assertPath(path10);
  const len = path10.length;
  if (len === 0)
    return ".";
  let rootEnd = -1;
  let end = -1;
  let matchedSlash = true;
  let offset = 0;
  const code = path10.charCodeAt(0);
  if (len > 1) {
    if (isPathSeparator(code)) {
      rootEnd = offset = 1;
      if (isPathSeparator(path10.charCodeAt(1))) {
        let j = 2;
        let last = j;
        for (; j < len; ++j) {
          if (isPathSeparator(path10.charCodeAt(j)))
            break;
        }
        if (j < len && j !== last) {
          last = j;
          for (; j < len; ++j) {
            if (!isPathSeparator(path10.charCodeAt(j)))
              break;
          }
          if (j < len && j !== last) {
            last = j;
            for (; j < len; ++j) {
              if (isPathSeparator(path10.charCodeAt(j)))
                break;
            }
            if (j === len) {
              return path10;
            }
            if (j !== last) {
              rootEnd = offset = j + 1;
            }
          }
        }
      }
    } else if (isWindowsDeviceRoot(code)) {
      if (path10.charCodeAt(1) === 58) {
        rootEnd = offset = 2;
        if (len > 2) {
          if (isPathSeparator(path10.charCodeAt(2)))
            rootEnd = offset = 3;
        }
      }
    }
  } else if (isPathSeparator(code)) {
    return path10;
  }
  for (let i79 = len - 1; i79 >= offset; --i79) {
    if (isPathSeparator(path10.charCodeAt(i79))) {
      if (!matchedSlash) {
        end = i79;
        break;
      }
    } else {
      matchedSlash = false;
    }
  }
  if (end === -1) {
    if (rootEnd === -1)
      return ".";
    else
      end = rootEnd;
  }
  return path10.slice(0, end);
}
function basename(path11, ext = "") {
  if (ext !== void 0 && typeof ext !== "string") {
    throw new TypeError('"ext" argument must be a string');
  }
  assertPath(path11);
  let start = 0;
  let end = -1;
  let matchedSlash = true;
  let i80;
  if (path11.length >= 2) {
    const drive = path11.charCodeAt(0);
    if (isWindowsDeviceRoot(drive)) {
      if (path11.charCodeAt(1) === 58)
        start = 2;
    }
  }
  if (ext !== void 0 && ext.length > 0 && ext.length <= path11.length) {
    if (ext.length === path11.length && ext === path11)
      return "";
    let extIdx = ext.length - 1;
    let firstNonSlashEnd = -1;
    for (i80 = path11.length - 1; i80 >= start; --i80) {
      const code = path11.charCodeAt(i80);
      if (isPathSeparator(code)) {
        if (!matchedSlash) {
          start = i80 + 1;
          break;
        }
      } else {
        if (firstNonSlashEnd === -1) {
          matchedSlash = false;
          firstNonSlashEnd = i80 + 1;
        }
        if (extIdx >= 0) {
          if (code === ext.charCodeAt(extIdx)) {
            if (--extIdx === -1) {
              end = i80;
            }
          } else {
            extIdx = -1;
            end = firstNonSlashEnd;
          }
        }
      }
    }
    if (start === end)
      end = firstNonSlashEnd;
    else if (end === -1)
      end = path11.length;
    return path11.slice(start, end);
  } else {
    for (i80 = path11.length - 1; i80 >= start; --i80) {
      if (isPathSeparator(path11.charCodeAt(i80))) {
        if (!matchedSlash) {
          start = i80 + 1;
          break;
        }
      } else if (end === -1) {
        matchedSlash = false;
        end = i80 + 1;
      }
    }
    if (end === -1)
      return "";
    return path11.slice(start, end);
  }
}
function extname(path12) {
  assertPath(path12);
  let start = 0;
  let startDot = -1;
  let startPart = 0;
  let end = -1;
  let matchedSlash = true;
  let preDotState = 0;
  if (path12.length >= 2 && path12.charCodeAt(1) === 58 && isWindowsDeviceRoot(path12.charCodeAt(0))) {
    start = startPart = 2;
  }
  for (let i81 = path12.length - 1; i81 >= start; --i81) {
    const code = path12.charCodeAt(i81);
    if (isPathSeparator(code)) {
      if (!matchedSlash) {
        startPart = i81 + 1;
        break;
      }
      continue;
    }
    if (end === -1) {
      matchedSlash = false;
      end = i81 + 1;
    }
    if (code === 46) {
      if (startDot === -1)
        startDot = i81;
      else if (preDotState !== 1)
        preDotState = 1;
    } else if (startDot !== -1) {
      preDotState = -1;
    }
  }
  if (startDot === -1 || end === -1 || preDotState === 0 || preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
    return "";
  }
  return path12.slice(startDot, end);
}
function format(pathObject) {
  if (pathObject === null || typeof pathObject !== "object") {
    throw new TypeError(`The "pathObject" argument must be of type Object. Received type ${typeof pathObject}`);
  }
  return _format("\\", pathObject);
}
function parse1(path13) {
  assertPath(path13);
  const ret = {
    root: "",
    dir: "",
    base: "",
    ext: "",
    name: ""
  };
  const len = path13.length;
  if (len === 0)
    return ret;
  let rootEnd = 0;
  let code = path13.charCodeAt(0);
  if (len > 1) {
    if (isPathSeparator(code)) {
      rootEnd = 1;
      if (isPathSeparator(path13.charCodeAt(1))) {
        let j = 2;
        let last = j;
        for (; j < len; ++j) {
          if (isPathSeparator(path13.charCodeAt(j)))
            break;
        }
        if (j < len && j !== last) {
          last = j;
          for (; j < len; ++j) {
            if (!isPathSeparator(path13.charCodeAt(j)))
              break;
          }
          if (j < len && j !== last) {
            last = j;
            for (; j < len; ++j) {
              if (isPathSeparator(path13.charCodeAt(j)))
                break;
            }
            if (j === len) {
              rootEnd = j;
            } else if (j !== last) {
              rootEnd = j + 1;
            }
          }
        }
      }
    } else if (isWindowsDeviceRoot(code)) {
      if (path13.charCodeAt(1) === 58) {
        rootEnd = 2;
        if (len > 2) {
          if (isPathSeparator(path13.charCodeAt(2))) {
            if (len === 3) {
              ret.root = ret.dir = path13;
              return ret;
            }
            rootEnd = 3;
          }
        } else {
          ret.root = ret.dir = path13;
          return ret;
        }
      }
    }
  } else if (isPathSeparator(code)) {
    ret.root = ret.dir = path13;
    return ret;
  }
  if (rootEnd > 0)
    ret.root = path13.slice(0, rootEnd);
  let startDot = -1;
  let startPart = rootEnd;
  let end = -1;
  let matchedSlash = true;
  let i82 = path13.length - 1;
  let preDotState = 0;
  for (; i82 >= rootEnd; --i82) {
    code = path13.charCodeAt(i82);
    if (isPathSeparator(code)) {
      if (!matchedSlash) {
        startPart = i82 + 1;
        break;
      }
      continue;
    }
    if (end === -1) {
      matchedSlash = false;
      end = i82 + 1;
    }
    if (code === 46) {
      if (startDot === -1)
        startDot = i82;
      else if (preDotState !== 1)
        preDotState = 1;
    } else if (startDot !== -1) {
      preDotState = -1;
    }
  }
  if (startDot === -1 || end === -1 || preDotState === 0 || preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
    if (end !== -1) {
      ret.base = ret.name = path13.slice(startPart, end);
    }
  } else {
    ret.name = path13.slice(startPart, startDot);
    ret.base = path13.slice(startPart, end);
    ret.ext = path13.slice(startDot, end);
  }
  if (startPart > 0 && startPart !== rootEnd) {
    ret.dir = path13.slice(0, startPart - 1);
  } else
    ret.dir = ret.root;
  return ret;
}
function fromFileUrl(url) {
  url = url instanceof URL ? url : new URL(url);
  if (url.protocol != "file:") {
    throw new TypeError("Must be a file URL.");
  }
  let path14 = decodeURIComponent(url.pathname.replace(/\//g, "\\").replace(/%(?![0-9A-Fa-f]{2})/g, "%25")).replace(/^\\*([A-Za-z]:)(\\|$)/, "$1\\");
  if (url.hostname != "") {
    path14 = `\\\\${url.hostname}${path14}`;
  }
  return path14;
}
function toFileUrl(path15) {
  if (!isAbsolute(path15)) {
    throw new TypeError("Must be an absolute path.");
  }
  const [, hostname, pathname] = path15.match(/^(?:[/\\]{2}([^/\\]+)(?=[/\\](?:[^/\\]|$)))?(.*)/);
  const url = new URL("file:///");
  url.pathname = encodeWhitespace(pathname.replace(/%/g, "%25"));
  if (hostname != null && hostname != "localhost") {
    url.hostname = hostname;
    if (!url.hostname) {
      throw new TypeError("Invalid hostname.");
    }
  }
  return url;
}
var mod9 = {
  sep,
  delimiter,
  resolve,
  normalize,
  isAbsolute,
  join: join1,
  relative,
  toNamespacedPath,
  dirname,
  basename,
  extname,
  format,
  parse: parse1,
  fromFileUrl,
  toFileUrl
};
var sep1 = "/";
var delimiter1 = ":";
function resolve1(...pathSegments) {
  let resolvedPath = "";
  let resolvedAbsolute = false;
  for (let i83 = pathSegments.length - 1; i83 >= -1 && !resolvedAbsolute; i83--) {
    let path16;
    if (i83 >= 0)
      path16 = pathSegments[i83];
    else {
      const { Deno: Deno2 } = globalThis;
      if (typeof Deno2?.cwd !== "function") {
        throw new TypeError("Resolved a relative path without a CWD.");
      }
      path16 = Deno2.cwd();
    }
    assertPath(path16);
    if (path16.length === 0) {
      continue;
    }
    resolvedPath = `${path16}/${resolvedPath}`;
    resolvedAbsolute = path16.charCodeAt(0) === CHAR_FORWARD_SLASH;
  }
  resolvedPath = normalizeString(resolvedPath, !resolvedAbsolute, "/", isPosixPathSeparator);
  if (resolvedAbsolute) {
    if (resolvedPath.length > 0)
      return `/${resolvedPath}`;
    else
      return "/";
  } else if (resolvedPath.length > 0)
    return resolvedPath;
  else
    return ".";
}
function normalize1(path17) {
  assertPath(path17);
  if (path17.length === 0)
    return ".";
  const isAbsolute12 = path17.charCodeAt(0) === 47;
  const trailingSeparator = path17.charCodeAt(path17.length - 1) === 47;
  path17 = normalizeString(path17, !isAbsolute12, "/", isPosixPathSeparator);
  if (path17.length === 0 && !isAbsolute12)
    path17 = ".";
  if (path17.length > 0 && trailingSeparator)
    path17 += "/";
  if (isAbsolute12)
    return `/${path17}`;
  return path17;
}
function isAbsolute1(path18) {
  assertPath(path18);
  return path18.length > 0 && path18.charCodeAt(0) === 47;
}
function join2(...paths) {
  if (paths.length === 0)
    return ".";
  let joined;
  for (let i84 = 0, len = paths.length; i84 < len; ++i84) {
    const path19 = paths[i84];
    assertPath(path19);
    if (path19.length > 0) {
      if (!joined)
        joined = path19;
      else
        joined += `/${path19}`;
    }
  }
  if (!joined)
    return ".";
  return normalize1(joined);
}
function relative1(from2, to) {
  assertPath(from2);
  assertPath(to);
  if (from2 === to)
    return "";
  from2 = resolve1(from2);
  to = resolve1(to);
  if (from2 === to)
    return "";
  let fromStart = 1;
  const fromEnd = from2.length;
  for (; fromStart < fromEnd; ++fromStart) {
    if (from2.charCodeAt(fromStart) !== 47)
      break;
  }
  const fromLen = fromEnd - fromStart;
  let toStart = 1;
  const toEnd = to.length;
  for (; toStart < toEnd; ++toStart) {
    if (to.charCodeAt(toStart) !== 47)
      break;
  }
  const toLen = toEnd - toStart;
  const length = fromLen < toLen ? fromLen : toLen;
  let lastCommonSep = -1;
  let i85 = 0;
  for (; i85 <= length; ++i85) {
    if (i85 === length) {
      if (toLen > length) {
        if (to.charCodeAt(toStart + i85) === 47) {
          return to.slice(toStart + i85 + 1);
        } else if (i85 === 0) {
          return to.slice(toStart + i85);
        }
      } else if (fromLen > length) {
        if (from2.charCodeAt(fromStart + i85) === 47) {
          lastCommonSep = i85;
        } else if (i85 === 0) {
          lastCommonSep = 0;
        }
      }
      break;
    }
    const fromCode = from2.charCodeAt(fromStart + i85);
    const toCode = to.charCodeAt(toStart + i85);
    if (fromCode !== toCode)
      break;
    else if (fromCode === 47)
      lastCommonSep = i85;
  }
  let out = "";
  for (i85 = fromStart + lastCommonSep + 1; i85 <= fromEnd; ++i85) {
    if (i85 === fromEnd || from2.charCodeAt(i85) === 47) {
      if (out.length === 0)
        out += "..";
      else
        out += "/..";
    }
  }
  if (out.length > 0)
    return out + to.slice(toStart + lastCommonSep);
  else {
    toStart += lastCommonSep;
    if (to.charCodeAt(toStart) === 47)
      ++toStart;
    return to.slice(toStart);
  }
}
function toNamespacedPath1(path20) {
  return path20;
}
function dirname1(path21) {
  assertPath(path21);
  if (path21.length === 0)
    return ".";
  const hasRoot = path21.charCodeAt(0) === 47;
  let end = -1;
  let matchedSlash = true;
  for (let i86 = path21.length - 1; i86 >= 1; --i86) {
    if (path21.charCodeAt(i86) === 47) {
      if (!matchedSlash) {
        end = i86;
        break;
      }
    } else {
      matchedSlash = false;
    }
  }
  if (end === -1)
    return hasRoot ? "/" : ".";
  if (hasRoot && end === 1)
    return "//";
  return path21.slice(0, end);
}
function basename1(path22, ext = "") {
  if (ext !== void 0 && typeof ext !== "string") {
    throw new TypeError('"ext" argument must be a string');
  }
  assertPath(path22);
  let start = 0;
  let end = -1;
  let matchedSlash = true;
  let i87;
  if (ext !== void 0 && ext.length > 0 && ext.length <= path22.length) {
    if (ext.length === path22.length && ext === path22)
      return "";
    let extIdx = ext.length - 1;
    let firstNonSlashEnd = -1;
    for (i87 = path22.length - 1; i87 >= 0; --i87) {
      const code = path22.charCodeAt(i87);
      if (code === 47) {
        if (!matchedSlash) {
          start = i87 + 1;
          break;
        }
      } else {
        if (firstNonSlashEnd === -1) {
          matchedSlash = false;
          firstNonSlashEnd = i87 + 1;
        }
        if (extIdx >= 0) {
          if (code === ext.charCodeAt(extIdx)) {
            if (--extIdx === -1) {
              end = i87;
            }
          } else {
            extIdx = -1;
            end = firstNonSlashEnd;
          }
        }
      }
    }
    if (start === end)
      end = firstNonSlashEnd;
    else if (end === -1)
      end = path22.length;
    return path22.slice(start, end);
  } else {
    for (i87 = path22.length - 1; i87 >= 0; --i87) {
      if (path22.charCodeAt(i87) === 47) {
        if (!matchedSlash) {
          start = i87 + 1;
          break;
        }
      } else if (end === -1) {
        matchedSlash = false;
        end = i87 + 1;
      }
    }
    if (end === -1)
      return "";
    return path22.slice(start, end);
  }
}
function extname1(path23) {
  assertPath(path23);
  let startDot = -1;
  let startPart = 0;
  let end = -1;
  let matchedSlash = true;
  let preDotState = 0;
  for (let i88 = path23.length - 1; i88 >= 0; --i88) {
    const code = path23.charCodeAt(i88);
    if (code === 47) {
      if (!matchedSlash) {
        startPart = i88 + 1;
        break;
      }
      continue;
    }
    if (end === -1) {
      matchedSlash = false;
      end = i88 + 1;
    }
    if (code === 46) {
      if (startDot === -1)
        startDot = i88;
      else if (preDotState !== 1)
        preDotState = 1;
    } else if (startDot !== -1) {
      preDotState = -1;
    }
  }
  if (startDot === -1 || end === -1 || preDotState === 0 || preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
    return "";
  }
  return path23.slice(startDot, end);
}
function format1(pathObject) {
  if (pathObject === null || typeof pathObject !== "object") {
    throw new TypeError(`The "pathObject" argument must be of type Object. Received type ${typeof pathObject}`);
  }
  return _format("/", pathObject);
}
function parse2(path24) {
  assertPath(path24);
  const ret = {
    root: "",
    dir: "",
    base: "",
    ext: "",
    name: ""
  };
  if (path24.length === 0)
    return ret;
  const isAbsolute22 = path24.charCodeAt(0) === 47;
  let start;
  if (isAbsolute22) {
    ret.root = "/";
    start = 1;
  } else {
    start = 0;
  }
  let startDot = -1;
  let startPart = 0;
  let end = -1;
  let matchedSlash = true;
  let i89 = path24.length - 1;
  let preDotState = 0;
  for (; i89 >= start; --i89) {
    const code = path24.charCodeAt(i89);
    if (code === 47) {
      if (!matchedSlash) {
        startPart = i89 + 1;
        break;
      }
      continue;
    }
    if (end === -1) {
      matchedSlash = false;
      end = i89 + 1;
    }
    if (code === 46) {
      if (startDot === -1)
        startDot = i89;
      else if (preDotState !== 1)
        preDotState = 1;
    } else if (startDot !== -1) {
      preDotState = -1;
    }
  }
  if (startDot === -1 || end === -1 || preDotState === 0 || preDotState === 1 && startDot === end - 1 && startDot === startPart + 1) {
    if (end !== -1) {
      if (startPart === 0 && isAbsolute22) {
        ret.base = ret.name = path24.slice(1, end);
      } else {
        ret.base = ret.name = path24.slice(startPart, end);
      }
    }
  } else {
    if (startPart === 0 && isAbsolute22) {
      ret.name = path24.slice(1, startDot);
      ret.base = path24.slice(1, end);
    } else {
      ret.name = path24.slice(startPart, startDot);
      ret.base = path24.slice(startPart, end);
    }
    ret.ext = path24.slice(startDot, end);
  }
  if (startPart > 0)
    ret.dir = path24.slice(0, startPart - 1);
  else if (isAbsolute22)
    ret.dir = "/";
  return ret;
}
function fromFileUrl1(url) {
  url = url instanceof URL ? url : new URL(url);
  if (url.protocol != "file:") {
    throw new TypeError("Must be a file URL.");
  }
  return decodeURIComponent(url.pathname.replace(/%(?![0-9A-Fa-f]{2})/g, "%25"));
}
function toFileUrl1(path25) {
  if (!isAbsolute1(path25)) {
    throw new TypeError("Must be an absolute path.");
  }
  const url = new URL("file:///");
  url.pathname = encodeWhitespace(path25.replace(/%/g, "%25").replace(/\\/g, "%5C"));
  return url;
}
var mod10 = {
  sep: sep1,
  delimiter: delimiter1,
  resolve: resolve1,
  normalize: normalize1,
  isAbsolute: isAbsolute1,
  join: join2,
  relative: relative1,
  toNamespacedPath: toNamespacedPath1,
  dirname: dirname1,
  basename: basename1,
  extname: extname1,
  format: format1,
  parse: parse2,
  fromFileUrl: fromFileUrl1,
  toFileUrl: toFileUrl1
};
var path = isWindows ? mod9 : mod10;
var { join: join3, normalize: normalize2 } = path;
var path1 = isWindows ? mod9 : mod10;
var { basename: basename2, delimiter: delimiter2, dirname: dirname2, extname: extname2, format: format2, fromFileUrl: fromFileUrl2, isAbsolute: isAbsolute2, join: join4, normalize: normalize3, parse: parse3, relative: relative2, resolve: resolve2, sep: sep2, toFileUrl: toFileUrl2, toNamespacedPath: toNamespacedPath2 } = path1;
function createWritableStdioStream(writer, name) {
  const stream1 = new Writable({
    write(buf, enc, cb) {
      if (!writer) {
        this.destroy(new Error(`Deno.${name} is not available in this environment`));
        return;
      }
      writer.writeSync(buf instanceof Uint8Array ? buf : Buffer2.from(buf, enc));
      cb();
    },
    destroy(err, cb) {
      cb(err);
      this._undestroy();
      if (!this._writableState.emitClose) {
        nextTick(() => this.emit("close"));
      }
    }
  });
  stream1.fd = writer?.rid ?? -1;
  stream1.destroySoon = stream1.destroy;
  stream1._isStdio = true;
  stream1.once("close", () => writer?.close());
  Object.defineProperties(stream1, {
    columns: {
      enumerable: true,
      configurable: true,
      get: () => workerDeno_isatty?.(writer?.rid) ? define_Deno_default.consoleSize?.(writer?.rid).columns : void 0
    },
    rows: {
      enumerable: true,
      configurable: true,
      get: () => workerDeno_isatty?.(writer?.rid) ? define_Deno_default.consoleSize?.(writer?.rid).rows : void 0
    },
    isTTY: {
      enumerable: true,
      configurable: true,
      get: () => workerDeno_isatty?.(writer?.rid)
    },
    getWindowSize: {
      enumerable: true,
      configurable: true,
      value: () => workerDeno_isatty?.(writer?.rid) ? Object.values(define_Deno_default.consoleSize?.(writer?.rid)) : void 0
    }
  });
  return stream1;
}
var stderr = stdio.stderr = createWritableStdioStream(workerDeno_stderr, "stderr");
var stdout = stdio.stdout = createWritableStdioStream(workerDeno_stdout, "stdout");
var stdin = stdio.stdin = new Readable({
  highWaterMark: 0,
  emitClose: false,
  read(size) {
    const p = Buffer2.alloc(size || 16 * 1024);
    if (!workerDeno_stdin) {
      this.destroy(new Error("Deno.stdin is not available in this environment"));
      return;
    }
    workerDeno_stdin.read(p).then((length) => {
      this.push(length === null ? null : p.slice(0, length));
    }, (error16) => {
      this.destroy(error16);
    });
  }
});
stdin.on("close", () => workerDeno_stdin?.close());
stdin.fd = workerDeno_stdin?.rid ?? -1;
Object.defineProperty(stdin, "isTTY", {
  enumerable: true,
  configurable: true,
  get() {
    return workerDeno_isatty?.(workerDeno_stdin.rid);
  }
});
stdin._isRawMode = false;
stdin.setRawMode = (enable) => {
  setRaw?.(workerDeno_stdin?.rid, enable);
  stdin._isRawMode = enable;
  return stdin;
};
Object.defineProperty(stdin, "isRaw", {
  enumerable: true,
  configurable: true,
  get() {
    return stdin._isRawMode;
  }
});
var mod11 = {};
var AI_V4MAPPED = 1 << 4;
var AI_ALL = 1 << 5;
var AI_ADDRCONFIG = 1 << 6;
function ares_strerror(code) {
  const errorText = [
    "Successful completion",
    "DNS server returned answer with no data",
    "DNS server claims query was misformatted",
    "DNS server returned general failure",
    "Domain name not found",
    "DNS server does not implement requested operation",
    "DNS server refused query",
    "Misformatted DNS query",
    "Misformatted domain name",
    "Unsupported address family",
    "Misformatted DNS reply",
    "Could not contact DNS servers",
    "Timeout while contacting DNS servers",
    "End of file",
    "Error reading file",
    "Out of memory",
    "Channel is being destroyed",
    "Misformatted string",
    "Illegal flags specified",
    "Given hostname is not numeric",
    "Illegal hints flags specified",
    "c-ares library initialization not yet performed",
    "Error loading iphlpapi.dll",
    "Could not find GetNetworkParams function",
    "DNS query cancelled"
  ];
  if (code >= 0 && code < errorText.length) {
    return errorText[code];
  } else {
    return "unknown";
  }
}
var GetAddrInfoReqWrap = class extends AsyncWrap {
  family;
  hostname;
  callback;
  resolve;
  reject;
  oncomplete;
  constructor() {
    super(providerType.GETADDRINFOREQWRAP);
  }
};
function getaddrinfo(req1, hostname, family, _hints, verbatim) {
  let addresses = [];
  const recordTypes = [];
  if (family === 0 || family === 4) {
    recordTypes.push("A");
  }
  if (family === 0 || family === 6) {
    recordTypes.push("AAAA");
  }
  (async () => {
    await Promise.allSettled(recordTypes.map((recordType) => define_Deno_default.resolveDns(hostname, recordType).then((records) => {
      records.forEach((record) => addresses.push(record));
    })));
    const error17 = addresses.length ? 0 : codeMap.get("EAI_NODATA");
    if (!verbatim) {
      addresses.sort((a, b) => {
        if (isIPv4(a)) {
          return -1;
        } else if (isIPv4(b)) {
          return 1;
        }
        return 0;
      });
    }
    if (isWindows && hostname === "localhost") {
      addresses = addresses.filter((address) => isIPv4(address));
    }
    req1.oncomplete(error17, addresses);
  })();
  return 0;
}
var QueryReqWrap = class extends AsyncWrap {
  bindingName;
  hostname;
  ttl;
  callback;
  resolve;
  reject;
  oncomplete;
  constructor() {
    super(providerType.QUERYWRAP);
  }
};
function fqdnToHostname(fqdn) {
  return fqdn.replace(/\.$/, "");
}
function compressIPv6(address) {
  const formatted = address.replace(/\b(?:0+:){2,}/, ":");
  const finalAddress = formatted.split(":").map((octet) => {
    if (octet.match(/^\d+\.\d+\.\d+\.\d+$/)) {
      return Number(octet.replaceAll(".", "")).toString(16);
    }
    return octet.replace(/\b0+/g, "");
  }).join(":");
  return finalAddress;
}
var ChannelWrap = class extends AsyncWrap {
  #servers = [];
  #timeout;
  #tries;
  constructor(timeout, tries) {
    super(providerType.DNSCHANNEL);
    this.#timeout = timeout;
    this.#tries = tries;
  }
  async #query(query, recordType) {
    let code;
    let ret;
    if (this.#servers.length) {
      for (const [ipAddr, port] of this.#servers) {
        const resolveOptions = {
          nameServer: {
            ipAddr,
            port
          }
        };
        ({ code, ret } = await this.#resolve(query, recordType, resolveOptions));
        if (code === 0 || code === codeMap.get("EAI_NODATA")) {
          break;
        }
      }
    } else {
      ({ code, ret } = await this.#resolve(query, recordType));
    }
    return {
      code,
      ret
    };
  }
  async #resolve(query1, recordType1, resolveOptions) {
    let ret = [];
    let code = 0;
    try {
      ret = await define_Deno_default.resolveDns(query1, recordType1, resolveOptions);
    } catch (e) {
      if (e instanceof workerDeno_errors.NotFound) {
        code = codeMap.get("EAI_NODATA");
      } else {
        code = codeMap.get("UNKNOWN");
      }
    }
    return {
      code,
      ret
    };
  }
  queryAny(req2, name) {
    (async () => {
      const records = [];
      await Promise.allSettled([
        this.#query(name, "A").then(({ ret }) => {
          ret.forEach((record) => records.push({
            type: "A",
            address: record
          }));
        }),
        this.#query(name, "AAAA").then(({ ret }) => {
          ret.forEach((record) => records.push({
            type: "AAAA",
            address: compressIPv6(record)
          }));
        }),
        this.#query(name, "CAA").then(({ ret }) => {
          ret.forEach(({ critical, tag, value }) => records.push({
            type: "CAA",
            [tag]: value,
            critical: +critical && 128
          }));
        }),
        this.#query(name, "CNAME").then(({ ret }) => {
          ret.forEach((record) => records.push({
            type: "CNAME",
            value: record
          }));
        }),
        this.#query(name, "MX").then(({ ret }) => {
          ret.forEach(({ preference, exchange }) => records.push({
            type: "MX",
            priority: preference,
            exchange: fqdnToHostname(exchange)
          }));
        }),
        this.#query(name, "NAPTR").then(({ ret }) => {
          ret.forEach(({ order, preference, flags, services, regexp, replacement }) => records.push({
            type: "NAPTR",
            order,
            preference,
            flags,
            service: services,
            regexp,
            replacement
          }));
        }),
        this.#query(name, "NS").then(({ ret }) => {
          ret.forEach((record) => records.push({
            type: "NS",
            value: fqdnToHostname(record)
          }));
        }),
        this.#query(name, "PTR").then(({ ret }) => {
          ret.forEach((record) => records.push({
            type: "PTR",
            value: fqdnToHostname(record)
          }));
        }),
        this.#query(name, "SOA").then(({ ret }) => {
          ret.forEach(({ mname, rname, serial, refresh, retry, expire, minimum }) => records.push({
            type: "SOA",
            nsname: fqdnToHostname(mname),
            hostmaster: fqdnToHostname(rname),
            serial,
            refresh,
            retry,
            expire,
            minttl: minimum
          }));
        }),
        this.#query(name, "SRV").then(({ ret }) => {
          ret.forEach(({ priority, weight, port, target }) => records.push({
            type: "SRV",
            priority,
            weight,
            port,
            name: target
          }));
        }),
        this.#query(name, "TXT").then(({ ret }) => {
          ret.forEach((record) => records.push({
            type: "TXT",
            entries: record
          }));
        })
      ]);
      const err = records.length ? 0 : codeMap.get("EAI_NODATA");
      req2.oncomplete(err, records);
    })();
    return 0;
  }
  queryA(req3, name) {
    this.#query(name, "A").then(({ code, ret }) => {
      req3.oncomplete(code, ret);
    });
    return 0;
  }
  queryAaaa(req4, name) {
    this.#query(name, "AAAA").then(({ code, ret }) => {
      const records = ret.map((record) => compressIPv6(record));
      req4.oncomplete(code, records);
    });
    return 0;
  }
  queryCaa(req5, name) {
    this.#query(name, "CAA").then(({ code, ret }) => {
      const records = ret.map(({ critical, tag, value }) => ({
        [tag]: value,
        critical: +critical && 128
      }));
      req5.oncomplete(code, records);
    });
    return 0;
  }
  queryCname(req6, name) {
    this.#query(name, "CNAME").then(({ code, ret }) => {
      req6.oncomplete(code, ret);
    });
    return 0;
  }
  queryMx(req7, name) {
    this.#query(name, "MX").then(({ code, ret }) => {
      const records = ret.map(({ preference, exchange }) => ({
        priority: preference,
        exchange: fqdnToHostname(exchange)
      }));
      req7.oncomplete(code, records);
    });
    return 0;
  }
  queryNaptr(req8, name) {
    this.#query(name, "NAPTR").then(({ code, ret }) => {
      const records = ret.map(({ order, preference, flags, services, regexp, replacement }) => ({
        flags,
        service: services,
        regexp,
        replacement,
        order,
        preference
      }));
      req8.oncomplete(code, records);
    });
    return 0;
  }
  queryNs(req9, name) {
    this.#query(name, "NS").then(({ code, ret }) => {
      const records = ret.map((record) => fqdnToHostname(record));
      req9.oncomplete(code, records);
    });
    return 0;
  }
  queryPtr(req10, name) {
    this.#query(name, "PTR").then(({ code, ret }) => {
      const records = ret.map((record) => fqdnToHostname(record));
      req10.oncomplete(code, records);
    });
    return 0;
  }
  querySoa(req11, name) {
    this.#query(name, "SOA").then(({ code, ret }) => {
      let record = {};
      if (ret.length) {
        const { mname, rname, serial, refresh, retry, expire, minimum } = ret[0];
        record = {
          nsname: fqdnToHostname(mname),
          hostmaster: fqdnToHostname(rname),
          serial,
          refresh,
          retry,
          expire,
          minttl: minimum
        };
      }
      req11.oncomplete(code, record);
    });
    return 0;
  }
  querySrv(req12, name) {
    this.#query(name, "SRV").then(({ code, ret }) => {
      const records = ret.map(({ priority, weight, port, target }) => ({
        priority,
        weight,
        port,
        name: target
      }));
      req12.oncomplete(code, records);
    });
    return 0;
  }
  queryTxt(req13, name) {
    this.#query(name, "TXT").then(({ code, ret }) => {
      req13.oncomplete(code, ret);
    });
    return 0;
  }
  getHostByAddr(_req, _name) {
    notImplemented("cares.ChannelWrap.prototype.getHostByAddr");
  }
  getServers() {
    return this.#servers;
  }
  setServers(servers) {
    if (typeof servers === "string") {
      const tuples = [];
      for (let i90 = 0; i90 < servers.length; i90 += 2) {
        tuples.push([
          servers[i90],
          parseInt(servers[i90 + 1])
        ]);
      }
      this.#servers = tuples;
    } else {
      this.#servers = servers.map(([_ipVersion, ip, port]) => [
        ip,
        port
      ]);
    }
    return 0;
  }
  setLocalAddress(_addr0, _addr1) {
    notImplemented("cares.ChannelWrap.prototype.setLocalAddress");
  }
  cancel() {
    notImplemented("cares.ChannelWrap.prototype.cancel");
  }
};
var DNS_ESETSRVPENDING = -1e3;
var EMSG_ESETSRVPENDING = "There are pending queries.";
function strerror(code) {
  return code === DNS_ESETSRVPENDING ? EMSG_ESETSRVPENDING : ares_strerror(code);
}
var mod12 = {
  GetAddrInfoReqWrap,
  getaddrinfo,
  QueryReqWrap,
  ChannelWrap,
  strerror
};
var mod13 = {};
var timingSafeEqual = (a, b) => {
  if (a instanceof DataView)
    a = Buffer2.from(a.buffer);
  if (b instanceof DataView)
    b = Buffer2.from(b.buffer);
  if (a instanceof ArrayBuffer)
    a = Buffer2.from(a);
  if (b instanceof ArrayBuffer)
    b = Buffer2.from(b);
  let result = 0;
  if (a.byteLength !== b.byteLength) {
    b = a;
    result = 1;
  }
  for (let i91 = 0; i91 < a.byteLength; i91++) {
    result |= a[i91] ^ b[i91];
  }
  return result === 0;
};
function getFipsCrypto() {
  notImplemented("crypto.getFipsCrypto");
}
function setFipsCrypto(_fips) {
  notImplemented("crypto.setFipsCrypto");
}
var mod14 = {
  timingSafeEqual,
  getFipsCrypto,
  setFipsCrypto
};
var mod15 = {};
var mod16 = {};
var mod17 = {};
var mod18 = {};
var mod19 = {};
var mod20 = {};
var mod21 = {};
var mod22 = {};
var mod23 = {};
var mod24 = {};
var mod25 = {};
var mod26 = {};
var mod27 = {};
var mod28 = {};
var mod29 = {};
var mod30 = {};
var ConnectionWrap = class extends LibuvStreamWrap {
  onconnection = null;
  constructor(provider, object) {
    super(provider, object);
  }
  afterConnect(req14, status) {
    const isSuccessStatus = !status;
    const readable = isSuccessStatus;
    const writable = isSuccessStatus;
    try {
      req14.oncomplete(status, this, req14, readable, writable);
    } catch {
    }
    return;
  }
};
function ceilPowOf2(n) {
  const roundPowOf2 = 1 << 31 - Math.clz32(n);
  return roundPowOf2 < n ? roundPowOf2 * 2 : roundPowOf2;
}
var INITIAL_ACCEPT_BACKOFF_DELAY = 5;
var MAX_ACCEPT_BACKOFF_DELAY = 1e3;
var socketType;
(function(socketType2) {
  socketType2[socketType2["SOCKET"] = 0] = "SOCKET";
  socketType2[socketType2["SERVER"] = 1] = "SERVER";
  socketType2[socketType2["IPC"] = 2] = "IPC";
})(socketType || (socketType = {}));
var Pipe = class extends ConnectionWrap {
  reading = false;
  ipc;
  #pendingInstances = 4;
  #address;
  #backlog;
  #listener;
  #connections = 0;
  #closed = false;
  #acceptBackoffDelay;
  constructor(type, conn) {
    let provider;
    let ipc;
    switch (type) {
      case socketType.SOCKET: {
        provider = providerType.PIPEWRAP;
        ipc = false;
        break;
      }
      case socketType.SERVER: {
        provider = providerType.PIPESERVERWRAP;
        ipc = false;
        break;
      }
      case socketType.IPC: {
        provider = providerType.PIPEWRAP;
        ipc = true;
        break;
      }
      default: {
        unreachable();
      }
    }
    super(provider, conn);
    this.ipc = ipc;
    if (conn && provider === providerType.PIPEWRAP) {
      const localAddr = conn.localAddr;
      this.#address = localAddr.path;
    }
  }
  open(_fd) {
    notImplemented("Pipe.prototype.open");
  }
  bind(name) {
    this.#address = name;
    return 0;
  }
  connect(req15, address) {
    if (isWindows) {
      notImplemented("Pipe.prototype.connect - Windows");
    }
    const connectOptions = {
      path: address,
      transport: "unix"
    };
    connect(connectOptions).then((conn) => {
      const localAddr = conn.localAddr;
      this.#address = req15.address = localAddr.path;
      this[kStreamBaseField] = conn;
      try {
        this.afterConnect(req15, 0);
      } catch {
      }
    }, (e) => {
      let code;
      if (e instanceof workerDeno_errors.NotFound) {
        code = codeMap.get("ENOENT");
      } else if (e instanceof workerDeno_errors.PermissionDenied) {
        code = codeMap.get("EACCES");
      } else {
        code = codeMap.get("ECONNREFUSED");
      }
      try {
        this.afterConnect(req15, code);
      } catch {
      }
    });
    return 0;
  }
  listen(backlog) {
    if (isWindows) {
      notImplemented("Pipe.prototype.listen - Windows");
    }
    this.#backlog = isWindows ? this.#pendingInstances : ceilPowOf2(backlog + 1);
    const listenOptions = {
      path: this.#address,
      transport: "unix"
    };
    let listener;
    try {
      listener = listen(listenOptions);
    } catch (e) {
      if (e instanceof workerDeno_errors.AddrInUse) {
        return codeMap.get("EADDRINUSE");
      } else if (e instanceof workerDeno_errors.AddrNotAvailable) {
        return codeMap.get("EADDRNOTAVAIL");
      }
      return codeMap.get("UNKNOWN");
    }
    const address = listener.addr;
    this.#address = address.path;
    this.#listener = listener;
    this.#accept();
    return 0;
  }
  ref() {
    if (this.#listener) {
      ListenerRef(this.#listener);
    }
  }
  unref() {
    if (this.#listener) {
      ListenerUnref(this.#listener);
    }
  }
  setPendingInstances(instances) {
    this.#pendingInstances = instances;
  }
  fchmod(mode) {
    if (mode != constants2.UV_READABLE && mode != constants2.UV_WRITABLE && mode != (constants2.UV_WRITABLE | constants2.UV_READABLE)) {
      return codeMap.get("EINVAL");
    }
    let desired_mode = 0;
    if (mode & constants2.UV_READABLE) {
      desired_mode |= fs.S_IRUSR | fs.S_IRGRP | fs.S_IROTH;
    }
    if (mode & constants2.UV_WRITABLE) {
      desired_mode |= fs.S_IWUSR | fs.S_IWGRP | fs.S_IWOTH;
    }
    try {
      define_Deno_default.chmodSync(this.#address, desired_mode);
    } catch {
      return codeMap.get("UNKNOWN");
    }
    return 0;
  }
  async #acceptBackoff() {
    if (!this.#acceptBackoffDelay) {
      this.#acceptBackoffDelay = INITIAL_ACCEPT_BACKOFF_DELAY;
    } else {
      this.#acceptBackoffDelay *= 2;
    }
    if (this.#acceptBackoffDelay >= 1e3) {
      this.#acceptBackoffDelay = MAX_ACCEPT_BACKOFF_DELAY;
    }
    await delay(this.#acceptBackoffDelay);
    this.#accept();
  }
  async #accept() {
    if (this.#closed) {
      return;
    }
    if (this.#connections > this.#backlog) {
      this.#acceptBackoff();
      return;
    }
    let connection;
    try {
      connection = await this.#listener.accept();
    } catch (e) {
      if (e instanceof workerDeno_errors.BadResource && this.#closed) {
        return;
      }
      try {
        this.onconnection(codeMap.get("UNKNOWN"), void 0);
      } catch {
      }
      this.#acceptBackoff();
      return;
    }
    this.#acceptBackoffDelay = void 0;
    const connectionHandle = new Pipe(socketType.SOCKET, connection);
    this.#connections++;
    try {
      this.onconnection(0, connectionHandle);
    } catch {
    }
    return this.#accept();
  }
  _onClose() {
    this.#closed = true;
    this.reading = false;
    this.#address = void 0;
    this.#backlog = void 0;
    this.#connections = 0;
    this.#acceptBackoffDelay = void 0;
    if (this.provider === providerType.PIPESERVERWRAP) {
      try {
        this.#listener.close();
      } catch {
      }
    }
    return LibuvStreamWrap.prototype._onClose.call(this);
  }
};
var PipeConnectWrap = class extends AsyncWrap {
  oncomplete;
  address;
  constructor() {
    super(providerType.PIPECONNECTWRAP);
  }
};
var constants2;
(function(constants5) {
  constants5[constants5["SOCKET"] = socketType.SOCKET] = "SOCKET";
  constants5[constants5["SERVER"] = socketType.SERVER] = "SERVER";
  constants5[constants5["IPC"] = socketType.IPC] = "IPC";
  constants5[constants5["UV_READABLE"] = 1] = "UV_READABLE";
  constants5[constants5["UV_WRITABLE"] = 2] = "UV_WRITABLE";
})(constants2 || (constants2 = {}));
var mod31 = {
  socketType,
  Pipe,
  PipeConnectWrap,
  constants: constants2
};
var mod32 = {};
var mod33 = {};
var mod34 = {};
var mod35 = {};
var mod36 = {};
var mod37 = {};
var mod38 = {};
var socketType1;
(function(socketType3) {
  socketType3[socketType3["SOCKET"] = 0] = "SOCKET";
  socketType3[socketType3["SERVER"] = 1] = "SERVER";
})(socketType1 || (socketType1 = {}));
var TCPConnectWrap = class extends AsyncWrap {
  oncomplete;
  address;
  port;
  localAddress;
  localPort;
  constructor() {
    super(providerType.TCPCONNECTWRAP);
  }
};
var constants3;
(function(constants6) {
  constants6[constants6["SOCKET"] = socketType1.SOCKET] = "SOCKET";
  constants6[constants6["SERVER"] = socketType1.SERVER] = "SERVER";
  constants6[constants6["UV_TCP_IPV6ONLY"] = 0] = "UV_TCP_IPV6ONLY";
})(constants3 || (constants3 = {}));
var TCP = class extends ConnectionWrap {
  [ownerSymbol] = null;
  reading = false;
  #address;
  #port;
  #remoteAddress;
  #remoteFamily;
  #remotePort;
  #backlog;
  #listener;
  #connections = 0;
  #closed = false;
  #acceptBackoffDelay;
  constructor(type, conn) {
    let provider;
    switch (type) {
      case socketType1.SOCKET: {
        provider = providerType.TCPWRAP;
        break;
      }
      case socketType1.SERVER: {
        provider = providerType.TCPSERVERWRAP;
        break;
      }
      default: {
        unreachable();
      }
    }
    super(provider, conn);
    if (conn && provider === providerType.TCPWRAP) {
      const localAddr = conn.localAddr;
      this.#address = localAddr.hostname;
      this.#port = localAddr.port;
      const remoteAddr = conn.remoteAddr;
      this.#remoteAddress = remoteAddr.hostname;
      this.#remotePort = remoteAddr.port;
      this.#remoteFamily = isIP(remoteAddr.hostname);
    }
  }
  open(_fd) {
    notImplemented("TCP.prototype.open");
  }
  bind(address, port) {
    return this.#bind(address, port, 0);
  }
  bind6(address, port, flags) {
    return this.#bind(address, port, flags);
  }
  connect(req16, address, port) {
    return this.#connect(req16, address, port);
  }
  connect6(req17, address, port) {
    return this.#connect(req17, address, port);
  }
  listen(backlog) {
    this.#backlog = ceilPowOf2(backlog + 1);
    const listenOptions = {
      hostname: this.#address,
      port: this.#port,
      transport: "tcp"
    };
    let listener;
    try {
      listener = define_Deno_default.listen(listenOptions);
    } catch (e) {
      if (e instanceof workerDeno_errors.AddrInUse) {
        return codeMap.get("EADDRINUSE");
      } else if (e instanceof workerDeno_errors.AddrNotAvailable) {
        return codeMap.get("EADDRNOTAVAIL");
      }
      return codeMap.get("UNKNOWN");
    }
    const address = listener.addr;
    this.#address = address.hostname;
    this.#port = address.port;
    this.#listener = listener;
    this.#accept();
    return 0;
  }
  ref() {
    if (this.#listener) {
      ListenerRef(this.#listener);
    }
  }
  unref() {
    if (this.#listener) {
      ListenerUnref(this.#listener);
    }
  }
  getsockname(sockname) {
    if (typeof this.#address === "undefined" || typeof this.#port === "undefined") {
      return codeMap.get("EADDRNOTAVAIL");
    }
    sockname.address = this.#address;
    sockname.port = this.#port;
    sockname.family = isIP(this.#address);
    return 0;
  }
  getpeername(peername) {
    if (typeof this.#remoteAddress === "undefined" || typeof this.#remotePort === "undefined") {
      return codeMap.get("EADDRNOTAVAIL");
    }
    peername.address = this.#remoteAddress;
    peername.port = this.#remotePort;
    peername.family = this.#remoteFamily;
    return 0;
  }
  setNoDelay(_noDelay) {
    return 0;
  }
  setKeepAlive(_enable, _initialDelay) {
    return 0;
  }
  setSimultaneousAccepts(_enable) {
    notImplemented("TCP.prototype.setSimultaneousAccepts");
  }
  #bind(address, port, _flags) {
    this.#address = address;
    this.#port = port;
    return 0;
  }
  #connect(req18, address1, port1) {
    this.#remoteAddress = address1;
    this.#remotePort = port1;
    this.#remoteFamily = isIP(address1);
    const connectOptions = {
      hostname: address1,
      port: port1,
      transport: "tcp"
    };
    define_Deno_default.connect(connectOptions).then((conn) => {
      const localAddr = conn.localAddr;
      this.#address = req18.localAddress = localAddr.hostname;
      this.#port = req18.localPort = localAddr.port;
      this[kStreamBaseField] = conn;
      try {
        this.afterConnect(req18, 0);
      } catch {
      }
    }, () => {
      try {
        this.afterConnect(req18, codeMap.get("ECONNREFUSED"));
      } catch {
      }
    });
    return 0;
  }
  async #acceptBackoff() {
    if (!this.#acceptBackoffDelay) {
      this.#acceptBackoffDelay = INITIAL_ACCEPT_BACKOFF_DELAY;
    } else {
      this.#acceptBackoffDelay *= 2;
    }
    if (this.#acceptBackoffDelay >= 1e3) {
      this.#acceptBackoffDelay = MAX_ACCEPT_BACKOFF_DELAY;
    }
    await delay(this.#acceptBackoffDelay);
    this.#accept();
  }
  async #accept() {
    if (this.#closed) {
      return;
    }
    if (this.#connections > this.#backlog) {
      this.#acceptBackoff();
      return;
    }
    let connection;
    try {
      connection = await this.#listener.accept();
    } catch (e) {
      if (e instanceof workerDeno_errors.BadResource && this.#closed) {
        return;
      }
      try {
        this.onconnection(codeMap.get("UNKNOWN"), void 0);
      } catch {
      }
      this.#acceptBackoff();
      return;
    }
    this.#acceptBackoffDelay = void 0;
    const connectionHandle = new TCP(socketType1.SOCKET, connection);
    this.#connections++;
    try {
      this.onconnection(0, connectionHandle);
    } catch {
    }
    return this.#accept();
  }
  _onClose() {
    this.#closed = true;
    this.reading = false;
    this.#address = void 0;
    this.#port = void 0;
    this.#remoteAddress = void 0;
    this.#remoteFamily = void 0;
    this.#remotePort = void 0;
    this.#backlog = void 0;
    this.#connections = 0;
    this.#acceptBackoffDelay = void 0;
    if (this.provider === providerType.TCPSERVERWRAP) {
      try {
        this.#listener.close();
      } catch {
      }
    }
    return LibuvStreamWrap.prototype._onClose.call(this);
  }
};
var mod39 = {
  TCPConnectWrap,
  constants: constants3,
  TCP
};
var mod40 = {};
var mod41 = {};
var mod42 = {};
var mod43 = {};
var AF_INET6 = 10;
var UDP_DGRAM_MAXSIZE = 64 * 1024;
var SendWrap = class extends AsyncWrap {
  list;
  address;
  port;
  callback;
  oncomplete;
  constructor() {
    super(providerType.UDPSENDWRAP);
  }
};
var UDP = class extends HandleWrap {
  [ownerSymbol] = null;
  #address;
  #family;
  #port;
  #remoteAddress;
  #remoteFamily;
  #remotePort;
  #listener;
  #receiving = false;
  #recvBufferSize = UDP_DGRAM_MAXSIZE;
  #sendBufferSize = UDP_DGRAM_MAXSIZE;
  onmessage;
  lookup;
  constructor() {
    super(providerType.UDPWRAP);
  }
  addMembership(_multicastAddress, _interfaceAddress) {
    notImplemented("udp.UDP.prototype.addMembership");
  }
  addSourceSpecificMembership(_sourceAddress, _groupAddress, _interfaceAddress) {
    notImplemented("udp.UDP.prototype.addSourceSpecificMembership");
  }
  bind(ip, port2, flags) {
    return this.#doBind(ip, port2, flags, 2);
  }
  bind6(ip, port3, flags) {
    return this.#doBind(ip, port3, flags, 10);
  }
  bufferSize(size, buffer, ctx) {
    let err;
    if (size > UDP_DGRAM_MAXSIZE) {
      err = "EINVAL";
    } else if (!this.#address) {
      err = isWindows ? "ENOTSOCK" : "EBADF";
    }
    if (err) {
      ctx.errno = codeMap.get(err);
      ctx.code = err;
      ctx.message = errorMap.get(ctx.errno)[1];
      ctx.syscall = buffer ? "uv_recv_buffer_size" : "uv_send_buffer_size";
      return;
    }
    if (size !== 0) {
      size = isLinux ? size * 2 : size;
      if (buffer) {
        return this.#recvBufferSize = size;
      }
      return this.#sendBufferSize = size;
    }
    return buffer ? this.#recvBufferSize : this.#sendBufferSize;
  }
  connect(ip, port4) {
    return this.#doConnect(ip, port4, 2);
  }
  connect6(ip, port5) {
    return this.#doConnect(ip, port5, 10);
  }
  disconnect() {
    this.#remoteAddress = void 0;
    this.#remotePort = void 0;
    this.#remoteFamily = void 0;
    return 0;
  }
  dropMembership(_multicastAddress, _interfaceAddress) {
    notImplemented("udp.UDP.prototype.dropMembership");
  }
  dropSourceSpecificMembership(_sourceAddress, _groupAddress, _interfaceAddress) {
    notImplemented("udp.UDP.prototype.dropSourceSpecificMembership");
  }
  getpeername(peername) {
    if (this.#remoteAddress === void 0) {
      return codeMap.get("EBADF");
    }
    peername.address = this.#remoteAddress;
    peername.port = this.#remotePort;
    peername.family = this.#remoteFamily;
    return 0;
  }
  getsockname(sockname) {
    if (this.#address === void 0) {
      return codeMap.get("EBADF");
    }
    sockname.address = this.#address;
    sockname.port = this.#port;
    sockname.family = this.#family;
    return 0;
  }
  open(_fd) {
    notImplemented("udp.UDP.prototype.open");
  }
  recvStart() {
    if (!this.#receiving) {
      this.#receiving = true;
      this.#receive();
    }
    return 0;
  }
  recvStop() {
    this.#receiving = false;
    return 0;
  }
  ref() {
    notImplemented("udp.UDP.prototype.ref");
  }
  send(req19, bufs, count, ...args) {
    return this.#doSend(req19, bufs, count, args, 2);
  }
  send6(req20, bufs, count, ...args) {
    return this.#doSend(req20, bufs, count, args, 10);
  }
  setBroadcast(_bool) {
    notImplemented("udp.UDP.prototype.setBroadcast");
  }
  setMulticastInterface(_interfaceAddress) {
    notImplemented("udp.UDP.prototype.setMulticastInterface");
  }
  setMulticastLoopback(_bool) {
    notImplemented("udp.UDP.prototype.setMulticastLoopback");
  }
  setMulticastTTL(_ttl) {
    notImplemented("udp.UDP.prototype.setMulticastTTL");
  }
  setTTL(_ttl) {
    notImplemented("udp.UDP.prototype.setTTL");
  }
  unref() {
    notImplemented("udp.UDP.prototype.unref");
  }
  #doBind(ip, port6, _flags1, family) {
    const listenOptions = {
      port: port6,
      hostname: ip,
      transport: "udp"
    };
    let listener;
    try {
      listener = listenDatagram(listenOptions);
    } catch (e) {
      if (e instanceof workerDeno_errors.AddrInUse) {
        return codeMap.get("EADDRINUSE");
      } else if (e instanceof workerDeno_errors.AddrNotAvailable) {
        return codeMap.get("EADDRNOTAVAIL");
      }
      return codeMap.get("UNKNOWN");
    }
    const address = listener.addr;
    this.#address = address.hostname;
    this.#port = address.port;
    this.#family = family === AF_INET6 ? "IPv6" : "IPv4";
    this.#listener = listener;
    return 0;
  }
  #doConnect(ip1, port11, family1) {
    this.#remoteAddress = ip1;
    this.#remotePort = port11;
    this.#remoteFamily = family1 === AF_INET6 ? "IPv6" : "IPv4";
    return 0;
  }
  #doSend(req21, bufs, _count, args, _family) {
    let hasCallback;
    if (args.length === 3) {
      this.#remotePort = args[0];
      this.#remoteAddress = args[1];
      hasCallback = args[2];
    } else {
      hasCallback = args[0];
    }
    const addr = {
      hostname: this.#remoteAddress,
      port: this.#remotePort,
      transport: "udp"
    };
    const payload = new Uint8Array(Buffer2.concat(bufs.map((buf) => {
      if (typeof buf === "string") {
        return Buffer2.from(buf);
      }
      return Buffer2.from(buf.buffer, buf.byteOffset, buf.byteLength);
    })));
    (async () => {
      let sent;
      let err = null;
      try {
        sent = await this.#listener.send(payload, addr);
      } catch (e) {
        if (e instanceof workerDeno_errors.BadResource) {
          err = codeMap.get("EBADF");
        } else if (e instanceof Error && e.message.match(/os error (40|90|10040)/)) {
          err = codeMap.get("EMSGSIZE");
        } else {
          err = codeMap.get("UNKNOWN");
        }
        sent = 0;
      }
      if (hasCallback) {
        try {
          req21.oncomplete(err, sent);
        } catch {
        }
      }
    })();
    return 0;
  }
  async #receive() {
    if (!this.#receiving) {
      return;
    }
    const p = new Uint8Array(this.#recvBufferSize);
    let buf;
    let remoteAddr;
    let nread;
    try {
      [buf, remoteAddr] = await this.#listener.receive(p);
      nread = buf.length;
    } catch (e) {
      if (e instanceof workerDeno_errors.Interrupted || e instanceof workerDeno_errors.BadResource) {
        nread = 0;
      } else {
        nread = codeMap.get("UNKNOWN");
      }
      buf = new Uint8Array(0);
      remoteAddr = null;
    }
    nread ??= 0;
    const rinfo = remoteAddr ? {
      address: remoteAddr.hostname,
      port: remoteAddr.port,
      family: isIP(remoteAddr.hostname) === 6 ? "IPv6" : "IPv4"
    } : void 0;
    try {
      this.onmessage(nread, this, Buffer2.from(buf), rinfo);
    } catch {
    }
    this.#receive();
  }
  _onClose() {
    this.#receiving = false;
    this.#address = void 0;
    this.#port = void 0;
    this.#family = void 0;
    try {
      this.#listener.close();
    } catch {
    }
    this.#listener = void 0;
    return 0;
  }
};
var mod44 = {
  SendWrap,
  UDP
};
var mod45 = {};
var mod46 = {};
var mod47 = {};
var mod48 = {};
var modules = {
  "async_wrap": mod6,
  buffer: mod5,
  "cares_wrap": mod12,
  config: mod11,
  constants: mod2,
  contextify: mod13,
  credentials: mod15,
  crypto: mod14,
  errors: mod16,
  fs: mod17,
  "fs_dir": mod18,
  "fs_event_wrap": mod19,
  "heap_utils": mod20,
  "http_parser": mod21,
  icu: mod22,
  inspector: mod23,
  "js_stream": mod24,
  messaging: mod25,
  "module_wrap": mod26,
  "native_module": mod27,
  natives: mod28,
  options: mod29,
  os: mod30,
  performance: mod32,
  "pipe_wrap": mod31,
  "process_methods": mod33,
  report: mod34,
  serdes: mod35,
  "signal_wrap": mod36,
  "spawn_sync": mod37,
  "stream_wrap": mod8,
  "string_decoder": mod4,
  symbols: mod7,
  "task_queue": mod38,
  "tcp_wrap": mod39,
  timers: mod40,
  "tls_wrap": mod41,
  "trace_events": mod42,
  "tty_wrap": mod43,
  types: mod,
  "udp_wrap": mod44,
  url: mod45,
  util: mod1,
  uv: mod3,
  v8: mod46,
  worker: mod47,
  zlib: mod48
};
function getBinding(name) {
  const mod49 = modules[name];
  if (!mod49) {
    throw new Error(`No such module: ${name}`);
  }
  return mod49;
}
var kInternal = Symbol("internal properties");
var replaceUnderscoresRegex = /_/g;
var leadingDashesRegex = /^--?/;
var trailingValuesRegex = /=.*$/;
function buildAllowedFlags() {
  const allowedNodeEnvironmentFlags = [
    "--track-heap-objects",
    "--no-track-heap-objects",
    "--node-snapshot",
    "--no-node-snapshot",
    "--require",
    "--max-old-space-size",
    "--trace-exit",
    "--no-trace-exit",
    "--disallow-code-generation-from-strings",
    "--experimental-json-modules",
    "--no-experimental-json-modules",
    "--interpreted-frames-native-stack",
    "--inspect-brk",
    "--no-inspect-brk",
    "--trace-tls",
    "--no-trace-tls",
    "--stack-trace-limit",
    "--experimental-repl-await",
    "--no-experimental-repl-await",
    "--preserve-symlinks",
    "--no-preserve-symlinks",
    "--report-uncaught-exception",
    "--no-report-uncaught-exception",
    "--experimental-modules",
    "--no-experimental-modules",
    "--report-signal",
    "--jitless",
    "--inspect-port",
    "--heapsnapshot-near-heap-limit",
    "--tls-keylog",
    "--force-context-aware",
    "--no-force-context-aware",
    "--napi-modules",
    "--abort-on-uncaught-exception",
    "--diagnostic-dir",
    "--verify-base-objects",
    "--no-verify-base-objects",
    "--unhandled-rejections",
    "--perf-basic-prof",
    "--trace-atomics-wait",
    "--no-trace-atomics-wait",
    "--deprecation",
    "--no-deprecation",
    "--perf-basic-prof-only-functions",
    "--perf-prof",
    "--max-http-header-size",
    "--report-on-signal",
    "--no-report-on-signal",
    "--throw-deprecation",
    "--no-throw-deprecation",
    "--warnings",
    "--no-warnings",
    "--force-fips",
    "--no-force-fips",
    "--pending-deprecation",
    "--no-pending-deprecation",
    "--input-type",
    "--tls-max-v1.3",
    "--no-tls-max-v1.3",
    "--tls-min-v1.2",
    "--no-tls-min-v1.2",
    "--inspect",
    "--no-inspect",
    "--heapsnapshot-signal",
    "--trace-warnings",
    "--no-trace-warnings",
    "--trace-event-categories",
    "--experimental-worker",
    "--tls-max-v1.2",
    "--no-tls-max-v1.2",
    "--perf-prof-unwinding-info",
    "--preserve-symlinks-main",
    "--no-preserve-symlinks-main",
    "--policy-integrity",
    "--experimental-wasm-modules",
    "--no-experimental-wasm-modules",
    "--node-memory-debug",
    "--inspect-publish-uid",
    "--tls-min-v1.3",
    "--no-tls-min-v1.3",
    "--experimental-specifier-resolution",
    "--secure-heap",
    "--tls-min-v1.0",
    "--no-tls-min-v1.0",
    "--redirect-warnings",
    "--experimental-report",
    "--trace-event-file-pattern",
    "--trace-uncaught",
    "--no-trace-uncaught",
    "--experimental-loader",
    "--http-parser",
    "--dns-result-order",
    "--trace-sigint",
    "--no-trace-sigint",
    "--secure-heap-min",
    "--enable-fips",
    "--no-enable-fips",
    "--enable-source-maps",
    "--no-enable-source-maps",
    "--insecure-http-parser",
    "--no-insecure-http-parser",
    "--use-openssl-ca",
    "--no-use-openssl-ca",
    "--tls-cipher-list",
    "--experimental-top-level-await",
    "--no-experimental-top-level-await",
    "--openssl-config",
    "--icu-data-dir",
    "--v8-pool-size",
    "--report-on-fatalerror",
    "--no-report-on-fatalerror",
    "--title",
    "--tls-min-v1.1",
    "--no-tls-min-v1.1",
    "--report-filename",
    "--trace-deprecation",
    "--no-trace-deprecation",
    "--report-compact",
    "--no-report-compact",
    "--experimental-policy",
    "--experimental-import-meta-resolve",
    "--no-experimental-import-meta-resolve",
    "--zero-fill-buffers",
    "--no-zero-fill-buffers",
    "--report-dir",
    "--use-bundled-ca",
    "--no-use-bundled-ca",
    "--experimental-vm-modules",
    "--no-experimental-vm-modules",
    "--force-async-hooks-checks",
    "--no-force-async-hooks-checks",
    "--frozen-intrinsics",
    "--no-frozen-intrinsics",
    "--huge-max-old-generation-size",
    "--disable-proto",
    "--debug-arraybuffer-allocations",
    "--no-debug-arraybuffer-allocations",
    "--conditions",
    "--experimental-wasi-unstable-preview1",
    "--no-experimental-wasi-unstable-preview1",
    "--trace-sync-io",
    "--no-trace-sync-io",
    "--use-largepages",
    "--experimental-abortcontroller",
    "--debug-port",
    "--es-module-specifier-resolution",
    "--prof-process",
    "-C",
    "--loader",
    "--report-directory",
    "-r",
    "--trace-events-enabled"
  ];
  const trimLeadingDashes = (flag) => flag.replace(leadingDashesRegex, "");
  const nodeFlags = allowedNodeEnvironmentFlags.map(trimLeadingDashes);
  class NodeEnvironmentFlagsSet extends Set {
    constructor(array) {
      super();
      this[kInternal] = {
        array
      };
    }
    add() {
      return this;
    }
    delete() {
      return false;
    }
    clear() {
    }
    has(key) {
      if (typeof key === "string") {
        key = key.replace(replaceUnderscoresRegex, "-");
        if (leadingDashesRegex.test(key)) {
          key = key.replace(trailingValuesRegex, "");
          return this[kInternal].array.includes(key);
        }
        return nodeFlags.includes(key);
      }
      return false;
    }
    entries() {
      this[kInternal].set ??= new Set(this[kInternal].array);
      return this[kInternal].set.entries();
    }
    forEach(callback, thisArg = void 0) {
      this[kInternal].array.forEach((v) => Reflect.apply(callback, thisArg, [
        v,
        v,
        this
      ]));
    }
    get size() {
      return this[kInternal].array.length;
    }
    values() {
      this[kInternal].set ??= new Set(this[kInternal].array);
      return this[kInternal].set.values();
    }
  }
  NodeEnvironmentFlagsSet.prototype.keys = NodeEnvironmentFlagsSet.prototype[Symbol.iterator] = NodeEnvironmentFlagsSet.prototype.values;
  Object.freeze(NodeEnvironmentFlagsSet.prototype.constructor);
  Object.freeze(NodeEnvironmentFlagsSet.prototype);
  return Object.freeze(new NodeEnvironmentFlagsSet(allowedNodeEnvironmentFlags));
}
var notImplementedEvents = [
  "beforeExit",
  "disconnect",
  "message",
  "multipleResolves",
  "rejectionHandled",
  "uncaughtException",
  "uncaughtExceptionMonitor",
  "unhandledRejection",
  "worker"
];
var argv = [
  "",
  "",
  ...workerDeno_args
];
Object.defineProperty(argv, "0", {
  get: workerDeno_execPath
});
Object.defineProperty(argv, "1", {
  get: () => fromFileUrl2(workerDeno_mainModule)
});
var exit = (code) => {
  if (code || code === 0) {
    if (typeof code === "string") {
      const parsedCode = parseInt(code);
      process1.exitCode = isNaN(parsedCode) ? void 0 : parsedCode;
    } else {
      process1.exitCode = code;
    }
  }
  if (!process1._exiting) {
    process1._exiting = true;
    process1.emit("exit", process1.exitCode || 0);
  }
  define_Deno_default.exit(process1.exitCode || 0);
};
function addReadOnlyProcessAlias(name, option, enumerable = true) {
  const value = getOptionValue(option);
  if (value) {
    Object.defineProperty(process1, name, {
      writable: false,
      configurable: true,
      enumerable,
      value
    });
  }
}
function createWarningObject(warning, type, code, ctor, detail) {
  assert(typeof warning === "string");
  const warningErr = new Error(warning);
  warningErr.name = String(type || "Warning");
  if (code !== void 0) {
    warningErr.code = code;
  }
  if (detail !== void 0) {
    warningErr.detail = detail;
  }
  Error.captureStackTrace(warningErr, ctor || process1.emitWarning);
  return warningErr;
}
function doEmitWarning(warning) {
  process1.emit("warning", warning);
}
function emitWarning(warning, type, code, ctor) {
  let detail;
  if (type !== null && typeof type === "object" && !Array.isArray(type)) {
    ctor = type.ctor;
    code = type.code;
    if (typeof type.detail === "string") {
      detail = type.detail;
    }
    type = type.type || "Warning";
  } else if (typeof type === "function") {
    ctor = type;
    code = void 0;
    type = "Warning";
  }
  if (type !== void 0) {
    validateString(type, "type");
  }
  if (typeof code === "function") {
    ctor = code;
    code = void 0;
  } else if (code !== void 0) {
    validateString(code, "code");
  }
  if (typeof warning === "string") {
    warning = createWarningObject(warning, type, code, ctor, detail);
  } else if (!(warning instanceof Error)) {
    throw new ERR_INVALID_ARG_TYPE("warning", [
      "Error",
      "string"
    ], warning);
  }
  if (warning.name === "DeprecationWarning") {
    if (process1.noDeprecation) {
      return;
    }
    if (process1.throwDeprecation) {
      return process1.nextTick(() => {
        throw warning;
      });
    }
  }
  process1.nextTick(doEmitWarning, warning);
}
function hrtime(time) {
  const milli = performance.now();
  const sec = Math.floor(milli / 1e3);
  const nano = Math.floor(milli * 1e6 - sec * 1e9);
  if (!time) {
    return [
      sec,
      nano
    ];
  }
  const [prevSec, prevNano] = time;
  return [
    sec - prevSec,
    nano - prevNano
  ];
}
hrtime.bigint = function() {
  const [sec, nano] = hrtime();
  return BigInt(sec) * 1000000000n + BigInt(nano);
};
function memoryUsage() {
  return {
    ...workerDeno_memoryUsage(),
    arrayBuffers: 0
  };
}
memoryUsage.rss = function() {
  return memoryUsage().rss;
};
function kill(pid1, sig = "SIGTERM") {
  if (pid1 != (pid1 | 0)) {
    throw new ERR_INVALID_ARG_TYPE("pid", "number", pid1);
  }
  if (typeof sig === "string") {
    try {
      define_Deno_default.kill(pid1, sig);
    } catch (e) {
      if (e instanceof TypeError) {
        throw new ERR_UNKNOWN_SIGNAL(sig);
      }
      throw e;
    }
  } else {
    throw new ERR_UNKNOWN_SIGNAL(sig.toString());
  }
  return true;
}
var Process = class extends EventEmitter {
  constructor() {
    super();
    workerGlobal_addEventListener("unload", () => {
      if (!process1._exiting) {
        process1._exiting = true;
        super.emit("exit", process1.exitCode || 0);
      }
    });
  }
  arch = arch;
  argv = argv;
  chdir = chdir;
  config = {
    target_defaults: {},
    variables: {}
  };
  cwd = cwd;
  env = env;
  execArgv = [];
  exit = exit;
  _exiting = _exiting;
  exitCode = void 0;
  mainModule = void 0;
  nextTick = nextTick2;
  on(event, listener) {
    if (notImplementedEvents.includes(event)) {
      warnNotImplemented(`process.on("${event}")`);
      super.on(event, listener);
    } else if (event.startsWith("SIG")) {
      if (event === "SIGBREAK" && workerDeno_build.os !== "windows") {
      } else {
        addSignalListener(event, listener);
      }
    } else {
      super.on(event, listener);
    }
    return this;
  }
  off(event, listener) {
    if (notImplementedEvents.includes(event)) {
      warnNotImplemented(`process.off("${event}")`);
      super.off(event, listener);
    } else if (event.startsWith("SIG")) {
      if (event === "SIGBREAK" && workerDeno_build.os !== "windows") {
      } else {
        removeSignalListener(event, listener);
      }
    } else {
      super.off(event, listener);
    }
    return this;
  }
  emit(event, ...args1) {
    if (event.startsWith("SIG")) {
      if (event === "SIGBREAK" && workerDeno_build.os !== "windows") {
      } else {
        define_Deno_default.kill(workerDeno_pid, event);
      }
    } else {
      return super.emit(event, ...args1);
    }
    return true;
  }
  prependListener(event, listener) {
    if (notImplementedEvents.includes(event)) {
      warnNotImplemented(`process.prependListener("${event}")`);
      super.prependListener(event, listener);
    } else if (event.startsWith("SIG")) {
      if (event === "SIGBREAK" && workerDeno_build.os !== "windows") {
      } else {
        addSignalListener(event, listener);
      }
    } else {
      super.prependListener(event, listener);
    }
    return this;
  }
  pid = pid;
  platform = platform;
  addListener(event, listener) {
    if (notImplementedEvents.includes(event)) {
      warnNotImplemented(`process.addListener("${event}")`);
    }
    return this.on(event, listener);
  }
  removeListener(event, listener) {
    if (notImplementedEvents.includes(event)) {
      warnNotImplemented(`process.removeListener("${event}")`);
    }
    return this.off(event, listener);
  }
  hrtime = hrtime;
  kill = kill;
  memoryUsage = memoryUsage;
  stderr = stderr;
  stdin = stdin;
  stdout = stdout;
  version = version;
  versions = versions;
  emitWarning = emitWarning;
  binding(name) {
    return getBinding(name);
  }
  umask() {
    return 18;
  }
  getuid() {
    return NaN;
  }
  getgid() {
    return NaN;
  }
  _eval = void 0;
  get execPath() {
    return argv[0];
  }
  #startTime = Date.now();
  uptime() {
    return (Date.now() - this.#startTime) / 1e3;
  }
  #allowedFlags = buildAllowedFlags();
  get allowedNodeEnvironmentFlags() {
    return this.#allowedFlags;
  }
  features = {
    inspector: false
  };
};
var process1 = new Process();
Object.defineProperty(process1, Symbol.toStringTag, {
  enumerable: false,
  writable: true,
  configurable: false,
  value: "process"
});
addReadOnlyProcessAlias("noDeprecation", "--no-deprecation");
addReadOnlyProcessAlias("throwDeprecation", "--throw-deprecation");
process1.removeListener;
process1.removeAllListeners;
var TIMEOUT_MAX = 2 ** 31 - 1;
var kTimerId = Symbol("timerId");
var kTimeout = Symbol("timeout");
var kRefed = Symbol("refed");
function Timeout(id) {
  this[kTimerId] = id;
  this[kRefed] = true;
}
Timeout.prototype[inspect.custom] = function(_, options) {
  return inspect(this, {
    ...options,
    depth: 0,
    customInspect: false
  });
};
Timeout.prototype.refresh = function() {
  notImplemented();
};
Timeout.prototype.unref = function() {
  if (this[kRefed]) {
    this[kRefed] = false;
    define_Deno_default.unrefTimer(this[kTimerId]);
  }
  return this;
};
Timeout.prototype.ref = function() {
  if (!this[kRefed]) {
    this[kRefed] = true;
    define_Deno_default.refTimer(this[kTimerId]);
  }
  return this;
};
Timeout.prototype.hasRef = function() {
  return this[kRefed];
};
Timeout.prototype[Symbol.toPrimitive] = function() {
  return this[kTimerId];
};
function getTimerDuration(msecs, name) {
  validateNumber(msecs, name);
  if (msecs < 0 || !Number.isFinite(msecs)) {
    throw new ERR_OUT_OF_RANGE(name, "a non-negative finite number", msecs);
  }
  if (msecs > TIMEOUT_MAX) {
    emitWarning(`${msecs} does not fit into a 32-bit signed integer.
Timer duration was truncated to ${TIMEOUT_MAX}.`, "TimeoutOverflowWarning");
    return TIMEOUT_MAX;
  }
  return msecs;
}
var setTimeout_ = globalThis.setTimeout;
globalThis.clearTimeout;
globalThis.setInterval;
globalThis.clearInterval;
function setTimeout1(cb, timeout, ...args1) {
  validateCallback(cb);
  if (typeof timeout === "number" && timeout > TIMEOUT_MAX) {
    timeout = 1;
  }
  const timer = new Timeout(setTimeout_((...args2) => {
    cb.bind(timer)(...args2);
  }, timeout, ...args1));
  return timer;
}
Object.defineProperty(setTimeout1, promisify.custom, {
  value: (timeout, ...args3) => {
    return new Promise((cb) => setTimeout1(cb, timeout, ...args3));
  },
  enumerable: true
});
function setUnrefTimeout(cb, timeout, ...args4) {
  setTimeout1(cb, timeout, ...args4).unref();
}
var kMaybeDestroy = Symbol("kMaybeDestroy");
var kUpdateTimer = Symbol("kUpdateTimer");
var kAfterAsyncWrite = Symbol("kAfterAsyncWrite");
var kHandle = Symbol("kHandle");
var kSession = Symbol("kSession");
var kBuffer = Symbol("kBuffer");
var kBufferGen = Symbol("kBufferGen");
var kBufferCb = Symbol("kBufferCb");
function handleWriteReq(req22, data1, encoding) {
  const { handle } = req22;
  switch (encoding) {
    case "buffer": {
      const ret = handle.writeBuffer(req22, data1);
      if (streamBaseState[kLastWriteWasAsync]) {
        req22.buffer = data1;
      }
      return ret;
    }
    case "latin1":
    case "binary":
      return handle.writeLatin1String(req22, data1);
    case "utf8":
    case "utf-8":
      return handle.writeUtf8String(req22, data1);
    case "ascii":
      return handle.writeAsciiString(req22, data1);
    case "ucs2":
    case "ucs-2":
    case "utf16le":
    case "utf-16le":
      return handle.writeUcs2String(req22, data1);
    default: {
      const buffer = Buffer2.from(data1, encoding);
      const ret = handle.writeBuffer(req22, buffer);
      if (streamBaseState[kLastWriteWasAsync]) {
        req22.buffer = buffer;
      }
      return ret;
    }
  }
}
function onWriteComplete(status) {
  let stream2 = this.handle[ownerSymbol];
  if (stream2.constructor.name === "ReusedHandle") {
    stream2 = stream2.handle;
  }
  if (stream2.destroyed) {
    if (typeof this.callback === "function") {
      this.callback(null);
    }
    return;
  }
  if (status < 0) {
    const ex = errnoException(status, "write", this.error);
    if (typeof this.callback === "function") {
      this.callback(ex);
    } else {
      stream2.destroy(ex);
    }
    return;
  }
  stream2[kUpdateTimer]();
  stream2[kAfterAsyncWrite](this);
  if (typeof this.callback === "function") {
    this.callback(null);
  }
}
function createWriteWrap(handle, callback) {
  const req23 = new WriteWrap();
  req23.handle = handle;
  req23.oncomplete = onWriteComplete;
  req23.async = false;
  req23.bytes = 0;
  req23.buffer = null;
  req23.callback = callback;
  return req23;
}
function writevGeneric(owner, data2, cb) {
  const req24 = createWriteWrap(owner[kHandle], cb);
  const allBuffers = data2.allBuffers;
  let chunks;
  if (allBuffers) {
    chunks = data2;
    for (let i92 = 0; i92 < data2.length; i92++) {
      data2[i92] = data2[i92].chunk;
    }
  } else {
    chunks = new Array(data2.length << 1);
    for (let i93 = 0; i93 < data2.length; i93++) {
      const entry = data2[i93];
      chunks[i93 * 2] = entry.chunk;
      chunks[i93 * 2 + 1] = entry.encoding;
    }
  }
  const err = req24.handle.writev(req24, chunks, allBuffers);
  if (err === 0) {
    req24._chunks = chunks;
  }
  afterWriteDispatched(req24, err, cb);
  return req24;
}
function writeGeneric(owner, data3, encoding, cb) {
  const req25 = createWriteWrap(owner[kHandle], cb);
  const err = handleWriteReq(req25, data3, encoding);
  afterWriteDispatched(req25, err, cb);
  return req25;
}
function afterWriteDispatched(req26, err, cb) {
  req26.bytes = streamBaseState[kBytesWritten];
  req26.async = !!streamBaseState[kLastWriteWasAsync];
  if (err !== 0) {
    return cb(errnoException(err, "write", req26.error));
  }
  if (!req26.async && typeof req26.callback === "function") {
    req26.callback();
  }
}
function onStreamRead(arrayBuffer, nread) {
  const handle = this;
  let stream3 = this[ownerSymbol];
  if (stream3.constructor.name === "ReusedHandle") {
    stream3 = stream3.handle;
  }
  stream3[kUpdateTimer]();
  if (nread > 0 && !stream3.destroyed) {
    let ret;
    let result;
    const userBuf = stream3[kBuffer];
    if (userBuf) {
      result = stream3[kBufferCb](nread, userBuf) !== false;
      const bufGen = stream3[kBufferGen];
      if (bufGen !== null) {
        const nextBuf = bufGen();
        if (isUint8Array(nextBuf)) {
          stream3[kBuffer] = ret = nextBuf;
        }
      }
    } else {
      const offset = streamBaseState[kArrayBufferOffset];
      const buf = Buffer2.from(arrayBuffer, offset, nread);
      result = stream3.push(buf);
    }
    if (!result) {
      handle.reading = false;
      if (!stream3.destroyed) {
        const err = handle.readStop();
        if (err) {
          stream3.destroy(errnoException(err, "read"));
        }
      }
    }
    return ret;
  }
  if (nread === 0) {
    return;
  }
  if (nread !== codeMap.get("EOF")) {
    stream3.destroy(errnoException(nread, "read"));
    return;
  }
  if (stream3._readableState.endEmitted) {
    if (stream3[kMaybeDestroy]) {
      stream3[kMaybeDestroy]();
    }
  } else {
    if (stream3[kMaybeDestroy]) {
      stream3.on("end", stream3[kMaybeDestroy]);
    }
    if (handle.readStop) {
      const err = handle.readStop();
      if (err) {
        stream3.destroy(errnoException(err, "read"));
        return;
      }
    }
    stream3.push(null);
    stream3.read(0);
  }
}
function setStreamTimeout(msecs, callback) {
  if (this.destroyed) {
    return this;
  }
  this.timeout = msecs;
  msecs = getTimerDuration(msecs, "msecs");
  clearTimeout(this[kTimeout]);
  if (msecs === 0) {
    if (callback !== void 0) {
      validateCallback(callback);
      this.removeListener("timeout", callback);
    }
  } else {
    this[kTimeout] = setUnrefTimeout(this._onTimeout.bind(this), msecs);
    if (this[kSession]) {
      this[kSession][kUpdateTimer]();
    }
    if (callback !== void 0) {
      validateCallback(callback);
      this.once("timeout", callback);
    }
  }
  return this;
}
var { DTRACE_HTTP_CLIENT_REQUEST = (..._args) => {
}, DTRACE_HTTP_CLIENT_RESPONSE = (..._args) => {
}, DTRACE_HTTP_SERVER_REQUEST = (..._args) => {
}, DTRACE_HTTP_SERVER_RESPONSE = (..._args) => {
}, DTRACE_NET_SERVER_CONNECTION = (..._args) => {
}, DTRACE_NET_STREAM_END = (..._args) => {
} } = {};
function isLookupOptions(options) {
  return typeof options === "object" || typeof options === "undefined";
}
function isLookupCallback(options) {
  return typeof options === "function";
}
function isFamily(options) {
  return typeof options === "number";
}
function isResolveCallback(callback) {
  return typeof callback === "function";
}
var IPv6RE = /^\[([^[\]]*)\]/;
var addrSplitRE = /(^.+?)(?::(\d+))?$/;
function validateTimeout(options) {
  const { timeout = -1 } = {
    ...options
  };
  validateInt32(timeout, "options.timeout", -1, 2 ** 31 - 1);
  return timeout;
}
function validateTries(options) {
  const { tries = 4 } = {
    ...options
  };
  validateInt32(tries, "options.tries", 1, 2 ** 31 - 1);
  return tries;
}
var Resolver = class {
  _handle;
  constructor(options) {
    const timeout = validateTimeout(options);
    const tries = validateTries(options);
    this._handle = new ChannelWrap(timeout, tries);
  }
  cancel() {
    this._handle.cancel();
  }
  getServers() {
    return this._handle.getServers().map((val) => {
      if (!val[1] || val[1] === 53) {
        return val[0];
      }
      const host = isIP(val[0]) === 6 ? `[${val[0]}]` : val[0];
      return `${host}:${val[1]}`;
    });
  }
  setServers(servers) {
    validateArray(servers, "servers");
    const orig = this._handle.getServers();
    const newSet = [];
    servers.forEach((serv, index) => {
      validateString(serv, `servers[${index}]`);
      let ipVersion = isIP(serv);
      if (ipVersion !== 0) {
        return newSet.push([
          ipVersion,
          serv,
          53
        ]);
      }
      const match = serv.match(IPv6RE);
      if (match) {
        ipVersion = isIP(match[1]);
        if (ipVersion !== 0) {
          const port7 = Number.parseInt(serv.replace(addrSplitRE, "$2")) || 53;
          return newSet.push([
            ipVersion,
            match[1],
            port7
          ]);
        }
      }
      const addrSplitMatch = serv.match(addrSplitRE);
      if (addrSplitMatch) {
        const hostIP = addrSplitMatch[1];
        const port8 = addrSplitMatch[2] || `${53}`;
        ipVersion = isIP(hostIP);
        if (ipVersion !== 0) {
          return newSet.push([
            ipVersion,
            hostIP,
            Number.parseInt(port8)
          ]);
        }
      }
      throw new ERR_INVALID_IP_ADDRESS(serv);
    });
    const errorNumber = this._handle.setServers(newSet);
    if (errorNumber !== 0) {
      this._handle.setServers(orig.join(","));
      const err = strerror(errorNumber);
      throw new ERR_DNS_SET_SERVERS_FAILED(err, servers.toString());
    }
  }
  setLocalAddress(ipv4, ipv6) {
    validateString(ipv4, "ipv4");
    if (ipv6 !== void 0) {
      validateString(ipv6, "ipv6");
    }
    this._handle.setLocalAddress(ipv4, ipv6);
  }
};
var defaultResolver = new Resolver();
function getDefaultResolver() {
  return defaultResolver;
}
function setDefaultResolver(resolver3) {
  defaultResolver = resolver3;
}
function validateHints(hints) {
  if ((hints & ~(AI_ADDRCONFIG | AI_ALL | AI_V4MAPPED)) !== 0) {
    throw new ERR_INVALID_ARG_VALUE("hints", hints, "is invalid");
  }
}
var invalidHostnameWarningEmitted = false;
function emitInvalidHostnameWarning(hostname) {
  if (invalidHostnameWarningEmitted) {
    return;
  }
  invalidHostnameWarningEmitted = true;
  emitWarning(`The provided hostname "${hostname}" is not a valid hostname, and is supported in the dns module solely for compatibility.`, "DeprecationWarning", "DEP0118");
}
var dnsOrder = getOptionValue("--dns-result-order") || "ipv4first";
function getDefaultVerbatim() {
  switch (dnsOrder) {
    case "verbatim": {
      return true;
    }
    case "ipv4first": {
      return false;
    }
    default: {
      return false;
    }
  }
}
function setDefaultResultOrder(order) {
  validateOneOf(order, "dnsOrder", [
    "verbatim",
    "ipv4first"
  ]);
  dnsOrder = order;
}
var base = 36;
var damp = 700;
var delimiter3 = "-";
var regexNonASCII = /[^\0-\x7E]/;
var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g;
var errors = {
  "overflow": "Overflow: input needs wider integers to process",
  "not-basic": "Illegal input >= 0x80 (not a basic code point)",
  "invalid-input": "Invalid input"
};
var baseMinusTMin = 36 - 1;
function error(type) {
  throw new RangeError(errors[type]);
}
function mapDomain(str, fn) {
  const parts = str.split("@");
  let result = "";
  if (parts.length > 1) {
    result = parts[0] + "@";
    str = parts[1];
  }
  str = str.replace(regexSeparators, ".");
  const labels = str.split(".");
  const encoded = labels.map(fn).join(".");
  return result + encoded;
}
function ucs2decode(str) {
  const output = [];
  let counter = 0;
  const length = str.length;
  while (counter < length) {
    const value = str.charCodeAt(counter++);
    if (value >= 55296 && value <= 56319 && counter < length) {
      const extra = str.charCodeAt(counter++);
      if ((extra & 64512) == 56320) {
        output.push(((value & 1023) << 10) + (extra & 1023) + 65536);
      } else {
        output.push(value);
        counter--;
      }
    } else {
      output.push(value);
    }
  }
  return output;
}
function digitToBasic(digit, flag) {
  return digit + 22 + 75 * Number(digit < 26) - (Number(flag != 0) << 5);
}
function adapt(delta, numPoints, firstTime) {
  let k = 0;
  delta = firstTime ? Math.floor(delta / damp) : delta >> 1;
  delta += Math.floor(delta / numPoints);
  for (; delta > baseMinusTMin * 26 >> 1; k += base) {
    delta = Math.floor(delta / baseMinusTMin);
  }
  return Math.floor(k + (baseMinusTMin + 1) * delta / (delta + 38));
}
function encode2(str) {
  const output = [];
  const input = ucs2decode(str);
  const inputLength = input.length;
  let n = 128;
  let delta = 0;
  let bias = 72;
  for (const currentValue of input) {
    if (currentValue < 128) {
      output.push(String.fromCharCode(currentValue));
    }
  }
  const basicLength = output.length;
  let handledCPCount = basicLength;
  if (basicLength) {
    output.push(delimiter3);
  }
  while (handledCPCount < inputLength) {
    let m = 2147483647;
    for (const currentValue of input) {
      if (currentValue >= n && currentValue < m) {
        m = currentValue;
      }
    }
    const handledCPCountPlusOne = handledCPCount + 1;
    if (m - n > Math.floor((2147483647 - delta) / handledCPCountPlusOne)) {
      error("overflow");
    }
    delta += (m - n) * handledCPCountPlusOne;
    n = m;
    for (const currentValue1 of input) {
      if (currentValue1 < n && ++delta > 2147483647) {
        error("overflow");
      }
      if (currentValue1 == n) {
        let q = delta;
        for (let k = 36; ; k += base) {
          const t = k <= bias ? 1 : k >= bias + 26 ? 26 : k - bias;
          if (q < t) {
            break;
          }
          const qMinusT = q - t;
          const baseMinusT = 36 - t;
          output.push(String.fromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0)));
          q = Math.floor(qMinusT / baseMinusT);
        }
        output.push(String.fromCharCode(digitToBasic(q, 0)));
        bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
        delta = 0;
        ++handledCPCount;
      }
    }
    ++delta;
    ++n;
  }
  return output.join("");
}
function toASCII(input) {
  return mapDomain(input, function(str) {
    return regexNonASCII.test(str) ? "xn--" + encode2(str) : str;
  });
}
function onlookup(err, addresses) {
  if (err) {
    this.reject(dnsException(err, "getaddrinfo", this.hostname));
    return;
  }
  const family2 = this.family || isIP(addresses[0]);
  this.resolve({
    address: addresses[0],
    family: family2
  });
}
function onlookupall(err, addresses) {
  if (err) {
    this.reject(dnsException(err, "getaddrinfo", this.hostname));
    return;
  }
  const family3 = this.family;
  const parsedAddresses = [];
  for (let i94 = 0; i94 < addresses.length; i94++) {
    const address2 = addresses[i94];
    parsedAddresses[i94] = {
      address: address2,
      family: family3 ? family3 : isIP(address2)
    };
  }
  this.resolve(parsedAddresses);
}
function createLookupPromise(family4, hostname, all, hints, verbatim) {
  return new Promise((resolve16, reject) => {
    if (!hostname) {
      emitInvalidHostnameWarning(hostname);
      resolve16(all ? [] : {
        address: null,
        family: family4 === 6 ? 6 : 4
      });
      return;
    }
    const matchedFamily = isIP(hostname);
    if (matchedFamily !== 0) {
      const result = {
        address: hostname,
        family: matchedFamily
      };
      resolve16(all ? [
        result
      ] : result);
      return;
    }
    const req27 = new GetAddrInfoReqWrap();
    req27.family = family4;
    req27.hostname = hostname;
    req27.oncomplete = all ? onlookupall : onlookup;
    req27.resolve = resolve16;
    req27.reject = reject;
    const err = getaddrinfo(req27, toASCII(hostname), family4, hints, verbatim);
    if (err) {
      reject(dnsException(err, "getaddrinfo", hostname));
    }
  });
}
var validFamilies = [
  0,
  4,
  6
];
function lookup(hostname, options) {
  let hints = 0;
  let family5 = 0;
  let all = false;
  let verbatim = getDefaultVerbatim();
  if (hostname) {
    validateString(hostname, "hostname");
  }
  if (isFamily(options)) {
    validateOneOf(options, "family", validFamilies);
    family5 = options;
  } else if (!isLookupOptions(options)) {
    throw new ERR_INVALID_ARG_TYPE("options", [
      "integer",
      "object"
    ], options);
  } else {
    if (options?.hints != null) {
      validateNumber(options.hints, "options.hints");
      hints = options.hints >>> 0;
      validateHints(hints);
    }
    if (options?.family != null) {
      validateOneOf(options.family, "options.family", validFamilies);
      family5 = options.family;
    }
    if (options?.all != null) {
      validateBoolean(options.all, "options.all");
      all = options.all;
    }
    if (options?.verbatim != null) {
      validateBoolean(options.verbatim, "options.verbatim");
      verbatim = options.verbatim;
    }
  }
  return createLookupPromise(family5, hostname, all, hints, verbatim);
}
function onresolve(err, records, ttls) {
  if (err) {
    this.reject(dnsException(err, this.bindingName, this.hostname));
    return;
  }
  const parsedRecords = ttls && this.ttl ? records.map((address3, index) => ({
    address: address3,
    ttl: ttls[index]
  })) : records;
  this.resolve(parsedRecords);
}
function createResolverPromise(resolver12, bindingName, hostname, ttl) {
  return new Promise((resolve21, reject) => {
    const req28 = new QueryReqWrap();
    req28.bindingName = bindingName;
    req28.hostname = hostname;
    req28.oncomplete = onresolve;
    req28.resolve = resolve21;
    req28.reject = reject;
    req28.ttl = ttl;
    const err = resolver12._handle[bindingName](req28, toASCII(hostname));
    if (err) {
      reject(dnsException(err, bindingName, hostname));
    }
  });
}
function resolver(bindingName) {
  function query2(name, options) {
    validateString(name, "name");
    const ttl = !!(options && options.ttl);
    return createResolverPromise(this, bindingName, name, ttl);
  }
  Object.defineProperty(query2, "name", {
    value: bindingName
  });
  return query2;
}
var resolveMap = /* @__PURE__ */ Object.create(null);
var Resolver1 = class extends Resolver {
};
Resolver1.prototype.resolveAny = resolveMap.ANY = resolver("queryAny");
Resolver1.prototype.resolve4 = resolveMap.A = resolver("queryA");
Resolver1.prototype.resolve6 = resolveMap.AAAA = resolver("queryAaaa");
Resolver1.prototype.resolveCaa = resolveMap.CAA = resolver("queryCaa");
Resolver1.prototype.resolveCname = resolveMap.CNAME = resolver("queryCname");
Resolver1.prototype.resolveMx = resolveMap.MX = resolver("queryMx");
Resolver1.prototype.resolveNs = resolveMap.NS = resolver("queryNs");
Resolver1.prototype.resolveTxt = resolveMap.TXT = resolver("queryTxt");
Resolver1.prototype.resolveSrv = resolveMap.SRV = resolver("querySrv");
Resolver1.prototype.resolvePtr = resolveMap.PTR = resolver("queryPtr");
Resolver1.prototype.resolveNaptr = resolveMap.NAPTR = resolver("queryNaptr");
Resolver1.prototype.resolveSoa = resolveMap.SOA = resolver("querySoa");
Resolver1.prototype.reverse = resolver("getHostByAddr");
Resolver1.prototype.resolve = _resolve;
function _resolve(hostname, rrtype) {
  let resolver2;
  if (typeof hostname !== "string") {
    throw new ERR_INVALID_ARG_TYPE("name", "string", hostname);
  }
  if (rrtype !== void 0) {
    validateString(rrtype, "rrtype");
    resolver2 = resolveMap[rrtype];
    if (typeof resolver2 !== "function") {
      throw new ERR_INVALID_ARG_VALUE("rrtype", rrtype);
    }
  } else {
    resolver2 = resolveMap.A;
  }
  return Reflect.apply(resolver2, this, [
    hostname
  ]);
}
function getServers() {
  return Resolver1.prototype.getServers.bind(getDefaultResolver())();
}
function resolveAny(hostname) {
  return Resolver1.prototype.resolveAny.bind(getDefaultResolver())(hostname);
}
function resolve4(hostname, options) {
  return Resolver1.prototype.resolve4.bind(getDefaultResolver())(hostname, options);
}
function resolve6(hostname, options) {
  return Resolver1.prototype.resolve6.bind(getDefaultResolver())(hostname, options);
}
function resolveCaa(hostname) {
  return Resolver1.prototype.resolveCaa.bind(getDefaultResolver())(hostname);
}
function resolveCname(hostname) {
  return Resolver1.prototype.resolveCname.bind(getDefaultResolver())(hostname);
}
function resolveMx(hostname) {
  return Resolver1.prototype.resolveMx.bind(getDefaultResolver())(hostname);
}
function resolveNs(hostname) {
  return Resolver1.prototype.resolveNs.bind(getDefaultResolver())(hostname);
}
function resolveTxt(hostname) {
  return Resolver1.prototype.resolveTxt.bind(getDefaultResolver())(hostname);
}
function resolveSrv(hostname) {
  return Resolver1.prototype.resolveSrv.bind(getDefaultResolver())(hostname);
}
function resolvePtr(hostname) {
  return Resolver1.prototype.resolvePtr.bind(getDefaultResolver())(hostname);
}
function resolveNaptr(hostname) {
  return Resolver1.prototype.resolveNaptr.bind(getDefaultResolver())(hostname);
}
function resolveSoa(hostname) {
  return Resolver1.prototype.resolveSoa.bind(getDefaultResolver())(hostname);
}
function reverse(ip2) {
  return Resolver1.prototype.reverse.bind(getDefaultResolver())(ip2);
}
function resolve3(hostname, rrtype) {
  return Resolver1.prototype.resolve.bind(getDefaultResolver())(hostname, rrtype);
}
var __default5 = {
  lookup,
  Resolver: Resolver1,
  getServers,
  resolveAny,
  resolve4,
  resolve6,
  resolveCaa,
  resolveCname,
  resolveMx,
  resolveNs,
  resolveTxt,
  resolveSrv,
  resolvePtr,
  resolveNaptr,
  resolveSoa,
  resolve: resolve3,
  reverse
};
function onlookup1(err, addresses) {
  if (err) {
    return this.callback(dnsException(err, "getaddrinfo", this.hostname));
  }
  this.callback(null, addresses[0], this.family || isIP(addresses[0]));
}
function onlookupall1(err, addresses) {
  if (err) {
    return this.callback(dnsException(err, "getaddrinfo", this.hostname));
  }
  const family6 = this.family;
  const parsedAddresses = [];
  for (let i95 = 0; i95 < addresses.length; i95++) {
    const addr = addresses[i95];
    parsedAddresses[i95] = {
      address: addr,
      family: family6 || isIP(addr)
    };
  }
  this.callback(null, parsedAddresses);
}
var validFamilies1 = [
  0,
  4,
  6
];
function lookup1(hostname, options, callback) {
  let hints = 0;
  let family7 = 0;
  let all = false;
  let verbatim = getDefaultVerbatim();
  if (hostname) {
    validateString(hostname, "hostname");
  }
  if (isLookupCallback(options)) {
    callback = options;
    family7 = 0;
  } else if (isFamily(options)) {
    validateCallback(callback);
    validateOneOf(options, "family", validFamilies1);
    family7 = options;
  } else if (!isLookupOptions(options)) {
    validateCallback(arguments.length === 2 ? options : callback);
    throw new ERR_INVALID_ARG_TYPE("options", [
      "integer",
      "object"
    ], options);
  } else {
    validateCallback(callback);
    if (options?.hints != null) {
      validateNumber(options.hints, "options.hints");
      hints = options.hints >>> 0;
      validateHints(hints);
    }
    if (options?.family != null) {
      validateOneOf(options.family, "options.family", validFamilies1);
      family7 = options.family;
    }
    if (options?.all != null) {
      validateBoolean(options.all, "options.all");
      all = options.all;
    }
    if (options?.verbatim != null) {
      validateBoolean(options.verbatim, "options.verbatim");
      verbatim = options.verbatim;
    }
  }
  if (!hostname) {
    emitInvalidHostnameWarning(hostname);
    if (all) {
      nextTick2(callback, null, []);
    } else {
      nextTick2(callback, null, null, family7 === 6 ? 6 : 4);
    }
    return {};
  }
  const matchedFamily = isIP(hostname);
  if (matchedFamily) {
    if (all) {
      nextTick2(callback, null, [
        {
          address: hostname,
          family: matchedFamily
        }
      ]);
    } else {
      nextTick2(callback, null, hostname, matchedFamily);
    }
    return {};
  }
  const req29 = new GetAddrInfoReqWrap();
  req29.callback = callback;
  req29.family = family7;
  req29.hostname = hostname;
  req29.oncomplete = all ? onlookupall1 : onlookup1;
  const err = getaddrinfo(req29, toASCII(hostname), family7, hints, verbatim);
  if (err) {
    nextTick2(callback, dnsException(err, "getaddrinfo", hostname));
    return {};
  }
  return req29;
}
Object.defineProperty(lookup1, customPromisifyArgs, {
  value: [
    "address",
    "family"
  ],
  enumerable: false
});
function onresolve1(err, records, ttls) {
  if (err) {
    this.callback(dnsException(err, this.bindingName, this.hostname));
    return;
  }
  const parsedRecords = ttls && this.ttl ? records.map((address4, index) => ({
    address: address4,
    ttl: ttls[index]
  })) : records;
  this.callback(null, parsedRecords);
}
function resolver1(bindingName) {
  function query3(name, options, callback) {
    if (isResolveCallback(options)) {
      callback = options;
      options = {};
    }
    validateString(name, "name");
    validateCallback(callback);
    const req30 = new QueryReqWrap();
    req30.bindingName = bindingName;
    req30.callback = callback;
    req30.hostname = name;
    req30.oncomplete = onresolve1;
    if (options && options.ttl) {
      notImplemented("dns.resolve* with ttl option");
    }
    req30.ttl = !!(options && options.ttl);
    const err = this._handle[bindingName](req30, toASCII(name));
    if (err) {
      throw dnsException(err, bindingName, name);
    }
    return req30;
  }
  Object.defineProperty(query3, "name", {
    value: bindingName
  });
  return query3;
}
var resolveMap1 = /* @__PURE__ */ Object.create(null);
var Resolver2 = class extends Resolver {
  constructor(options) {
    super(options);
  }
};
Resolver2.prototype.resolveAny = resolveMap1.ANY = resolver1("queryAny");
Resolver2.prototype.resolve4 = resolveMap1.A = resolver1("queryA");
Resolver2.prototype.resolve6 = resolveMap1.AAAA = resolver1("queryAaaa");
Resolver2.prototype.resolveCaa = resolveMap1.CAA = resolver1("queryCaa");
Resolver2.prototype.resolveCname = resolveMap1.CNAME = resolver1("queryCname");
Resolver2.prototype.resolveMx = resolveMap1.MX = resolver1("queryMx");
Resolver2.prototype.resolveNs = resolveMap1.NS = resolver1("queryNs");
Resolver2.prototype.resolveTxt = resolveMap1.TXT = resolver1("queryTxt");
Resolver2.prototype.resolveSrv = resolveMap1.SRV = resolver1("querySrv");
Resolver2.prototype.resolvePtr = resolveMap1.PTR = resolver1("queryPtr");
Resolver2.prototype.resolveNaptr = resolveMap1.NAPTR = resolver1("queryNaptr");
Resolver2.prototype.resolveSoa = resolveMap1.SOA = resolver1("querySoa");
Resolver2.prototype.reverse = resolver1("getHostByAddr");
Resolver2.prototype.resolve = _resolve1;
function _resolve1(hostname, rrtype, callback) {
  let resolver11;
  if (typeof hostname !== "string") {
    throw new ERR_INVALID_ARG_TYPE("name", "string", hostname);
  }
  if (typeof rrtype === "string") {
    resolver11 = resolveMap1[rrtype];
  } else if (typeof rrtype === "function") {
    resolver11 = resolveMap1.A;
    callback = rrtype;
  } else {
    throw new ERR_INVALID_ARG_TYPE("rrtype", "string", rrtype);
  }
  if (typeof resolver11 === "function") {
    return Reflect.apply(resolver11, this, [
      hostname,
      callback
    ]);
  }
  throw new ERR_INVALID_ARG_VALUE("rrtype", rrtype);
}
function setServers(servers) {
  const resolver2 = new Resolver2();
  resolver2.setServers(servers);
  setDefaultResolver(resolver2);
}
Object.defineProperties(__default5, {
  setServers: {
    configurable: true,
    enumerable: true,
    value: setServers
  },
  setDefaultResultOrder: {
    configurable: true,
    enumerable: true,
    value: setDefaultResultOrder
  }
});
var debug1 = debuglog("net", (fn) => {
  debug1 = fn;
});
var kLastWriteQueueSize = Symbol("lastWriteQueueSize");
var kSetNoDelay = Symbol("kSetNoDelay");
var kBytesRead = Symbol("kBytesRead");
var kBytesWritten1 = Symbol("kBytesWritten");
var DEFAULT_IPV4_ADDR = "0.0.0.0";
var DEFAULT_IPV6_ADDR = "::";
function _getNewAsyncId(handle) {
  return !handle || typeof handle.getAsyncId !== "function" ? newAsyncId1() : handle.getAsyncId();
}
var _noop = (_arrayBuffer, _nread) => {
  return;
};
function _toNumber(x) {
  return (x = Number(x)) >= 0 ? x : false;
}
function _isPipeName(s) {
  return typeof s === "string" && _toNumber(s) === false;
}
function _normalizeArgs(args5) {
  let arr;
  if (args5.length === 0) {
    arr = [
      {},
      null
    ];
    arr[normalizedArgsSymbol] = true;
    return arr;
  }
  const arg0 = args5[0];
  let options = {};
  if (typeof arg0 === "object" && arg0 !== null) {
    options = arg0;
  } else if (_isPipeName(arg0)) {
    options.path = arg0;
  } else {
    options.port = arg0;
    if (args5.length > 1 && typeof args5[1] === "string") {
      options.host = args5[1];
    }
  }
  const cb = args5[args5.length - 1];
  if (!_isConnectionListener(cb)) {
    arr = [
      options,
      null
    ];
  } else {
    arr = [
      options,
      cb
    ];
  }
  arr[normalizedArgsSymbol] = true;
  return arr;
}
function _isTCPConnectWrap(req31) {
  return "localAddress" in req31 && "localPort" in req31;
}
function _afterConnect(status, handle, req32, readable, writable) {
  let socket = handle[ownerSymbol];
  if (socket.constructor.name === "ReusedHandle") {
    socket = socket.handle;
  }
  if (socket.destroyed) {
    return;
  }
  debug1("afterConnect");
  assert(socket.connecting);
  socket.connecting = false;
  socket._sockname = null;
  if (status === 0) {
    if (socket.readable && !readable) {
      socket.push(null);
      socket.read();
    }
    if (socket.writable && !writable) {
      socket.end();
    }
    socket._unrefTimer();
    socket.emit("connect");
    socket.emit("ready");
    if (readable && !socket.isPaused()) {
      socket.read(0);
    }
  } else {
    socket.connecting = false;
    let details;
    if (_isTCPConnectWrap(req32)) {
      details = req32.localAddress + ":" + req32.localPort;
    }
    const ex = exceptionWithHostPort(status, "connect", req32.address, req32.port, details);
    if (_isTCPConnectWrap(req32)) {
      ex.localAddress = req32.localAddress;
      ex.localPort = req32.localPort;
    }
    socket.destroy(ex);
  }
}
function _checkBindError(err, port9, handle) {
  if (err === 0 && port9 > 0 && handle.getsockname) {
    const out = {};
    err = handle.getsockname(out);
    if (err === 0 && port9 !== out.port) {
      err = codeMap.get("EADDRINUSE");
    }
  }
  return err;
}
function _isPipe(options) {
  return "path" in options && !!options.path;
}
function _connectErrorNT(socket, err) {
  socket.destroy(err);
}
function _internalConnect(socket, address5, port10, addressType, localAddress, localPort, flags) {
  assert(socket.connecting);
  let err;
  if (localAddress || localPort) {
    if (addressType === 4) {
      localAddress = localAddress || DEFAULT_IPV4_ADDR;
      err = socket._handle.bind(localAddress, localPort);
    } else {
      localAddress = localAddress || DEFAULT_IPV6_ADDR;
      err = socket._handle.bind6(localAddress, localPort, flags);
    }
    debug1("binding to localAddress: %s and localPort: %d (addressType: %d)", localAddress, localPort, addressType);
    err = _checkBindError(err, localPort, socket._handle);
    if (err) {
      const ex = exceptionWithHostPort(err, "bind", localAddress, localPort);
      socket.destroy(ex);
      return;
    }
  }
  if (addressType === 6 || addressType === 4) {
    const req33 = new TCPConnectWrap();
    req33.oncomplete = _afterConnect;
    req33.address = address5;
    req33.port = port10;
    req33.localAddress = localAddress;
    req33.localPort = localPort;
    if (addressType === 4) {
      err = socket._handle.connect(req33, address5, port10);
    } else {
      err = socket._handle.connect6(req33, address5, port10);
    }
  } else {
    const req34 = new PipeConnectWrap();
    req34.oncomplete = _afterConnect;
    req34.address = address5;
    err = socket._handle.connect(req34, address5);
  }
  if (err) {
    let details = "";
    const sockname = socket._getsockname();
    if (sockname) {
      details = `${sockname.address}:${sockname.port}`;
    }
    const ex = exceptionWithHostPort(err, "connect", address5, port10, details);
    socket.destroy(ex);
  }
}
function _writeAfterFIN(chunk, encoding, cb) {
  if (!this.writableEnded) {
    return Duplex.prototype.write.call(this, chunk, encoding, cb);
  }
  if (typeof encoding === "function") {
    cb = encoding;
    encoding = null;
  }
  const err = genericNodeError("This socket has been ended by the other party", {
    code: "EPIPE"
  });
  if (typeof cb === "function") {
    defaultTriggerAsyncIdScope(this[asyncIdSymbol], nextTick2, cb, err);
  }
  if (this._server) {
    nextTick2(() => this.destroy(err));
  } else {
    this.destroy(err);
  }
  return false;
}
function _tryReadStart(socket) {
  debug1("Socket._handle.readStart");
  socket._handle.reading = true;
  const err = socket._handle.readStart();
  if (err) {
    socket.destroy(errnoException(err, "read"));
  }
}
function _onReadableStreamEnd() {
  if (!this.allowHalfOpen) {
    this.write = _writeAfterFIN;
  }
}
function _initSocketHandle(socket) {
  socket._undestroy();
  socket._sockname = void 0;
  if (socket._handle) {
    socket._handle[ownerSymbol] = socket;
    socket._handle.onread = onStreamRead;
    socket[asyncIdSymbol] = _getNewAsyncId(socket._handle);
    let userBuf = socket[kBuffer];
    if (userBuf) {
      const bufGen = socket[kBufferGen];
      if (bufGen !== null) {
        userBuf = bufGen();
        if (!isUint8Array(userBuf)) {
          return;
        }
        socket[kBuffer] = userBuf;
      }
      socket._handle.useUserBuffer(userBuf);
    }
  }
}
function _lookupAndConnect(self, options) {
  const { localAddress, localPort } = options;
  const host = options.host || "localhost";
  let { port: port12 } = options;
  if (localAddress && !isIP(localAddress)) {
    throw new ERR_INVALID_IP_ADDRESS(localAddress);
  }
  if (localPort) {
    validateNumber(localPort, "options.localPort");
  }
  if (typeof port12 !== "undefined") {
    if (typeof port12 !== "number" && typeof port12 !== "string") {
      throw new ERR_INVALID_ARG_TYPE("options.port", [
        "number",
        "string"
      ], port12);
    }
    validatePort(port12);
  }
  port12 |= 0;
  const addressType1 = isIP(host);
  if (addressType1) {
    defaultTriggerAsyncIdScope(self[asyncIdSymbol], nextTick2, () => {
      if (self.connecting) {
        defaultTriggerAsyncIdScope(self[asyncIdSymbol], _internalConnect, self, host, port12, addressType1, localAddress, localPort);
      }
    });
    return;
  }
  if (options.lookup !== void 0) {
    validateFunction(options.lookup, "options.lookup");
  }
  const dnsOpts = {
    family: options.family,
    hints: options.hints || 0
  };
  if (!isWindows && dnsOpts.family !== 4 && dnsOpts.family !== 6 && dnsOpts.hints === 0) {
    dnsOpts.hints = AI_ADDRCONFIG;
  }
  debug1("connect: find host", host);
  debug1("connect: dns options", dnsOpts);
  self._host = host;
  const lookup2 = options.lookup || lookup1;
  defaultTriggerAsyncIdScope(self[asyncIdSymbol], function() {
    lookup2(host, dnsOpts, function emitLookup(err, ip3, addressType) {
      self.emit("lookup", err, ip3, addressType, host);
      if (!self.connecting) {
        return;
      }
      if (err) {
        nextTick2(_connectErrorNT, self, err);
      } else if (!isIP(ip3)) {
        err = new ERR_INVALID_IP_ADDRESS(ip3);
        nextTick2(_connectErrorNT, self, err);
      } else if (addressType !== 4 && addressType !== 6) {
        err = new ERR_INVALID_ADDRESS_FAMILY(`${addressType}`, options.host, options.port);
        nextTick2(_connectErrorNT, self, err);
      } else {
        self._unrefTimer();
        defaultTriggerAsyncIdScope(self[asyncIdSymbol], _internalConnect, self, ip3, port12, addressType, localAddress, localPort);
      }
    });
  });
}
function _afterShutdown() {
  const self = this.handle[ownerSymbol];
  debug1("afterShutdown destroyed=%j", self.destroyed, self._readableState);
  this.callback();
}
function _emitCloseNT(s) {
  debug1("SERVER: emit close");
  s.emit("close");
}
var Socket = class extends Duplex {
  [asyncIdSymbol] = -1;
  [kHandle] = null;
  [kSetNoDelay] = false;
  [kLastWriteQueueSize] = 0;
  [kTimeout] = null;
  [kBuffer] = null;
  [kBufferCb] = null;
  [kBufferGen] = null;
  [kBytesRead] = 0;
  [kBytesWritten1] = 0;
  server = null;
  _server = null;
  _peername;
  _sockname;
  _pendingData = null;
  _pendingEncoding = "";
  _host = null;
  _parent = null;
  constructor(options) {
    if (typeof options === "number") {
      options = {
        fd: options
      };
    } else {
      options = {
        ...options
      };
    }
    options.allowHalfOpen = Boolean(options.allowHalfOpen);
    options.emitClose = false;
    options.autoDestroy = true;
    options.decodeStrings = false;
    super(options);
    if (options.handle) {
      this._handle = options.handle;
      this[asyncIdSymbol] = _getNewAsyncId(this._handle);
    } else if (options.fd !== void 0) {
      notImplemented("net.Socket.prototype.constructor with fd option");
    }
    const onread = options.onread;
    if (onread !== null && typeof onread === "object" && (isUint8Array(onread.buffer) || typeof onread.buffer === "function") && typeof onread.callback === "function") {
      if (typeof onread.buffer === "function") {
        this[kBuffer] = true;
        this[kBufferGen] = onread.buffer;
      } else {
        this[kBuffer] = onread.buffer;
      }
      this[kBufferCb] = onread.callback;
    }
    this.on("end", _onReadableStreamEnd);
    _initSocketHandle(this);
    if (this._handle && options.readable !== false) {
      if (options.pauseOnCreate) {
        this._handle.reading = false;
        this._handle.readStop();
        this.readableFlowing = false;
      } else if (!options.manualStart) {
        this.read(0);
      }
    }
  }
  connect(...args6) {
    let normalized;
    if (Array.isArray(args6[0]) && args6[0][normalizedArgsSymbol]) {
      normalized = args6[0];
    } else {
      normalized = _normalizeArgs(args6);
    }
    const options = normalized[0];
    const cb = normalized[1];
    if (options.port === void 0 && options.path == null) {
      throw new ERR_MISSING_ARGS([
        "options",
        "port",
        "path"
      ]);
    }
    if (this.write !== Socket.prototype.write) {
      this.write = Socket.prototype.write;
    }
    if (this.destroyed) {
      this._handle = null;
      this._peername = void 0;
      this._sockname = void 0;
    }
    const { path: path26 } = options;
    const pipe = _isPipe(options);
    debug1("pipe", pipe, path26);
    if (!this._handle) {
      this._handle = pipe ? new Pipe(constants2.SOCKET) : new TCP(constants3.SOCKET);
      _initSocketHandle(this);
    }
    if (cb !== null) {
      this.once("connect", cb);
    }
    this._unrefTimer();
    this.connecting = true;
    if (pipe) {
      validateString(path26, "options.path");
      defaultTriggerAsyncIdScope(this[asyncIdSymbol], _internalConnect, this, path26);
    } else {
      _lookupAndConnect(this, options);
    }
    return this;
  }
  pause() {
    if (this[kBuffer] && !this.connecting && this._handle && this._handle.reading) {
      this._handle.reading = false;
      if (!this.destroyed) {
        const err = this._handle.readStop();
        if (err) {
          this.destroy(errnoException(err, "read"));
        }
      }
    }
    return Duplex.prototype.pause.call(this);
  }
  resume() {
    if (this[kBuffer] && !this.connecting && this._handle && !this._handle.reading) {
      _tryReadStart(this);
    }
    return Duplex.prototype.resume.call(this);
  }
  setTimeout = setStreamTimeout;
  setNoDelay(noDelay) {
    if (!this._handle) {
      this.once("connect", noDelay ? this.setNoDelay : () => this.setNoDelay(noDelay));
      return this;
    }
    const newValue = noDelay === void 0 ? true : !!noDelay;
    if ("setNoDelay" in this._handle && this._handle.setNoDelay && newValue !== this[kSetNoDelay]) {
      this[kSetNoDelay] = newValue;
      this._handle.setNoDelay(newValue);
    }
    return this;
  }
  setKeepAlive(enable, initialDelay) {
    if (!this._handle) {
      this.once("connect", () => this.setKeepAlive(enable, initialDelay));
      return this;
    }
    if ("setKeepAlive" in this._handle) {
      this._handle.setKeepAlive(enable, ~~(initialDelay / 1e3));
    }
    return this;
  }
  address() {
    return this._getsockname();
  }
  unref() {
    if (!this._handle) {
      this.once("connect", this.unref);
      return this;
    }
    if (typeof this._handle.unref === "function") {
      this._handle.unref();
    }
    return this;
  }
  ref() {
    if (!this._handle) {
      this.once("connect", this.ref);
      return this;
    }
    if (typeof this._handle.ref === "function") {
      this._handle.ref();
    }
    return this;
  }
  get bufferSize() {
    if (this._handle) {
      return this.writableLength;
    }
    return 0;
  }
  get bytesRead() {
    return this._handle ? this._handle.bytesRead : this[kBytesRead];
  }
  get bytesWritten() {
    let bytes = this._bytesDispatched;
    const data4 = this._pendingData;
    const encoding = this._pendingEncoding;
    const writableBuffer = this.writableBuffer;
    if (!writableBuffer) {
      return void 0;
    }
    for (const el of writableBuffer) {
      bytes += el.chunk instanceof Buffer2 ? el.chunk.length : Buffer2.byteLength(el.chunk, el.encoding);
    }
    if (Array.isArray(data4)) {
      for (let i96 = 0; i96 < data4.length; i96++) {
        const chunk = data4[i96];
        if (data4.allBuffers || chunk instanceof Buffer2) {
          bytes += chunk.length;
        } else {
          bytes += Buffer2.byteLength(chunk.chunk, chunk.encoding);
        }
      }
    } else if (data4) {
      if (typeof data4 !== "string") {
        bytes += data4.length;
      } else {
        bytes += Buffer2.byteLength(data4, encoding);
      }
    }
    return bytes;
  }
  connecting = false;
  get localAddress() {
    return this._getsockname().address;
  }
  get localPort() {
    return this._getsockname().port;
  }
  get remoteAddress() {
    return this._getpeername().address;
  }
  get remoteFamily() {
    return `IPv${this._getpeername().family}`;
  }
  get remotePort() {
    return this._getpeername().port;
  }
  get pending() {
    return !this._handle || this.connecting;
  }
  get readyState() {
    if (this.connecting) {
      return "opening";
    } else if (this.readable && this.writable) {
      return "open";
    } else if (this.readable && !this.writable) {
      return "readOnly";
    } else if (!this.readable && this.writable) {
      return "writeOnly";
    }
    return "closed";
  }
  end(data5, encoding, cb) {
    Duplex.prototype.end.call(this, data5, encoding, cb);
    DTRACE_NET_STREAM_END(this);
    return this;
  }
  read(size) {
    if (this[kBuffer] && !this.connecting && this._handle && !this._handle.reading) {
      _tryReadStart(this);
    }
    return Duplex.prototype.read.call(this, size);
  }
  destroySoon() {
    if (this.writable) {
      this.end();
    }
    if (this.writableFinished) {
      this.destroy();
    } else {
      this.once("finish", this.destroy);
    }
  }
  _unrefTimer() {
    for (let s = this; s !== null; s = s._parent) {
      if (s[kTimeout]) {
        s[kTimeout].refresh();
      }
    }
  }
  _final(cb) {
    if (this.pending) {
      debug1("_final: not yet connected");
      return this.once("connect", () => this._final(cb));
    }
    if (!this._handle) {
      return cb();
    }
    debug1("_final: not ended, call shutdown()");
    const req35 = new ShutdownWrap();
    req35.oncomplete = _afterShutdown;
    req35.handle = this._handle;
    req35.callback = cb;
    const err = this._handle.shutdown(req35);
    if (err === 1 || err === codeMap.get("ENOTCONN")) {
      return cb();
    } else if (err !== 0) {
      return cb(errnoException(err, "shutdown"));
    }
  }
  _onTimeout() {
    const handle = this._handle;
    const lastWriteQueueSize = this[kLastWriteQueueSize];
    if (lastWriteQueueSize > 0 && handle) {
      const { writeQueueSize } = handle;
      if (lastWriteQueueSize !== writeQueueSize) {
        this[kLastWriteQueueSize] = writeQueueSize;
        this._unrefTimer();
        return;
      }
    }
    debug1("_onTimeout");
    this.emit("timeout");
  }
  _read(size) {
    debug1("_read");
    if (this.connecting || !this._handle) {
      debug1("_read wait for connection");
      this.once("connect", () => this._read(size));
    } else if (!this._handle.reading) {
      _tryReadStart(this);
    }
  }
  _destroy(exception, cb) {
    debug1("destroy");
    this.connecting = false;
    for (let s = this; s !== null; s = s._parent) {
      clearTimeout(s[kTimeout]);
    }
    debug1("close");
    if (this._handle) {
      debug1("close handle");
      const isException = exception ? true : false;
      this[kBytesRead] = this._handle.bytesRead;
      this[kBytesWritten1] = this._handle.bytesWritten;
      this._handle.close(() => {
        this._handle.onread = _noop;
        this._handle = null;
        this._sockname = void 0;
        cb(exception);
        debug1("emit close");
        this.emit("close", isException);
      });
    } else {
      cb(exception);
      nextTick2(_emitCloseNT, this);
    }
    if (this._server) {
      debug1("has server");
      this._server._connections--;
      if (this._server._emitCloseIfDrained) {
        this._server._emitCloseIfDrained();
      }
    }
  }
  _getpeername() {
    if (!this._handle || !("getpeername" in this._handle)) {
      return this._peername || {};
    } else if (!this._peername) {
      this._peername = {};
      this._handle.getpeername(this._peername);
    }
    return this._peername;
  }
  _getsockname() {
    if (!this._handle || !("getsockname" in this._handle)) {
      return {};
    } else if (!this._sockname) {
      this._sockname = {};
      this._handle.getsockname(this._sockname);
    }
    return this._sockname;
  }
  _writeGeneric(writev, data6, encoding, cb) {
    if (this.connecting) {
      this._pendingData = data6;
      this._pendingEncoding = encoding;
      this.once("connect", function connect2() {
        this._writeGeneric(writev, data6, encoding, cb);
      });
      return;
    }
    this._pendingData = null;
    this._pendingEncoding = "";
    if (!this._handle) {
      cb(new ERR_SOCKET_CLOSED());
      return false;
    }
    this._unrefTimer();
    let req36;
    if (writev) {
      req36 = writevGeneric(this, data6, cb);
    } else {
      req36 = writeGeneric(this, data6, encoding, cb);
    }
    if (req36.async) {
      this[kLastWriteQueueSize] = req36.bytes;
    }
  }
  _writev(chunks, cb) {
    this._writeGeneric(true, chunks, "", cb);
  }
  _write(data7, encoding, cb) {
    this._writeGeneric(false, data7, encoding, cb);
  }
  [kAfterAsyncWrite]() {
    this[kLastWriteQueueSize] = 0;
  }
  get [kUpdateTimer]() {
    return this._unrefTimer;
  }
  get _connecting() {
    return this.connecting;
  }
  get _bytesDispatched() {
    return this._handle ? this._handle.bytesWritten : this[kBytesWritten1];
  }
  get _handle() {
    return this[kHandle];
  }
  set _handle(v) {
    this[kHandle] = v;
  }
};
function _isConnectionListener(connectionListener) {
  return typeof connectionListener === "function";
}
function isatty(fd) {
  if (typeof fd !== "number") {
    return false;
  }
  try {
    return workerDeno_isatty(fd);
  } catch (_) {
    return false;
  }
}
var ReadStream = class extends Socket {
};
var WriteStream = class extends Socket {
};
export {
  ReadStream,
  WriteStream,
  isatty
};
